﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Music");
    WinJS.Namespace.define("MS.Entertainment.Music.Freeplay", {
        Events: {
            emptyRoomLimitReached: "emptyRoomLimitReached", travelLimitReached: "travelLimitReached", monthlyFreeLimitExceeded: "monthlyFreeLimitExceeded", monthlyFreeLimitReset: "monthlyFreeLimitReset", freeTrialStarted: "freeTrialStarted", freeTrialCompleted: "freeTrialCompleted", freeTrackLimitExceeded: "freeTrackLimitExceeded", freeTrackLimitReset: "freeTrackLimitReset", unauthenticatedTrackLimitExceeded: "unauthenticatedTrackLimitExceeded", audioAdStart: "audioAdStart", audioAdComplete: "audioAdComplete", audioAdReasonClickThru: "audioAdReasonClickThru", videoAdStart: "videoAdStart", videoAdClosed: "videoAdClosed", videoAdComplete: "videoAdComplete", videoAdClickThru: "videoAdClickThru", videoAdReasonClickThru: "videoAdReasonClickThru", videoAdError: "videoAdError", adCompanionShown: "adCompanionShown", adCompanionClosed: "adCompanionClosed", adCompanionFullTerm: "adCompanionFullTerm", adCompanionClickThru: "adCompanionClickThru", adCompanionClosedOnNav: "adCompanionClosedOnNav", limitDialogDisplayed: "limitDialogDisplayed", limitDialogCancel: "limitDialogCancel", limitDialogContinuePlaying: "limitDialogContinuePlaying", limitDialogOk: "limitDialogOk", limitDialogSignIn: "limitDialogSignIn", limitDialogSignInNowForExistingUser: "limitDialogSignInNowForExistingUser", limitDialogSignInNowForNewUser: "limitDialogSignInNowForNewUser", limitDialogSubscribe: "limitDialogSubscribe", limitDialogSignInThenSignUp: "limitDialogSignInThenSignUp", limitDialogBuyTrack: "limitDialogBuyTrack", limitDialogBuyAlbum: "limitDialogBuyAlbum", limitSettingsSubscribe: "limitSettingsSubscribe", musicPassSignUpShown: "musicPassSignUpShown", musicPassUpsellAppBarInvoked: "musicPassUpsellAppBarInvoked", musicPassUpsellEngagePanelInvoked: "musicPassUpsellEngagePanelInvoked", musicPassUpsellVideoAdInvoked: "musicPassUpsellVideoAdInvoked", musicPassUpsellAlbumPopoverLinkInvoked: "musicPassUpsellAlbumPopoverLinkInvoked", musicPassUpsellArtistDiscographyInvoked: "musicPassUpsellArtistDiscographyInvoked", musicPassUpsellMarketplaceLinkInvoked: "musicPassUpsellMarketplaceLinkInvoked"
        }, sendTelemetryEvent: function sendTelemetryEvent(event) {
                MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(event)
            }
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Music", {AdService: MS.Entertainment.UI.Framework.define(function AdServiceConstructor() {
            this._eventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell;
            var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
            this._isFreePlayEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay) && MS.Entertainment.Utilities.isMusicApp1;
            if (!this._isFreePlayEnabled)
                return;
            this._signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
            this._signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
            this._uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
            this._configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
            var onUserStatusChanged = this._onUserStatusChanged.bind(this);
            this._signInBinding = WinJS.Binding.bind(this._signIn, {isSignedIn: onUserStatusChanged});
            this._subscriptionBinding = WinJS.Binding.bind(this._signedInUser, {isSubscription: onUserStatusChanged});
            if (!this._signIn.isSignedIn && !this._configurationManager.service.lastSignedInUserSubscription)
                this.initialize()
        }, {
            _eventProvider: null, _isFreePlayEnabled: false, _initialized: false, _audioAdPackage: null, _audioAdPackageRefreshing: false, _audioAdPackageRefreshTimer: null, _videoAdPackage: null, _videoAdPackageRefreshing: false, _videoAdPackageRefreshTimer: null, _networkOpenRequest: null, _currentAudioAd: null, _currentVideoAd: null, _adManager: null, _emptyRoomTimeout: null, _emptyRoomDialogVisible: false, _companionAdVisible: false, _companionAdTimer: null, _sessionManager: null, _playbackSession: null, _currentMediaType: null, _currentPlaybackSessionOrdinal: null, _currentOrdinalChangedCallback: null, _signIn: null, _signedInUser: null, _lastSignedInState: false, _uiStateService: null, _configurationManager: null, _signInBinding: null, _subscriptionBinding: null, _navigationBinding: null, _uiStateServiceBindings: null, _playbackSessionBindings: null, _inputHandler: null, _visibilityChanged: null, _lastInteractionEventTime: null, _appInSnappedMode: false, _streamingTracks: null, _adPlaying: false, _videoAdPlaying: false, _mediaControlArtOverridden: false, _skipAudioAdForNextTrack: false, _freePlayLimits: null, _lastAudioAdMediaInstance: null, _lastAudioAdMediaInstanceIsNext: false, _lastVideoAdMediaItemProperties: null, initialize: function initialize() {
                    if (this._initialized)
                        return;
                    this._lastSignedInState = this._signIn.isSignedIn;
                    this._streamingTracks = {};
                    this._adManager = new Microsoft.Entertainment.Ads.AdManager;
                    this._emptyRoomTimeout = this._adManager.getEmptyRoomTimeout();
                    var applicationId = MS.Entertainment.UI.Music.AdService._getAdApplicationId();
                    var unAuthExtension = String.empty;
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    if (!this._signIn.isSignedIn && featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlayAnonAds))
                        unAuthExtension = "UnAuth";
                    var audioAdUnitIds = MS.Entertainment.UI.Music.AdService._getAdUnitId(MS.Entertainment.UI.Music.AdService.audioAdUnitIdConfig + unAuthExtension);
                    var videoAdUnitIds = MS.Entertainment.UI.Music.AdService._getAdUnitId(MS.Entertainment.UI.Music.AdService.videoAdUnitIdConfig + unAuthExtension);
                    this._audioAdPackage = new MicrosoftNSJS.Advertising.AdPackage(applicationId, audioAdUnitIds);
                    this._audioAdPackage.onAdRefreshed = this._onAudioAdRefreshed.bind(this);
                    this._audioAdPackage.onErrorOccurred = this._onAdErrorOccurred.bind(this);
                    this._videoAdPackage = new MicrosoftNSJS.Advertising.AdPackage(applicationId, videoAdUnitIds);
                    this._videoAdPackage.onAdRefreshed = this._onVideoAdRefreshed.bind(this);
                    this._videoAdPackage.onErrorOccurred = this._onAdErrorOccurred.bind(this);
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation)) {
                        var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        this._navigationBinding = WinJS.Binding.bind(navigationService, {currentPage: this._handleNavigation.bind(this)})
                    }
                    this._sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                    this._uiStateServiceBindings = WinJS.Binding.bind(this._uiStateService, {
                        networkStatus: this._onNetworkStatusChanged.bind(this), primarySessionId: function primarySessionIdChanged() {
                                this._playbackSession = this._sessionManager.primarySession;
                                this._setUpSessionBindings()
                            }.bind(this)
                    });
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits))
                        this._freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                    this._inputHandler = this._onInputReceived.bind(this);
                    var interactionNotifier = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.interactionNotifier);
                    interactionNotifier.addInteractionListener(this._inputHandler);
                    this._visibilityChanged = this._onVisibilityChanged.bind(this);
                    document.addEventListener("visibilitychange", this._visibilityChanged, false);
                    this._uiStateService.shouldShowAdsForFreePlay = true;
                    this._initialized = true;
                    this._eventProvider.traceAdService_Initialized()
                }, dispose: function dispose() {
                    this._initialized = false;
                    this._adManager = null;
                    this._streamingTracks = null;
                    this._lastAudioAdMediaInstance = null;
                    this._lastVideoAdMediaItemProperties = null;
                    if (this._audioAdPackage)
                        this._audioAdPackage.dispose();
                    if (this._videoAdPackage)
                        this._videoAdPackage.dispose();
                    if (this._networkOpenRequest) {
                        this._networkOpenRequest.release();
                        this._networkOpenRequest = null
                    }
                    if (this._navigationBinding) {
                        this._navigationBinding.cancel();
                        this._navigationBinding = null
                    }
                    if (this._uiStateServiceBindings) {
                        this._uiStateServiceBindings.cancel();
                        this._uiStateServiceBindings = null
                    }
                    if (this._playbackSessionBindings) {
                        this._playbackSessionBindings.cancel();
                        this._playbackSessionBindings = null
                    }
                    if (this._currentOrdinalChangedCallback) {
                        this._currentOrdinalChangedCallback.cancel();
                        this._currentOrdinalChangedCallback = null
                    }
                    if (this._companionAdTimer) {
                        window.clearTimeout(this._companionAdTimer);
                        this._companionAdTimer = null
                    }
                    this._hideCompanionAd();
                    var interactionNotifier = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.interactionNotifier);
                    interactionNotifier.removeInteractionListener(this._inputHandler);
                    document.removeEventListener("visibilitychange", this._visibilityChanged);
                    this._inputHandler = null;
                    this._visibilityChanged = null;
                    this._videoAdPlaying = false;
                    this._eventProvider.traceAdService_Unloaded()
                }, isAudioAdRequired: function isAudioAdRequired(mediaInstance, isNextMediaInstance) {
                    var promise = WinJS.Promise.wrap();
                    var adMediaItem;
                    if (!this._isFreePlayEnabled || !this._initialized || !this._isStreamingTrack(mediaInstance) || this._skipAudioAdForNextTrack || (this._freePlayLimits && this._freePlayLimits.isMonthlyFreeLimitExceeded)) {
                        this._skipAudioAdForNextTrack = false;
                        return promise
                    }
                    if (this._currentAudioAd && this._adManager.isAdRequired(Microsoft.Entertainment.Ads.AdType.audio, isNextMediaInstance)) {
                        adMediaItem = this._getAudioAdMediaItem(mediaInstance);
                        this._lastAudioAdMediaInstance = mediaInstance;
                        this._lastAudioAdMediaInstanceIsNext = isNextMediaInstance
                    }
                    var currentTimeInMs = Date.now();
                    var lastInputTimeInMs = this._lastInteractionEventTime || currentTimeInMs;
                    var timeDeltaInMin = (currentTimeInMs - lastInputTimeInMs) / (1000 * 60);
                    if (timeDeltaInMin > this._emptyRoomTimeout) {
                        var dialogDismissed;
                        promise = new WinJS.Promise(function(c, e, p) {
                            dialogDismissed = c
                        }).then(function onDialogDismissed() {
                            var playAdIfNeeded = this._signIn.isSignedIn && !this._signedInUser.isSubscription;
                            var mediaItemToInject = playAdIfNeeded ? adMediaItem : null;
                            this._emptyRoomDialogVisible = false;
                            if (this._playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.paused)
                                this._playbackSession.targetTransportState = MS.Entertainment.Platform.Playback.TransportState.playing;
                            return WinJS.Promise.wrap(mediaItemToInject)
                        }.bind(this));
                        MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.emptyRoomLimitReached);
                        MS.Entertainment.Music.MusicBrandDialog.showEmptyRoomDialog(dialogDismissed);
                        this._emptyRoomDialogVisible = true;
                        var uiState = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        if (uiState.isSnapped || !uiState.isAppVisible)
                            this._sendEmptyRoomToast()
                    }
                    else
                        promise = WinJS.Promise.wrap(adMediaItem);
                    return promise
                }, playVideoAdIfRequired: function playVideoAdIfRequired(mediaItem, collectionFilter, isSmartDjPlayRequest) {
                    var networkIsUnrestricted;
                    if (this._videoAdPlaying || !mediaItem)
                        return WinJS.Promise.wrap(false);
                    if (!this._isFreePlayEnabled || (this._freePlayLimits && this._freePlayLimits.isMonthlyFreeLimitExceeded) || !this._currentVideoAd || !this._initialized)
                        return WinJS.Promise.wrap(true);
                    return this._isStreamingMediaItem(mediaItem, collectionFilter, isSmartDjPlayRequest).then(function isStreamingMediaItem_Completed(isStreamingMediaItem) {
                            if (!isStreamingMediaItem || !this._initialized)
                                return WinJS.Promise.wrap(true);
                            networkIsUnrestricted = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unrestricted;
                            this._adManager.setStreamingTrackInvoked();
                            if (this._adManager.isAdRequired(Microsoft.Entertainment.Ads.AdType.video, false) && networkIsUnrestricted && this._currentVideoAd.videoAd.url) {
                                var audioPlaybackStopped;
                                var startVideoAdTimeout;
                                if (this._videoAdPlaying)
                                    return WinJS.Promise.wrap(false);
                                this._videoAdPlaying = true;
                                this._lastVideoAdMediaItemProperties = this._lastVideoAdMediaItemProperties || {};
                                this._lastVideoAdMediaItemProperties.mediaType = mediaItem.mediaType;
                                this._lastVideoAdMediaItemProperties.inCollection = mediaItem.inCollection;
                                this._lastVideoAdMediaItemProperties.hasLocalContent = mediaItem.hasLocalContent;
                                this._lastVideoAdMediaItemProperties.isLibraryQuery = MS.Entertainment.Data.MainQuery.isQuery(mediaItem) && MS.Entertainment.Data.Query.LibraryQueryBase.isLibraryQuery(mediaItem);
                                MS.Entertainment.UI.Music.assert(!this._videoAdPackageRefreshing, "playVideoAdIfRequired was called while AdService was refreshing Ad.");
                                var showVideoPromise = new WinJS.Promise(function(c, e, p) {
                                        audioPlaybackStopped = c
                                    }).then(function showVideoAd() {
                                        return this.playVideoAd()
                                    }.bind(this));
                                var startVideoAdPlayback = function startVideoAdPlayback() {
                                        audioPlaybackStopped()
                                    }.bind(this);
                                if (this._companionAdVisible)
                                    this._hideCompanionAd();
                                this._playbackSession.targetTransportState = MS.Entertainment.Platform.Playback.TransportState.stopped;
                                startVideoAdTimeout = WinJS.Promise.timeout(500).then(function playVideoAd() {
                                    startVideoAdPlayback();
                                    return WinJS.Promise.timeout(1000)
                                }).then(this._stopPlaybackForAd.bind(this));
                                return showVideoPromise
                            }
                            return WinJS.Promise.wrap(true)
                        }.bind(this), function isStreamingMediaItem_Failed() {
                            return WinJS.Promise.wrap(true)
                        })
                }, playVideoAd: function playVideoAd() {
                    return MS.Entertainment.UI.Controls.VideoAd.showVideoAd(this._currentVideoAd.videoAd.url, this._currentVideoAd.clickThroughUrl, this._currentVideoAd.adClickThroughCallback, function onVideoAdPlaybackStarted() {
                            this._videoAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdImpression);
                            this._videoAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdVideoStart)
                        }.bind(this)).then(function showVideoAd_Success(control) {
                            var userControl = (control && control.userControlInstance) || {};
                            if (!this._initialized) {
                                this._videoAdPlaying = false;
                                return true
                            }
                            var watchedFullAd = userControl.adCompleted;
                            var playbackFailed = userControl.adErrorOccurred;
                            if (watchedFullAd) {
                                this._adManager.setAdPlayed(Microsoft.Entertainment.Ads.AdType.video);
                                this._configurationManager.music.totalVideoAdImpressions++
                            }
                            if (watchedFullAd && !playbackFailed)
                                this._videoAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdComplete);
                            if (watchedFullAd || playbackFailed)
                                this._refreshVideoAd();
                            this._lastVideoAdMediaItemProperties = null;
                            this._videoAdPlaying = false;
                            return WinJS.Promise.wrap(watchedFullAd)
                        }.bind(this), function showVideoAd_Error() {
                            MS.Entertainment.UI.Music.fail("Could not show video ad.");
                            this._videoAdPlaying = false;
                            return WinJS.Promise.wrap(true)
                        })
                }, audioAdPlayed: function audioAdPlayed() {
                    if (this._isFreePlayEnabled && this._initialized) {
                        this._adManager.setAdPlayed(Microsoft.Entertainment.Ads.AdType.audio);
                        this._adPlaying = false;
                        this._lastAudioAdMediaInstance = null;
                        this._eventProvider.traceAdService_AudioAdPlayed();
                        MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.audioAdComplete);
                        this._configurationManager.music.totalAudioAdImpressions++;
                        if (this._companionAdVisible)
                            this._companionAdTimer = window.setTimeout(function hideCompanionAd() {
                                MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.adCompanionFullTerm);
                                this._hideCompanionAd()
                            }.bind(this), MS.Entertainment.UI.Music.AdService.adCompanionTimeoutInMs);
                        this._refreshAudioAd()
                    }
                }, audioAdPlaying: function audioAdPlaying() {
                    if (this._isFreePlayEnabled && !this._adPlaying) {
                        var networkOpenRequest = this._sessionManager.requestNetwork("AdService");
                        var releaseNetwork = function releaseNetwork() {
                                networkOpenRequest.release()
                            };
                        WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.networkOpenDelayMs).then(function reportAdPlayed() {
                            if (this._audioAdPackage && !this._audioAdPackageRefreshing)
                                return this._audioAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdImpression).then(function delayNetworkClose() {
                                        return WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.adPackageReportDelayMs)
                                    });
                            else
                                return WinJS.Promise.wrap()
                        }.bind(this)).done(releaseNetwork, releaseNetwork);
                        this._adPlaying = true;
                        this._eventProvider.traceAdService_AudioAdPlaying();
                        MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.audioAdStart);
                        if (!MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).nowPlayingVisible && !window.onNewMusicPage)
                            MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar).show(MS.Entertainment.UI.Controls.BottomAppBar.defaultHideTimeoutMS);
                        if (this._currentAudioAd.adCompanion) {
                            var parameters = {
                                    imageUrl: this._currentAudioAd.adCompanion.imageUrl, linkUrl: this._currentAudioAd.adCompanion.clickThroughUrl, closedCallback: this._currentAudioAd.adCompanionClosedCallback, clickCallback: this._currentAudioAd.adClickThroughCallback
                                };
                            if (this._companionAdTimer) {
                                window.clearTimeout(this._companionAdTimer);
                                this._companionAdTimer = null
                            }
                            this._appInSnappedMode = this._uiStateService.isSnapped;
                            this._companionAdVisible = true;
                            MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.adCompanionShown);
                            MS.Entertainment.UI.Controls.AdCompanion.showAdCompanion(parameters)
                        }
                    }
                }, streamingTrackPlayed: function streamingTrackPlayed() {
                    if (this._isFreePlayEnabled && this._initialized) {
                        this._adManager.setStreamingTrackPlayed();
                        this._eventProvider.traceAdService_StreamingTrackPlayed()
                    }
                }, isStreamingBlocked: function isStreamingBlocked(mediaItem) {
                    var promise;
                    if (!this._isFreePlayEnabled)
                        return WinJS.Promise.wrap(false);
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var anonymousLimitReached = this._configurationManager.music.anonymousLimitReached;
                    var anonymousFreePlayEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlayAnonymous) && !anonymousLimitReached;
                    var anonymousUser = !this._signIn.isSignedIn && !this._configurationManager.service.lastSignedInUserSubscription;
                    if ((this._uiStateService.servicesEnabled && (!anonymousUser || anonymousFreePlayEnabled)) || !MS.Entertainment.UI.NetworkStatusService.isOnline())
                        promise = WinJS.Promise.wrap(false);
                    else
                        promise = this._isStreamingMediaItem(mediaItem).then(function isStreamingMediaItem_Completed(isStreamingMediaItem) {
                            if (isStreamingMediaItem && anonymousUser && featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlayAnonymous) && anonymousLimitReached)
                                MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.unauthenticatedTrackLimitExceeded);
                            return WinJS.Promise.wrap(isStreamingMediaItem)
                        }, function isStreamingMediaItem_Failed() {
                            return WinJS.Promise.wrap(true)
                        });
                    return promise
                }, skipAudioAdForNextTrack: {
                    get: function() {
                        return this._skipAudioAdForNextTrack
                    }, set: function(value) {
                            this._skipAudioAdForNextTrack = value
                        }
                }, sendAudioAdReasonClickTelemetryInfo: function sendAudioAdReasonClickTelemetryInfo() {
                    MS.Entertainment.Utilities.Telemetry.logAudioAdServiceEvent(MS.Entertainment.Music.Freeplay.Events.audioAdReasonClickThru, this._lastAudioAdMediaInstance, this._lastAudioAdMediaInstanceIsNext)
                }, sendVideoAdReasonClickTelemetryInfo: function sendVideoAdReasonClickTelemetryInfo() {
                    MS.Entertainment.Utilities.Telemetry.logVideoAdServiceEvent(MS.Entertainment.Music.Freeplay.Events.videoAdReasonClickThru, this._lastVideoAdMediaItemProperties)
                }, _stopPlaybackForAd: function _stopPlaybackForAd() {
                    if (this._videoAdPlaying) {
                        this._playbackSession.targetTransportState = MS.Entertainment.Platform.Playback.TransportState.stopped;
                        this._playbackSession.currentMedia = null;
                        var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                        if (appBarControl)
                            appBarControl.hide()
                    }
                }, _onUserStatusChanged: function _onUserStatusChanged() {
                    if (this._isFreePlayEnabled && this._signIn.isSignedIn && !this._signedInUser.isSubscription) {
                        if (this._lastSignedInState !== this._signIn.isSignedIn && this._initialized)
                            this.dispose();
                        this.initialize()
                    }
                    else {
                        this.dispose();
                        this._uiStateService.shouldShowAdsForFreePlay = this._isFreePlayEnabled && !this._configurationManager.service.lastSignedInUserSubscription
                    }
                }, _onInputReceived: function _onInputReceived() {
                    if (this._isFreePlayEnabled)
                        this._lastInteractionEventTime = Date.now()
                }, _onVisibilityChanged: function _onVisibilityChanged() {
                    if (this._isFreePlayEnabled && !document.hidden)
                        this._lastInteractionEventTime = Date.now()
                }, _handleNavigation: function _handleNavigation() {
                    if (this._appInSnappedMode === this._uiStateService.isSnapped && this._companionAdVisible) {
                        MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.adCompanionClosedOnNav);
                        this._hideCompanionAd()
                    }
                    this._appInSnappedMode = this._uiStateService.isSnapped
                }, _refreshAudioAd: function _refreshAudioAd() {
                    if (this._audioAdPackageRefreshTimer) {
                        this._audioAdPackageRefreshTimer.cancel();
                        this._audioAdPackageRefreshTimer = null
                    }
                    if (!this._adPlaying && !this._companionAdVisible) {
                        if (!this._networkOpenRequest)
                            this._networkOpenRequest = this._sessionManager.requestNetwork("AdService");
                        this._audioAdPackageRefreshing = false;
                        WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.networkOpenDelayMs).done(function refreshAdPackage() {
                            if (!this._adPlaying && !this._companionAdVisible && !this._audioAdPackageRefreshing) {
                                this._audioAdPackageRefreshTimer = WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.adRefreshPeriod).then(function refreshAudioAd() {
                                    if (this._audioAdPackageRefreshTimer)
                                        this._refreshAudioAd()
                                }.bind(this));
                                this._audioAdPackageRefreshing = true;
                                this._audioAdPackage.refresh();
                                this._eventProvider.traceAdService_AudioAdRefreshing()
                            }
                        }.bind(this))
                    }
                }, _refreshVideoAd: function _refreshVideoAd() {
                    if (this._videoAdPackageRefreshTimer) {
                        this._videoAdPackageRefreshTimer.cancel();
                        this._videoAdPackageRefreshTimer = null
                    }
                    this._videoAdPackageRefreshTimer = WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.adRefreshPeriod).then(function refreshVideoAd() {
                        if (this._videoAdPackageRefreshTimer)
                            this._refreshVideoAd()
                    }.bind(this));
                    this._videoAdPackageRefreshing = true;
                    this._videoAdPackage.refresh();
                    this._eventProvider.traceAdService_VideoAdRefreshing()
                }, _hideCompanionAd: function _hideCompanionAd() {
                    if (this._companionAdVisible) {
                        this._companionAdVisible = false;
                        MS.Entertainment.UI.Controls.AdCompanion.hideAdCompanion();
                        this._refreshAudioAd()
                    }
                }, _isStreamingTrack: function _isStreamingTrack(mediaInstance) {
                    var serviceId = mediaInstance && MS.Entertainment.Utilities.valueFromPropertyPathFragments(mediaInstance, ["_mediaItem", "data", "serviceId"]);
                    var isStreamingTrack = serviceId && !mediaInstance.isLocal && mediaInstance.protectionState === MS.Entertainment.Platform.Playback.ProtectionState.drmProtected;
                    if (isStreamingTrack && serviceId)
                        this._streamingTracks[serviceId] = true;
                    return isStreamingTrack
                }, _isStreamingMediaItem: function _isStreamingMediaItem(mediaItem, collectionFilter, isSmartDjPlayRequest) {
                    if (isSmartDjPlayRequest || mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.smartDJ || (this._freePlayLimits && this._freePlayLimits.isMonthlyFreeLimitExceeded) || (MS.Entertainment.Data.MainQuery.isQuery(mediaItem) && !MS.Entertainment.Data.Query.LibraryQueryBase.isLibraryQuery(mediaItem)))
                        return WinJS.Promise.wrap(true);
                    return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(mediaItem).then(function hydrateLibraryInfoCompleted() {
                            return MS.Entertainment.ViewModels.SmartBuyStateEngine.getPlayabilityAsync(mediaItem, collectionFilter).then(function getPlayabilityAsync_complete(playability) {
                                    if (mediaItem.inCollection && !playability.counts.cloudOnly)
                                        return WinJS.Promise.wrap(false);
                                    return MS.Entertainment.ViewModels.SmartBuyStateEngine.getMarketplaceFileAccessAsync(mediaItem).then(function marketplaceFileAccess_Complete(marketplaceInfo) {
                                            var returnPromise;
                                            var trackCount;
                                            switch (mediaItem.mediaType) {
                                                case Microsoft.Entertainment.Queries.ObjectType.track:
                                                    trackCount = 1;
                                                    break;
                                                case Microsoft.Entertainment.Queries.ObjectType.album:
                                                case Microsoft.Entertainment.Queries.ObjectType.person:
                                                    trackCount = mediaItem.totalTracks || mediaItem.totalTracksCount;
                                                    break
                                            }
                                            this._lastVideoAdMediaItemProperties = {
                                                trackCount: trackCount, hasPurchasedCount: marketplaceInfo.hasPurchased, localOnly: playability.counts.localOnly, cloudOnly: playability.counts.cloudOnly
                                            };
                                            return WinJS.Promise.wrap(marketplaceInfo.hasPurchased !== trackCount)
                                        }.bind(this), function marketplaceFileAccess_Failed() {
                                            return WinJS.Promise.wrap(!mediaItem.hasLocalContent)
                                        })
                                }.bind(this), function getPlayabilityAsync_failed() {
                                    return WinJS.Promise.wrap(!mediaItem.hasLocalContent)
                                })
                        }.bind(this), function hydrateLibraryInfoFailed() {
                            return WinJS.Promise.wrap(false)
                        })
                }, _onAudioAdRefreshed: function _onAudioAdRefreshed() {
                    this._audioAdPackageRefreshing = false;
                    if (this._audioAdPackageRefreshTimer) {
                        this._audioAdPackageRefreshTimer.cancel();
                        this._audioAdPackageRefreshTimer = null
                    }
                    if (this._networkOpenRequest) {
                        this._networkOpenRequest.release();
                        this._networkOpenRequest = null
                    }
                    if (!this._isValidDuration(this._audioAdPackage)) {
                        this._audioAdPackageRefreshTimer = WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.adRefreshPeriod).then(function refreshAudioAd() {
                            if (this._audioAdPackageRefreshTimer)
                                this._refreshAudioAd()
                        }.bind(this));
                        return
                    }
                    var audioAd = this._getBestAudioAd();
                    var adCompanionData = this._parseAdCompanions();
                    var adClickThrough = function adClickThrough() {
                            this._audioAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdClickThru);
                            MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.adCompanionClickThru);
                            this._hideCompanionAd()
                        }.bind(this);
                    var adCompanionClosed = function adCompanionClosed() {
                            MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.adCompanionClosed);
                            this._hideCompanionAd()
                        }.bind(this);
                    this._currentAudioAd = {
                        audioAd: audioAd, adCompanion: adCompanionData.adCompanion, appBarAdCompanion: adCompanionData.appBarAdDetails, adClickThroughCallback: adClickThrough, adCompanionClosedCallback: adCompanionClosed
                    };
                    this._eventProvider.traceAdService_AudioAdRefreshed()
                }, _isValidDuration: function _isValidDuration(adPackage) {
                    MS.Entertainment.UI.Music.assert(adPackage, "Invalid adPackage passed in");
                    var duration = MS.Entertainment.Utilities.valueFromPropertyPathFragments(adPackage, ["linearCreative", "Duration"]);
                    duration = duration && duration.replace(/\D/g, String.empty);
                    return (duration && duration < MS.Entertainment.UI.Music.AdService.adMaxDurationSec && !isNaN(duration))
                }, _parseAdCompanions: function _parseAdCompanions() {
                    var adCompanionData;
                    var appBarAdDetails;
                    var adCompanions = this._audioAdPackage.adCompanions;
                    var numberOfAdCompanions = (adCompanions && adCompanions.length) || 0;
                    for (var i = 0; i < numberOfAdCompanions; i++) {
                        var adCompanion = adCompanions[i];
                        if (!adCompanion || adCompanion.creativeType !== MS.Entertainment.UI.Music.AdService.adCompanionType)
                            continue;
                        var staticResource = adCompanion.StaticResource || String.empty;
                        var companionClickThrough = adCompanion.CompanionClickThrough || String.empty;
                        if (adCompanion.height === MS.Entertainment.UI.Music.AdService.adCompanionHeight && adCompanion.width === MS.Entertainment.UI.Music.AdService.adCompanionWidth)
                            adCompanionData = {
                                id: adCompanion.id, imageUrl: staticResource.replace(/^\s*|\s*$/g, String.empty), clickThroughUrl: companionClickThrough.replace(/^\s*|\s*$/g, String.empty)
                            };
                        else if (adCompanion.height === MS.Entertainment.UI.Music.AdService.appBarAdImageHeightWidth && adCompanion.width === MS.Entertainment.UI.Music.AdService.appBarAdImageHeightWidth)
                            appBarAdDetails = {
                                id: adCompanion.id, imageUrl: staticResource.replace(/^\s*|\s*$/g, String.empty), clickThroughUrl: companionClickThrough.replace(/^\s*|\s*$/g, String.empty)
                            }
                    }
                    return {
                            adCompanion: adCompanionData, appBarAdDetails: appBarAdDetails
                        }
                }, _onVideoAdRefreshed: function _onVideoAdRefreshed() {
                    this._videoAdPackageRefreshing = false;
                    if (this._videoAdPackageRefreshTimer) {
                        this._videoAdPackageRefreshTimer.cancel();
                        this._videoAdPackageRefreshTimer = null
                    }
                    if (!this._isValidDuration(this._videoAdPackage)) {
                        this._videoAdPackageRefreshTimer = WinJS.Promise.timeout(MS.Entertainment.UI.Music.AdService.adRefreshPeriod).then(function refreshVideoAd() {
                            if (this._videoAdPackageRefreshTimer)
                                this._refreshVideoAd()
                        }.bind(this));
                        return
                    }
                    var videoAd = this._getBestVideoAd();
                    var videoClickThrough = this._getVideoAdClickThrough();
                    var adClickThrough = function adClickThrough() {
                            this._videoAdPackage.reportEvent(MicrosoftNSJS.Advertising.AdPackage.eventType.AdClickThru)
                        }.bind(this);
                    this._currentVideoAd = {
                        videoAd: videoAd, clickThroughUrl: videoClickThrough, adClickThroughCallback: adClickThrough
                    };
                    this._eventProvider.traceAdService_VideoAdRefreshed()
                }, _onAdErrorOccurred: function _onAdErrorOccurred(ad, error) {
                    var errorCode = (error && error.errorCode) || String.empty;
                    var errorMessage = (error && error.errorMessage) || String.empty;
                    MS.Entertainment.UI.Music.fail("Ad Package Error\n\tError: {0}\n\tMessage: {1}".format(errorCode, errorMessage), null, MS.Entertainment.UI.Debug.errorLevel.low)
                }, _getAudioAdMediaItem: function _getAudioAdMediaItem() {
                    var appBarAdUrl = this._currentAudioAd.appBarAdCompanion && this._currentAudioAd.appBarAdCompanion.imageUrl;
                    var adUrl = this._currentAudioAd.audioAd && this._currentAudioAd.audioAd.url;
                    var audioAdMediaItem = MS.Entertainment.Data.augment({
                            isAudioAd: true, source: adUrl
                        }, MS.Entertainment.Data.Augmenter.Marketplace.Track);
                    audioAdMediaItem.name = String.load(String.id.IDS_ADVERTISEMENT);
                    audioAdMediaItem.imageUri = appBarAdUrl;
                    audioAdMediaItem.durationString = String.empty;
                    audioAdMediaItem.releaseYear = String.empty;
                    return audioAdMediaItem
                }, _getBestAudioAd: function _getBestAudioAd() {
                    var audioAd;
                    audioAd = MS.Entertainment.Utilities.valueFromPropertyPathFragments(this._audioAdPackage, ["linearCreative", "MediaFiles"]);
                    if (audioAd)
                        audioAd = audioAd.reduce(function getAudioAdFromMediaFiles(previousValue, currentValue) {
                            if (currentValue && currentValue.delivery === MS.Entertainment.UI.Music.AdService.audioAdDelivery && currentValue.type === MS.Entertainment.UI.Music.AdService.audioAdType)
                                if (!previousValue || previousValue.bitrate < currentValue.bitrate)
                                    return currentValue;
                            return previousValue
                        });
                    MS.Entertainment.UI.Music.assert(audioAd, "No Audio Ad found");
                    return audioAd
                }, _getBestVideoAd: function _getBestVideoAd() {
                    var videoAd;
                    videoAd = MS.Entertainment.Utilities.valueFromPropertyPathFragments(this._videoAdPackage, ["linearCreative", "MediaFiles"]);
                    if (videoAd)
                        videoAd = videoAd.reduce(function getVideoAdFromMediaFiles(previousValue, currentValue) {
                            if (this._isValidAd(currentValue))
                                if (!this._isValidAd(previousValue) || previousValue.bitrate < currentValue.bitrate)
                                    return currentValue;
                            return previousValue
                        }.bind(this));
                    MS.Entertainment.UI.Music.assert(videoAd, "No Video Ad found");
                    return videoAd
                }, _isValidAd: function _isValidAd(ad) {
                    return (ad && ad.delivery === MS.Entertainment.UI.Music.AdService.videoAdDelivery && ad.type === MS.Entertainment.UI.Music.AdService.videoAdType)
                }, _getVideoAdClickThrough: function _getVideoAdClickThrough() {
                    var clickThroughUrl;
                    var videoAdClickThrough = MS.Entertainment.Utilities.valueFromPropertyPathFragments(this._videoAdPackage, ["linearCreative", "VideoClicks", "ClickThrough", "url"]);
                    if (videoAdClickThrough)
                        clickThroughUrl = videoAdClickThrough.replace(/^\s*|\s*$/g, String.empty);
                    return clickThroughUrl
                }, _currentMediaChanged: function _currentMediaChanged() {
                    if (this._currentOrdinalChangedCallback) {
                        this._currentOrdinalChangedCallback.cancel();
                        this._currentOrdinalChangedCallback = null
                    }
                    this._currentPlaybackSessionOrdinal = this._playbackSession.currentOrdinal;
                    if (!this._playbackSession.currentMedia)
                        return;
                    else if (this._playbackSession.currentMedia.isAudioAd) {
                        this._currentMediaType = MS.Entertainment.UI.Music.AdService.currentMediaType.audioAd;
                        this._adPlaying = false;
                        if (this._playbackSession.currentMedia.imageUri)
                            MS.Entertainment.UI.Shell.ImageLoader.getServiceImageUrl(this._playbackSession.currentMedia, 100, 100).done(function gotAlbumArt(uri) {
                                var previousAlbumArt = Windows.Media.MediaControl.albumArt;
                                try {
                                    var artUri = new Windows.Foundation.Uri(uri);
                                    Windows.Media.MediaControl.albumArt = artUri;
                                    this._mediaControlArtOverridden = true
                                }
                                catch(e) {
                                    try {
                                        Windows.Media.MediaControl.albumArt = previousAlbumArt
                                    }
                                    catch(e) {}
                                }
                            }.bind(this))
                    }
                    else if (this._streamingTracks[this._playbackSession.currentMedia.serviceId]) {
                        this._currentMediaType = MS.Entertainment.UI.Music.AdService.currentMediaType.streamingTrack;
                        this._eventProvider.traceAdService_StreamingTrackPlaying()
                    }
                    else {
                        this._currentMediaType = MS.Entertainment.UI.Music.AdService.currentMediaType.unknown;
                        this._eventProvider.traceAdService_TrackPlaying()
                    }
                    if (this._currentMediaType !== MS.Entertainment.UI.Music.AdService.currentMediaType.audioAd) {
                        if (this._adPlaying) {
                            this._adPlaying = false;
                            this._hideCompanionAd()
                        }
                        if (this._mediaControlArtOverridden) {
                            MS.Entertainment.UI.Shell.ImageLoader.getServiceImageUrl(this._playbackSession.currentMedia, 100, 100).done(function gotAlbumArt(uri) {
                                try {
                                    var artUri = new Windows.Foundation.Uri(uri);
                                    Windows.Media.MediaControl.albumArt = artUri
                                }
                                catch(e) {
                                    try {
                                        Windows.Media.MediaControl.albumArt = null
                                    }
                                    catch(e) {}
                                }
                            });
                            this._mediaControlArtOverridden = false
                        }
                    }
                }, _currentPositionChanged: function _currentPositionChanged(newValue, oldValue) {
                    if (this._currentMediaType === MS.Entertainment.UI.Music.AdService.currentMediaType.audioAd) {
                        if (!this._adPlaying && newValue > 0)
                            this.audioAdPlaying();
                        else if (this._adPlaying && this._playbackSession.currentPosition && this._playbackSession.duration && this._playbackSession.currentPosition >= (this._playbackSession.duration - MS.Entertainment.UI.Music.AdService.audioAdDurationDelta)) {
                            this.audioAdPlayed();
                            this._currentMediaType = MS.Entertainment.UI.Music.AdService.currentMediaType.unknown
                        }
                    }
                    else if (this._currentMediaType === MS.Entertainment.UI.Music.AdService.currentMediaType.streamingTrack && this._playbackSession.currentPosition >= MS.Entertainment.UI.Music.AdService.streamingTrackThreshold) {
                        this.streamingTrackPlayed();
                        this._currentMediaType = MS.Entertainment.UI.Music.AdService.currentMediaType.unknown;
                        delete this._streamingTracks[this._playbackSession.currentMedia.serviceId]
                    }
                }, _setUpSessionBindings: function _setUpSessionBindings() {
                    var currentPositionChanged = this._currentPositionChanged.bind(this);
                    var currentMediaChanged = this._currentMediaChanged.bind(this);
                    var currentOrdinalChanged = this._onCurrentOrdinalChanged.bind(this);
                    var currentTransportStateChanged = this._onCurrentTransportStateChanged.bind(this);
                    if (this._playbackSessionBindings) {
                        this._playbackSessionBindings.cancel();
                        this._playbackSessionBindings = null
                    }
                    this._playbackSessionBindings = WinJS.Binding.bind(this._playbackSession, {
                        currentPosition: currentPositionChanged, currentMedia: currentMediaChanged, currentOrdinal: currentOrdinalChanged, currentTransportState: currentTransportStateChanged
                    })
                }, _onCurrentTransportStateChanged: function _onCurrentTransportStateChanged(newState) {
                    if (this._playbackSession.currentTransportState !== MS.Entertainment.Platform.Playback.TransportState.stopped)
                        this._stopPlaybackForAd();
                    if (this._inputHandler && (newState === MS.Entertainment.Platform.Playback.TransportState.playing))
                        this._inputHandler()
                }, _onCurrentOrdinalChanged: function _onCurrentOrdinalChanged(newOrdinal) {
                    if (newOrdinal !== null) {
                        if (this._emptyRoomDialogVisible)
                            this._playbackSession.targetTransportState = MS.Entertainment.Platform.Playback.TransportState.paused;
                        this._currentOrdinalChangedCallback = WinJS.Promise.timeout(500).then(function _currentOrdinalChanged() {
                            if (this._currentPlaybackSessionOrdinal !== newOrdinal)
                                this._currentMediaChanged()
                        }.bind(this))
                    }
                }, _onNetworkStatusChanged: function _onNetworkStatusChanged(newValue) {
                    if (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unrestricted) {
                        if (!this._audioAdPackageRefreshing && !this._audioAdPackage.linearCreative)
                            this._refreshAudioAd();
                        if (!this._videoAdPackageRefreshing && !this._videoAdPackage.linearCreative)
                            this._refreshVideoAd()
                    }
                }, _sendEmptyRoomToast: function _sendEmptyRoomToast() {
                    try {
                        var notifications = Windows.UI.Notifications;
                        var notificationManager = notifications.ToastNotificationManager;
                        var toastXml = notificationManager.getTemplateContent(notifications.ToastTemplateType.toastText02);
                        var textNodes = toastXml.getElementsByTagName("text");
                        textNodes[0].appendChild(toastXml.createTextNode(String.load(String.id.IDS_MUSIC_STREAMING_EMPTY_ROOM_NOTIFICATION_LINE1)));
                        textNodes[1].appendChild(toastXml.createTextNode(String.load(String.id.IDS_MUSIC_STREAMING_EMPTY_ROOM_NOTIFICATION_LINE2)));
                        var toast = new notifications.ToastNotification(toastXml);
                        toast.addEventListener("activated", function toastNotificationActivate() {
                            var appView = Windows.UI.ViewManagement.ApplicationView;
                            var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                            if (uiStateService.isSnapped)
                                appView.tryUnsnap()
                        }.bind(this));
                        notificationManager.createToastNotifier().show(toast)
                    }
                    catch(exception) {
                        MS.Entertainment.Music.fail("Failure in calls to ToastNotificationManager: " + exception)
                    }
                }
        }, {
            _getAdApplicationId: function _getAdApplicationId(ad) {
                var adApplicationId;
                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                adApplicationId = configurationManager.ads.musicAdApplicationId;
                MS.Entertainment.UI.Music.assert(adApplicationId, "Ad configuration application id not found for: configuration.ads.musicAdApplicationId");
                return adApplicationId
            }, _getAdUnitId: function _getAdUnitId(adUnitType) {
                    var adIds = String.empty;
                    var adUnitId;
                    var regionCode;
                    var languageCode;
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    var globalizationManager = new Microsoft.Entertainment.Util.GlobalizationManager;
                    regionCode = globalizationManager.getRegion();
                    var resourceLanguage = MS.Entertainment.Utilities.getResourceLanguage();
                    languageCode = MS.Entertainment.Utilities.getLanguageFromLocale(resourceLanguage);
                    adIds = configurationManager.ads[adUnitType];
                    MS.Entertainment.UI.Components.Shell.assert(adIds, "Ad configuration unit ids not found: configuration.ads." + adUnitType);
                    if (adIds) {
                        adUnitId = MS.Entertainment.Utilities.getValueFromCsvList(adIds, languageCode + "-" + regionCode);
                        if (!adUnitId)
                            adUnitId = MS.Entertainment.Utilities.getValueFromCsvList(adIds, regionCode)
                    }
                    return adUnitId
                }, currentMediaType: {
                    audioAd: "audioAd", streamingTrack: "streamingTrack", unknown: "unknown"
                }, adMaxDurationSec: 39, audioAdDurationDelta: 1000, adRefreshPeriod: 300000, streamingTrackThreshold: 30000, audioAdDelivery: "progressive", audioAdType: "audio/mpeg", videoAdDelivery: "progressive", videoAdType: "video/mp4", adCompanionType: "image/jpeg", adCompanionHeight: 250, adCompanionWidth: 300, appBarAdImageHeightWidth: 90, adCompanionTimeoutInMs: 30000, audioAdUnitIdConfig: "musicAudioAdUnitIds", videoAdUnitIdConfig: "musicVideoAdUnitIds", networkOpenDelayMs: 300, adPackageReportDelayMs: 2000
        })});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.adService, function AdServiceFactory() {
        return new MS.Entertainment.UI.Music.AdService
    })
})()
