﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(undefined) {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Actions");
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {AddTo: MS.Entertainment.deferredDerive(MS.Entertainment.UI.Actions.Action, function addTo() {
            this.base();
            this.maxFlyoutItems = MS.Entertainment.Utilities.isApp2 ? 6 : -1;
            Object.defineProperty(this, "referenceContainer", {
                get: this._getReferenceContainer, set: this._setReferenceContainer
            })
        }, {
            deferredSubActions: null, hasSubActions: true, subMenuIds: null, maxFlyoutItems: 0, _executedPromise: null, _populateSubMenuPromise: null, _referenceContainer: null, _lastPlaylistRevisionNum: -1, _getReferenceContainer: function _getReferenceContainer() {
                    return this._referenceContainer
                }, _setReferenceContainer: function _setReferenceContainer(value) {
                    if (this._referenceContainer !== value) {
                        this._referenceContainer = value;
                        this._updateReferenceContainer()
                    }
                }, executed: function executed(param, referenceElement) {
                    if (this._executedPromise)
                        return WinJS.Promise.unwrap(this._executedPromise);
                    var mediaItem = this.parameter.mediaItem;
                    if (!mediaItem) {
                        var appToolbarService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                        mediaItem = appToolbarService.currentMediaContext.mediaItem
                    }
                    if (referenceElement)
                        MS.Entertainment.Utilities.Telemetry.logPageAction({domElement: referenceElement}, {
                            uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Dash
                        });
                    if (this._hasPlaylistQueryRefreshed()) {
                        var populateSubMenuPromise = WinJS.Binding.unwrap(this._populateSubMenuPromise);
                        if (populateSubMenuPromise) {
                            populateSubMenuPromise.cancel();
                            populateSubMenuPromise = null
                        }
                        this._populateSubMenuPromise = this.populateSubMenu(this.subMenuIds)
                    }
                    MS.Entertainment.UI.Actions.assert(this._populateSubMenuPromise, "execute called before subActions were set");
                    var populateSubMenuPromise = WinJS.Binding.unwrap(this._populateSubMenuPromise).then(function updateList() {
                            if (this.deferredSubActions) {
                                this.subActions = this.deferredSubActions;
                                this.deferredSubActions = null
                            }
                        }.bind(this));
                    if (MS.Entertainment.Utilities.isMusicApp2)
                        this._executedPromise = populateSubMenuPromise.then(function populated() {
                            for (var i = 0; i < this.subActions.length; i++)
                                if (!this.subActions[i].skipOnCompletedHandler)
                                    this.subActions[i].action.onComplete = MS.Entertainment.UI.Actions.AddTo.onCompleteHandler;
                            var mediaItemTitle = mediaItem.primaryText || mediaItem.title;
                            var contextualData = {
                                    title: String.load(String.id.IDS_MUSIC_ADD_TO_LIST_TITLE).format(mediaItemTitle), subTitle: String.empty, commands: this.subActions
                                };
                            return MS.Entertainment.UI.Controls.CommandingPopOver.showContextualCommands(contextualData)
                        }.bind(this), function onError(error) {
                            MS.Entertainment.UI.Actions.fail("populateSubMenuItemsPromise failed: " + error && error.message)
                        });
                    else {
                        for (var i = 0; this.subActions && i < this.subActions.length; i++)
                            this.subActions[i].action.onExecuting = MS.Entertainment.UI.Actions.AddTo.onExecutingHandler;
                        this._executedPromise = populateSubMenuPromise
                    }
                    return WinJS.Binding.unwrap(this._executedPromise).then(function onAddToCompleted() {
                            this._executedPromise = null
                        }.bind(this))
                }, canExecute: function canExecute(param) {
                    return true
                }, setSubActions: function setSubActions(subMenuIds) {
                    var populateSubMenuPromise = WinJS.Binding.unwrap(this._populateSubMenuPromise);
                    if (populateSubMenuPromise) {
                        populateSubMenuPromise.cancel();
                        populateSubMenuPromise = null;
                        this._populateSubMenuPromise = null
                    }
                    this.subMenuIds = subMenuIds;
                    this._populateSubMenuPromise = this.populateSubMenu(subMenuIds)
                }, populateSubMenu: function populateSubMenu(subMenuIds) {
                    var mediaItems = this.parameter.mediaItem;
                    if (!mediaItems) {
                        var appToolbarService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                        mediaItems = appToolbarService.currentMediaContext.mediaItem
                    }
                    var initializeMediaItemsPromise = WinJS.Promise.as();
                    if (MS.Entertainment.Data.MainQuery.isQuery(mediaItems))
                        initializeMediaItemsPromise = mediaItems.getItems().then(function gotItems(items) {
                            mediaItems = items
                        }, function queryFailed(error) {
                            MS.Entertainment.UI.assert(WinJS.Promise.isCanceledError(error), "Media query failed: " + (error && error.message));
                            mediaItems = null
                        });
                    return initializeMediaItemsPromise.then(MS.Entertainment.UI.Actions.AddTo.getRecentPlaylists).then(function gotRecentPlaylists() {
                            return mediaItems ? MS.Entertainment.Data.List.listToArray(mediaItems) : WinJS.Promise.as([])
                        }).then(function populateSubMenu(mediaItemArray) {
                            var subItems = [];
                            var actionsToAdd = {};
                            var playlistLibraryId = -1;
                            var addOtherPlaylistAction = false;
                            var recentPlaylists;
                            var isPopoverOpen;
                            var addSeperators;
                            this._lastPlaylistRevisionNum = -1;
                            if (mediaItemArray.length > 0 && mediaItemArray[0])
                                if (mediaItemArray[0].mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist)
                                    playlistLibraryId = mediaItemArray[0].libraryId;
                                else if (mediaItemArray[0].mediaType === Microsoft.Entertainment.Queries.ObjectType.track && mediaItemArray[0].playlistItemId >= 0)
                                    playlistLibraryId = mediaItemArray[0].playlistId;
                            addSeperators = MS.Entertainment.Utilities.isMusicApp1;
                            subMenuIds.forEach(function addId(id) {
                                MS.Entertainment.UI.assert(id, "Missing action Id");
                                actionsToAdd[id] = true
                            });
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToCloud])
                                subItems.push(MS.Entertainment.UI.Actions.AddTo.createAddToCloud(mediaItems));
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToMyMusic])
                                subItems.push(MS.Entertainment.UI.Actions.AddTo.createAddToMyMusicAction(mediaItems));
                            if (subMenuIds.length > 1 && subItems.length > 0)
                                if (subItems.length > 0 && addSeperators)
                                    subItems.push(MS.Entertainment.UI.Controls.ActionList.getSeparatorAction());
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToNowPlaying]) {
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addLocalArtistToNowPlaying], "Conflicting action added to subMenu");
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addMarketplaceArtistToNowPlaying], "Conflicting action added to subMenu");
                                subItems.push(MS.Entertainment.UI.Actions.AddTo.createAddToNowPlayingAction(mediaItems))
                            }
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addLocalArtistToNowPlaying]) {
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToNowPlaying], "Conflicting action added to subMenu");
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addMarketplaceArtistToNowPlaying], "Conflicting action added to subMenu");
                                subItems.push(MS.Entertainment.UI.Actions.AddTo.createAddLocalArtistToNowPlayingAction(mediaItems))
                            }
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addMarketplaceArtistToNowPlaying]) {
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToNowPlaying], "Conflicting action added to subMenu");
                                MS.Entertainment.UI.assert(!actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addLocalArtistToNowPlaying], "Conflicting action added to subMenu");
                                subItems.push(MS.Entertainment.UI.Actions.AddTo.createAddMarketplaceArtistToNowPlayingAction(mediaItems))
                            }
                            if (actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToPlaylist] || actionsToAdd[MS.Entertainment.UI.Actions.AddTo.subMenuIds.addTrackToPlaylist]) {
                                var createNewPlaylist = MS.Entertainment.UI.Actions.Playlists.getCreatePlaylistFlyoutAction(mediaItems, function disableCommandingPopover() {
                                        MS.Entertainment.UI.Actions.AddTo.onCompleteHandler()
                                    });
                                createNewPlaylist.skipOnCompletedHandler = true;
                                if (MS.Entertainment.Utilities.isMusicApp2) {
                                    createNewPlaylist.action.title = String.load(String.id.IDS_MUSIC2_ADD_TO_NEW_PLAYLIST_BUTTON_VUI_GUI);
                                    createNewPlaylist.action.voicePhraseStringId = String.id.IDS_MUSIC2_ADD_TO_NEW_PLAYLIST_BUTTON_VUI_ALM;
                                    createNewPlaylist.action.voicePhoneticPhraseStringId = String.id.IDS_MUSIC2_ADD_TO_NEW_PLAYLIST_BUTTON_VUI_PRON
                                }
                                subItems.push(createNewPlaylist);
                                recentPlaylists = MS.Entertainment.UI.Actions.AddTo.recentPlaylists || [];
                                isPopoverOpen = MS.Entertainment.UI.Controls.PopOver.isPopoverOpen || MS.Entertainment.UI.Controls.NavigationPopover.isPopoverOpen;
                                this._lastPlaylistRevisionNum = MS.Entertainment.UI.Actions.AddTo.playlistQueryRevisionNum;
                                for (var i = 0; i < recentPlaylists.length; i++) {
                                    var playlist = recentPlaylists[i];
                                    if (!isPopoverOpen || playlist.libraryId !== playlistLibraryId)
                                        subItems.push(MS.Entertainment.UI.Actions.Playlists.getAddToPlaylistMenuAction(playlist, playlist.name, null, mediaItems))
                                }
                                if (MS.Entertainment.UI.Actions.AddTo.recentPlaylistsGreaterThanMax)
                                    if (MS.Entertainment.Utilities.isMusicApp2)
                                        addOtherPlaylistAction = true;
                                    else {
                                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                                        addOtherPlaylistAction = !uiStateService.isSnapped
                                    }
                                if (this.maxFlyoutItems > 0) {
                                    var startValue = this.maxFlyoutItems;
                                    var itemsToRemove;
                                    if (addOtherPlaylistAction)
                                        startValue--;
                                    itemsToRemove = subItems.length - startValue;
                                    subItems.splice(startValue, itemsToRemove)
                                }
                                if (addOtherPlaylistAction) {
                                    var anotherPlaylistAction = MS.Entertainment.UI.Actions.AddTo.createAnotherPlaylistAction(mediaItems);
                                    anotherPlaylistAction.action.parameter = {mediaItem: mediaItems};
                                    subItems.push(anotherPlaylistAction)
                                }
                            }
                            this.deferredSubActions = subItems;
                            this._updateReferenceContainer()
                        }.bind(this))
                }, _hasPlaylistQueryRefreshed: function _hasPlaylistQueryRefreshed() {
                    return (this._lastPlaylistRevisionNum > 0 && this._lastPlaylistRevisionNum !== MS.Entertainment.UI.Actions.AddTo.playlistQueryRevisionNum)
                }, _updateReferenceContainer: function _updateReferenceContainer() {
                    if (this.subActions)
                        this.subActions.forEach(function(subItem) {
                            if (subItem && subItem.action)
                                subItem.action.referenceContainer = this.referenceContainer
                        }, this)
                }
        }, {
            createAddToMyMusicAction: function createAddToMyMusicAction(mediaItems) {
                var addToMyMusicAction = MS.Entertainment.ViewModels.SmartAppbarActions.createAddToMyMusicAppbarAction();
                addToMyMusicAction.action.parameter = addToMyMusicAction.action.parameter || {};
                addToMyMusicAction.action.parameter.mediaItem = mediaItems;
                addToMyMusicAction.action.parameter.isFlyoutAction = true;
                return addToMyMusicAction
            }, createAddToNowPlayingAction: function createAddToNowPlayingAction(mediaItems) {
                    var addToNowPlayingAction = MS.Entertainment.ViewModels.SmartAppbarActions.createAddToNowPlayingAppbarAction();
                    addToNowPlayingAction.action.parameter = addToNowPlayingAction.action.parameter || {};
                    addToNowPlayingAction.action.parameter.mediaItem = mediaItems;
                    addToNowPlayingAction.action.parameter.isFlyoutAction = true;
                    return addToNowPlayingAction
                }, createAddLocalArtistToNowPlayingAction: function createAddLocalArtistToNowPlayingAction(mediaItems) {
                    var addToNowPlayingAction = MS.Entertainment.ViewModels.SmartAppbarActions.createAddToNowPlayingAppbarAction(MS.Entertainment.UI.AppBarActions.addLocalArtistToNowPlaying);
                    addToNowPlayingAction.action.parameter = addToNowPlayingAction.action.parameter || {};
                    addToNowPlayingAction.action.parameter.mediaItem = mediaItems;
                    addToNowPlayingAction.action.parameter.isFlyoutAction = true;
                    return addToNowPlayingAction
                }, createAddMarketplaceArtistToNowPlayingAction: function createAddMarketplaceArtistToNowPlayingAction(mediaItems) {
                    var addToNowPlayingAction = MS.Entertainment.ViewModels.SmartAppbarActions.createAddToNowPlayingAppbarAction(MS.Entertainment.UI.AppBarActions.addMarketplaceArtistToNowPlaying);
                    addToNowPlayingAction.action.parameter = addToNowPlayingAction.action.parameter || {};
                    addToNowPlayingAction.action.parameter.mediaItem = mediaItems;
                    addToNowPlayingAction.action.parameter.isFlyoutAction = true;
                    return addToNowPlayingAction
                }, createAddToCloud: function createAddToCloud(mediaItems) {
                    var addToCloudAction = MS.Entertainment.ViewModels.SmartAppbarActions.createAddToCloudAppbarAction();
                    addToCloudAction.action.parameter = addToCloudAction.action.parameter || {};
                    addToCloudAction.action.parameter.mediaItem = mediaItems;
                    return addToCloudAction
                }, createAnotherPlaylistAction: function createAnotherPlaylistAction(mediaItems) {
                    var pickPlaylistAction;
                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                    if (MS.Entertainment.Utilities.isMusicApp1) {
                        pickPlaylistAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.pickPlaylist);
                        pickPlaylistAction.title = String.load(String.id.IDS_MUSIC_ADD_TO_LIST_PLAYLIST_ACTION)
                    }
                    else {
                        pickPlaylistAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.selectPlaylist);
                        pickPlaylistAction.action = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.addToPlaylist);
                        pickPlaylistAction.galleryClass = "addToActionGallery";
                        pickPlaylistAction.action.callback = function navigateBack() {
                            var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                            navigationService.navigateBack()
                        };
                        pickPlaylistAction.title = String.load(String.id.IDS_MUSIC2_ADD_TO_ANOTHER_PLAYLIST_BUTTON_VUI_GUI);
                        pickPlaylistAction.voicePhraseStringId = String.id.IDS_MUSIC2_ADD_TO_ANOTHER_PLAYLIST_BUTTON_VUI_ALM;
                        pickPlaylistAction.voicePhoneticPhraseStringId = String.id.IDS_MUSIC2_ADD_TO_ANOTHER_PLAYLIST_BUTTON_VUI_PRON
                    }
                    pickPlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.flyoutOtherPlaylist;
                    pickPlaylistAction.icon = MS.Entertainment.UI.Icon.addToPlaylist;
                    pickPlaylistAction.id = MS.Entertainment.UI.AppBarActions.addToOtherPlaylist;
                    pickPlaylistAction.parameter = {mediaItem: mediaItems};
                    return {action: pickPlaylistAction}
                }, onExecutingHandler: function onExecutingHandler() {
                    var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                    if (appBarControl)
                        appBarControl.hide();
                    return WinJS.Promise.timeout()
                }, onCompleteHandler: function onCompleteHandler() {
                    if (MS.Entertainment.UI.Controls.CommandingPopOver) {
                        var addingLabel = String.load(String.id.IDS_MUSIC2_PANEL_ADD_ADDING);
                        MS.Entertainment.UI.Controls.CommandingPopOver.disableCurrentCommandingPopover(addingLabel)
                    }
                }, unload: function unload() {
                    MS.Entertainment.UI.Actions.AddTo.recentPlaylists = [];
                    if (MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise) {
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise.cancel();
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise = null
                    }
                    if (MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults)
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults = null
                }, getRecentPlaylists: function getRecentPlaylists() {
                    if (MS.Entertainment.UI.Actions.AddTo.recentPlaylists)
                        return WinJS.Promise.wrap(MS.Entertainment.UI.Actions.AddTo.recentPlaylists);
                    if (MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise)
                        return MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise;
                    var recentPlaylistQuery = new MS.Entertainment.Data.Query.libraryPlaylists;
                    recentPlaylistQuery.isLive = true;
                    recentPlaylistQuery.sort = Microsoft.Entertainment.Queries.PlaylistsSortBy.dateEditedDescending;
                    recentPlaylistQuery.chunkSize = MS.Entertainment.UI.Actions.AddTo.maxRecentPlaylists * 2;
                    recentPlaylistQuery.chunked = false;
                    MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise = recentPlaylistQuery.getItems().then(function getResults(items) {
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults = items;
                        var handlePlaylistListNotifications = MS.Entertainment.UI.Actions.AddTo._handleRecentPlaylistsListNotifications;
                        var handlePlaylistsChangedNotifications = MS.Entertainment.UI.Actions.AddTo._handleRecentPlaylistsDataChangeNotifications;
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults.setNotificationHandler(new MS.Entertainment.UI.Actions.Playlists.playlistDataNotificationHandler(handlePlaylistListNotifications, handlePlaylistsChangedNotifications));
                        return MS.Entertainment.UI.Actions.AddTo._refreshRecentPlaylistArray()
                    }, function onError(error) {
                        if (!error || error.message !== "Canceled")
                            MS.Entertainment.UI.fail("library playlist query failed: " + (error && error.message));
                        MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise = null;
                        return []
                    });
                    return WinJS.Promise.as(MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise)
                }, playlistQueryRevisionNum: 0, recentPlaylists: null, recentPlaylistQueryPromise: null, recentPlaylistQueryResults: null, recentPlaylistsGreaterThanMax: false, maxRecentPlaylists: 4, _handleRecentPlaylistsListNotifications: function _handleRecentPlaylistsListNotifications(indices) {
                    for (var i = 0; i < indices.length; i++)
                        if (indices[i] < MS.Entertainment.UI.Actions.AddTo.maxRecentPlaylists) {
                            WinJS.Promise.timeout(50).done(function delay() {
                                MS.Entertainment.UI.Actions.AddTo._refreshRecentPlaylistArray()
                            });
                            return
                        }
                }, _handleRecentPlaylistsDataChangeNotifications: function _handleRecentPlaylistsDataChangeNotifications(changedItems) {
                    for (var i = 0; i < changedItems.length; i++)
                        for (var j = 0; j < MS.Entertainment.UI.Actions.AddTo.recentPlaylists.length; j++)
                            if (MS.Entertainment.UI.Actions.AddTo.recentPlaylists[j].libraryId === changedItems[i].data.libraryId && MS.Entertainment.UI.Actions.AddTo.recentPlaylists[j].name !== changedItems[i].data.name)
                                MS.Entertainment.UI.Actions.AddTo._refreshRecentPlaylistArray()
                }, _refreshRecentPlaylistArray: function _refreshRecentPlaylistArray() {
                    if (!MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults)
                        return WinJS.Promise.wrap();
                    MS.Entertainment.UI.Actions.AddTo.recentPlaylistsGreaterThanMax = MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults.count > MS.Entertainment.UI.Actions.AddTo.maxRecentPlaylists;
                    return MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryResults.toArrayAll(0, MS.Entertainment.UI.Actions.AddTo.maxRecentPlaylists).then(function gotArray(playlistItems) {
                            MS.Entertainment.UI.Actions.AddTo.recentPlaylists = playlistItems;
                            MS.Entertainment.UI.Actions.AddTo.playlistQueryRevisionNum++;
                            MS.Entertainment.UI.Actions.AddTo.recentPlaylistQueryPromise = null;
                            return MS.Entertainment.UI.Actions.AddTo.recentPlaylists
                        }, function onError(error) {
                            var message = error && error.message;
                            MS.Entertainment.UI.fail("toArray failed: " + message);
                            return []
                        })
                }, subMenuIds: {
                    addToMyMusic: "addToMyMusic", addTrackToPlaylist: "addTrackToPlaylist", addToPlaylist: "addToPlaylist", addToNowPlaying: "addToNowPlaying", addLocalArtistToNowPlaying: "addLocalArtistToNowPlaying", addMarketplaceArtistToNowPlaying: "addMarketplaceArtistToNowPlaying", addToCloud: "addToCloud"
                }
        })});
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.addTo, function() {
        return new MS.Entertainment.UI.Actions.AddTo
    })
})()
