﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.ViewModels");
    WinJS.Namespace.define("MS.Entertainment.ViewModels.SmartAppbarActions", {
        defaultActions: {
            _defaultActions: null, get: function() {
                    if (!MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions && !MS.Entertainment.Utilities.isApp2)
                        MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions = [MS.Entertainment.UI.AppBarActions.openFile];
                    return MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions
                }
        }, setDefaultGalleryEventHandlers: function setDefaultGalleryEventHandlers(clearSelectionCallback, removeCompleteCallback) {
                var eventHandlers = {};
                if (clearSelectionCallback) {
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToNowPlaying] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToPlaylist] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToMyMusic] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToOtherPlaylist] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.artistDetails] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.clearSelection] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.createNewPlaylist] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.exploreAlbum] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.playSelection] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteMedia] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteSmartDJ] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deletePlaylist] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.downloadFromMarketplace] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.subscriptionDownload] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.tryDownloadAgain] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.renamePlaylist] = clearSelectionCallback
                }
                if (removeCompleteCallback) {
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteMedia] = removeCompleteCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deletePlaylist] = removeCompleteCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.removeFromPlaylist] = removeCompleteCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.removeFromList] = removeCompleteCallback
                }
                return eventHandlers
            }, _appBarActions: null, getAppbarActions: function getAppbarActions() {
                if (MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions)
                    return MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions;
                if (MS.Entertainment.Utilities.isMusicApp1)
                    MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions = [MS.Entertainment.UI.Components.Shell.OpenFileAction.getOpenFileAction(), this.createPlaySelectionAppbarAction(MS.Entertainment.UI.AppBarActions.playContinuous), this.createPlaySelectionAppbarAction(MS.Entertainment.UI.AppBarActions.playSelection), this.createPlaySelectionAppbarAction(MS.Entertainment.UI.AppBarActions.previewSelection), this.createPlaySelectionAppbarAction(MS.Entertainment.UI.AppBarActions.playSelectionContinuous), this.createPlayTopSongsAppbarAction(), this.createTrackPlayPreviewAppbarAction(), this.createSaveNowPlayingPlaylistAppbarAction(), this.createAddToAppbarAction(String.id.IDS_MUSIC_ADD_TO_LIST_BUTTON), this.createRemoveFromPlaylistAppbarAction(), this.createRemoveFromNowPlayingAppbarAction(), this.createRemoveFromListAppbarAction(), this.createMoveListItemUpAppbarAction(), this.createMoveListItemDownAppbarAction(), this.createPlaySmartDJAppbarAction(), this.createArtistDetailsAppbarAction(), this.createCollectionTrackAlbumPopoverAppbarAction(), this.createRemoveDownloadAppbarAction(), this.createTryDownloadAgainAppbarAction(), this.createPurchaseTrackAppbarAction(), this.createPurchaseAlbumAppbarAction(), this.createRenamePlaylistAppbarAction(), this.createDeletePlaylistAppbarAction(), this.createImportPlaylistAppbarAction(), this.createPlayOnXboxAppbarAction(MS.Entertainment.UI.AppBarActions.playTrackOnXbox360), this.createPlayOnXboxAppbarAction(), this.createPinToStartScreenAction(), this.createUnpinFromStartScreenAction(), this.createDownloadFromMarketplaceAppbarAction(), this.createSubscriptionDownloadAppbarAction(), this.createDeleteMediaAppbarAction(), this.createDeleteSmartDJAppbarAction(), this.createMediaPropertiesAppbarAction(), this.createFindAlbumInfoAppbarAction(), this.createShowPlaylistItemInformationAppbarAction(), this.createClearSelectionAppbarAction(), this.createSubscriptionSignupAction()];
                else
                    MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions = [this.createPlaySelectionAppbarAction(MS.Entertainment.UI.AppBarActions.playContinuous), this.createTrackPlayPreviewAppbarAction(), this.createAddSongToAppbarAction(), this.createRemoveFromPlaylistAppbarAction(), this.createRemoveFromNowPlayingAppbarAction(), this.createPlaySmartDJAppbarAction(), this.createArtistDetailsAppbarAction(), this.createRenamePlaylistAppbarAction(), this.createDeleteMediaAppbarAction(), ];
                return MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions
            }, getMusicMultiSelectActions: function getMusicMultiSelectActions(firstMediaItem) {
                var actions = new MS.Entertainment.UI.Actions.ActionArray;
                if (!firstMediaItem)
                    return actions;
                MS.Entertainment.ViewModels.assert(firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.playlist && firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.smartDJ, "Playlist and SmartDJ media items cannot be passed into this function");
                var fromCollection = firstMediaItem.fromCollection;
                if (firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person || fromCollection)
                    actions.push(MS.Entertainment.UI.AppBarActions.playSelection);
                var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                var canAddToNowPlaying = !sessionMgr.primarySession.smartDJSeed;
                if (canAddToNowPlaying)
                    if (firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person || !firstMediaItem.fromCollection)
                        actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToNowPlaying);
                    else
                        actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addLocalArtistToNowPlaying);
                var canAddToMyMusic = this._canAddToMyMusic(firstMediaItem);
                if (fromCollection || canAddToMyMusic)
                    actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToPlaylist);
                if (firstMediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && firstMediaItem.playlistItemId >= 0) {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    if (mediaContext && mediaContext.options && mediaContext.options.containingMedia && mediaContext.options.containingMedia.editableItemSource)
                        actions.push(MS.Entertainment.UI.AppBarActions.removeFromList);
                    else
                        actions.push(MS.Entertainment.UI.AppBarActions.removeFromPlaylist)
                }
                else if (firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person && fromCollection)
                    actions.push(MS.Entertainment.UI.AppBarActions.deleteMedia);
                if (!fromCollection && firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person && canAddToMyMusic)
                    actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToMyMusic);
                if (actions.hasSubActions(MS.Entertainment.UI.AppBarActions.addTo))
                    actions.push(MS.Entertainment.UI.AppBarActions.addTo);
                var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                if (signedInUserService.isSubscription) {
                    var shouldAddDownloadAction = false;
                    if (firstMediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person)
                        if (fromCollection)
                            shouldAddDownloadAction = true;
                        else {
                            var cloudServiceManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection);
                            var downloadOnAddToMyMusicCloud = cloudServiceManager.shouldDownloadOnAdd;
                            shouldAddDownloadAction = !downloadOnAddToMyMusicCloud
                        }
                    if (shouldAddDownloadAction)
                        actions.push(MS.Entertainment.UI.AppBarActions.subscriptionDownload)
                }
                actions.push(MS.Entertainment.UI.AppBarActions.clearSelection);
                return actions
            }, getMusicPlaylistMultiSelectActions: function getMusicPlaylistMultiSelectActions(firstMediaItem) {
                MS.Entertainment.ViewModels.assert(firstMediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist, "Invalid mediaType passed into function, mediaType: " + firstMediaItem.mediaType);
                var actions = new MS.Entertainment.UI.Actions.ActionArray;
                actions.push(MS.Entertainment.UI.AppBarActions.playSelection);
                actions.push(MS.Entertainment.UI.AppBarActions.addTo);
                actions.push(MS.Entertainment.UI.AppBarActions.deletePlaylist);
                actions.push(MS.Entertainment.UI.AppBarActions.clearSelection);
                actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToNowPlaying);
                actions.pushSubAction(MS.Entertainment.UI.AppBarActions.addTo, MS.Entertainment.UI.Actions.AddTo.subMenuIds.addToPlaylist);
                var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                if (signedInUserService.isSubscription)
                    actions.push(MS.Entertainment.UI.AppBarActions.subscriptionDownload);
                return actions
            }, getSmartDJMultiSelectActions: function getMusicPlaylistMultiSelectActions() {
                return [MS.Entertainment.UI.AppBarActions.clearSelection, MS.Entertainment.UI.AppBarActions.deleteSmartDJ]
            }, _isRemoteSession: function _isRemoteSession(mediaItem) {
                var isRemoteSession = false;
                if (mediaItem.mediaType !== undefined) {
                    var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                    isRemoteSession = sessionMgr && sessionMgr.primarySession && sessionMgr.primarySession.isRemoteSession && sessionMgr.primarySession.isRemoteSession()
                }
                return isRemoteSession
            }, _hasSubscription: function _hasSubscription() {
                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                var isSignedIn = signInService.isSignedIn;
                var signedInUserHasSubscription = isSignedIn && signedInUserService.isSubscription;
                var musicSubscriptionEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                return musicSubscriptionEnabled && signedInUserHasSubscription
            }, _canAddToMyMusic: function _canAddToMyMusic(mediaItem) {
                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                var networkStatus = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.networkStatus);
                var musicMarketplaceEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace);
                var freeStreamEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay);
                var musicMarketplaceConnected = musicMarketplaceEnabled && networkStatus.isEnabled(MS.Entertainment.UI.NetworkStatusService.NetworkedFeature.musicMarketplace);
                var canFreeStream = (freeStreamEnabled && musicMarketplaceConnected && !this._isRemoteSession(mediaItem) && !(Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToByRef && MS.Entertainment.Utilities.isWindowsBlue) && (mediaItem.mediaType !== Microsoft.Entertainment.Queries.ObjectType.track || MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(mediaItem)));
                return musicMarketplaceConnected && (canFreeStream || this._hasSubscription())
            }
    });
    WinJS.Namespace.define("MS.Entertainment.ViewModels.GlobalAppbarActions", {getGlobalCommandActions: function getGlobalCommandActions() {
            var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
            var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
            var playbackSession = sessionMgr.getSession(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying);
            var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
            var currentLocation = navigationService.currentPage.iaNode.moniker;
            var actions = [];
            if (!uiStateService.nowPlayingConstrainedMode) {
                if (currentLocation !== MS.Entertainment.UI.Monikers.root)
                    actions.push(MS.Entertainment.ViewModels.GlobalAppbarActions.createNavigateToHomeAction());
                var searchAction = MS.Entertainment.ViewModels.GlobalAppbarActions.createSearchAction();
                searchAction.action.wrappedAction.startWithExistingQuery = true;
                actions.push(searchAction)
            }
            if (MS.Entertainment.Utilities.isMusicApp && playbackSession.currentMedia && currentLocation !== MS.Entertainment.UI.Monikers.fullScreenNowPlaying)
                actions.push(MS.Entertainment.ViewModels.GlobalAppbarActions.createNavigateToNowPlayingAction());
            if (MS.Entertainment.Utilities.isApp2)
                actions.push(MS.Entertainment.ViewModels.GlobalAppbarActions.createHelpAction());
            return actions
        }})
})()
