﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {cloudGrovelInfo: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/CloudGrovelInfo.html#cloudGrovelInfoTemplate", function cloudGrovelInfo(element, options) {
            this._nextButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_FAI_NEXT_BUTTON), isEnabled: true, isAvailable: true, execute: function onNext() {
                        this._onNext()
                    }.bind(this)
            });
            this._finishButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_CLOSE_BUTTON), isEnabled: true, isAvailable: true, execute: function onFinish() {
                        this._onFinish()
                    }.bind(this)
            });
            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
            if (signedInUser.isSubscription) {
                this.subHeaderString = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_SUB_HEADER_XMP);
                this.streamIconParagraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_STREAM_PARA_1_XMP);
                this.streamIconParagraphTwoText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_STREAM_PARA_2_XMP);
                this.cloudIconParagraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_CLOUD_PARA_1_XMP)
            }
            else {
                this.subHeaderString = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_SUB_HEADER_FREE);
                this.streamIconParagraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_STREAM_PARA_1_FREE);
                this.streamIconParagraphTwoText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_STREAM_PARA_2_FREE);
                this.cloudIconParagraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_CLOUD_PARA_1_FREE)
            }
        }, {
            _nextButton: null, _finishButton: null, _container: null, _currentPage: 0, _dialogContainer: null, subHeaderString: String.empty, streamIconParagraphOneText: String.empty, streamIconParagraphTwoText: String.empty, cloudIconParagraphOneText: String.empty, initialize: function initialize() {
                    this.xboxMusicPassWebLink.domElement.href = MS.Entertainment.UI.FWLink.cloudGrovelLearnMore;
                    this._dialogContainer = document.querySelector(".dialogContainerBackground")
                }, setOverlay: function setOverlay(container) {
                    this._container = container;
                    container.buttons = [this._nextButton, this._finishButton];
                    container.backClickHandler = this._onBack.bind(this);
                    this._updateState()
                }, _onNext: function _onNext() {
                    this._currentPage = 1;
                    this._updateState()
                }, _onBack: function _onBack() {
                    this._currentPage = 0;
                    this._updateState()
                }, _onFinish: function _onFinish() {
                    this._container.hide()
                }, _updateState: function _updateState() {
                    this._showElement(this.cloudInfoDialogPage1, this._currentPage === 0);
                    this._showElement(this.cloudInfoDialogPage2, this._currentPage === 1);
                    this._showElement(this._container._backButton, this._currentPage !== 0);
                    this._container.defaultButtonIndex = (this._currentPage === 0) ? 0 : 1;
                    this._nextButton.isAvailable = this._currentPage === 0;
                    if (this._dialogContainer)
                        if (this._currentPage === 0) {
                            WinJS.Utilities.addClass(this._dialogContainer, "page1");
                            WinJS.Utilities.removeClass(this._dialogContainer, "page2")
                        }
                        else {
                            WinJS.Utilities.addClass(this._dialogContainer, "page2");
                            WinJS.Utilities.removeClass(this._dialogContainer, "page1")
                        }
                }, _showElement: function _showElement(element, show) {
                    if (element.domElement)
                        element = element.domElement;
                    if (show)
                        WinJS.Utilities.removeClass(element, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(element, "removeFromDisplay")
                }, _sendTelemetryEvent: function _sendTelemetryEvent(event) {
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(event)
                }
        }, {}, {})});
    WinJS.Namespace.define("MS.Entertainment.Music", {cloudGrovelInfoDialog: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.Dialog", "Components/Music/CloudGrovelInfo.html#dialogTemplate", null, {
            backClickHandler: null, onBackClick: function onBackClick(event) {
                    if (this.backClickHandler)
                        this.backClickHandler(event)
                }
        }, null, {show: function show() {
                var options = {
                        width: "900px", height: "700px", cancelButtonIndex: 2, defaultButtonIndex: 0, title: String.load(String.id.IDS_MUSIC_CLOUD_INFO_DIALOG_TITLE), userControl: "MS.Entertainment.Music.cloudGrovelInfo", userControlOptions: {}, persistOnNavigate: false
                    };
                var dialog = new MS.Entertainment.Music.cloudGrovelInfoDialog(document.createElement("div"), options);
                return dialog.show()
            }})})
})()
