﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {CloudMatchOptIn: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/CloudMatchOptInDialog.html#cloudMatchOptInTemplate", function cloudMatchOptIn(element, options) {
            this._cloudCollectionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection);
            this._matchButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_MUSIC_CLOUD_MATCH_ACCEPT_BUTTON), execute: this._onMatch.bind(this)
            });
            this._cancelButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_MUSIC_CLOUD_MATCH_CANCEL_BUTTON), execute: this._onCancel.bind(this)
            });
            this._closeButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_MUSIC_CLOUD_ICON_CLOSE_BUTTON), execute: this._onClose.bind(this)
            });
            this.subHeaderString = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_HEADER);
            this.paragraphTwoText = String.empty;
            var showOptInText = !this._cloudCollectionService.isCloudMatchOptedIn;
            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
            if (signedInUser.isSubscription) {
                this.paragraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_PARA_1_XMP);
                if (showOptInText)
                    this.paragraphTwoText = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_PARA_2_XMP)
            }
            else {
                this.paragraphOneText = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_PARA_1_FREE);
                if (showOptInText)
                    this.paragraphTwoText = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_PARA_2_FREE);
                this.footerText = String.load(String.id.IDS_MUSIC_CLOUD_MATCH_FOOTER_ALT_FREE)
            }
            this.footerLinkText = String.load(String.id.IDS_MUSIC_CLOUD_ICON_LEARN_MORE_TEXT);
            this.footerLinkUrl = MS.Entertainment.UI.FWLink.musicIntro
        }, {
            _matchButton: null, _cancelButton: null, _closeButton: null, _container: null, _cloudCollectionService: null, subHeaderString: String.empty, paragraphOneText: String.empty, paragraphTwoText: String.empty, footerText: String.empty, footerLinkText: String.empty, footerLinkUrl: String.empty, dialogResult: null, setOverlay: function setOverlay(container) {
                    this._container = container;
                    container.buttons = this._cloudCollectionService.isCloudMatchOptedIn ? [this._closeButton] : [this._matchButton, this._cancelButton]
                }, _onMatch: function _onMatch() {
                    this._cloudCollectionService.setCloudMatchOptIn(MS.Entertainment.CloudCollectionService.CloudMatchStatus.OptedIn);
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(MS.Entertainment.Utilities.PreferenceSettingsWrapper.TelemetryEvents.CloudMatchEnabledStateChanged, MS.Entertainment.Utilities.PreferenceSettingsWrapper.States.CloudMatchEnabledState, true, MS.Entertainment.Utilities.Telemetry.Events.CloudMatchStateChangeMethod, MS.Entertainment.Utilities.Telemetry.StateChangeMethodValues.dialog);
                    this.dialogResult = MS.Entertainment.Music.CloudMatchOptIn.DialogResult.optIn;
                    this._container.hide()
                }, _onCancel: function _onCancel() {
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(MS.Entertainment.Music.CloudMatchOptIn.TelemetryEvent.CloudMatchDialogResultMaybeLater);
                    this.dialogResult = MS.Entertainment.Music.CloudMatchOptIn.DialogResult.maybeLater;
                    this._container.hide()
                }, _onClose: function _onClose() {
                    this._container.hide()
                }
        }, null, {
            DialogResult: {
                optIn: "optIn", maybeLater: "maybeLater"
            }, TelemetryEvent: {CloudMatchDialogResultMaybeLater: "CloudMatchDialogResultMaybeLater"}
        })});
    WinJS.Namespace.define("MS.Entertainment.Music", {cloudMatchOptInDialog: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.Dialog", "Components/Music/CloudMatchOptInDialog.html#dialogTemplate", null, {}, null, {
            _dialog: null, show: function show(dismissAction) {
                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    var options = {
                            width: "900px", height: "725px", cancelButtonIndex: 1, defaultButtonIndex: 0, title: signedInUser.isSubscription ? String.load(String.id.IDS_MUSIC_CLOUD_MATCH_SUB_HEADER_XMP) : String.load(String.id.IDS_MUSIC_CLOUD_MATCH_SUB_HEADER_FREE), userControl: "MS.Entertainment.Music.CloudMatchOptIn", userControlOptions: {}, persistOnNavigate: false
                        };
                    if (!this._dialog) {
                        this._dialog = new MS.Entertainment.Music.cloudMatchOptInDialog(document.createElement("div"), options);
                        return this._dialog.show().then(function dialogClosed() {
                                if (dismissAction)
                                    dismissAction(this._dialog.userControlInstance.dialogResult);
                                this._dialog = null
                            }.bind(this))
                    }
                    else
                        return WinJS.Promise.wrap()
                }
        })})
})()
