﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/utilities.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {FindAlbumInfoDropDown: MS.Entertainment.UI.Framework.defineUserControl(null, function findAlbumInfoDropDown(element, options){}, {
            _dataSource: null, initialize: function initialize() {
                    this.domElement.addEventListener("change", function() {
                        var value = parseInt(this.domElement.value);
                        if (value === -1)
                            this.dataSource.selectedTrack = null;
                        else
                            this.dataSource.selectedTrack = this.dataSource.availableTracks[value]
                    }.bind(this))
                }, dataSource: {
                    get: function() {
                        return this._dataSource
                    }, set: function(value) {
                            this._dataSource = value;
                            this._render()
                        }
                }, _render: function _render() {
                    WinJS.Promise.timeout().then(function() {
                        var htmlOriginalTrack = MS.Entertainment.Music.FindAlbumInfoDropDown._groupsFormat.format(String.load(String.id.IDS_FAI_ORIGINAL_TRACK), this._formatTrack("-1", this.dataSource.originalTrack));
                        var htmlAvailableTracks;
                        if (MS.Entertainment.Music.FindAlbumInfoDropDown._cachedAvailableTracks !== this.dataSource.availableTracks) {
                            var htmlOptions = String.empty;
                            for (var i = 0; i < this.dataSource.availableTracks.length; i++)
                                htmlOptions += this._formatTrack(i, this.dataSource.availableTracks[i]);
                            htmlAvailableTracks = MS.Entertainment.Music.FindAlbumInfoDropDown._groupsFormat.format(String.load(String.id.IDS_FAI_AVAILABLE_TRACKS), htmlOptions);
                            MS.Entertainment.Music.FindAlbumInfoDropDown._cachedAvailableTracks = this.dataSource.availableTracks;
                            MS.Entertainment.Music.FindAlbumInfoDropDown._cachedAvailableTracksHtml = htmlAvailableTracks
                        }
                        else
                            htmlAvailableTracks = MS.Entertainment.Music.FindAlbumInfoDropDown._cachedAvailableTracksHtml;
                        this.domElement.innerHTML = htmlOriginalTrack + htmlAvailableTracks;
                        MS.Entertainment.Utilities.forceFullLayout()
                    }.bind(this))
                }, _formatTrack: function _formatTrack(index, track) {
                    var trackNumber = 1;
                    if (track.trackNumber && track.trackNumber > 1)
                        trackNumber = track.trackNumber;
                    var name = MS.Entertainment.Utilities.escapeHTML(track.name);
                    return MS.Entertainment.Music.FindAlbumInfoDropDown._optionFormat.format(index, trackNumber, name)
                }
        }, {}, {
            _cachedAvailableTracks: null, _cachedAvailableTracksHtml: null, _groupsFormat: "<optgroup label=\"{0}\">{1}</optgroup>", _optionFormat: "<option value=\"{0}\">{1}&nbsp;&nbsp;{2}</option>"
        })});
    WinJS.Namespace.define("MS.Entertainment.Music", {FindAlbumInfo: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/FindAlbumInfo.html#findAlbumInfoTemplate", function findAlbumInfo(element, options) {
            var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
            this._musicMarketplaceEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace);
            this._storeSyncEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.storeSync);
            this._musicMatchEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMatchService);
            this._nextButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_FAI_NEXT_BUTTON), isEnabled: true, isAvailable: true, execute: function onNext(dialog, event) {
                        this._onNext(event, this._createTelemetryActionData("findAlbumInfoNavBar", "nextButton", this._containerButtons.indexOf(this._nextButton)))
                    }.bind(this)
            });
            this._finishButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_FAI_FINISH_BUTTON), isEnabled: true, isAvailable: true, execute: function onFinish(dialog, event) {
                        this._onFinish(event, this._createTelemetryActionData("findAlbumInfoNavBar", "finishButton", this._containerButtons.indexOf(this._finishButton)))
                    }.bind(this)
            });
            this._cancelButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_FAI_CANCEL_BUTTON), isEnabled: true, isAvailable: true, execute: function onCancel(dialog, event) {
                        this._onCancel(event, this._createTelemetryActionData("findAlbumInfoNavBar", "cancelButton", this._containerButtons.indexOf(this._cancelButton)))
                    }.bind(this)
            });
            this._containerButtons = [this._nextButton, this._finishButton, this._cancelButton];
            this._queryWatcher = new MS.Entertainment.Framework.QueryWatcher("findAlbumInfo");
            this._pageBackStack = []
        }, {
            collectionUpdated: false, _originalAlbum: null, _originalTracks: null, _keywords: null, _selectedAlbum: null, _selectedAlbumIndex: -1, _tracksMatch: false, _setFocusOnPage: true, _pageBackStack: null, _musicMarketplaceEnabled: false, _storeSyncEnabled: false, _musicMatchEnabled: false, _nextButton: null, _finishButton: null, _cancelButton: null, _container: null, _containerButtons: null, _queryWatcher: null, _matchedTracks: null, _navigating: false, _unmatchedTracks: null, _albums: null, _matchMode: null, _matchSource: null, _signedInUser: null, _cloudCollectionService: null, _currentPage: null, _lastXCorrelationId: null, _page: {
                    get: function() {
                        return this._currentPage
                    }, set: function(value) {
                            if (value !== this._currentPage) {
                                var currentPageData;
                                if (this._currentPage)
                                    currentPageData = {
                                        uri: this._currentPage, pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popover
                                    };
                                else
                                    currentPageData = {
                                        uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.TelemetryParameterValues.Unknown
                                    };
                                MS.Entertainment.Utilities.Telemetry.logPageView(this.domElement, {
                                    uri: "findAlbumInfo/" + value, pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popover
                                }, currentPageData);
                                this._currentPage = value;
                                this._setFocusOnPage = true
                            }
                        }
                }, initialize: function initialize() {
                    MS.Entertainment.Music.assert(this._matchMode, "_matchMode must be specified in the options");
                    this._keywords = this._getInitialKeywords();
                    this._page = MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum;
                    if (this._originalAlbum.libraryId === -1) {
                        if (this._originalAlbum.tracks)
                            this._originalAlbum.tracks.toArrayAll().done(function(tracks) {
                                this._originalTracks = tracks;
                                this.tracks = tracks
                            }.bind(this), function handleError(error) {
                                MS.Entertainment.Music.fail("Getting all tracks failed. Error: " + error && error.message)
                            })
                    }
                    else
                        this._queryLibraryTracks();
                    this._showElement(this._trackColumnHeader, false);
                    this._showElement(this._trackList, false);
                    this._queryAlbums();
                    this._sendTelemetryEvent("FindAlbumInfo_Begin");
                    this._albumList.selectionHelperFactory = function selectionHelperFactory() {
                        return new MS.Entertainment.UI.Controls.DoNothingSelectionHelper
                    };
                    this._signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    this._cloudCollectionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection)
                }, onSearch: function onSearch() {
                    if (this._keywords !== this._keywordsEdit.value) {
                        this._sendTelemetryPageAction(this._searchIcon, this._currentPage);
                        this._keywords = this._keywordsEdit.value;
                        this._queryAlbums();
                        this._sendTelemetryEvent("FindAlbumInfo_NewSearch")
                    }
                }, onSearchKeyDown: function onSearchKeyDown(event) {
                    if (event.keyCode === WinJS.Utilities.Key.enter)
                        this.onSearch()
                }, onSearchFocus: function onSearchFocus(event) {
                    if (this._searchContainer)
                        WinJS.Utilities.addClass(this._searchContainer, "searchFocused")
                }, onSearchBlur: function onSearchBlur(event) {
                    if (this._searchContainer)
                        WinJS.Utilities.removeClass(this._searchContainer, "searchFocused")
                }, unload: function unload() {
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, setOverlay: function setOverlay(container) {
                    this._container = container;
                    container.buttons = this._containerButtons;
                    container.backClickHandler = this.onBackClick.bind(this);
                    container.searchAlbumsClickHandler = this.onSearchAlbumsClick.bind(this);
                    container.bulkMatchClickHandler = this.onBulkMatchClick.bind(this);
                    this._updateState()
                }, onAlbumSelected: function onAlbumSelected(event) {
                    if (this._navigating)
                        return;
                    if (event && event.target && event.target.winControl && event.target.winControl.selection) {
                        var indices = event.target.winControl.selection.getIndices();
                        if (indices && indices.length > 0)
                            this._albumList.dataSource.itemsFromIndex(indices[0], 0, 0).done(function albumSelected(args) {
                                var mediaResult = args.items[args.offset];
                                var media;
                                if (mediaResult && mediaResult.data)
                                    media = mediaResult.data;
                                this._sendTelemetryPageAction(event.target, this._currentPage, media);
                                this.albumSelectionHandler(media, indices[0])
                            }.bind(this), function handleError(error) {
                                MS.Entertainment.Music.fail("Failed to get selected album. Error: " + (error && error.message))
                            });
                        else if (this._selectedAlbumIndex >= 0)
                            this.albumSelectionHandler(null, this._selectedAlbumIndex)
                    }
                    else
                        MS.Entertainment.Music.fail("selectionchanged event invalid.  Unable to cloud match album")
                }, albumSelectionHandler: function albumSelectionHandler(mediaItem, itemIndex) {
                    if (this._selectedAlbum && this._selectedAlbumIndex === itemIndex) {
                        this._selectedAlbum = null;
                        this._selectedAlbumIndex = -1;
                        this._updateState()
                    }
                    else if (mediaItem) {
                        this._selectedAlbum = mediaItem;
                        this._selectedAlbumIndex = itemIndex;
                        this._queryTracks(mediaItem)
                    }
                    else
                        MS.Entertainment.Music.fail("Invalid selection state.  Unable to cloud match album")
                }, onSearchAlbumsClick: function onSearchAlbumsClick(event) {
                    this._sendTelemetryPageAction(event.target, MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums);
                    var telemetryParameterArray = [];
                    if (this._lastXCorrelationId)
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.XCorrelationId, parameterValue: this._lastXCorrelationId
                        });
                    this._sendTelemetryEvent("FindAlbumInfo_Search", telemetryParameterArray);
                    this._pageBackStack.push(this._page);
                    this._page = MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums;
                    this._updateState();
                    if (this._musicMarketplaceEnabled)
                        this._queryAlbums();
                    this.tracks = this._originalTracks
                }, onBulkMatchClick: function onBulkMatchClick(event) {
                    MS.Entertainment.Music.cloudMatchOptInDialog.show()
                }, _onNext: function _onNext(event, pageContentDataObject) {
                    this._sendTelemetryPageAction(event.target, MS.Entertainment.Music.FindAlbumInfo.Page.matchTracks, null, pageContentDataObject);
                    this._navigating = true;
                    this._pageBackStack.push(this._page);
                    this._page = MS.Entertainment.Music.FindAlbumInfo.Page.matchTracks;
                    this._updateState();
                    this._navigating = false
                }, onBackClick: function onBackClick(event) {
                    this._navigating = true;
                    if (this._pageBackStack.length > 0) {
                        this._sendTelemetryPageAction(event.target, this._pageBackStack[this._pageBackStack.length - 1]);
                        this._page = this._pageBackStack.pop();
                        this._updateState();
                        if (this._pageBackStack.length === 0 && (this._musicMarketplaceEnabled || this._keywords !== this._getInitialKeywords())) {
                            this._keywords = this._getInitialKeywords();
                            this._queryAlbums()
                        }
                    }
                    this._navigating = false
                }, _onCancel: function _onCancel(event, pageContentDataObject) {
                    var domElement = event ? event.target : null;
                    this._sendTelemetryPageAction(domElement, null, null, pageContentDataObject);
                    var telemetryParameterArray = [];
                    if (this._lastXCorrelationId)
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.XCorrelationId, parameterValue: this._lastXCorrelationId
                        });
                    this._sendTelemetryEvent("FindAlbumInfo_Cancel", telemetryParameterArray);
                    this._container.hide()
                }, _getInitialKeywords: function _getInitialKeywords() {
                    var keywords = this._originalAlbum.name;
                    if (this._originalAlbum.artistName !== String.load(String.id.IDS_MEDIASTORE_VARIOUS_ARTISTS))
                        keywords += " " + this._originalAlbum.artistName;
                    return keywords
                }, _isCloudMatch: {get: function get_isCloudMatch() {
                        return this._matchMode === MS.Entertainment.Music.FindAlbumInfo.MatchMode.cloud
                    }}, _isLibraryMatch: {get: function get_isLibraryMatch() {
                        return this._matchMode === MS.Entertainment.Music.FindAlbumInfo.MatchMode.library
                    }}, _queryLibraryTracks: function _queryLibraryTracks() {
                    var query = new MS.Entertainment.Data.Query.libraryTracks;
                    query.albumId = this._originalAlbum.libraryId;
                    query.sort = Microsoft.Entertainment.Queries.TracksSortBy.numberAscending;
                    this._queryWatcher.registerQuery(query);
                    query.execute().done(function querySuccess(q) {
                        q.result.items.toArrayAll().done(function(tracks) {
                            this._originalTracks = tracks;
                            this.tracks = tracks
                        }.bind(this))
                    }.bind(this), function queryError(q) {
                        MS.Entertainment.Music.fail("library tracks query failed!")
                    })
                }, _queryAlbums: function _queryAlbums() {
                    this._matchSource = null;
                    this._albums = null;
                    this.tracks = null;
                    this._tracksMatch = false;
                    this._selectedAlbum = null;
                    this._selectedAlbumIndex = -1;
                    if (this._tracksLoadingControl)
                        this._tracksLoadingControl.reset();
                    if (this._albumsLoadingControl)
                        this._albumsLoadingControl.reset();
                    this._showElement(this._noAlbumsLabel, false);
                    this._albumsLoadingControl.isBusy = true;
                    this._updateState();
                    var keywords = this._keywords;
                    if (keywords) {
                        if (keywords.length > MS.Entertainment.Music.FindAlbumInfo._maxSearchTextLength)
                            keywords = keywords.slice(0, MS.Entertainment.Music.FindAlbumInfo._maxSearchTextLength);
                        var query;
                        var matchSource;
                        if (this._musicMatchEnabled)
                            if (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum) {
                                matchSource = MS.Entertainment.Music.FindAlbumInfo.MatchSource.musicMatch;
                                query = new MS.Entertainment.Data.Query.Music.MusicMatch.AlbumSearch;
                                query.albumLibraryId = this._originalAlbum.libraryId
                            }
                            else {
                                matchSource = MS.Entertainment.Music.FindAlbumInfo.MatchSource.eds;
                                query = new MS.Entertainment.Data.Query.Music.AlbumSearch;
                                query.inflateParentItems = true
                            }
                        else {
                            var edsQuery = this._musicMarketplaceEnabled && this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum;
                            if (edsQuery || this._isCloudMatch) {
                                matchSource = MS.Entertainment.Music.FindAlbumInfo.MatchSource.eds;
                                query = new MS.Entertainment.Data.Query.Music.AlbumSearch;
                                query.inflateParentItems = true
                            }
                            else {
                                matchSource = MS.Entertainment.Music.FindAlbumInfo.MatchSource.wmis;
                                query = new MS.Entertainment.Data.Query.Music.WMIS.AlbumSearch
                            }
                        }
                        query.search = keywords;
                        this._queryWatcher.registerQuery(query);
                        query.execute().done(function querySuccess(q) {
                            if (this.domElement) {
                                if (q.result.xCorrelationId)
                                    this._lastXCorrelationId = q.result.xCorrelationId;
                                this._matchSource = matchSource;
                                this._albums = q.result.items;
                                if (!this._albums || !this._albums.count)
                                    if (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums)
                                        this._showElement(this._noAlbumsLabel, true);
                                    else {
                                        this._page = MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums;
                                        this._queryAlbums()
                                    }
                                this._albumsLoadingControl.isBusy = false;
                                this._updateState()
                            }
                        }.bind(this), function queryError(q) {
                            if (this.domElement)
                                if (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums) {
                                    if (this._albumsLoadingControl)
                                        this._albumsLoadingControl.isOffline = true
                                }
                                else {
                                    this._page = MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums;
                                    this._queryAlbums()
                                }
                        }.bind(this))
                    }
                }, _queryTracks: function _queryTracks(album) {
                    this.tracks = null;
                    if (this._tracksLoadingControl)
                        this._tracksLoadingControl.reset();
                    this._tracksMatch = null;
                    var query;
                    var promise = WinJS.Promise.as();
                    var matchUsingRequestId = false;
                    if (this._musicMatchEnabled)
                        if (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum) {
                            matchUsingRequestId = true;
                            query = {result: album}
                        }
                        else {
                            query = new MS.Entertainment.Data.Query.Music.AlbumSongs;
                            query.id = album.canonicalId
                        }
                    else if (this._isCloudMatch || (this._musicMarketplaceEnabled && this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum)) {
                        query = new MS.Entertainment.Data.Query.Music.AlbumSongs;
                        query.id = album.canonicalId
                    }
                    else {
                        query = new MS.Entertainment.Data.Query.Music.WMIS.AlbumWithTracks;
                        query.id = album.id
                    }
                    function loadPages(promise) {
                        return promise.then(function complete(query) {
                                var result = query.result;
                                if (result.tracks && result.tracks.count < result.total)
                                    return loadPages(query.loadNextChunk())
                            })
                    }
                    {};
                    if (query.execute) {
                        query.idType = album.serviceIdType;
                        this._queryWatcher.registerQuery(query);
                        this._tracksLoadingControl.isBusy = true;
                        promise = loadPages(query.execute())
                    }
                    var result;
                    promise.then(function queryComplete() {
                        if (query.result.item)
                            result = query.result.item;
                        else
                            result = query.result;
                        if (!result)
                            return WinJS.Promise.as();
                        var tracks = result.tracks;
                        if (tracks) {
                            var trackArray = Array.isArray(tracks) ? tracks : null;
                            if (trackArray)
                                return WinJS.Promise.wrap(trackArray);
                            return MS.Entertainment.Data.List.listToArray(tracks)
                        }
                    }).done(function gotTrackArray(trackArray) {
                        var tracks = [];
                        if (trackArray && trackArray.length > 0)
                            if (this._isCloudMatch) {
                                var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                var hasSubscription = signInService.isSignedIn && signedInUserService.isSubscription;
                                trackArray.forEach(function filterTracks(track) {
                                    if ((track.isInMusicCatalog && MS.Entertainment.Utilities.isValidServiceId(track.actionableMediaId)) || track.canFreeStream || (hasSubscription && track.canSubscriptionStream))
                                        tracks.push(track)
                                })
                            }
                            else
                                tracks = trackArray;
                        MS.Entertainment.Utilities.forceFullLayout();
                        tracks.sort(function(track0, track1) {
                            return track0.trackNumber - track1.trackNumber
                        });
                        this.tracks = tracks;
                        if (matchUsingRequestId)
                            this._tracksMatch = this._matchTracksUsingRequestId();
                        else
                            this._tracksMatch = this._matchTracks();
                        this._updateState();
                        if (result) {
                            if (result.uniqueFileId)
                                album.uniqueFileId = result.uniqueFileId;
                            if (result.imageUri)
                                album.imageUri = result.imageUri
                        }
                        this._tracksLoadingControl.isBusy = false
                    }.bind(this), function queryError(q) {
                        if (this._tracksLoadingControl)
                            this._tracksLoadingControl.isOffline = true
                    }.bind(this))
                }, _matchTracksUsingRequestId: function _matchTracksUsingRequestId() {
                    this._matchedTracks = [];
                    this._unmatchedTracks = [];
                    var i;
                    var originalTrack;
                    var matchedTrack;
                    var returnedTrack;
                    var tracksMap = [];
                    for (i = 0; i < this.tracks.length; i++) {
                        returnedTrack = this.tracks[i];
                        returnedTrack.isMatched = false;
                        if (returnedTrack.requestId)
                            tracksMap[returnedTrack.requestId] = returnedTrack
                    }
                    if (this._originalTracks)
                        for (i = 0; i < this._originalTracks.length; i++) {
                            originalTrack = this._originalTracks[i];
                            matchedTrack = tracksMap[originalTrack.libraryId.toString()];
                            if (matchedTrack) {
                                matchedTrack.isMatched = true;
                                matchedTrack.libraryId = originalTrack.libraryId;
                                this._matchedTracks.push(matchedTrack)
                            }
                            else
                                this._unmatchedTracks.push({
                                    originalTrack: originalTrack, availableTracks: this.tracks, selectedTrack: null
                                })
                        }
                    return (this._unmatchedTracks.length === 0)
                }, _matchTracks: function _matchTracks() {
                    this._matchedTracks = [];
                    this._unmatchedTracks = [];
                    var key = function key(trackName, trackNumber) {
                            return trackName.toLowerCase() + "/" + trackNumber
                        };
                    var i;
                    var tracksMap = [];
                    for (i = 0; i < this.tracks.length; i++) {
                        var track = this.tracks[i];
                        track.isMatched = false;
                        if (track.name)
                            tracksMap[key(track.name, track.trackNumber)] = track;
                        if (track.mainTitle)
                            tracksMap[key(track.mainTitle, track.trackNumber)] = track
                    }
                    if (this._originalTracks)
                        for (i = 0; i < this._originalTracks.length; i++) {
                            var originalTrack = this._originalTracks[i];
                            var matchedTrack = tracksMap[key(originalTrack.name, originalTrack.trackNumber)];
                            if (matchedTrack) {
                                matchedTrack.isMatched = true;
                                matchedTrack.libraryId = originalTrack.libraryId;
                                this._matchedTracks.push(matchedTrack)
                            }
                            else
                                this._unmatchedTracks.push({
                                    originalTrack: originalTrack, availableTracks: this.tracks, selectedTrack: null
                                })
                        }
                    return (this._unmatchedTracks.length === 0)
                }, _updateState: function _updateState() {
                    var selectAlbum = (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum);
                    var searchAlbums = (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums);
                    var matchTracks = (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.matchTracks);
                    var showSelectAlbumsPage;
                    var isAlbumSelected = !!this._selectedAlbum;
                    if (this._container) {
                        var titleStringId,
                            subTitleStringId;
                        switch (this._page) {
                            case MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum:
                                if (this._isCloudMatch) {
                                    titleStringId = String.id.IDS_FAI_ADD_ALBUM_CLOUD_TITLE;
                                    subTitleStringId = String.id.IDS_FAI_ADD_ALBUM_CLOUD_SUBTITLE
                                }
                                else
                                    titleStringId = (this._musicMarketplaceEnabled && this._storeSyncEnabled) ? String.id.IDS_FAI_CHOOSE_ALBUM_CLOUD_TITLE : String.id.IDS_FAI_CHOOSE_ALBUM_TITLE;
                                this._showElement(this._trackColumnHeader, isAlbumSelected);
                                this._showElement(this._trackList, isAlbumSelected);
                                break;
                            case MS.Entertainment.Music.FindAlbumInfo.Page.searchAlbums:
                                titleStringId = String.id.IDS_FAI_SEARCH_ALBUM_TITLE;
                                this._showElement(this._trackColumnHeader, isAlbumSelected);
                                this._showElement(this._trackList, isAlbumSelected);
                                break;
                            case MS.Entertainment.Music.FindAlbumInfo.Page.matchTracks:
                                titleStringId = String.id.IDS_FAI_MATCH_SONGS_TITLE;
                                if (this._isCloudMatch)
                                    subTitleStringId = String.id.IDS_FAI_MATCH_SONGS_SUBTITLE;
                                break;
                            default:
                                MS.Entertainment.Music.fail("Invalid PageType")
                        }
                        this._container.title = String.load(titleStringId);
                        if (subTitleStringId)
                            this.subTitle = String.load(subTitleStringId);
                        else
                            this.subTitle = String.empty;
                        var showBulkMatchLink = matchTracks && this._isCloudMatch && !this._cloudCollectionService.isCloudMatchOptedIn && !this._cloudCollectionService.isCloudMatchOptedOut;
                        this._showElement(this._container._searchAlbumsLink, selectAlbum && !this._albumsLoadingControl.isBusy);
                        this._showElement(this._container._bulkMatchLink, showBulkMatchLink);
                        this._showElement(this._container._backButton, this._pageBackStack.length > 0);
                        if (!this._albumList.selection || this._albumList.selection._selected._itemsCount <= 0) {
                            this.tracks = this._originalTracks;
                            this._trackColumnHeader.textContent = String.load(String.id.IDS_FAI_SONG_COLUMN_TITLE)
                        }
                        else {
                            this._showElement(this._noCloudMatchText, this.tracks);
                            this._trackColumnHeader.textContent = String.load(String.id.IDS_FAI_MATCH_COLUMN_TITLE)
                        }
                    }
                    this._finishButton.isEnabled = (this._tracksMatch && this._selectedAlbum) || matchTracks;
                    this._nextButton.isAvailable = this.tracks && this.tracks.length && !this._tracksMatch && this._selectedAlbum && (selectAlbum || searchAlbums);
                    this._finishButton.isAvailable = !this._nextButton.isAvailable;
                    showSelectAlbumsPage = selectAlbum || searchAlbums;
                    if (showSelectAlbumsPage)
                        this._albumList.dataSource = this._albums;
                    else
                        this._albumList.dataSource = null;
                    this._showElement(this._matchTracksPage, matchTracks);
                    this._showElement(this._selectAlbumsPages, showSelectAlbumsPage);
                    if (selectAlbum || searchAlbums) {
                        this._keywordsEdit.value = this._keywords;
                        this._showElement(this._searchIcon, searchAlbums);
                        this._showElement(this._keywordsEdit, searchAlbums);
                        if (searchAlbums) {
                            MS.Entertainment.Utilities.forceFullLayout();
                            WinJS.Utilities.addClass(this._albumList.domElement, "searchAlbums")
                        }
                        else
                            WinJS.Utilities.removeClass(this._albumList.domElement, "searchAlbums");
                        this._unmatchedTracksList.dataSource = null;
                        this._matchedTrackList.dataSource = null;
                        this._showElement(this._noCloudMatchText, this._selectedAlbum && this.tracks && this.tracks.length === 0)
                    }
                    else if (matchTracks) {
                        this._showElement(this._noAlbumsLabel, false);
                        this._showElement(this._matchedTrackList, this._matchedTracks && this._matchedTracks.length);
                        this._showElement(this._matchedTrackHeader, (this._matchedTracks && this._matchedTracks.length));
                        this._unmatchedTracksList.dataSource = this._unmatchedTracks;
                        this._matchedTrackList.dataSource = this._matchedTracks
                    }
                    if (this._setFocusOnPage) {
                        this._setFocusOnPage = false;
                        if (selectAlbum) {
                            this._albumList.focusFirstItemOnPageLoad = selectAlbum;
                            if (!(this._albums && this._albums.count > 0))
                                this._setFocusOnPage = true
                        }
                        else if (searchAlbums)
                            MS.Entertainment.UI.Framework.focusElement(this._keywordsEdit);
                        else if (matchTracks)
                            MS.Entertainment.UI.Framework.focusFirstInSubTree(this._unmatchedTracksList.domElement)
                    }
                }, _showElement: function _showElement(element, show) {
                    if (!element)
                        return;
                    if (element.domElement)
                        element = element.domElement;
                    if (show)
                        WinJS.Utilities.removeClass(element, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(element, "removeFromDisplay")
                }, _onFinish: function _onFinish(event, pageContentDataObject) {
                    this._sendTelemetryPageAction(event.target, null, null, pageContentDataObject);
                    var albumMetadata = new Microsoft.Entertainment.Platform.AlbumMetadata;
                    var selectedAlbum = this._selectedAlbum;
                    albumMetadata.editedFields = Microsoft.Entertainment.Platform.FieldMask.empty_BIT_MASK;
                    if (selectedAlbum.name) {
                        albumMetadata.title = selectedAlbum.name;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.title_BIT_MASK
                    }
                    if (selectedAlbum.artistName) {
                        albumMetadata.artist = selectedAlbum.artistName;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_BIT_MASK
                    }
                    if (selectedAlbum.primaryGenreName) {
                        albumMetadata.genre = selectedAlbum.primaryGenreName;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.genre_BIT_MASK
                    }
                    if (selectedAlbum.releaseDate) {
                        albumMetadata.releaseDate = MS.Entertainment.Formatters.formatDatabaseDataFromReleaseDate(selectedAlbum.releaseDate);
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.release_DATE_BIT_MASK
                    }
                    if (selectedAlbum.imageUri) {
                        albumMetadata.largeCoverUrl = selectedAlbum.imageUri;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.large_COVER_URL_BIT_MASK
                    }
                    if (selectedAlbum.trackCount) {
                        albumMetadata.trackCount = selectedAlbum.trackCount;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.track_COUNT_BIT_MASK
                    }
                    if (selectedAlbum.hasSmartDJ !== undefined)
                        if (selectedAlbum.hasSmartDJ)
                            albumMetadata.canSmartDJ = Microsoft.Entertainment.Platform.SmartDJState.canSmartDJ;
                        else
                            albumMetadata.canSmartDJ = Microsoft.Entertainment.Platform.SmartDJState.cannotSmartDJ;
                    else
                        albumMetadata.canSmartDJ = Microsoft.Entertainment.Platform.SmartDJState.unknown;
                    albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.can_SMARTDJ_BIT_MASK;
                    if (selectedAlbum.label) {
                        albumMetadata.label = selectedAlbum.label;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.lable_BIT_MASK
                    }
                    if (MS.Entertainment.Utilities.isValidServiceId(selectedAlbum.canonicalId)) {
                        albumMetadata.albumBingId = selectedAlbum.canonicalId;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.album_BINGID_BIT_MASK
                    }
                    else
                        albumMetadata.albumBingId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (MS.Entertainment.Utilities.isValidServiceId(selectedAlbum.zuneId)) {
                        albumMetadata.albumMediaId = selectedAlbum.zuneId;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.album_MEDIAID_BIT_MASK
                    }
                    else
                        albumMetadata.albumMediaId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (selectedAlbum.artist && MS.Entertainment.Utilities.isValidServiceId(selectedAlbum.artist.canonicalId)) {
                        albumMetadata.artistBingId = selectedAlbum.artist.canonicalId;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_BINGID_BIT_MASK
                    }
                    if (selectedAlbum.artist && MS.Entertainment.Utilities.isValidServiceId(selectedAlbum.artist.zuneId)) {
                        albumMetadata.artistMediaId = selectedAlbum.artist.zuneId;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_MEDIAID_BIT_MASK
                    }
                    var i;
                    var tracks = [];
                    if (this._matchedTracks)
                        for (i = 0; i < this._matchedTracks.length; i++) {
                            var matchedTrack = this._matchedTracks[i];
                            if (MS.Entertainment.Utilities.isValidLibraryId(matchedTrack.libraryId)) {
                                var trackMetadata = new Microsoft.Entertainment.Platform.TrackMetadata;
                                trackMetadata.requestId = matchedTrack.libraryId;
                                this._populateTrackMetadata(trackMetadata, matchedTrack, selectedAlbum);
                                tracks.push(trackMetadata)
                            }
                        }
                    var matchTracksSelected = false;
                    if (this._unmatchedTracks)
                        for (i = 0; i < this._unmatchedTracks.length; i++) {
                            var unmatchedTrack = this._unmatchedTracks[i];
                            if (unmatchedTrack.selectedTrack && MS.Entertainment.Utilities.isValidLibraryId(unmatchedTrack.originalTrack.libraryId)) {
                                var trackMetadata = new Microsoft.Entertainment.Platform.TrackMetadata;
                                trackMetadata.requestId = unmatchedTrack.originalTrack.libraryId;
                                this._populateTrackMetadata(trackMetadata, unmatchedTrack.selectedTrack, selectedAlbum);
                                tracks.push(trackMetadata);
                                matchTracksSelected = true
                            }
                        }
                    if (tracks.length) {
                        albumMetadata.trackMetadata = tracks;
                        albumMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.tracks_BIT_MASK
                    }
                    this._sendTelemetryEvent("FindAlbumInfo_Finish");
                    var telemetryParameterArray = [];
                    if (this._lastXCorrelationId)
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.XCorrelationId, parameterValue: this._lastXCorrelationId
                        });
                    if (selectedAlbum.hasZuneId)
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ZuneId, parameterValue: selectedAlbum.zuneId
                        });
                    switch (this._matchSource) {
                        case MS.Entertainment.Music.FindAlbumInfo.MatchSource.wmis:
                            this._sendTelemetryEvent("FindAlbumInfo_updateFromWMIS", telemetryParameterArray);
                            break;
                        case MS.Entertainment.Music.FindAlbumInfo.MatchSource.eds:
                            this._sendTelemetryEvent("FindAlbumInfo_updateFromEDS", telemetryParameterArray);
                            break;
                        case MS.Entertainment.Music.FindAlbumInfo.MatchSource.musicMatch:
                            this._sendTelemetryEvent("FindAlbumInfo_updateFromMusicMatch", telemetryParameterArray);
                            break
                    }
                    if (this._page === MS.Entertainment.Music.FindAlbumInfo.Page.selectAlbum)
                        this._sendTelemetryEvent("FindAlbumInfo_FinishFromFirstPage");
                    if (matchTracksSelected)
                        this._sendTelemetryEvent("FindAlbumInfo_MatchTracksSelected");
                    var albumId = this._originalAlbum.libraryId;
                    var requestType = Microsoft.Entertainment.Platform.RequestType.wmisalbumIDRequest;
                    var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                    mediaStore.albumProvider.updateAlbumMetadataAsync(albumMetadata, requestType, albumId).done(function onUpdateAlbumMetadataCompete(result) {
                        if (this._isCloudMatch || (this._cloudCollectionService.isCloudMatchOptedIn && selectedAlbum.hasZuneId))
                            mediaStore.mediaProvider.addMediaToCloudAsync(Microsoft.Entertainment.Queries.ObjectType.album, [result.libraryId]);
                        this.collectionUpdated = true;
                        this._container.hide()
                    }.bind(this), function onUpdateAlbumMetadataError(errorCode) {
                        if (errorCode && errorCode.number)
                            errorCode = errorCode.number;
                        MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_MEDIA_ERROR_CAPTION), errorCode)
                    }.bind(this))
                }, _populateTrackMetadata: function _populateTrackMetadata(trackMetadata, track, album) {
                    trackMetadata.editedFields = Microsoft.Entertainment.Platform.FieldMask.empty_BIT_MASK;
                    trackMetadata.discNumber = 1;
                    trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.disc_NUMBER_BIT_MASK;
                    if (track.name) {
                        trackMetadata.title = track.name;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.title_BIT_MASK
                    }
                    if (track.trackNumber) {
                        trackMetadata.trackNumber = track.trackNumber;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.track_NUMBER_BIT_MASK
                    }
                    if (track.releaseDate) {
                        trackMetadata.releaseDate = MS.Entertainment.Formatters.formatDatabaseDataFromReleaseDate(track.releaseDate);
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.release_DATE_BIT_MASK
                    }
                    else if (album.releaseDate) {
                        trackMetadata.releaseDate = MS.Entertainment.Formatters.formatDatabaseDataFromReleaseDate(album.releaseDate);
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.release_DATE_BIT_MASK
                    }
                    if (album.artistName) {
                        trackMetadata.artist = album.artistName;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_BIT_MASK
                    }
                    if (album.primaryGenreName) {
                        trackMetadata.genre = album.primaryGenreName;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.genre_BIT_MASK
                    }
                    if (MS.Entertainment.Utilities.isValidServiceId(track.zuneId)) {
                        trackMetadata.trackMediaId = track.zuneId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.track_MEDIAID_BIT_MASK
                    }
                    else {
                        trackMetadata.trackMediaId = MS.Entertainment.Utilities.EMPTY_GUID;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.track_MEDIAID_BIT_MASK
                    }
                    if (MS.Entertainment.Utilities.isValidServiceId(track.actionableMediaId)) {
                        trackMetadata.actionableMediaId = track.actionableMediaId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.actionable_MEDIAID_BIT_MASK
                    }
                    else
                        trackMetadata.actionableMediaId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (MS.Entertainment.Utilities.isValidServiceId(album.zuneId)) {
                        trackMetadata.albumMediaId = album.zuneId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.album_MEDIAID_BIT_MASK
                    }
                    else
                        trackMetadata.albumMediaId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (album.artist && MS.Entertainment.Utilities.isValidServiceId(album.artist.zuneId)) {
                        trackMetadata.artistMediaId = album.artist.zuneId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_MEDIAID_BIT_MASK
                    }
                    if (MS.Entertainment.Utilities.isValidServiceId(track.canonicalId)) {
                        trackMetadata.trackBingId = track.canonicalId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.track_BINGID_BIT_MASK
                    }
                    else
                        trackMetadata.trackBingId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (MS.Entertainment.Utilities.isValidServiceId(album.canonicalId)) {
                        trackMetadata.albumBingId = album.canonicalId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.album_BINGID_BIT_MASK
                    }
                    else
                        trackMetadata.albumBingId = MS.Entertainment.Utilities.EMPTY_GUID;
                    if (album.artist && MS.Entertainment.Utilities.isValidServiceId(album.artist.canonicalId)) {
                        trackMetadata.artistBingId = album.artist.canonicalId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.artist_BINGID_BIT_MASK
                    }
                    if (album.uniqueFileId && track.uniqueFileId) {
                        var uniqueFileId = "{0};{1}".format(album.uniqueFileId, track.uniqueFileId);
                        trackMetadata.uniqueFileId = uniqueFileId;
                        trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.unique_FILEID_BIT_MASK
                    }
                    trackMetadata.unblockFromCloud = this._isCloudMatch;
                    trackMetadata.editedFields |= Microsoft.Entertainment.Platform.FieldMask.unblock_FROM_CLOUD_BIT_MASK
                }, _sendTelemetryEvent: function _sendTelemetryEvent(event, telemetryParameterArray) {
                    if (Array.isArray(telemetryParameterArray) && telemetryParameterArray.length > 0)
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(event, telemetryParameterArray);
                    else
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(event)
                }, _sendTelemetryPageAction: function _sendTelemetryPageAction(domElement, targetPage, media, pageContentDataObject) {
                    var targetPageData;
                    if (targetPage !== this._currentPage)
                        targetPageData = targetPage ? {
                            uri: "findAlbumInfo/" + targetPage, pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popover
                        } : {
                            uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.TelemetryParameterValues.Unknown
                        };
                    if (!pageContentDataObject)
                        pageContentDataObject = {
                            domElement: domElement, itemPropertyBag: media
                        };
                    MS.Entertainment.Utilities.Telemetry.logPageAction(pageContentDataObject, {
                        uri: "findAlbumInfo/" + this._currentPage, pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popover
                    }, targetPageData)
                }, _createTelemetryActionData: function _createTelemetryActionData(areaName, automationId, slot) {
                    return {
                            slot: slot, areaName: areaName, contentId: automationId, contentCatalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.App, contentSourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.App, contentTypeId: MS.Entertainment.Utilities.Telemetry.ContentTypeId.App, contentName: automationId
                        }
                }
        }, {
            tracks: null, subTitle: String.empty
        }, {
            Page: {
                selectAlbum: "selectAlbum", searchAlbums: "searchAlbums", matchTracks: "matchTracks"
            }, MatchMode: {
                    library: "library", cloud: "cloud"
                }, MatchSource: {
                    eds: "eds", wmis: "wmis", musicMatch: "musicMatch"
                }, _maxSearchTextLength: 100
        })});
    WinJS.Namespace.define("MS.Entertainment.Music", {FindAlbumInfoLoadingControl: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/FindAlbumInfo.html#loadingControlTemplate", null, {
            initialize: function initialize() {
                this.bind("isBusy", function isBusyChanged(isBusy) {
                    this._loadingProgress.isBusy = isBusy
                }.bind(this));
                this.bind("isOffline", function isOfflineChanged(isOffline) {
                    this._loadingOffline.visibility = isOffline;
                    if (isOffline)
                        this.isBusy = false
                }.bind(this))
            }, reset: function reset() {
                    this.isBusy = false;
                    this.isOffline = false
                }
        }, {
            isBusy: false, isOffline: false
        })});
    WinJS.Namespace.define("MS.Entertainment.Music", {FindAlbumInfoDialog: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.Dialog", "Components/Music/FindAlbumInfo.html#dialogTemplate", null, {
            backClickHandler: null, searchAlbumsClickHandler: null, bulkMatchClickHandler: null, onBackClick: function onBackClick(event) {
                    if (this.backClickHandler)
                        this.backClickHandler(event)
                }, onSearchAlbumsClick: function onSearchAlbumsClick(event) {
                    if (this.searchAlbumsClickHandler)
                        this.searchAlbumsClickHandler(event)
                }, onBulkMatchClick: function onBulkMatchClick(event) {
                    if (this.bulkMatchClickHandler)
                        this.bulkMatchClickHandler(event)
                }
        }, null, {show: function show(album, mode) {
                var options = {
                        width: "900px", height: "700px", cancelButtonIndex: 2, defaultButtonIndex: -1, title: String.load(String.id.IDS_FAI_CHOOSE_ALBUM_TITLE), userControl: "MS.Entertainment.Music.FindAlbumInfo", userControlOptions: {
                                _originalAlbum: album, _matchMode: mode
                            }, persistOnNavigate: false
                    };
                var dialog = new MS.Entertainment.Music.FindAlbumInfoDialog(document.createElement("div"), options);
                return dialog.show()
            }})});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {FindAlbumInfoAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function findAlbumInfoAction() {
            this.base()
        }, {
            executed: function executed(param) {
                var mediaItems = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                var options = mediaContext.options || {};
                if (!mediaItems)
                    mediaItems = mediaContext.mediaItem;
                MS.Entertainment.Data.List.getData(mediaItems, 0).then(function showFindAlbumInfoDialog(album) {
                    var mode = MS.Entertainment.Music.FindAlbumInfo.MatchMode.library;
                    var cloudServiceEnabled = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection).isEnabled;
                    if (cloudServiceEnabled && album.remoteTracksCount > 0) {
                        mode = MS.Entertainment.Music.FindAlbumInfo.MatchMode.cloud;
                        if (!MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).isSignedIn)
                            return MS.Entertainment.Music.MusicBrandDialog.show(String.load(String.id.IDS_MUSIC_STREAMING_ADD_TO_MY_MUSIC_TITLE), String.load(String.id.IDS_MUSIC_STREAMING_SIGN_IN_DESC), null, [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signUp, MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel])
                    }
                    return MS.Entertainment.Music.FindAlbumInfoDialog.show(album, mode)
                }.bind(this)).done(function findAlbumInfoDialogClosed(dialog) {
                    if (dialog && dialog.userControlInstance && dialog.userControlInstance.collectionUpdated && mediaContext)
                        mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.findAlbumInfo)
                }, function findAlbumInfoDialogError(error) {
                    MS.Entertainment.ViewModels.fail("FindAlbumInfo Dialog Failure: " + (error && error.message))
                })
            }, canExecute: function canExecute(parameter) {
                    return true
                }
        })});
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.findAlbumInfo, function() {
        return new MS.Entertainment.ViewModels.FindAlbumInfoAction
    })
})()
