﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Actions");
WinJS.Namespace.define("MS.Entertainment.UI.Actions.ImportPlaylists", {
    AutomationIds: {
        appBarImportAction: "appBarImportPlaylistsAction", playPlaylistsImportAction: "playPlaylistsImportPlaylistsAction", emptyCollectionImportAction: "emptyCollectionImportPlaylistsAction"
    }, _configurationManager: null, _mediaStore: null, _getConfigurationManager: function _getConfigurationManager() {
            if (!MS.Entertainment.UI.Actions.ImportPlaylists._configurationManager)
                MS.Entertainment.UI.Actions.ImportPlaylists._configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
            return MS.Entertainment.UI.Actions.ImportPlaylists._configurationManager
        }, _getMediaStore: function _getMediaStore() {
            if (!MS.Entertainment.UI.Actions.ImportPlaylists._mediaStore)
                MS.Entertainment.UI.Actions.ImportPlaylists._mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
            return MS.Entertainment.UI.Actions.ImportPlaylists._mediaStore
        }, _grovelerPlaylistImportCompleted: function _grovelerPlaylistImportCompleted() {
            return MS.Entertainment.UI.Actions.ImportPlaylists._getConfigurationManager().groveler.playlistImportCompleted
        }
});
WinJS.Namespace.define("MS.Entertainment.UI.Actions.ImportPlaylists", {
    ImportPlaylistsAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function importPlaylistsAction() {
        this.base()
    }, {
        automationId: MS.Entertainment.UI.Actions.ImportPlaylists.AutomationIds.emptyCollectionImportAction, executed: function executed(param) {
                return MS.Entertainment.UI.Actions.ImportPlaylists._showImportPlaylistsOverlay()
            }, canExecute: function canExecute(param) {
                return true
            }
    }), getImportPlaylistsAction: function getImportPlaylistsAction() {
            var importPlaylistsAction = new MS.Entertainment.UI.ToolbarAction;
            importPlaylistsAction.id = MS.Entertainment.UI.AppBarActions.importPlaylists;
            importPlaylistsAction.title = String.load(String.id.IDS_PLAYLIST_IMPORT_PLAYLIST_BUTTON);
            importPlaylistsAction.icon = WinJS.UI.AppBarIcon.importall;
            importPlaylistsAction.automationId = MS.Entertainment.UI.Actions.ImportPlaylists.AutomationIds.appBarImportAction;
            importPlaylistsAction.executed = function executed(param) {
                return MS.Entertainment.UI.Actions.ImportPlaylists._showImportPlaylistsOverlay()
            };
            importPlaylistsAction.canExecute = function canExecute(param) {
                return !MS.Entertainment.UI.Actions.ImportPlaylists._importInProgress && MS.Entertainment.UI.Actions.ImportPlaylists._grovelerPlaylistImportCompleted()
            };
            return {action: importPlaylistsAction}
        }, getDoImportPlaylistsAction: function getDoImportPlaylistsAction() {
            var importPlaylistsAction = new MS.Entertainment.UI.ToolbarAction;
            var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
            var options = mediaContext.options || {};
            var location = options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas;
            importPlaylistsAction.parameter = {
                actionType: MS.Entertainment.UI.Actions.ActionWrapperType.button, executeLocation: location
            };
            importPlaylistsAction.id = MS.Entertainment.UI.AppBarActions.importPlaylists;
            importPlaylistsAction.title = String.load(String.id.IDS_PLAYLIST_IMPORT_PLAYLIST_BUTTON);
            importPlaylistsAction.icon = WinJS.UI.AppBarIcon.importall;
            importPlaylistsAction.automationId = MS.Entertainment.UI.Actions.ImportPlaylists.AutomationIds.playPlaylistsImportAction;
            importPlaylistsAction.shouldAutomaticallySendTelemetry = false;
            importPlaylistsAction.executed = function executed() {
                if (MS.Entertainment.UI.Actions.ImportPlaylists._importInProgress)
                    return MS.Entertainment.UI.Actions.ImportPlaylists._showImportInProgressOverlay();
                else
                    return MS.Entertainment.UI.Actions.ImportPlaylists._startPlaylistImport()
            }.bind(this);
            importPlaylistsAction.canExecute = function canExecute() {
                return true
            };
            return importPlaylistsAction
        }, _startPlaylistImport: function _startPlaylistImport(resumeLastImport) {
            var playlistProvider = MS.Entertainment.UI.Actions.ImportPlaylists._getMediaStore().playlistProvider;
            MS.Entertainment.UI.Actions.ImportPlaylists._setImportInProgress(true);
            var importPromise = resumeLastImport ? playlistProvider.resumeImportPlaylistsAsync() : playlistProvider.importPlaylistsAsync();
            importPromise.then(function success(result) {
                MS.Entertainment.UI.Actions.ImportPlaylists._showImportCompleteNotification(result.importPlaylistsCount)
            }, function error(error) {
                MS.Entertainment.UI.Actions.ImportPlaylists._showImportFailedNotification(error)
            }).done(function finishImport() {
                MS.Entertainment.UI.Actions.ImportPlaylists._setImportInProgress(false)
            });
            if (MS.Entertainment.UI.Actions.ImportPlaylists._importInProgress)
                MS.Entertainment.UI.Actions.ImportPlaylists._showImportInProgressNotification();
            return WinJS.Promise.wrap()
        }, resumeLastPlaylistImport: function resumeLastPlaylistImport() {
            if (!MS.Entertainment.UI.Actions.ImportPlaylists._grovelerPlaylistImportCompleted())
                this._startPlaylistImport(true);
            else
                MS.Entertainment.UI.Actions.ImportPlaylists._getMediaStore().playlistProvider.resumeImportPlaylistsAsync()
        }, _setImportInProgress: function _setImportInProgress(isImporting) {
            MS.Entertainment.UI.Actions.ImportPlaylists._importInProgress = isImporting;
            var appToolbarService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
            var importAction = appToolbarService.getToolbarAction(MS.Entertainment.UI.AppBarActions.importPlaylists);
            if (importAction)
                importAction.requeryCanExecute()
        }, _showImportPlaylistsOverlay: function _showImportPlaylistsOverlay() {
            if (MS.Entertainment.UI.Actions.ImportPlaylists._importInProgress)
                return MS.Entertainment.UI.Actions.ImportPlaylists._showImportInProgressOverlay();
            var overlayWidth = "40%";
            var overlayHeight = "310px";
            return MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_PLAYLIST_IMPORT_DIALOG_TITLE), String.load(String.id.IDS_PLAYLIST_IMPORT_DIALOG_DESC_TEXT), {
                    width: overlayWidth, height: overlayHeight, buttons: [WinJS.Binding.as({
                                title: String.load(String.id.IDS_PLAYLIST_IMPORT_PLAYLIST_BUTTON), execute: function executeSubmit(dialog) {
                                        MS.Entertainment.UI.Actions.ImportPlaylists._startPlaylistImport();
                                        dialog.hide()
                                    }
                            }), WinJS.Binding.as({
                                title: String.load(String.id.IDS_CANCEL_BUTTON_TC), execute: function executeCancel(dialog) {
                                        dialog.hide()
                                    }
                            })], defaultButtonIndex: 0, cancelButtonIndex: 1
                })
        }, _showImportInProgressOverlay: function _showImportInProgressOverlay() {
            return MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_PLAYLIST_IMPORT_IN_PROGRESS_DIALOG_TITLE), String.load(String.id.IDS_PLAYLIST_IMPORT_IN_PROGRESS_DIALOG_DESC_TEXT))
        }, _showImportInProgressNotification: function _showImportInProgressNotification() {
            var appNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification);
            appNotificationService.send(new MS.Entertainment.UI.Notification({
                notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(String.id.IDS_PLAYLIST_IMPORT_IN_PROGRESS), subTitle: String.empty, moreDetails: null, icon: WinJS.UI.AppBarIcon.importall, action: null, secondaryActions: null, category: MS.Entertainment.UI.Actions.ImportPlaylists._importNotificationCategory, isPersistent: true, dismissOnSignOut: true
            }))
        }, _showImportCompleteNotification: function _showImportCompleteNotification(count) {
            var appNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification);
            appNotificationService.send(new MS.Entertainment.UI.Notification({
                notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(String.id.IDS_PLAYLIST_IMPORT_COMPLETED), subTitle: MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.playlistsAddedCountText), moreDetails: null, icon: WinJS.UI.AppBarIcon.importall, action: null, secondaryActions: null, category: MS.Entertainment.UI.Actions.ImportPlaylists._importNotificationCategory, isPersistent: false, dismissOnSignOut: true
            }))
        }, _showImportFailedNotification: function _showImportFailedNotification(error) {
            var appNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification);
            appNotificationService.removeNotificationByCategory(MS.Entertainment.UI.Actions.ImportPlaylists._importNotificationCategory);
            appNotificationService.send(new MS.Entertainment.UI.Notification({
                notificationType: MS.Entertainment.UI.Notification.Type.Critical, title: String.load(String.id.IDS_PLAYLIST_IMPORT_FAILURE_OCCURRED), subTitle: String.load(String.id.IDS_PLAYLIST_IMPORT_FAILURE_SUBTITLE), moreDetails: null, icon: WinJS.UI.AppBarIcon.importall, action: MS.Entertainment.UI.Actions.ImportPlaylists._getImportPlaylistErrorAction(error), secondaryActions: null, category: MS.Entertainment.UI.Actions.ImportPlaylists._importNotificationCategory, isPersistent: true, dismissOnSignOut: true
            }))
        }, _getImportPlaylistErrorAction: function _getImportPlaylistErrorAction(error) {
            return function showImportPlaylistError() {
                    MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_PLAYLIST_IMPORT_FAILURE_OCCURRED), String.load(String.id.IDS_PLAYLIST_IMPORT_FAILURE_DETAIL))
                }
        }, _importInProgress: false, _importNotificationCategory: "playlistImport"
});
MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.importPlaylists, function() {
    return new MS.Entertainment.UI.Actions.ImportPlaylists.ImportPlaylistsAction
})
