﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {localGrovelInfo: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/LocalGrovelInfo.html#localGrovelInfoTemplate", function localGrovelInfo(element, options) {
            this._cancelButton = WinJS.Binding.as({
                title: String.load(String.id.IDS_CLOSE_BUTTON), isEnabled: true, isAvailable: true, execute: function onCancel() {
                        this._onCancel()
                    }.bind(this)
            });
            var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
            if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace))
                this.addMusicDialogBodyText = String.load(String.id.IDS_MUSIC_CLOUD_ADD_MUSIC_DIALOG_BODY_XBOX);
            else
                this.addMusicDialogBodyText = String.load(String.id.IDS_MUSIC_CLOUD_ADD_MUSIC_DIALOG_BODY)
        }, {
            _cancelButton: null, _container: null, addMusicDialogBodyText: String.empty, initialize: function initialize(){}, setOverlay: function setOverlay(container) {
                    this._container = container;
                    container.buttons = [this._cancelButton];
                    this._updateState()
                }, _onCancel: function _onCancel() {
                    this._sendTelemetryEvent("LocalGrovelInfo_Cancel");
                    this._container.hide()
                }, _updateState: function _updateState() {
                    this.moreAboutLibrariesWebLink.domElement.href = MS.Entertainment.UI.FWLink.musicLibraries
                }, _showElement: function _showElement(element, show) {
                    if (element.domElement)
                        element = element.domElement;
                    if (show)
                        WinJS.Utilities.removeClass(element, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(element, "removeFromDisplay")
                }, _sendTelemetryEvent: function _sendTelemetryEvent(event) {
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEvent(event)
                }
        }, {}, {})});
    WinJS.Namespace.define("MS.Entertainment.Music", {localGrovelInfoDialog: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.Dialog", "Components/Music/LocalGrovelInfo.html#dialogTemplate", null, {}, null, {show: function show() {
                var options = {
                        width: "900px", height: "500px", cancelButtonIndex: 0, defaultButtonIndex: 0, title: String.load(String.id.IDS_MUSIC_CLOUD_ADD_MUSIC_DIALOG_TITLE), userControl: "MS.Entertainment.Music.localGrovelInfo", userControlOptions: {}, persistOnNavigate: false
                    };
                var dialog = new MS.Entertainment.Music.localGrovelInfoDialog(document.createElement("div"), options);
                return dialog.show()
            }})});
    WinJS.Namespace.define("MS.Entertainment.Music", {ShowLocalGrovelInfoDialogAction: MS.Entertainment.deferredDerive(MS.Entertainment.UI.Actions.Action, null, {
            automationId: MS.Entertainment.UI.AutomationIds.showLocalGrovelInfoDialog, executed: function executed(param) {
                    if (WinJS.Utilities.getMember("Windows.Storage.StorageLibrary"))
                        return MS.Entertainment.UI.Controls.ManageFoldersDialog.show();
                    else
                        return MS.Entertainment.Music.localGrovelInfoDialog.show()
                }, canExecute: function canExecute(param) {
                    return true
                }
        })});
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.showLocalGrovelInfoDialog, function getLocalGrovelInfoDialogAction() {
        return new MS.Entertainment.Music.ShowLocalGrovelInfoDialogAction
    })
})()
