﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.ViewModels");
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {
        _MusicState: {
            _featureEnablement: null, _networkStatus: null, _signInService: null, _signedInUserService: null, _navigationService: null, _uiStateService: null, _sessionManager: null, _cloudServiceManager: null, _initialized: false, _inMusicApp: false, _downloadEnabled: false, _musicMarketplaceEnabled: false, _musicSubscriptionEnabled: false, _freeStreamEnabled: false, _consoleRegionEnabled: false, _shouldDownloadOnAdd: false, _pinToStartScreenEnabled: false, _actions: null, _init: function _init() {
                    if (!this._initialized) {
                        this._featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        this._configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                        this._networkStatus = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.networkStatus);
                        this._signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        this._signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                        this._uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        this._musicMarketplaceEnabled = this._featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace);
                        this._musicSubscriptionEnabled = this._featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                        this._musicSmartDJEnabled = this._featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.smartDJMarketplace);
                        this._freeStreamEnabled = this._featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay);
                        this._consoleRegionEnabled = this._featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.xbox360ConsoleRegions);
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation))
                            this._navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        this._actions = MS.Entertainment.UI.AppBarActions;
                        this._inMusicApp = MS.Entertainment.Utilities.isMusicApp;
                        this._downloadEnabled = MS.Entertainment.Utilities.isMusicApp1;
                        this._pinToStartScreenEnabled = MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.pinToStartScreen);
                        if (this._inMusicApp)
                            this._cloudServiceManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection);
                        this._initialized = true
                    }
                }, getCurrentState: function getCurrentState(media, stateInfo) {
                    this._init();
                    var isRemoteSession = false;
                    if (media.mediaType !== undefined) {
                        this._sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        isRemoteSession = this._sessionManager && this._sessionManager.primarySession && this._sessionManager.primarySession.isRemoteSession && this._sessionManager.primarySession.isRemoteSession()
                    }
                    var isSnapped = this._uiStateService.isSnapped;
                    var musicMarketplaceConnected = this._musicMarketplaceEnabled && this._networkStatus.isEnabled(MS.Entertainment.UI.NetworkStatusService.NetworkedFeature.musicMarketplace);
                    var currentLocation = MS.Entertainment.Utilities.getCurrentUserLocation();
                    var isMarketplaceArtist = (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person && media.hasServiceId);
                    var showArtistDetails;
                    if (isSnapped)
                        showArtistDetails = false;
                    else if (window.onNewMusicPage) {
                        var isCurrentLocationLXPage;
                        if (this._navigationService)
                            isCurrentLocationLXPage = MS.Entertainment.UI.Monikers && this._navigationService.currentPage && this._navigationService.currentPage.iaNode.moniker === MS.Entertainment.UI.Monikers.homeHub;
                        else
                            isCurrentLocationLXPage = true;
                        showArtistDetails = isCurrentLocationLXPage && (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person || media.artist)
                    }
                    else
                        showArtistDetails = musicMarketplaceConnected && (media.artist && media.artist.hasServiceId || isMarketplaceArtist);
                    if (showArtistDetails && MS.Entertainment.UI.Monikers && currentLocation === MS.Entertainment.UI.Monikers.immersiveDetails) {
                        var currentPageArtist = this._navigationService && this._navigationService.currentPage && this._navigationService.currentPage.options && this._navigationService.currentPage.options.mediaItem;
                        currentPageArtist = currentPageArtist.artist || currentPageArtist;
                        if (currentPageArtist && media.isChildOf && media.isEqual)
                            showArtistDetails = !media.isEqual(currentPageArtist) && !media.isChildOf(currentPageArtist);
                        else if (media.mediaType && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person)
                            showArtistDetails = false
                    }
                    var isSignedIn = this._signInService.isSignedIn;
                    var signedInUserHasSubscription = isSignedIn && this._signedInUserService.isSubscription;
                    var cachedSubscriptionStatus = this._configurationManager.service.lastSignedInUserSubscription;
                    var canAddToNowPlaying = !this._sessionManager || !this._sessionManager.primarySession.smartDJSeed;
                    var canSaveNowPlaying = this._sessionManager && (!this._sessionManager.playContext || !this._sessionManager.playContext.activationFilePath);
                    var isPlaylistTrack = media.playlistItemId >= 0;
                    var canDelete = media.isRemovable;
                    var canFindAlbumInfo = (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album) && media.fromCollection && stateInfo && stateInfo.collection.playability.counts.local > 0;
                    var canPlayOnXbox = musicMarketplaceConnected && this._musicSubscriptionEnabled && this.shouldPlayOnXbox360() && signedInUserHasSubscription && this._consoleRegionEnabled && media.mediaType && media.mediaType !== Microsoft.Entertainment.Queries.ObjectType.playlist && media.mediaType !== Microsoft.Entertainment.Queries.ObjectType.smartDJ && ((signedInUserHasSubscription && media.fromCollection && stateInfo.collection.canStreamFromCloud) || (isMarketplaceArtist || MS.Entertainment.ViewModels.MusicStateHelpers._canXboxAccessMusicMedia(media, [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Stream])));
                    var canDownloadPurchasedTrack = this._downloadEnabled && stateInfo.marketplace.hasPurchased && stateInfo.marketplace.canDownload && stateInfo.download.items.length === 0 && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track;
                    var isDownloadingPurchasedTrack = this._downloadEnabled && stateInfo.marketplace.hasPurchased && stateInfo.marketplace.canDownload && stateInfo.download.items.length > 0 && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track;
                    var canShowMediaProperties = !isSnapped && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && (media.hydrated || media.fromCollection);
                    var canSubscriptionDownload = false;
                    if (musicMarketplaceConnected && this._musicSubscriptionEnabled && signedInUserHasSubscription)
                        if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist)
                            canSubscriptionDownload = (media.count > 0);
                        else
                            canSubscriptionDownload = (!media.hasLocalContent && media.hasServiceId) || (stateInfo.collection.playability.counts.cloudOnly > 0 && stateInfo.collection.playability.counts.cloudOnly > stateInfo.collection.playability.counts.downloading);
                    var canPlayLocallyOrStreamFromCloud = stateInfo && (stateInfo.collection.canPlayLocally || (stateInfo.collection.canStreamFromCloud && musicMarketplaceConnected));
                    var freeStreamEnabled = this._musicMarketplaceEnabled && this._freeStreamEnabled && (!isSignedIn || !signedInUserHasSubscription);
                    var canFreeStream = false;
                    var freeStreamBlockedByFreeLimits = false;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits)) {
                        var freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                        canFreeStream = (freeStreamEnabled && musicMarketplaceConnected && ((Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToByRef && MS.Entertainment.Utilities.isWindowsBlue) || !isRemoteSession) && (media.mediaType !== Microsoft.Entertainment.Queries.ObjectType.track || MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(media)));
                        freeStreamBlockedByFreeLimits = canFreeStream && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && (freePlayLimits.isMonthlyFreeLimitExceeded || media.isFreeStreamRestrictedByIndividualLimit || media.isFreeStreamRestrictedByMonthlyLimit)
                    }
                    var smartDJEnabled = this._musicSmartDJEnabled && this._musicMarketplaceEnabled && ((isSignedIn && this._signedInUserService.isSubscription) || freeStreamEnabled);
                    var canPlaySmartDJ = musicMarketplaceConnected && (media.hasSmartDJ || (media.artist && media.artist.hasSmartDJ)) && smartDJEnabled && ((Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToByRef && MS.Entertainment.Utilities.isWindowsBlue) || !isRemoteSession);
                    var cloudServiceEnabled = this._cloudServiceManager && this._cloudServiceManager.isEnabled;
                    var canAddToCloud = this._cloudServiceManager && this._cloudServiceManager.isFeatureEnabled && (cloudServiceEnabled || !isSignedIn) && media.fromCollection && !isSnapped && stateInfo && (stateInfo.collection.playability.counts.cloud === 0 || stateInfo.collection.playability.counts.localOnly > 0) && (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album || media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track);
                    var canPlayTopSongs = isMarketplaceArtist && ((this._musicSubscriptionEnabled && signedInUserHasSubscription) || canFreeStream);
                    var downloadOrLocalOrCloudCount = stateInfo ? stateInfo.collection.playability.counts.downloading + stateInfo.collection.playability.counts.localOrCloud : 0;
                    var marketplaceCount = 1;
                    if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album)
                        if (media.tracks && media.tracks.count > (media.trackCount || 0))
                            marketplaceCount = media.tracks.count;
                        else
                            marketplaceCount = media.trackCount >= 0 ? media.trackCount : downloadOrLocalOrCloudCount + 1;
                    var canAddToMyMusic = musicMarketplaceConnected && (canFreeStream || (this._musicSubscriptionEnabled && signedInUserHasSubscription) || (stateInfo.marketplace.hasPurchased && cloudServiceEnabled)) && ((downloadOrLocalOrCloudCount < marketplaceCount) || (media.collectionState === Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights)) && media.mediaType !== Microsoft.Entertainment.Queries.ObjectType.person;
                    var canAddToPlaylist = ((media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person)) && (!stateInfo || (stateInfo.collection.playability.counts.downloading > 0) || (stateInfo.collection.playability.counts.localOrCloud > 0) || (musicMarketplaceConnected && (canFreeStream || (this._musicSubscriptionEnabled && signedInUserHasSubscription) || (stateInfo.marketplace.hasPurchased && cloudServiceEnabled))));
                    var canPinToStartScreen = this._pinToStartScreenEnabled && ((media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person) || (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.smartDJ));
                    var downloadOnAddToMyMusicCloud = this._cloudServiceManager && this._cloudServiceManager.shouldDownloadOnAdd;
                    var showRelatedArtists = !!(media.artist && media.artist.hasCanonicalId);
                    return {
                            actions: this._actions, musicMarketplaceConnected: musicMarketplaceConnected, musicSubscriptionEnabled: this._musicSubscriptionEnabled, smartDJEnabled: smartDJEnabled, canPlayOnXbox: canPlayOnXbox, consoleRegionEnabled: this._consoleRegionEnabled, showAlbumDetailsAction: function() {
                                    return !isSnapped && media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && media.album && (media.album.hasServiceId || media.album.hasLibraryId) && (MS.Entertainment.Utilities.isValidLibraryId(media.playlistId) || !MS.Entertainment.UI.Controls.PopOver.isPopoverOpen)
                                }.bind(this), showArtistDetailsButton: showArtistDetails, showArtistDetailsAction: function() {
                                    var elements;
                                    var nonPlaylistPopOverOpen;
                                    if (showArtistDetails && (!media || !MS.Entertainment.Utilities.isValidLibraryId(media.playlistId)))
                                        nonPlaylistPopOverOpen = MS.Entertainment.UI.Controls.PopOver.isPopoverOpen;
                                    return showArtistDetails && !nonPlaylistPopOverOpen
                                }.bind(this), canPinToStartScreen: canPinToStartScreen, isSignedIn: isSignedIn, signedInUserHasSubscription: signedInUserHasSubscription, cachedSubscriptionStatus: cachedSubscriptionStatus, isPlaylistTrack: isPlaylistTrack, isSnapped: isSnapped, canDelete: canDelete, canAddToNowPlaying: canAddToNowPlaying, canSaveNowPlaying: canSaveNowPlaying, canPlaySmartDJ: canPlaySmartDJ, canShowMediaProperties: canShowMediaProperties, canSubscriptionDownload: canSubscriptionDownload, canFreeStream: canFreeStream, canPlayTopSongs: canPlayTopSongs, canPlayLocallyOrStreamFromCloud: canPlayLocallyOrStreamFromCloud, freeStreamEnabled: this._freeStreamEnabled, canFindAlbumInfo: canFindAlbumInfo, canAddToCloud: canAddToCloud, isRemoteSession: isRemoteSession, cloudServiceEnabled: cloudServiceEnabled, canAddToMyMusic: canAddToMyMusic, canAddToPlaylist: canAddToPlaylist, canDownloadPurchasedTrack: canDownloadPurchasedTrack, isDownloadingPurchasedTrack: isDownloadingPurchasedTrack, downloadOnAddToMyMusicCloud: downloadOnAddToMyMusicCloud, showRelatedArtists: showRelatedArtists, freeStreamBlockedByFreeLimits: freeStreamBlockedByFreeLimits
                        }
                }, shouldPlayOnXbox360: function shouldPlayOnXbox360() {
                    return !MS.Entertainment.Utilities.isWindowsBlue
                }
        }, MusicStateHelpers: {
                _canXboxAccessMusicMedia: function _canXboxAccessMusicMedia(media, rights) {
                    MS.Entertainment.ViewModels.assert(media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album || media.mediaType === Microsoft.Entertainment.Queries.ObjectType.track || media.mediaType === Microsoft.Entertainment.Queries.ObjectType.person, "Unexpected mediaType: " + media.mediaType);
                    var currentIndex = 0;
                    var canAccess = false;
                    var mediaToCheck;
                    if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album) {
                        mediaToCheck = media.tracks || media.marketplaceTracks;
                        if (MS.Entertainment.Data.List.isList(mediaToCheck)) {
                            var mediaToCheckArray = [];
                            mediaToCheck.forEach(function addMedia(args) {
                                mediaToCheckArray.push(args.item.data)
                            });
                            mediaToCheck = mediaToCheckArray
                        }
                    }
                    if (!mediaToCheck)
                        mediaToCheck = [media];
                    while (!canAccess && currentIndex < mediaToCheck.length) {
                        canAccess = MS.Entertainment.ViewModels.SmartBuyStateHandlers._canXboxAccessMedia(mediaToCheck[currentIndex], rights);
                        currentIndex++
                    }
                    return canAccess
                }, _getDownloadAppBarActions: function _getDownloadAppBarActions(appState, stateInfo, mediaItem) {
                        if (!appState) {
                            MS.Entertainment.UI.fail("Expected app state to be defined.");
                            return []
                        }
                        var downloadActionSet = {
                                tryDownloadAgain: appState.actions.tryDownloadAgain, removeFailedDownload: appState.actions.removeFailedDownload, subscriptionDownload: appState.actions.subscriptionDownload, downloadFromMarketplace: appState.actions.downloadFromMarketplace
                            };
                        return MS.Entertainment.ViewModels.MusicStateHelpers._getDownloadActions(stateInfo, mediaItem, downloadActionSet)
                    }, _getDownloadButtons: function _getDownloadButtons(mediaButtons, stateInfo, mediaItem) {
                        if (!mediaButtons) {
                            MS.Entertainment.UI.fail("Expected button set to be defined.");
                            return []
                        }
                        var downloadActionSet = {
                                tryDownloadAgain: mediaButtons.tryAgain, removeFailedDownload: mediaButtons.remove, subscriptionDownload: mediaButtons.subscriptionDownload, downloadFromMarketplace: mediaButtons.download
                            };
                        return MS.Entertainment.ViewModels.MusicStateHelpers._getDownloadActions(stateInfo, mediaItem, downloadActionSet)
                    }, _getDownloadActions: function _getDownloadActions(stateInfo, mediaItem, downloadActionSet) {
                        MS.Entertainment.UI.assert(mediaItem && stateInfo, "This function requires a valid media item and state info.");
                        mediaItem = mediaItem || {};
                        if (!stateInfo)
                            return actions;
                        var actions = [];
                        if (stateInfo.download.hasFailed)
                            if (stateInfo.download.hasRetryable) {
                                MS.Entertainment.UI.assert(downloadActionSet.tryDownloadAgain, "Missing action: tryDownloadAgain");
                                actions.push(downloadActionSet.tryDownloadAgain)
                            }
                            else {
                                MS.Entertainment.UI.assert(downloadActionSet.removeFailedDownload, "Missing action: removeFailedDownload");
                                actions.push(downloadActionSet.removeFailedDownload)
                            }
                        else if (mediaItem.canPurchaseDownload && !stateInfo.collection.canPlayLocally && !stateInfo.download.hasActive) {
                            MS.Entertainment.UI.assert(downloadActionSet.downloadFromMarketplace, "Missing action: downloadFromMarketplace");
                            actions.push(downloadActionSet.downloadFromMarketplace)
                        }
                        else if (mediaItem.canSubscriptionDownload && !stateInfo.collection.canPlayLocally && !stateInfo.download.hasActive) {
                            MS.Entertainment.UI.assert(downloadActionSet.subscriptionDownload, "Missing action: subscriptionDownload");
                            actions.push(downloadActionSet.subscriptionDownload)
                        }
                        else {
                            var hasDownloads = false;
                            var shouldRunMachineActivationCheck = true;
                            var playabilityItems = stateInfo.collection.playability.items;
                            var entitlements = stateInfo.marketplace.entitlements;
                            if (playabilityItems && playabilityItems.length > 0 && entitlements && entitlements.length > 0) {
                                var hasNonLocalMedia = false;
                                var nonLocalMedia = {};
                                for (var i = 0; i < playabilityItems.length; i++) {
                                    var playabilityItem = playabilityItems[i];
                                    if (playabilityItem && playabilityItem.mediaId && !playabilityItem.isDownloading && !playabilityItem.locallyPlayable) {
                                        nonLocalMedia[playabilityItem.mediaId.toLowerCase()] = playabilityItem;
                                        hasNonLocalMedia = true
                                    }
                                }
                                if (hasNonLocalMedia)
                                    for (var i = 0; i < entitlements.length; i++) {
                                        var entitlement = entitlements[i];
                                        if (entitlement && entitlement.canFullyDownload && nonLocalMedia[entitlement.serviceMediaId.toLowerCase()]) {
                                            hasDownloads = true;
                                            var downloadLicenseRight = 200;
                                            if (entitlement.purchase.download.isAvailable && downloadLicenseRight !== entitlement.purchase.download.licenseRight) {
                                                shouldRunMachineActivationCheck = false;
                                                break
                                            }
                                        }
                                    }
                            }
                            if (hasDownloads)
                                if (shouldRunMachineActivationCheck) {
                                    MS.Entertainment.UI.assert(downloadActionSet.subscriptionDownload, "Missing action: subscriptionDownload");
                                    actions.push(downloadActionSet.subscriptionDownload)
                                }
                                else {
                                    MS.Entertainment.UI.assert(downloadActionSet.downloadFromMarketplace, "Missing action: downloadFromMarketplace");
                                    actions.push(downloadActionSet.downloadFromMarketplace)
                                }
                        }
                        MS.Entertainment.UI.Actions.assert(actions.length <= 1, "Expected at most 1 action to be returned, actual: " + actions.length);
                        return actions
                    }
            }
    })
})()
