﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/utilities.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {MusicBrandDialogContent: MS.Entertainment.UI.Framework.defineUserControl("Components/Music/MusicBrandDialog.html#dialogContentTemplate", function musicBrandDialogContentConstructor(element, options){}, {}, {
            description: null, actionLink: null
        })});
    WinJS.Namespace.define("MS.Entertainment.Music", {MusicBrandDialog: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.Dialog", "Components/Music/MusicBrandDialog.html#dialogTemplate", function musicBrandDialog(element, options){}, {
            mediaItem: null, buttonIds: null, dialogDismissedCallback: null, persistOnNavigate: true, initialize: function initialize() {
                    MS.Entertainment.UI.Controls.Dialog.prototype.initialize.call(this);
                    this._xenonTitle.innerText = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).applicationTitle;
                    this._xenonTitleIcon.innerText = MS.Entertainment.UI.Icon.xboxXenonLogo;
                    var themeNum = MS.Entertainment.Music.MusicBrandDialog.colorThemes.length;
                    var themeIndex = Math.floor(Math.random() * themeNum);
                    var theme = MS.Entertainment.Music.MusicBrandDialog.colorThemes[themeIndex];
                    WinJS.Utilities.addClass(this.musicDialog, theme)
                }, unload: function unload() {
                    MS.Entertainment.UI.Controls.Dialog.prototype.unload.call(this)
                }, _setInitialButtons: function _setInitialButtons() {
                    this.buttons = this._getButtonArray()
                }, _getButtonArray: function _getButtonArray() {
                    var buttons = [];
                    var cancelButton = {
                            title: String.load(String.id.IDS_CANCEL_BUTTON), isEnabled: true, isAvailable: true, execute: function onCancelClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogCancel);
                                    if (this.dialogDismissedCallback)
                                        this.dialogDismissedCallback()
                                }.bind(this)
                        };
                    var okButton = {
                            title: String.load(String.id.IDS_OK_BUTTON), isEnabled: true, isAvailable: true, execute: function onOkClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogOk);
                                    if (this.dialogDismissedCallback)
                                        this.dialogDismissedCallback()
                                }.bind(this)
                        };
                    var signUpButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_SIGN_IN_ACTION), isEnabled: true, isAvailable: true, execute: function onSigninClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogSignIn);
                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                    signIn.signIn().done(function signInComplete(result) {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback(result)
                                    }.bind(this), function signInError() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this))
                                }.bind(this)
                        };
                    var subscribeButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_PLAY_LIMIT_PREMIUM_ACTION), isEnabled: true, isAvailable: true, execute: function onSubscriptionClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogSubscribe);
                                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                    var action = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup);
                                    action.automationId = MS.Entertainment.UI.AutomationIds.freeLimitsSubscriptionSignup;
                                    action.execute().done(function signUpComplete() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this), function signUpError() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this))
                                }.bind(this)
                        };
                    var signInAndSubscribeButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_SIGN_IN_ACTION), isEnabled: true, isAvailable: true, execute: function onSignInAndSubscribeClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogSignInThenSignUp);
                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                    signIn.signIn().done(function signInComplete() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback();
                                        var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                        var action = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup);
                                        action.automationId = MS.Entertainment.UI.AutomationIds.freeLimitsSubscriptionSignup;
                                        action.execute()
                                    }.bind(this), function signInError() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this))
                                }.bind(this)
                        };
                    var signInNowForNewUserButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_KEEP_PLAYING_NEW_USER_ACTION), isEnabled: true, isAvailable: true, execute: function onSigninClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogSignInNowForNewUser);
                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                    signIn.signIn().done(function signInComplete(result) {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback(result)
                                    }.bind(this), function signInError() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this))
                                }.bind(this)
                        };
                    var signInNowForExistingUserButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_KEEP_PLAYING_EXISTING_USER_ACTION), isEnabled: true, isAvailable: true, execute: function onSigninClicked() {
                                    this.hide();
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogSignInNowForExistingUser);
                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                    signIn.signIn().done(function signInComplete(result) {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback(result)
                                    }.bind(this), function signInError() {
                                        if (this.dialogDismissedCallback)
                                            this.dialogDismissedCallback()
                                    }.bind(this))
                                }.bind(this)
                        };
                    var continuePlayingButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_EMPTY_ROOM_PLAY_ACTION), isEnabled: true, isAvailable: true, execute: function onKeepPlayingClicked() {
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogContinuePlaying);
                                    var onSigninCompleteOrError = function onSigninCompleteOrError() {
                                            this.hide();
                                            if (this.dialogDismissedCallback)
                                                this.dialogDismissedCallback()
                                        }.bind(this);
                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                    signIn.signIn().done(onSigninCompleteOrError, onSigninCompleteOrError)
                                }.bind(this)
                        };
                    var buyTrackButton = {
                            title: String.load(String.id.IDS_BUY_BUTTON), isEnabled: true, isAvailable: true, execute: function onBuyTrackClicked() {
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogBuyTrack);
                                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                    var purchaseAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.purchase);
                                    purchaseAction.automationId = MS.Entertainment.Music.Freeplay.Events.limitDialogBuyTrack;
                                    purchaseAction.parameter = this.mediaItem;
                                    purchaseAction.execute()
                                }.bind(this)
                        };
                    var buyAlbumButton = {
                            title: String.load(String.id.IDS_MUSIC_STREAMING_TRACK_LIMIT_BUY_ACTION), isEnabled: true, isAvailable: true, execute: function onBuyAlbumClicked() {
                                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogBuyAlbum);
                                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                    var purchaseAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.purchase);
                                    purchaseAction.automationId = MS.Entertainment.Music.Freeplay.Events.limitDialogBuyAlbum;
                                    purchaseAction.parameter = this.mediaItem;
                                    purchaseAction.execute()
                                }.bind(this)
                        };
                    for (var i = 0; i < this.buttonIds.length; i++) {
                        var button = this.buttonIds[i];
                        switch (button) {
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel:
                                buttons.push(cancelButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.continuePlaying:
                                buttons.push(continuePlayingButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.ok:
                                buttons.push(okButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signUp:
                                buttons.push(signUpButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signUpOrSubscribe:
                                var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                if (!signIn.isSignedIn)
                                    buttons.push(signUpButton);
                                else if (!signedInUser.isSubscription)
                                    buttons.push(subscribeButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.subscribe:
                                buttons.push(subscribeButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signInAndSubscribe:
                                buttons.push(signInAndSubscribeButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signInNowForNewUser:
                                buttons.push(signInNowForNewUserButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signInNowForExistingUser:
                                buttons.push(signInNowForExistingUserButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.buyTrack:
                                buttons.push(buyTrackButton);
                                break;
                            case MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.buyAlbum:
                                buttons.push(buyAlbumButton);
                                break;
                            default:
                                MS.Entertainment.Music.fail("unknown button Id: " + button);
                                break
                        }
                    }
                    return buttons
                }
        }, {}, {
            _dialogShown: false, show: function show(titleString, contentString, contentLink, buttonIds, dialogDismissedCallback, mediaItem) {
                    var showPromise;
                    var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    var networkStatus = uiStateService.networkStatus;
                    if (!uiStateService.servicesEnabled)
                        showPromise = MS.Entertainment.UI.Shell.showAppUpdateDialog();
                    else if (networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.localOnly || networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.none)
                        showPromise = MS.Entertainment.Music.MusicBrandDialog.showOfflineDialog(contentLink, dialogDismissedCallback);
                    else
                        showPromise = MS.Entertainment.Music.MusicBrandDialog._show(titleString, contentString, contentLink, buttonIds, dialogDismissedCallback, mediaItem);
                    return WinJS.Promise.as(showPromise)
                }, showOfflineDialog: function showOfflineDialog(contentLink, dialogDismissedCallback) {
                    return MS.Entertainment.Music.MusicBrandDialog._show(String.load(String.id.IDS_FAILED_PANEL_OFFLINE_HEADER), String.load(String.id.IDS_FAILED_PANEL_OFFLINE_DESC), contentLink, [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel], dialogDismissedCallback, null, "offlineDialog")
                }, showEmptyRoomDialog: function showOfflineDialog(dialogDismissedCallback) {
                    var buttons;
                    if (MS.Entertainment.Utilities.getWindowWidth() > 480)
                        buttons = [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.continuePlaying, MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.subscribe];
                    else
                        buttons = [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.continuePlaying];
                    return MS.Entertainment.Music.MusicBrandDialog._show(String.load(String.id.IDS_MUSIC_STREAMING_EMPTY_ROOM_TITLE), String.load(String.id.IDS_MUSIC_STREAMING_EMPTY_ROOM_DESC), null, buttons, dialogDismissedCallback, null, "emptyRoomDialog")
                }, _show: function _show(titleString, contentString, contentLink, buttonIds, dialogDismissedCallback, mediaItem, customStyle) {
                    if (MS.Entertainment.Music.MusicBrandDialog._dialogShown)
                        return WinJS.Promise.wrap();
                    buttonIds = buttonIds || [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel];
                    var dialogDismissedCallbackWrapper = function dialogDismissedCallbackWrapper(result) {
                            MS.Entertainment.Music.MusicBrandDialog._dialogShown = false;
                            if (dialogDismissedCallback)
                                dialogDismissedCallback(result)
                        };
                    if (contentLink && contentLink.execute) {
                        var wrappedExecute = contentLink.execute;
                        contentLink.execute = function executeWrapper() {
                            wrappedExecute();
                            dialog.hide();
                            dialogDismissedCallbackWrapper()
                        }
                    }
                    var options = {
                            title: titleString, defaultButtonIndex: 0, buttonIds: buttonIds, customStyle: customStyle, dialogDismissedCallback: dialogDismissedCallbackWrapper, mediaItem: mediaItem, userControl: "MS.Entertainment.Music.MusicBrandDialogContent", userControlOptions: {
                                    description: contentString, actionLink: contentLink
                                }
                        };
                    var dialog = new MS.Entertainment.Music.MusicBrandDialog(document.createElement("div"), options);
                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.limitDialogDisplayed);
                    MS.Entertainment.Music.MusicBrandDialog._dialogShown = true;
                    return dialog.show()
                }, colorThemes: ["blue", "green", "orange", "pink"], dialogButtonIds: {
                    cancel: "cancel", continuePlaying: "continuePlaying", ok: "ok", signUp: "signUp", signUpOrSubscribe: "signUpOrSubscribe", signInAndSubscribe: "signInAndSubscribe", signInNowForNewUser: "signInNowForNewUser", signInNowForExistingUser: "signInNowForExistingUser", subscribe: "subscribe", buyTrack: "buyTrack", buyAlbum: "buyAlbum"
                }
        })})
})()
