﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/corefx.js", "/Framework/utilities.js", "/Framework/selectionManager.js", "/Controls/pivotControls.js");
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
    WinJS.Namespace.define("MS.Entertainment.Music", {MusicFullScreenNowPlaying: MS.Entertainment.UI.Framework.defineUserControl(null, function MusicFullScreenNowPlaying(element, options) {
            this._uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState)
        }, {
            _nowPlayingManager: null, _nowPlayingContainer: null, _nowPlayingControl: null, _uiStateService: null, initialize: function initialize() {
                    var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                    this._nowPlayingContainer = document.createElement("div");
                    this._nowPlayingContainer.className = "musicFullScreenNowPlaying nowPlayingContainer win-ui-dark";
                    this.domElement.appendChild(this._nowPlayingContainer);
                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).nowPlayingTileVisible = false;
                    this._nowPlayingManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.nowPlayingControlManager);
                    WinJS.Promise.timeout(500).done(function loadNowPlaying() {
                        this._reclaimNowPlayingControl()
                    }.bind(this));
                    WinJS.Utilities.addClass(this._nowPlayingContainer, "musicTrack")
                }, unload: function unload() {
                    this._releaseNowPlayingControl();
                    this._uiStateService.nowPlayingVisible = false;
                    this._uiStateService.isFullScreenMusic = false;
                    if (this.domElement.contains(this._nowPlayingControl.domElement))
                        this._nowPlayingManager.releaseNowPlayingControl(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying);
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, freeze: function freeze() {
                    this._releaseNowPlayingControl();
                    this._uiStateService.nowPlayingVisible = false;
                    this._uiStateService.isFullScreenMusic = false;
                    MS.Entertainment.UI.Framework.UserControl.prototype.freeze.call(this)
                }, thaw: function thaw() {
                    MS.Entertainment.UI.Framework.UserControl.prototype.thaw.call(this);
                    this._reclaimNowPlayingControl()
                }, _reclaimNowPlayingControl: function _getNowPlayingControl() {
                    this._uiStateService.nowPlayingVisible = true;
                    this._uiStateService.isFullScreenMusic = true;
                    this._uiStateService.nowPlayingInset = false;
                    this._uiStateService.nowPlayingTileVisible = false;
                    this._nowPlayingControl = this._nowPlayingManager.getNowPlayingControl(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying);
                    if (this._nowPlayingContainer) {
                        MS.Entertainment.Utilities.empty(this._nowPlayingContainer);
                        this._nowPlayingContainer.appendChild(this._nowPlayingControl.domElement);
                        this._nowPlayingControl.onReparented(true)
                    }
                }, _releaseNowPlayingControl: function _releaseNowPlayingControl() {
                    if (this._initialized && this._nowPlayingControl && this.domElement.contains(this._nowPlayingControl.domElement))
                        this._nowPlayingManager.releaseNowPlayingControl(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying)
                }
        })})
})()
