﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Actions");
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.UI.Actions.Playlists", {
        ERROR_PLAYLIST_ALREADY_EXISTS: -2147024713, ERROR_MAXIMUM_PLAYLIST_LENGTH_EXCEEDED: -1056898871, getCreatePlaylistFlyoutAction: function getCreatePlaylistFlyoutAction(mediaItems, completeAction) {
                var createPlaylistFlyoutAction = new MS.Entertainment.UI.ToolbarAction;
                createPlaylistFlyoutAction.id = MS.Entertainment.UI.AppBarActions.createNewPlaylist;
                createPlaylistFlyoutAction.automationId = MS.Entertainment.UI.AutomationIds.playlistFlyoutCreatePlaylist;
                createPlaylistFlyoutAction.title = String.load(String.id.IDS_MUSIC_ADD_TO_LIST_NEW_PLAYLIST_ACTION);
                createPlaylistFlyoutAction.icon = MS.Entertainment.UI.Icon.playlist;
                createPlaylistFlyoutAction.parameter = {
                    mediaItems: mediaItems, completeAction: completeAction
                };
                createPlaylistFlyoutAction.useRelativePositioning = true;
                createPlaylistFlyoutAction.shouldAutomaticallySendTelemetry = false;
                createPlaylistFlyoutAction.executed = function executed(params) {
                    var referenceContainer;
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var options = mediaContext.options || {};
                    var executeLocation = options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas;
                    createPlaylistFlyoutAction.parameter = {
                        mediaItems: mediaItems, completeAction: completeAction, actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, executeLocation: executeLocation
                    };
                    var appBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                    if (appBar)
                        appBar.hide();
                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                    var namePlaylistAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.createPlaylist);
                    namePlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistNewPlaylistNameEntry;
                    if (this.referenceContainer && this.referenceContainer.relativeOffset) {
                        referenceContainer = this.referenceContainer.relativeOffset;
                        if (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isSnapped)
                            referenceContainer.left = (MS.Entertainment.Utilities.getWindowWidth() - 300) / 2
                    }
                    else
                        referenceContainer = {
                            left: 0, bottom: 0
                        };
                    namePlaylistAction.referenceContainer = referenceContainer;
                    namePlaylistAction.parameter = {
                        mediaItems: params.mediaItems, completeAction: params.completeAction, actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, executeLocation: executeLocation
                    };
                    namePlaylistAction.action = new MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction;
                    namePlaylistAction.execute()
                };
                createPlaylistFlyoutAction.canExecute = function canExecute(parameter) {
                    return true
                };
                return {action: createPlaylistFlyoutAction}
            }, getShowPlaylistItemInformationAction: function getShowPlaylistItemInformationAction() {
                var showPlaylistItemInformationAction = new MS.Entertainment.UI.ToolbarAction;
                showPlaylistItemInformationAction.id = MS.Entertainment.UI.AppBarActions.showPlaylistItemInformation;
                showPlaylistItemInformationAction.automationId = MS.Entertainment.UI.AutomationIds.playlistShowPlaylistInformation;
                showPlaylistItemInformationAction.title = String.load(String.id.IDS_PLAYLIST_ITEM_BUTTON_NOT_AVAILABLE);
                showPlaylistItemInformationAction.icon = MS.Entertainment.UI.Icon.info;
                showPlaylistItemInformationAction.executed = function executed() {
                    var webLink = MS.Entertainment.UI.FWLink.learnMore;
                    MS.Entertainment.UI.Shell.showMessageLinkBox(String.load(String.id.IDS_PLAYLIST_ITEM_DIALOG_NOT_AVAILABLE), String.load(String.id.IDS_PLAYLIST_ITEM_DIALOG_NO_MATCH_XBOX_MUSIC_CLOUD), webLink)
                };
                showPlaylistItemInformationAction.canExecute = function canExecute() {
                    return true
                };
                return {action: showPlaylistItemInformationAction}
            }, getAddToPlaylistMenuAction: function getAddToPlaylistMenuAction(playlist, name, completeAction, mediaItems) {
                var addToPlaylistAction = new MS.Entertainment.UI.ToolbarAction;
                addToPlaylistAction.id = MS.Entertainment.UI.AppBarActions.addToPlaylist;
                addToPlaylistAction.title = name;
                addToPlaylistAction.icon = MS.Entertainment.UI.Icon.addToPlaylist;
                addToPlaylistAction.shouldAutomaticallySendTelemetry = false;
                addToPlaylistAction.parameter = {
                    name: name, mediaItem: mediaItems, playlist: playlist, actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, commandingButtonTemplate: "/Components/Music/Music2SharedTemplates.html#addToPlaylistItemTemplate"
                };
                addToPlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistAddToPlaylistAction;
                if (addToPlaylistAction.isVoiceEnabled) {
                    addToPlaylistAction.voicePhrase = MS.Entertainment.UI.App2.VoiceStatics.normalizeStringForVoice(name);
                    addToPlaylistAction.voicePhoneticPhrase = MS.Entertainment.UI.App2.VoiceStatics.normalizeStringForVoice(name)
                }
                addToPlaylistAction.executed = function executed(params) {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var mediaItems = params.mediaItem || mediaContext.mediaItem;
                    mediaItems = MS.Entertainment.Data.List.isListOrArray(mediaItems) ? mediaItems : [mediaItems];
                    var options = mediaContext.options || {};
                    var collectionFilter = mediaContext.collectionFilter;
                    addToPlaylistAction.parameter.executeLocation = options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas;
                    MS.Entertainment.Data.List.listToArray(mediaItems).done(function gotArray(mediaItemsArray) {
                        if (mediaItemsArray.length) {
                            MS.Entertainment.UI.Actions.Playlists._appendToPlaylist(playlist.libraryId, playlist.name, mediaItemsArray, collectionFilter);
                            if (mediaContext)
                                mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.addToPlaylist)
                        }
                    })
                };
                addToPlaylistAction.canExecute = function canExecute(parameter) {
                    return true
                };
                return {action: addToPlaylistAction}
            }, getRemoveFromPlaylistAction: function getRemoveFromPlaylistAction() {
                var removeFromPlaylistAction = new MS.Entertainment.UI.ToolbarAction;
                removeFromPlaylistAction.id = MS.Entertainment.UI.AppBarActions.removeFromPlaylist;
                removeFromPlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistRemoveFromPlaylist;
                removeFromPlaylistAction.title = String.load(String.id.IDS_PLAYLIST_REMOVE);
                removeFromPlaylistAction.icon = WinJS.UI.AppBarIcon.remove;
                removeFromPlaylistAction.shouldAutomaticallySendTelemetry = false;
                if (removeFromPlaylistAction.isVoiceEnabled) {
                    removeFromPlaylistAction.title = String.load(String.id.IDS_PLAYLIST_REMOVE_BUTTON_VUI_GUI);
                    removeFromPlaylistAction.voicePhraseStringId = String.id.IDS_PLAYLIST_REMOVE_BUTTON_VUI_ALM;
                    removeFromPlaylistAction.voicePhoneticPhraseStringId = String.id.IDS_PLAYLIST_REMOVE_BUTTON_VUI_PRON
                }
                removeFromPlaylistAction.executed = function executed() {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var options = mediaContext.options || {};
                    var collectionFilter = mediaContext.collectionFilter || Microsoft.Entertainment.Platform.MediaAvailability.undefined;
                    removeFromPlaylistAction.parameter = {
                        actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, executeLocation: options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas
                    };
                    var playlistIdOrMediaItems = mediaContext.mediaItem;
                    var galleryControl = mediaContext.options && mediaContext.options.galleryControl;
                    var promise;
                    if (isNaN(playlistIdOrMediaItems))
                        promise = MS.Entertainment.Data.List.getData(playlistIdOrMediaItems, 0).then(function(data) {
                            return data ? data.playlistId : -1
                        });
                    else
                        promise = WinJS.Promise.wrap(playlistIdOrMediaItems);
                    return promise.then(function gotArray(playlistId) {
                            var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                            var playlistProvider = mediaStore.playlistProvider;
                            var hasSelectionIndices = (galleryControl && galleryControl.selectedIndices && galleryControl.selectedIndices.length > 0);
                            var hasInvokeIndices = !isNaN(options.invokedIndex) && (typeof options.invokedIndex === "number");
                            MS.Entertainment.UI.Actions.assert(hasSelectionIndices || hasInvokeIndices, "No valid indicies to remove");
                            var indicesToRemove = hasSelectionIndices ? galleryControl.selectedIndices : [options.invokedIndex];
                            if (indicesToRemove && indicesToRemove.length > 0)
                                playlistProvider.removePlaylistItemsAsync(playlistId, indicesToRemove, collectionFilter).done(function complete() {
                                    if (mediaContext)
                                        mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.removeFromPlaylist, {
                                            removedIndices: indicesToRemove, complete: true
                                        })
                                }, function onError(error) {
                                    var message = error && error.message;
                                    MS.Entertainment.UI.Actions.fail("Failure removing an item from a playlist: " + message)
                                })
                        })
                };
                removeFromPlaylistAction.canExecute = function canExecute(parameter) {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var playlistIdOrMediaItems = mediaContext.mediaItem;
                    var options = mediaContext.options || {};
                    var galleryControl = options && options.galleryControl;
                    var invokedIndex = options && options.invokedIndex;
                    var hasSelectionIndices = (galleryControl && galleryControl.selectedIndices && galleryControl.selectedIndices.length > 0);
                    var hasInvokeIndices = !isNaN(options.invokedIndex) && (typeof options.invokedIndex === "number");
                    return !!playlistIdOrMediaItems && (hasSelectionIndices || hasInvokeIndices)
                };
                return {action: removeFromPlaylistAction}
            }, getRemoveFromNowPlayingAction: function getRemoveFromNowPlayingAction() {
                var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                var removeFromNowPlayingAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.removeFromPlaybackSession);
                removeFromNowPlayingAction.id = MS.Entertainment.UI.AppBarActions.removeFromNowPlaying;
                removeFromNowPlayingAction.automationId = MS.Entertainment.UI.AutomationIds.playlistRemoveFromNowPlaying;
                removeFromNowPlayingAction.title = String.load(String.id.IDS_NOW_PLAYING_REMOVE_TRACK_ACTION);
                removeFromNowPlayingAction.icon = WinJS.UI.AppBarIcon.remove;
                if (removeFromNowPlayingAction.isVoiceEnabled) {
                    removeFromNowPlayingAction.title = String.load(String.id.IDS_MUSIC2_REMOVE_TRACK_FROM_NOW_PLAYING_BUTTON_VUI_GUI);
                    removeFromNowPlayingAction.voicePhraseStringId = String.id.IDS_MUSIC2_REMOVE_TRACK_FROM_NOW_PLAYING_BUTTON_VUI_ALM;
                    removeFromNowPlayingAction.voicePhoneticPhraseStringId = String.id.IDS_MUSIC2_REMOVE_TRACK_FROM_NOW_PLAYING_BUTTON_VUI_PRON
                }
                removeFromNowPlayingAction.transformParameter = function removeFromNowPlaying_transformParameter(parameter) {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var parameters = {};
                    if (mediaContext.options && mediaContext.options.containingMedia) {
                        parameters.mediaItem = mediaContext.options.containingMedia.playbackItemSource;
                        parameters.key = mediaContext.options.containingMedia.playbackKey;
                        parameters.offset = mediaContext.options.containingMedia.playbackOffset
                    }
                    return parameters
                };
                return {action: removeFromNowPlayingAction}
            }, getDeletePlaylistAction: function getDeletePlaylistAction() {
                var deletePlaylistAction = new MS.Entertainment.UI.ToolbarAction;
                deletePlaylistAction.id = MS.Entertainment.UI.AppBarActions.deletePlaylist;
                deletePlaylistAction.title = String.load(String.id.IDS_DELETE_LABEL);
                deletePlaylistAction.icon = WinJS.UI.AppBarIcon["delete"];
                deletePlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistDeletePlaylist;
                deletePlaylistAction.shouldAutomaticallySendTelemetry = false;
                deletePlaylistAction.executed = function executed() {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var mediaItems = mediaContext.mediaItem;
                    var collectionFilter = mediaContext.collectionFilter;
                    var options = mediaContext.options || {};
                    deletePlaylistAction.parameter = {
                        actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, executeLocation: options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas
                    };
                    return MS.Entertainment.UI.Controls.RemoveOverlay.show(mediaItems, collectionFilter).done(function overlayClosed(overlay) {
                            if (overlay && overlay.userControlInstance && overlay.userControlInstance.removed) {
                                if (mediaContext)
                                    mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.deletePlaylist, {deleted: overlay.userControlInstance.removed});
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.mediaDeleted).mediaDeleted()
                            }
                        }, function onError(error) {
                            var message = error && error.message;
                            MS.Entertainment.UI.Actions.fail("Failure from remove playlist dialog: " + message)
                        })
                };
                deletePlaylistAction.canExecute = function canExecute() {
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var mediaItems = mediaContext.mediaItem;
                    return !!mediaItems
                };
                return {action: deletePlaylistAction}
            }, getRenamePlaylistAction: function getRenamePlaylistAction() {
                var renamePlaylistFlyoutAction = new MS.Entertainment.UI.ToolbarAction;
                renamePlaylistFlyoutAction.id = MS.Entertainment.UI.AppBarActions.renamePlaylist;
                renamePlaylistFlyoutAction.automationId = MS.Entertainment.UI.AutomationIds.playlistRenamePlaylistAction;
                renamePlaylistFlyoutAction.title = String.load(String.id.IDS_MUSIC_RENAME_PLAYLIST);
                renamePlaylistFlyoutAction.icon = WinJS.UI.AppBarIcon.edit;
                renamePlaylistFlyoutAction.shouldAutomaticallySendTelemetry = false;
                if (renamePlaylistFlyoutAction.isVoiceEnabled) {
                    renamePlaylistFlyoutAction.title = String.load(String.id.IDS_MUSIC_RENAME_PLAYLIST_BUTTON_VUI_GUI);
                    renamePlaylistFlyoutAction.voicePhraseStringId = String.id.IDS_MUSIC_RENAME_PLAYLIST_BUTTON_VUI_ALM;
                    renamePlaylistFlyoutAction.voicePhoneticPhraseStringId = String.id.IDS_MUSIC_RENAME_PLAYLIST_BUTTON_VUI_PRON
                }
                renamePlaylistFlyoutAction.executed = function executed(params) {
                    var renamePlaylist = new MS.Entertainment.UI.Actions.Playlists.RenamePlaylistAction;
                    renamePlaylist.shouldAutomaticallySendTelemetry = false;
                    renamePlaylist.execute()
                };
                renamePlaylistFlyoutAction.canExecute = function canExecute() {
                    return true
                };
                return {action: renamePlaylistFlyoutAction}
            }, queryPlaylistById: function queryPlaylistById(playlistId, isCloudId) {
                var playlistQuery = new MS.Entertainment.Data.Query.libraryPlaylists;
                playlistQuery.isLive = false;
                if (isCloudId)
                    playlistQuery.cloudSyncItemId = playlistId;
                else
                    playlistQuery.playlistId = playlistId;
                return playlistQuery.getItemsArrayAndIgnoreErrors().then(function showPlaylistPopover(playlistsArray) {
                        var playlistsArrayLength = playlistsArray ? playlistsArray.length : 0;
                        if (playlistsArrayLength !== 1) {
                            var error = new Error("Expected to retrieve a single playlist, but instead retrieved " + playlistsArrayLength);
                            return WinJS.Promise.wrapError(error)
                        }
                        return playlistsArray[0]
                    })
            }, CreatePlaylistAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function createPlaylistAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.playlistCreatePlaylistAction, supportsOverwrite: true, executed: function executed(param) {
                        var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                        var playlistProvider = mediaStore.playlistProvider;
                        var createResult;
                        var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                        var collectionFilter = mediaContext.collectionFilter;
                        playlistProvider.createPlaylistAsync(Microsoft.Entertainment.Platform.PlaylistType.static, param.name, !!param.overwrite).then(function createdPlaylist(result) {
                            createResult = result;
                            return MS.Entertainment.Data.List.listToArray(param.mediaItems)
                        }).done(function addItems(mediaItems) {
                            if (createResult) {
                                if (mediaItems.length)
                                    MS.Entertainment.UI.Actions.Playlists._appendToPlaylist(createResult.playlistId, param.name, mediaItems, collectionFilter);
                                else if (param.showPlaylistPopover)
                                    MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction._showPlaylistPopover(createResult.playlistId)
                            }
                            else if (param.failedCallback)
                                param.failedCallback();
                            if (param.completeCallback)
                                param.completeCallback();
                            if (mediaContext)
                                mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.createNewPlaylist)
                        }, function error(e) {
                            if (param.failedCallback)
                                param.failedCallback()
                        })
                    }, canExecute: function canExecute(parameter) {
                        return true
                    }
            }, {_showPlaylistPopover: function _showPlaylistPopover(playlistId) {
                    MS.Entertainment.UI.Actions.Playlists.queryPlaylistById(playlistId).done(function _gotPlaylist(playlistToShow) {
                        if (playlistToShow) {
                            MS.Entertainment.UI.Controls.PopOver.dismissCurrentPopOver();
                            var popOverParameters = {
                                    itemConstructor: "MS.Entertainment.Pages.MusicPlaylistInlineDetails", dataContext: {
                                            data: playlistToShow, location: MS.Entertainment.Data.ItemLocation.collection
                                        }
                                };
                            MS.Entertainment.UI.Controls.PopOver.showPopOver(popOverParameters)
                        }
                    }, function _playlistQueryFailed(error) {
                        var message = error && error.message;
                        MS.Entertainment.UI.Actions.fail("Failed to show a playlist popover: " + message)
                    })
                }}), RenamePlaylistCompleteAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function renamePlaylistCompleteAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.playlistRenamePlaylistAction, executed: function executed(param) {
                        if (param.playlist.name === param.name) {
                            if (param.completeCallback)
                                param.completeCallback();
                            return
                        }
                        var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                        var playlistProvider = mediaStore.playlistProvider;
                        playlistProvider.renamePlaylistAsync(param.playlist.libraryId, param.name).done(function success() {
                            param.playlist.name = param.name;
                            if (param.completeCallback)
                                param.completeCallback()
                        }, function error(e) {
                            if (param.failedCallback)
                                param.failedCallback()
                        })
                    }, canExecute: function canExecute(parameter) {
                        return parameter.playlist && parameter.playlist.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist
                    }
            }), CreatePlaylistFromNowPlayingAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function createPlaylistFromNowPlayingAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.playlistCreatePlaylistFromNowPlayingAction, supportsOverwrite: true, executed: function executed(param) {
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).nowPlayingSession.savePlaylist(param.name, !!param.overwrite, true).done(function completeCallback() {
                            if (param.completeCallback)
                                param.completeCallback()
                        }, function error(e) {
                            if (param.failedCallback)
                                param.failedCallback()
                        })
                    }, canExecute: function canExecute(parameter) {
                        return true
                    }
            }), RemoveFromPlaylistAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function removeFromPlaylistAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.playlistRemoveFromPlaylist, executed: function executed(param) {
                        var mediaItem = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                        var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                        var playlistProvider = mediaStore.playlistProvider;
                        var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                        var collectionFilter = mediaContext.collectionFilter || Microsoft.Entertainment.Platform.MediaAvailability.undefined;
                        if (mediaItem) {
                            var index = param.index;
                            if (mediaContext) {
                                var returnValues = {updatedIndex: param.index};
                                mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.removeFromPlaylist, {
                                    removedIndices: [param.index], complete: false, returnValues: returnValues
                                });
                                index = returnValues.updatedIndex
                            }
                            playlistProvider.removePlaylistItemsAsync(mediaItem.playlistId, [index], collectionFilter).done(function complete() {
                                if (mediaContext)
                                    mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.removeFromPlaylist, {
                                        removedIndices: [index], complete: true
                                    })
                            })
                        }
                    }, canExecute: function canExecute(parameter) {
                        var mediaItem = MS.Entertainment.UI.Actions.extractMediaItemFromParam(parameter);
                        return mediaItem && mediaItem.playlistId
                    }
            }), RenamePlaylistAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function renamePlaylistAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.playlistRenamePlaylistAction, executed: function executed(param) {
                        var mediaItems = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                        var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                        var completeAction = function completeAction() {
                                if (mediaContext)
                                    mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.renamePlaylist)
                            };
                        var options = mediaContext.options || {};
                        var executeLocation = options.executeLocation || MS.Entertainment.UI.Actions.ExecutionLocation.canvas;
                        if (!mediaItems)
                            mediaItems = mediaContext.mediaItem;
                        MS.Entertainment.Data.List.listToArray(mediaItems).done(function listToArray_Success(arrayMediaItems) {
                            MS.Entertainment.UI.Actions.assert(arrayMediaItems.length === 1, "Expected 1 array element, received: " + arrayMediaItems.length);
                            var appBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                            if (appBar)
                                appBar.hide();
                            var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                            var namePlaylistAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.createPlaylist);
                            namePlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistRenamePlaylistNameEntry;
                            var referenceContainer = this.referenceContainer || {
                                    left: 0, bottom: 0
                                };
                            namePlaylistAction.referenceContainer = referenceContainer;
                            namePlaylistAction.action = new MS.Entertainment.UI.Actions.Playlists.RenamePlaylistCompleteAction;
                            namePlaylistAction.parameter = {
                                playlist: arrayMediaItems[0], defaultPlaylistName: arrayMediaItems[0].name, completeAction: completeAction, actionType: MS.Entertainment.UI.Actions.ActionWrapperType.appbarAction, executeLocation: executeLocation
                            };
                            namePlaylistAction.execute()
                        }.bind(this), function listToArray_Failed(error) {
                            var message = error && error.message;
                            MS.Entertainment.UI.Actions.fail("listToArray failed: " + message)
                        })
                    }, canExecute: function canExecute(parameter) {
                        return true
                    }
            }), SaveNowPlayingPlaylistAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function saveNowPlayingPlaylistAction() {
                this.base()
            }, {
                executed: function executed(param) {
                    var appBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                    if (appBar)
                        appBar.hide();
                    MS.Entertainment.UI.Actions.Playlists.SaveNowPlayingPlaylistAction._getPlaylistNameFromPlayContext().done(function _gotPlaylistName(defaultPlaylistName) {
                        MS.Entertainment.UI.Actions.assert(defaultPlaylistName, "Expected non-empty default playlist name for Save Now Playing action.");
                        var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                        var namePlaylistAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.createPlaylist);
                        namePlaylistAction.automationId = MS.Entertainment.UI.AutomationIds.playlistSaveNowPlayingPlaylistNameEntry;
                        var referenceContainer = this.referenceContainer || {
                                left: 0, bottom: 0
                            };
                        namePlaylistAction.referenceContainer = referenceContainer;
                        namePlaylistAction.action = new MS.Entertainment.UI.Actions.Playlists.CreatePlaylistFromNowPlayingAction;
                        namePlaylistAction.parameter = {
                            actionType: param.actionType, executeLocation: param.executeLocation, defaultPlaylistName: defaultPlaylistName
                        };
                        namePlaylistAction.execute()
                    }.bind(this))
                }, canExecute: function canExecute(parameter) {
                        return true
                    }
            }, {_getPlaylistNameFromPlayContext: function _getPlaylistNameFromPlayContext() {
                    var playlistNamePromise;
                    var playContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).playContext;
                    var shortDateFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).shortDate;
                    var shortDateString = shortDateFormatter.format(new Date);
                    if (playContext)
                        if (playContext.artistSeed) {
                            var playlistStringId = playContext.isSmartDJ ? String.id.IDS_MUSIC_NOW_PLAYING_SMART_DJ_LIST_NAME : String.id.IDS_MUSIC_NOW_PLAYING_TOP_SONGS_LIST_NAME;
                            playlistNamePromise = WinJS.Promise.wrap(String.load(playlistStringId).format(playContext.artistSeed.name, shortDateString))
                        }
                        else if (playContext.playlist)
                            if (typeof playContext.playlist === "number")
                                playlistNamePromise = MS.Entertainment.UI.Actions.Playlists.queryPlaylistById(playContext.playlist).then(function _playlistQuerySucceeded(playlist) {
                                    return playlist && playlist.name
                                }, function _playlistQueryFailed(error) {
                                    var errorMessage = error && error.message;
                                    MS.Entertainment.UI.Actions.fail("Failed to get the name of the provided playlist: " + errorMessage);
                                    return null
                                });
                            else
                                playlistNamePromise = WinJS.Promise.wrap(playContext.playlist.name);
                    return WinJS.Promise.as(playlistNamePromise).then(function _gotPlaylistName(playlistName) {
                            return playlistName || String.load(String.id.IDS_MUSIC_NOW_PLAYING_DEFAULT_LIST_NAME).format(shortDateString)
                        })
                }}), ShowPlaylistItemInformationAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function showPlaylistItemInformationAction() {
                this.base()
            }, {
                executed: function executed(param) {
                    var webLink = MS.Entertainment.UI.FWLink.learnMore;
                    MS.Entertainment.UI.Shell.showMessageLinkBox(String.load(String.id.IDS_PLAYLIST_ITEM_DIALOG_NOT_AVAILABLE), String.load(String.id.IDS_PLAYLIST_ITEM_DIALOG_NO_MATCH_XBOX_MUSIC_CLOUD), webLink)
                }, canExecute: function canExecute(parameter) {
                        return true
                    }
            }), MoveTrackUpAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function moveTrackUp() {
                this.base();
                this.iconInfo = {
                    icon: MS.Entertainment.UI.Icon.upChevron, className: "trackListMoveUp"
                };
                this.executed = this.executed.bind(this);
                this.canExecute = this.canExecute.bind(this)
            }, {
                playlist: null, iconInfo: null, automationId: MS.Entertainment.UI.AutomationIds.playlistMoveTrackUp, executed: function executed(param) {
                        var currentIndex = param.index;
                        var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                        var playlistProvider = mediaStore.playlistProvider;
                        var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                        var collectionFilter = mediaContext.collectionFilter || Microsoft.Entertainment.Platform.MediaAvailability.undefined;
                        playlistProvider.reorderPlaylistItemsAsync(this.playlist.libraryId, [currentIndex], (currentIndex - 1), collectionFilter).done(function postExecute() {
                            if (param.postExecute)
                                param.postExecute(currentIndex, currentIndex - 1)
                        })
                    }, canExecute: function canExecute(param) {
                        return (!!this.playlist && param.index > 0)
                    }
            }), MoveTrackDownAction: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function moveTrackDown() {
                this.base();
                this.iconInfo = {
                    icon: MS.Entertainment.UI.Icon.downChevron, className: "trackListMoveDown"
                };
                this.executed = this.executed.bind(this);
                this.canExecute = this.canExecute.bind(this)
            }, {
                playlist: null, iconInfo: null, automationId: MS.Entertainment.UI.AutomationIds.playlistMoveTrackDown, executed: function executed(param) {
                        var currentIndex = param.index;
                        var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                        var playlistProvider = mediaStore.playlistProvider;
                        var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                        var collectionFilter = mediaContext.collectionFilter || Microsoft.Entertainment.Platform.MediaAvailability.undefined;
                        playlistProvider.reorderPlaylistItemsAsync(this.playlist.libraryId, [currentIndex], (currentIndex + 2), collectionFilter).done(function postExecute() {
                            {};
                            if (param.postExecute)
                                param.postExecute(currentIndex, currentIndex + 2)
                        })
                    }, canExecute: function canExecute(param) {
                        return (!!this.playlist && param.index < (this.playlist.count - 1))
                    }
            }), _appendToPlaylist: function _appendToPlaylist(playlistLibraryId, playlistName, inputMediaItemsArray, collectionFilter) {
                var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                var playlistProvider = mediaStore.playlistProvider;
                var libraryIds = [];
                var serviceMediaIds = [];
                var mediaTypes = [];
                var addFromMarketplace = false;
                var appendToPlaylist = function appendToPlaylist(mediaItemsArray) {
                        mediaItemsArray.forEach(function(mediaItem) {
                            if (mediaItem) {
                                libraryIds.push(mediaItem.libraryId);
                                serviceMediaIds.push(!MS.Entertainment.Utilities.isEmptyGuid(mediaItem.zuneId) ? mediaItem.zuneId : MS.Entertainment.Utilities.EMPTY_GUID);
                                mediaTypes.push(mediaItem.mediaType);
                                addFromMarketplace = addFromMarketplace || (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && !mediaItem.inCollection)
                            }
                        });
                        var addItemsPromise;
                        if (addFromMarketplace)
                            addItemsPromise = MS.Entertainment.Platform.PurchaseHelpers.addNonCollectionMediaToLibrary(mediaItemsArray).then(function mediaAddedToDb(result) {
                                libraryIds = result.mediaIdentifiers.map(function _getLibraryId(item) {
                                    return item.libraryId
                                });
                                mediaTypes = result.mediaIdentifiers.map(function _getLibraryId(item) {
                                    return item.libraryType
                                });
                                serviceMediaIds = result.mediaIdentifiers.map(function _getLibraryId(item) {
                                    return item.mediaId
                                });
                                return WinJS.Promise.wrap({
                                        libraryIds: libraryIds, mediaTypes: mediaTypes, serviceMediaIds: serviceMediaIds, collectionFilter: Microsoft.Entertainment.Platform.MediaAvailability.undefined
                                    })
                            });
                        else
                            addItemsPromise = WinJS.Promise.wrap({
                                libraryIds: libraryIds, mediaTypes: mediaTypes, serviceMediaIds: serviceMediaIds, collectionFilter: collectionFilter
                            });
                        addItemsPromise.then(function addItemsComplete(result) {
                            return playlistProvider.appendPlaylistItemsAsync(playlistLibraryId, result.libraryIds, result.serviceMediaIds, result.mediaTypes, result.collectionFilter)
                        }).done(function appendToPlaylistSucceeded() {
                            if (mediaItemsArray && mediaItemsArray.length)
                                MS.Entertainment.UI.Actions.Playlists._showPlaylistNotification(playlistLibraryId, mediaItemsArray, mediaItemsArray[0].mediaType, false, inputMediaItemsArray, playlistName);
                            MS.Entertainment.ViewModels.MediaItemModel.hydrateListLibraryInfoAsync(inputMediaItemsArray)
                        }, function appendToPlaylistFailed(error) {
                            if (error.number === MS.Entertainment.UI.Actions.Playlists.ERROR_MAXIMUM_PLAYLIST_LENGTH_EXCEEDED) {
                                var maxPlaylistItemCount = (new Microsoft.Entertainment.Configuration.ConfigurationManager).groveler.maxPlaylistItemCount;
                                MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_CLOUD_SYNC_PLAYLIST_FULL_DIALOG_TITLE).format(playlistName), String.load(String.id.IDS_CLOUD_SYNC_PLAYLIST_FULL_DIALOG_MESSAGE).format(maxPlaylistItemCount))
                            }
                        })
                    };
                var addToMyMusic = function addToMyMusic(media) {
                        var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                        var addToMyMusicAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionAddToMyMusic);
                        addToMyMusicAction.automationId = MS.Entertainment.UI.AutomationIds.playlistSubscriptionAddToMyMusic;
                        addToMyMusicAction.parameter = {
                            mediaItem: media, suppressNotification: true
                        };
                        return addToMyMusicAction.execute()
                    };
                WinJS.Promise.join(inputMediaItemsArray.map(function expandToTracksIfNeeded(mediaItem) {
                    var returnPromise;
                    switch (mediaItem.mediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            if (!mediaItem.fromCollection) {
                                var albumTracks;
                                if (mediaItem.tracks)
                                    returnPromise = WinJS.Promise.as();
                                else
                                    returnPromise = mediaItem.hydrate();
                                returnPromise = returnPromise.then(function _getTracksArray() {
                                    return mediaItem.tracks ? mediaItem.tracks.toArrayAll() : []
                                }).then(function _addMediaToMyMusic(media) {
                                    albumTracks = media;
                                    return addToMyMusic(albumTracks)
                                }).then(function _returnMedia() {
                                    return albumTracks
                                })
                            }
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.person:
                            if (!mediaItem.fromCollection) {
                                var query = new MS.Entertainment.Data.Query.Music.ArtistSongs;
                                query.id = mediaItem.canonicalId;
                                query.impressionGuid = mediaItem.impressionGuid;
                                query.aggregateChunks = !MS.Entertainment.Utilities.isMusicApp2;
                                returnPromise = query.getItemsArrayAndIgnoreErrors()
                            }
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.track:
                            if (!mediaItem.fromCollection)
                                returnPromise = addToMyMusic(mediaItem).then(function _returnMedia() {
                                    return [mediaItem]
                                });
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.playlist:
                            if (mediaItem.tracks)
                                returnPromise = mediaItem.tracks.toArrayAll();
                            break;
                        default:
                            MS.Entertainment.UI.Actions.fail("Unsupported mediaType to add to playlist");
                            break
                    }
                    return WinJS.Promise.as(returnPromise || [mediaItem])
                })).then(function result(items) {
                    return items
                }, function ignoreError(error) {
                    MS.Entertainment.UI.Actions.fail("Failed to expand media items in playlist actions");
                    return []
                }).done(function expandedItems(promiseResults) {
                    var items = [];
                    if (promiseResults)
                        if (promiseResults.length === 1)
                            items = promiseResults[0];
                        else if (promiseResults.length > 1)
                            items = Array.prototype.concat.apply(promiseResults[0], promiseResults.slice(1));
                    items = items.filter(this._validateItemNotBlocked);
                    appendToPlaylist(items)
                }.bind(this))
            }, _validateItemNotBlocked: function _validateItemNotBlocked(item) {
                var isBlocked = item && item.isParentallyBlocked;
                if (isBlocked)
                    item = null;
                return item
            }, _showPlaylistNotification: function _showPlaylistNotification(playlistLibraryId, mediaItems, mediaType, isNowPlaying, inputMediaItemsArray, playlistName) {
                var string = String.empty;
                var numberFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                var formattedCount = numberFormatter.format(mediaItems.length);
                if (MS.Entertainment.UI.Controls.CommandingPopOver && MS.Entertainment.UI.Controls.CommandingPopOver.popoverOpen) {
                    var locationString = isNowPlaying ? String.load(String.id.IDS_MUSIC2_PANEL_ADD_NOW_PLAYING) : String.load(String.id.IDS_MUSIC2_PANEL_ADD_TO_PLAYLIST).format(playlistName);
                    var inputMediaItem = (inputMediaItemsArray && inputMediaItemsArray[0]) || mediaItems[0];
                    switch (inputMediaItem.mediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.track:
                            string = String.load(String.id.IDS_MUSIC2_PANEL_ADD_1_ITEM).format(String.load(String.id.IDS_MUSIC2_PANEL_ADD_SONG), locationString);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            string = String.load(String.id.IDS_MUSIC2_PANEL_ADD_1_ITEM).format(String.load(String.id.IDS_MUSIC2_PANEL_ADD_ALBUM), locationString);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.person:
                            string = String.load(String.id.IDS_MUSIC2_PANEL_ADD_N_ITEMS).format(String.load(inputMediaItem.libraryId === -1 ? String.id.IDS_MUSIC2_PANEL_ADD_TOP_SONGS : String.id.IDS_MUSIC2_PANEL_ADD_MY_SONGS), locationString);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.playlist:
                            string = String.load(String.id.IDS_MUSIC2_PANEL_ADD_1_ITEM).format(String.load(String.id.IDS_MUSIC2_PANEL_ADD_PLAYLIST), locationString);
                            break;
                        default:
                            MS.Entertainment.UI.Actions.fail("Unknown media type given to _showPlaylistNotification(). MediaType = " + mediaType);
                            break
                    }
                    MS.Entertainment.UI.Controls.CommandingPopOver.displayPopoverNotification(string, true)
                }
                else {
                    switch (mediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.track:
                            if (mediaItems.length === 1)
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_1_TRACK_ADDED);
                            else
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_N_TRACKS_ADDED).format(formattedCount);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            if (mediaItems.length === 1)
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_1_ALBUM_ADDED);
                            else
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_N_ALBUMS_ADDED).format(formattedCount);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.person:
                            if (mediaItems.length === 1)
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_1_ARTIST_ADDED);
                            else
                                string = String.load(String.id.IDS_MUSIC_NOTIFICATION_N_ARTISTS_ADDED).format(formattedCount);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.playlist:
                            string = MS.Entertainment.Formatters.playlistCountText(mediaItems.length);
                            break;
                        default:
                            MS.Entertainment.UI.Actions.fail("Unknown media type given to _showPlaylistNotification(). MediaType = " + mediaType);
                            break
                    }
                    var playlistTapAction = WinJS.Utilities.markSupportedForProcessing(function navigateToCollection() {
                            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.winJSNavigation)) {
                                var playlists = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.playlists);
                                playlists.navigateToPlaylist(playlistLibraryId)
                            }
                            else {
                                var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                if (navigationService.currentPage.iaNode.moniker !== MS.Entertainment.UI.Monikers.musicCollection) {
                                    var navigated = null;
                                    if (MS.Entertainment.Utilities.isMusicApp1)
                                        navigated = navigationService.navigateTo(MS.Entertainment.UI.Monikers.musicCollection, MS.Entertainment.UI.Monikers.musicCollectionPlaylists, null, {selectHub: true});
                                    else
                                        navigated = navigationService.navigateTo(MS.Entertainment.UI.Monikers.musicPlaylistCollection);
                                    if (navigated)
                                        MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction._showPlaylistPopover(playlistLibraryId)
                                }
                                else
                                    MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction._showPlaylistPopover(playlistLibraryId)
                            }
                        });
                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification).send(new MS.Entertainment.UI.Notification({
                        notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(isNowPlaying ? String.id.IDS_MUSIC_NOTIFICATION_ADDED_TO_NOW_PLAYING : String.id.IDS_MUSIC_NOTIFICATION_ADDED_TO_PLAYLIST), subTitle: string, moreDetails: null, icon: MS.Entertainment.UI.Icon.playlist, action: isNowPlaying ? null : playlistTapAction, secondaryActions: null, category: null, isPersistent: false
                    }))
                }
            }, playlistDataNotificationHandler: MS.Entertainment.UI.Framework.define(function playlistDataNotificationHandler(listUpdateCallback, itemChangedCallback) {
                this._listUpdateCallback = listUpdateCallback;
                this._itemChangedCallback = itemChangedCallback
            }, {
                _listUpdateCallback: null, _itemChangedCallback: null, _listChangedIndices: [], _itemChangedItems: [], dispose: function dispose() {
                        this._listUpdateCallback = null;
                        this._itemChangedCallback = null
                    }, inserted: function inserted(item, previousKey, nextKey, index) {
                        this._listChangedIndices.push(index)
                    }, changed: function changed(newItem, oldItem) {
                        this._itemChangedItems.push(newItem)
                    }, moved: function moved(item, previousKey, nextKey, oldIndex, newIndex){}, removed: function removed(key, index) {
                        this._listChangedIndices.push(index)
                    }, countChanged: function countChanged(newCount, oldCount){}, endNotifications: function endNotifications() {
                        if (this._listUpdateCallback && this._listChangedIndices.length) {
                            this._listUpdateCallback(this._listChangedIndices);
                            this._listChangedIndices = []
                        }
                        if (this._itemChangedCallback && this._itemChangedItems.length) {
                            this._itemChangedCallback(this._itemChangedItems);
                            this._itemChangedItems = []
                        }
                    }
            }), populateTimeout: 50
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.saveNowPlayingPlaylist, function() {
        return new MS.Entertainment.UI.Actions.Playlists.SaveNowPlayingPlaylistAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.renamePlaylist, function() {
        return new MS.Entertainment.UI.Actions.Playlists.RenamePlaylistAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.removeFromPlaylist, function() {
        return new MS.Entertainment.UI.Actions.Playlists.RemoveFromPlaylistAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.showPlaylistItemInformation, function() {
        return new MS.Entertainment.UI.Actions.Playlists.ShowPlaylistItemInformationAction
    })
})()
