﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
WinJS.Namespace.define("MS.Entertainment.Music", {SubscriptionSignup: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Controls.WebHostExperience", function SubscriptionSignup_constructor() {
        this.base()
    }, {
        startListener: function startListener() {
            this.eventProvider.traceSubscriptionSignup_Start(String.empty);
            MS.Entertainment.UI.Controls.WebHostExperience.prototype.startListener.apply(this, arguments)
        }, messageReceived: function messageReceived(messageStruct, webHost, sendMessageFunc) {
                switch (messageStruct.verb) {
                    case"CLOSE_DIALOG":
                        if (messageStruct.reason === "ERROR")
                            this.eventProvider.traceSubscriptionSignup_Error(String.empty, messageStruct.errorCode);
                        else if (messageStruct.reason === "CANCEL")
                            this.eventProvider.traceSubscriptionSignup_Cancel(String.empty);
                        break;
                    case"MEMBERSHIP_UPGRADE_SUCESSFUL":
                    case"MEMBERSHIP_UPGRADE_SUCCESSFUL":
                    case"MEMBERSHIP_UPGRADE_SUCESSFUL ":
                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        signIn.refreshSignInState();
                        this.eventProvider.traceSubscriptionSignup_Finish(String.empty);
                        break;
                    case"TOKEN_REDEMPTION_SUCCESSFUL":
                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        signIn.refreshSignInState();
                        break;
                    case"MEMBERSHIP_UPGRADE_NAVIGATE":
                        if (messageStruct.reason === "NEXT") {
                            webHost.authenticatedSourceUrl = webHost.reachFlowUrl;
                            webHost._webHostWaitCursor.isBusy = true;
                            webHost.skipPurchasePrompt = false;
                            webHost._loadAuthenticatedUrlOnSignIn()
                        }
                        break
                }
                MS.Entertainment.UI.Controls.WebHostExperience.prototype.messageReceived.apply(this, arguments)
            }
    }, {doSubscriptionSignup: function doSubscriptionSignup() {
            if (MS.Entertainment.Utilities.isMusicApp2)
                return MS.Entertainment.UI.Shell.ModernWebBlend.showModernMusicPassSubscriptionFlowAsync();
            var initialPageUrl;
            var skipPurchasePrompt = false;
            var reachFlowUrl = MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_XBoxLiveSSL) + "/Subscriptions?workflow=ManageSubscription&TitleId=0xfffe0777&xboxMusic=true";
            var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
            if (configurationManager.service.useLandingPageForMusicPassSignup) {
                initialPageUrl = MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_XBoxLiveSSL) + "/SubscriptionUpsell/Music";
                skipPurchasePrompt = true
            }
            else
                initialPageUrl = reachFlowUrl;
            MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.musicPassSignUpShown);
            var experience = new MS.Entertainment.Music.SubscriptionSignup;
            return MS.Entertainment.UI.Shell.showWebHostDialog(String.load(String.id.IDS_MUSIC_GET_A_SUBSCRIPTION_TEXT), {
                    desiredLeft: "0%", desiredTop: MS.Entertainment.Utilities.isModernMPEnabled ? null : "10%", desiredHeight: MS.Entertainment.Utilities.isModernMPEnabled ? configurationManager.service.modernWebBlendHeight : null, showBackButton: false, showCancelButton: false, desiredZIndex: 1002
                }, {
                    sourceUrl: "", signInOverride: false, authenticatedSourceUrl: initialPageUrl, reachFlowUrl: reachFlowUrl, webHostExperience: experience, taskId: MS.Entertainment.UI.Controls.WebHost.TaskId.ACCOUNT, isDialog: true, skipPurchasePrompt: skipPurchasePrompt
                })
        }})});
(function(undefined) {
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {SubscriptionSignup: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function subscriptionSignup() {
            this.base()
        }, {
            executed: function executed(param) {
                if (this.parameter)
                    MS.Entertainment.Music.Freeplay.sendTelemetryEvent(this.parameter);
                return MS.Entertainment.Music.SubscriptionSignup.doSubscriptionSignup()
            }, canExecute: function canExecute(param) {
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var subscriptionEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    return (signIn.isSignedIn && !signedInUser.isSubscription && subscriptionEnabled)
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {SubscriptionWithSignIn: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function subscriptionSignup() {
            this.base()
        }, {
            executed: function executed(param) {
                var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                MS.Entertainment.Music.Freeplay.sendTelemetryEvent(MS.Entertainment.Music.Freeplay.Events.musicPassUpsellEngagePanelInvoked);
                if (signIn.isSignedIn)
                    return MS.Entertainment.Music.SubscriptionSignup.doSubscriptionSignup();
                else
                    return MS.Entertainment.Music.MusicBrandDialog.show(String.load(String.id.IDS_MUSIC_SUBSCRIPTION_SIGN_IN_TITLE), String.load(String.id.IDS_MUSIC_SUBSCRIPTION_SIGN_IN_DESC), null, [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signInAndSubscribe, MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel])
            }, canExecute: function canExecute(param) {
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var subscriptionEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    return (!signedInUser.isSubscription && subscriptionEnabled)
                }
        })});
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    if (!actionService.isRegistered(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup))
        actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup, function() {
            return new MS.Entertainment.UI.Actions.SubscriptionSignup
        });
    if (!actionService.isRegistered(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionWithSignIn))
        actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionWithSignIn, function() {
            return new MS.Entertainment.UI.Actions.SubscriptionWithSignIn
        })
})()
