﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(Music) {
            MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Music");
            var AnonymousFreePlay = (function() {
                    function AnonymousFreePlay(){}
                    Object.defineProperty(AnonymousFreePlay.prototype, "anonymousLimitReached", {
                        get: function() {
                            var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                            if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlayAnonymous) && (new Microsoft.Entertainment.Configuration.ConfigurationManager).music.anonymousLimitReached)
                                return true;
                            return false
                        }, enumerable: true, configurable: true
                    });
                    AnonymousFreePlay.factory = function() {
                        return new MS.Entertainment.Music.AnonymousFreePlay
                    };
                    return AnonymousFreePlay
                })();
            Music.AnonymousFreePlay = AnonymousFreePlay
        })(Entertainment.Music || (Entertainment.Music = {}));
        var Music = Entertainment.Music
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}));
MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.anonymousFreePlay, MS.Entertainment.Music.AnonymousFreePlay.factory)
