﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var __extends = this.__extends || function(d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
        function __() {
            this.constructor = d
        }
        __.prototype = b.prototype;
        d.prototype = new __
    };
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(Music) {
            var ViewState;
            (function(ViewState) {
                ViewState[ViewState["error"] = -1] = "error";
                ViewState[ViewState["loading"] = 1] = "loading";
                ViewState[ViewState["ready"] = 2] = "ready"
            })(ViewState || (ViewState = {}));
            var SubscriptionSignupDialogContent = (function(_super) {
                    __extends(SubscriptionSignupDialogContent, _super);
                    function SubscriptionSignupDialogContent(element, options) {
                        this.templateStorage = "/Components/Music1/SubscriptionSignup.html";
                        this.templateName = "dialogContentTemplate";
                        _super.call(this, element, options)
                    }
                    SubscriptionSignupDialogContent.prototype.initialize = function() {
                        var _this = this;
                        this.viewState = ViewState.loading;
                        var query = new MS.Entertainment.Data.Query.Music.Subscriptions;
                        query.execute().then(function(queryResult) {
                            query.dispose();
                            if (!queryResult || !queryResult.result || !queryResult.result.itemsArray || queryResult.result.itemsArray.length === 0)
                                return WinJS.Promise.wrapError(new Error("No subscription offers"));
                            _this.subscriptions = queryResult.result.itemsArray;
                            _this.viewState = ViewState.ready
                        }).done(null, function(error) {
                            _this.viewState = ViewState.error
                        })
                    };
                    SubscriptionSignupDialogContent.prototype.setOverlay = function(dialog) {
                        this._purchaseOfferAction = new Music.SubscriptionSignupPurchaseOfferAction(dialog)
                    };
                    Object.defineProperty(SubscriptionSignupDialogContent.prototype, "purchaseOfferAction", {
                        get: function() {
                            return this._purchaseOfferAction
                        }, enumerable: true, configurable: true
                    });
                    Object.defineProperty(SubscriptionSignupDialogContent.prototype, "subscriptions", {
                        get: function() {
                            return this._subscriptions
                        }, set: function(value) {
                                this.updateAndNotify("subscriptions", value)
                            }, enumerable: true, configurable: true
                    });
                    Object.defineProperty(SubscriptionSignupDialogContent.prototype, "viewState", {
                        get: function() {
                            return this._viewState
                        }, set: function(value) {
                                var _this = this;
                                this.updateAndNotify("viewState", value);
                                switch (value) {
                                    case ViewState.loading:
                                        var configManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                        WinJS.Promise.timeout(configManager.music.pageLoadTimeUntilSpinner).then(function() {
                                            if (_this.viewState === ViewState.loading)
                                                WinJS.Utilities.removeClass(_this._loadingElement, "removeFromDisplay")
                                        });
                                        break;
                                    case ViewState.ready:
                                        WinJS.Utilities.addClass(this._loadingElement, "removeFromDisplay");
                                        break;
                                    case ViewState.error:
                                        WinJS.Utilities.addClass(this._loadingElement, "removeFromDisplay");
                                        WinJS.Utilities.removeClass(this._errorElement, "removeFromDisplay");
                                        break;
                                    default:
                                        MS.Entertainment.fail("Unexpected view state");
                                        break
                                }
                            }, enumerable: true, configurable: true
                    });
                    return SubscriptionSignupDialogContent
                })(MS.Entertainment.UI.Framework.UserControl);
            Music.SubscriptionSignupDialogContent = SubscriptionSignupDialogContent;
            var SubscriptionSignupDialog = (function(_super) {
                    __extends(SubscriptionSignupDialog, _super);
                    function SubscriptionSignupDialog(element, options) {
                        this.templateStorage = "/Components/Music1/subscriptionSignup.html";
                        this.templateName = "dialogTemplate";
                        _super.call(this, element, options)
                    }
                    SubscriptionSignupDialog.showDialog = function() {
                        var options = {
                                userControl: "MS.Entertainment.Music.SubscriptionSignupDialogContent", userControlOptions: {}
                            };
                        var dialog = new MS.Entertainment.Music.SubscriptionSignupDialog(document.createElement("div"), options);
                        return dialog.show()
                    };
                    return SubscriptionSignupDialog
                })(MS.Entertainment.UI.Controls.Dialog);
            Music.SubscriptionSignupDialog = SubscriptionSignupDialog
        })(Entertainment.Music || (Entertainment.Music = {}));
        var Music = Entertainment.Music
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}));
WinJS.Utilities.markSupportedForProcessing(MS.Entertainment.Music.SubscriptionSignupDialog);
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(Music) {
            var SubscriptionSignupPurchaseOfferAction = (function(_super) {
                    __extends(SubscriptionSignupPurchaseOfferAction, _super);
                    function SubscriptionSignupPurchaseOfferAction(dialog) {
                        _super.call(this);
                        this.automationId = MS.Entertainment.UI.AutomationIds.subscriptionSignupPurchaseOffer;
                        this._dialog = dialog
                    }
                    SubscriptionSignupPurchaseOfferAction.prototype.canExecute = function(param) {
                        return true
                    };
                    SubscriptionSignupPurchaseOfferAction.prototype.executed = function(subscription) {
                        var _this = this;
                        MS.Entertainment.Utilities.Telemetry.logPageAction({domElement: event.target}, {
                            uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popup
                        });
                        var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                        var eventHandlers = {onStartEvent: function() {
                                    _this._dialog.hide()
                                }};
                        return MS.Entertainment.Platform.PurchaseHelpers.launchPurchaseFlow(subscription, null, null, eventHandlers, subscription.offerId, null, signedInUser.gamerTag, subscription.signedOffer)
                    };
                    return SubscriptionSignupPurchaseOfferAction
                })(MS.Entertainment.UI.Actions.Action);
            Music.SubscriptionSignupPurchaseOfferAction = SubscriptionSignupPurchaseOfferAction;
            var SubscriptionSignupAction = (function(_super) {
                    __extends(SubscriptionSignupAction, _super);
                    function SubscriptionSignupAction() {
                        _super.apply(this, arguments)
                    }
                    SubscriptionSignupAction.prototype.canExecute = function(param) {
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        return featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription)
                    };
                    SubscriptionSignupAction.prototype.executed = function(param) {
                        return Music.SubscriptionSignupDialog.showDialog()
                    };
                    return SubscriptionSignupAction
                })(MS.Entertainment.UI.Actions.Action);
            Music.SubscriptionSignupAction = SubscriptionSignupAction;
            var SubscriptionSignupWithSignInAction = (function(_super) {
                    __extends(SubscriptionSignupWithSignInAction, _super);
                    function SubscriptionSignupWithSignInAction() {
                        _super.apply(this, arguments)
                    }
                    SubscriptionSignupWithSignInAction.prototype.canExecute = function(param) {
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        var subscriptionEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                        var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                        return (!signedInUser.isSubscription && subscriptionEnabled)
                    };
                    SubscriptionSignupWithSignInAction.prototype.executed = function(param) {
                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        if (signIn.isSignedIn)
                            return _super.prototype.executed.call(this, param);
                        else
                            return MS.Entertainment.Music.MusicBrandDialog.show(String.load(String.id.IDS_MUSIC_SUBSCRIPTION_SIGN_IN_TITLE), String.load(String.id.IDS_MUSIC_SUBSCRIPTION_SIGN_IN_DESC), null, [MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.signInAndSubscribe, MS.Entertainment.Music.MusicBrandDialog.dialogButtonIds.cancel])
                    };
                    return SubscriptionSignupWithSignInAction
                })(Entertainment.Music.SubscriptionSignupAction);
            Music.SubscriptionSignupWithSignInAction = SubscriptionSignupWithSignInAction
        })(Entertainment.Music || (Entertainment.Music = {}));
        var Music = Entertainment.Music
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}));
(function() {
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    if (actionService.isRegistered(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup))
        actionService._unregister(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup);
    if (actionService.isRegistered(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionWithSignIn))
        actionService._unregister(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionWithSignIn);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionSignup, function() {
        if (MS.Entertainment.Utilities.isModernMPEnabled)
            return new MS.Entertainment.Music.SubscriptionSignupAction;
        else
            return new MS.Entertainment.UI.Actions.SubscriptionSignup
    });
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.subscriptionWithSignIn, function() {
        if (MS.Entertainment.Utilities.isModernMPEnabled)
            return new MS.Entertainment.Music.SubscriptionSignupWithSignInAction;
        else
            return new MS.Entertainment.UI.Actions.SubscriptionWithSignIn
    })
})()
