﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(undefined) {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Actions");
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {
        AddToNowPlaying: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function addToNowPlaying() {
            this.base()
        }, {
            executed: function executed(param) {
                var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                var collectionFilter = mediaContext.collectionFilter;
                var mediaItem = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                var string = String.empty;
                var mediaItems = null;
                if (Array.isArray(mediaItem)) {
                    mediaItem.forEach(function addMediaItem(item) {
                        MS.Entertainment.Platform.PlaybackHelpers.addToNowPlaying(item, collectionFilter)
                    });
                    mediaItems = mediaItem
                }
                else {
                    MS.Entertainment.Platform.PlaybackHelpers.addToNowPlaying(mediaItem, collectionFilter);
                    mediaItems = [mediaItem]
                }
                if (!param.suppressNotification)
                    MS.Entertainment.UI.Actions.Playlists._showPlaylistNotification(null, mediaItems, mediaItems[0].mediaType, true);
                if (param.completeAction)
                    param.completeAction()
            }, canExecute: function canExecute(param) {
                    return true
                }
        }), AddArtistToNowPlayingAction: MS.Entertainment.deferredDerive(MS.Entertainment.UI.Actions.Action, function addArtistToNowPlayingAction() {
                this.base()
            }, {
                executed: function executed(param) {
                    var query,
                        id;
                    var mediaItem = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                    var mediaItems = Array.isArray(mediaItem) ? mediaItem : [mediaItem];
                    var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                    var collectionFilter = mediaContext.collectionFilter;
                    MS.Entertainment.ViewModels.assert(mediaItems[0].mediaType === Microsoft.Entertainment.Queries.ObjectType.person && mediaItems[0].personType === Microsoft.Entertainment.Queries.PersonType.artist, "Invalid media type. Was expecting an artist media object");
                    mediaItems.forEach(function addMediaItemToNowPlaying(mediaItem) {
                        var itemCollection = null;
                        if (param.playCollectionItemsOnly) {
                            itemCollection = new MS.Entertainment.Data.Query.libraryTracks;
                            itemCollection.mediaAvailability = collectionFilter;
                            itemCollection.artistId = mediaItem.libraryId;
                            itemCollection.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.artist, MS.Entertainment.Utilities.isValidServiceId(mediaItem.canonicalId) ? mediaItem.canonicalId : String.empty);
                            if (param.librarySort)
                                itemCollection.sort = param.librarySort
                        }
                        else
                            itemCollection = mediaItem;
                        if (itemCollection)
                            MS.Entertainment.Platform.PlaybackHelpers.addToNowPlaying(itemCollection)
                    });
                    if (!param.suppressNotification)
                        MS.Entertainment.UI.Actions.Playlists._showPlaylistNotification(null, mediaItems, mediaItems[0].mediaType, true)
                }, canExecute: function canExecute(param) {
                        return true
                    }
            })
    });
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.addToNowPlaying, function() {
        return new MS.Entertainment.UI.Actions.AddToNowPlaying
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.addArtistToNowPlaying, function() {
        return new MS.Entertainment.UI.Actions.AddArtistToNowPlayingAction
    })
})()
