﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Utilities");
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.Utilities", {SignedInUser: MS.Entertainment.deferredDerive("MS.Entertainment.Utilities.User", function signedInUser() {
            MS.Entertainment.Utilities.SignedInUser._instanceCount++;
            MS.Entertainment.Utilities.assert(MS.Entertainment.Utilities.SignedInUser._instanceCount === 1, "Use MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser)");
            this.base();
            this.refresh(null, true)
        }, {
            gamerTag: String.empty, xuid: String.empty, locale: String.empty, isParentallyControlled: false, hasExplicitPrivilege: false, pointsBalance: 0, zestAccountType: String.empty, isSubscription: false, membershipLevel: String.empty, meteringCertificate: String.empty, signInName: String.empty, _userPuid: String.empty, _userAnid: String.empty, canSignOut: false, isTunerActivated: false, isTunerActivatable: false, isGamerTag: function isGamerTag(gamerTag) {
                    return gamerTag && this.gamerTag && this.gamerTag.match(new RegExp("^" + gamerTag + "$", "i")) !== null
                }, isGold: function isGold() {
                    return this.membershipLevel === MS.Entertainment.Utilities.SignedInUser.membershipStringMap.Gold || this.membershipLevel === MS.Entertainment.Utilities.SignedInUser.membershipStringMap.FamilyGold
                }, isSilver: function isSilver() {
                    return this.membershipLevel === MS.Entertainment.Utilities.SignedInUser.membershipStringMap.Silver
                }, getUserAnid: function getUserAnid() {
                    if (this._userAnid)
                        return this.userAnid;
                    if (!this._userPuid)
                        return String.empty;
                    var padding = [];
                    for (var w = 0; w < (MS.Entertainment.Utilities.SignedInUser._initialPuidLength - this._userPuid.length); w++)
                        padding[w] = "0";
                    var puidToUse = padding.join(String.empty).concat(this._userPuid);
                    try {
                        var macAlgorithmProvider = Windows.Security.Cryptography.Core.MacAlgorithmProvider.openAlgorithm("HMAC_MD5");
                        var keyMaterial = Windows.Security.Cryptography.CryptographicBuffer.createFromByteArray([99, 202, 90, 90, 191, 64, 70, 72, 58, 206, 107, 87, 165, 187, 152, 8]);
                        var key = macAlgorithmProvider.createKey(keyMaterial);
                        var encodedPuid = Windows.Security.Cryptography.CryptographicBuffer.convertStringToBinary(puidToUse, Windows.Security.Cryptography.BinaryStringEncoding.utf16LE);
                        var bytes = null;
                        bytes = Windows.Security.Cryptography.CryptographicBuffer.copyToByteArray(encodedPuid);
                        var bytes2 = [];
                        for (var i = 0; i < bytes.length; i++)
                            bytes2[i] = bytes[i];
                        for (var k = bytes.length - 1; k < MS.Entertainment.Utilities.SignedInUser._encodedMaterialLength; k++)
                            bytes2[k] = 0;
                        var finalEncodedPuid = Windows.Security.Cryptography.CryptographicBuffer.createFromByteArray(bytes2);
                        var signatureBuffer = Windows.Security.Cryptography.Core.CryptographicEngine.sign(key, finalEncodedPuid);
                        var signature = Windows.Security.Cryptography.CryptographicBuffer.encodeToHexString(signatureBuffer);
                        var finalString = signature.slice(0, MS.Entertainment.Utilities.SignedInUser._anidSliceLength).concat(MS.Entertainment.Utilities.SignedInUser._paddingForPuidHash);
                        this._userAnid = finalString
                    }
                    catch(e) {
                        MS.Entertainment.Utilities.fail("Failed to hash anid " + e);
                        return null
                    }
                    return finalString
                }, refresh: function refresh(signInProvider, doNotUpdatePropertyCache) {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    this.nativeUserModel = [null];
                    this._userAnid = null;
                    if (signInProvider) {
                        this.gamerTag = signInProvider.gamerTag;
                        this.xuid = signInProvider.xuid;
                        this.locale = signInProvider.locale;
                        this.isParentallyControlled = signInProvider.parentallyControlled;
                        this.hasExplicitPrivilege = signInProvider.explicitPrivilege;
                        this.pointsBalance = signInProvider.pointsBalance;
                        this.zestAccountType = signInProvider.accountType;
                        this.isSubscription = signInProvider.isSubscription;
                        this.membershipLevel = signInProvider.membershipLevel;
                        this.subscriptionOfferID = signInProvider.subscriptionOfferID;
                        this.meteringCertificate = signInProvider.meteringCertificate;
                        this.signInName = signInProvider.signInName;
                        this._userPuid = signInProvider.id;
                        this.canSignOut = signInProvider.canSignOut;
                        this.isTunerActivated = signInProvider.isTunerActivated;
                        this.isTunerActivatable = signInProvider.isTunerActivatable
                    }
                    else {
                        this.gamerTag = String.empty;
                        this.xuid = String.empty;
                        this.locale = String.empty;
                        this.isParentallyControlled = false;
                        this.hasExplicitPrivilege = false;
                        this.pointsBalance = 0;
                        this.zestAccountType = String.empty;
                        this.isSubscription = false;
                        this.membershipLevel = String.empty;
                        this.subscriptionOfferID = String.empty;
                        this.meteringCertificate = String.empty;
                        this.signInName = String.empty;
                        this._userPuid = null;
                        this.canSignOut = false;
                        this.isTunerActivated = false;
                        this.isTunerActivatable = false
                    }
                    if (!doNotUpdatePropertyCache)
                        this.updateLastSignedInUserPropertyCache()
                }, updateLastSignedInUserPropertyCache: function updateLastSignedInUserPropertyCache() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    if (!configurationManager.service.enableTimeTravel) {
                        configurationManager.service.lastSignedInUserParentControl = this.isParentallyControlled;
                        configurationManager.service.lastSignedInUserExplicitPrivilege = this.hasExplicitPrivilege;
                        configurationManager.service.lastSignedInUserSubscription = this.isSubscription;
                        configurationManager.service.lastSignedInUserMembership = MS.Entertainment.Utilities.SignedInUser.membershipStringMap[this.membershipLevel];
                        configurationManager.service.lastSignedInUserGamerTag = this.gamerTag;
                        configurationManager.service.lastSignedInUserXuid = this.xuid;
                        configurationManager.service.lastSignedInUserSignInName = this.signInName;
                        configurationManager.service.lastSignedInUserAccountLocale = this.locale
                    }
                }
        }, {
            factory: function factory() {
                return new MS.Entertainment.Utilities.SignedInUser
            }, _instanceCount: 0, _initialPuidLength: 16, _anidSliceLength: 24, _paddingForPuidHash: "FFFFFFFF", _encodedMaterialLength: 66, membershipStringMap: {
                    None: "None", Silver: "Free", Gold: "Gold", FamilyGold: "FamilyGold"
                }
        })});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.signedInUser, MS.Entertainment.Utilities.SignedInUser.factory, true);
    WinJS.Namespace.define("MS.Entertainment.Utilities", {SignIn: MS.Entertainment.defineObservable(function SignIn_constructor() {
            MS.Entertainment.Utilities.SignIn._instanceCount++;
            MS.Entertainment.Utilities.assert(MS.Entertainment.Utilities.SignIn._instanceCount === 1, "Use MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn)");
            this._signInProvider = new Microsoft.Entertainment.Util.SignIn;
            this._liveIdChangeCompleteHandler = this._liveIdChangeCompleteHandler.bind(this);
            Object.defineProperty(this, "appNotificationService", {get: function _getAppNotificationService() {
                    if (!this._appNotificationService && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.appNotification))
                        this._appNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification);
                    return this._appNotificationService
                }.bind(this)});
            if (WinJS.Utilities.getMember("Social.UI")) {
                var profilePickerContainer = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.profilePickerContainer);
                if (profilePickerContainer && profilePickerContainer.firstElementChild) {
                    var pickerControlElement = profilePickerContainer.firstElementChild;
                    this.handleApp2CurrentUserChanged = this.handleApp2CurrentUserChanged.bind(this);
                    pickerControlElement.addEventListener("currentuserchanged", this.handleApp2CurrentUserChanged);
                    pickerControlElement.suppressUnload = true;
                    if (pickerControlElement.winControl)
                        pickerControlElement.winControl.domElement = profilePickerContainer.firstElementChild
                }
            }
        }, {
            isSignedIn: false, isSigningIn: false, signInError: 0, isSigningOut: false, isSignInEnabled: true, _partnerToken: null, _appNotificationService: null, _liveIdChangeTaskName: "LiveIdChange", _networkStatusBinding: null, _lastSignedInUserRegion: null, _signInStartTime: null, signIn: function signIn(dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowCredUI, dontShowTOS) {
                    var that = this;
                    if (this.isSignedIn)
                        return WinJS.Promise.wrap(MS.Entertainment.Utilities.SignIn.SignInResult.success);
                    else if (this.isSigningIn)
                        return WinJS.Promise.wrap(MS.Entertainment.Utilities.SignIn.SignInResult.signingIn);
                    else if (this.isSigningOut)
                        return WinJS.Promise.wrap(MS.Entertainment.Utilities.SignIn.SignInResult.signingOut);
                    else {
                        this.signInError = 0;
                        this.isSigningIn = true;
                        return this._doSignIn(dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowCredUI, dontShowTOS)
                    }
                }, _doSignIn: function _doSignIn(dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowCredUI, dontShowTOS) {
                    if ((new Microsoft.Entertainment.Configuration.ConfigurationManager).shell.retailExperience)
                        return WinJS.Promise.as();
                    this._signInStartTime = new Date;
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var isSignInAvailable = false;
                    var isSupported = true;
                    if (MS.Entertainment.Utilities.isMusicApp)
                        isSignInAvailable = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSignInAvailable);
                    else if (MS.Entertainment.Utilities.isVideoApp)
                        isSignInAvailable = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.videoSignInAvailable);
                    else
                        isSignInAvailable = true;
                    var stateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.upgradeReminderDisplayer))
                        isSupported = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.upgradeReminderDisplayer).checkAndRunUpgradeReminder(!dontShowErrors);
                    if (!isSupported || !stateService.servicesEnabled) {
                        this.isSignInEnabled = false;
                        return this._onSignInComplete(MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_VERSION_NOT_SUPPORTED, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS)
                    }
                    if (!isSignInAvailable) {
                        this.isSignInEnabled = false;
                        return this._onSignInComplete(MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION, dontShowErrors, dontShowAccountCreation, true, dontShowTOS)
                    }
                    var promptType = Microsoft.Entertainment.Util.SignInPromptType.promptIfNeeded;
                    if (dontShowCredUI)
                        promptType = Microsoft.Entertainment.Util.SignInPromptType.doNotPrompt;
                    var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    if (uiStateService.networkStatus && (uiStateService.networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.none || uiStateService.networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.localOnly))
                        return this._onSignInComplete(MS.Entertainment.Utilities.SignInErrors.NS_E_WMPIM_USEROFFLINE, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS);
                    var globalizationManager = new Microsoft.Entertainment.Util.GlobalizationManager;
                    this._lastSignedInUserRegion = globalizationManager.getRegion();
                    var accountPickerPromise = WinJS.Promise.as();
                    if (MS.Entertainment.Utilities.isApp2) {
                        var currentUser = this.getAppCurrentUser();
                        if (!currentUser && App2 && App2.ApplicationModel && App2.ApplicationModel.Core && App2.ApplicationModel.Core.CoreApplicationContext)
                            currentUser = App2.ApplicationModel.Core.CoreApplicationContext.currentUser;
                        var useAccountPicker = !dontShowCredUI;
                        if ((!currentUser || currentUser.isGuest || !currentUser.isSignedIn) && useAccountPicker)
                            accountPickerPromise = MS.Entertainment.UI.Shell.AccountPicker.showAccountPickerAsync().then(function showAccountPickerAsyncComplete(result) {
                                if (!result || !result.user)
                                    return this._onSignInComplete(MS.Entertainment.Utilities.SignInErrors.NO_CONNECTED_ACCOUNT, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS);
                                this._signInProvider.currentUser = result.user;
                                if (WinJS.Utilities.getMember("Social.UI")) {
                                    var profilePicker = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.profilePicker);
                                    if (profilePicker)
                                        profilePicker.currentUser = result.user
                                }
                            }.bind(this), function showAccountPickerAsyncError(error) {
                                return this._onSignInComplete(error, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS)
                            }.bind(this));
                        else if (currentUser && currentUser.isSignedIn && !currentUser.isGuest)
                            this._signInProvider.currentUser = currentUser
                    }
                    return accountPickerPromise.then(function accountPickerComplete() {
                            return this.getPassportTicket(MS.Entertainment.Utilities.SignIn.TicketType.MBI_SSL, MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_Passport), true, promptType).then(function getPassportTicketSuccess(passportTicket) {
                                    if (!(Windows.ApplicationModel.Search && MS.Entertainment.Utilities.isApp2))
                                        MS.Entertainment.Utilities.assert(passportTicket, "No passport ticket");
                                    if (this.appNotificationService) {
                                        this.appNotificationService.removeNotificationByCategory(MS.Entertainment.Utilities.SignIn.NotificationCategory.signInError);
                                        if (!dontShowNotifications)
                                            this.appNotificationService.send(new MS.Entertainment.UI.Notification({
                                                notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(String.id.IDS_SIGNIN_PROGRESS), subTitle: "", moreDetails: "", icon: WinJS.UI.AppBarIcon.sync, action: null, secondaryActions: null, category: MS.Entertainment.Utilities.SignIn.NotificationCategory.signInInfo, isPersistent: true, iconClassName: MS.Entertainment.Utilities.SignIn.NotificationIconClass
                                            }))
                                    }
                                    return this._signInInternal(passportTicket).then(function signInInternalSuccess() {
                                            if (!MS.Entertainment.Utilities.isApp2)
                                                WinJS.xhr({url: "version.json"}).done(function(data) {
                                                    var versionInformation = JSON.parse(data.responseText);
                                                    var expectedVersion = {
                                                            major: 6, minor: 2, build: 0, revision: 0
                                                        };
                                                    var currentVersion = MS.Entertainment.Utilities.parseVersionString(versionInformation.systemVersion);
                                                    if (MS.Entertainment.Utilities.compareVersions(expectedVersion, currentVersion) === 0)
                                                        this._updateAgeAndGender()
                                                }.bind(this));
                                            return this._onSignInComplete(MS.Entertainment.Utilities.SignIn.SignInResult.success, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS)
                                        }.bind(this), function signInInternalError(err) {
                                            return this._onSignInComplete(err.number, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS)
                                        }.bind(this))
                                }.bind(this), function getPassportTicketError(errTicket) {
                                    return this._onSignInComplete(errTicket.number, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS)
                                }.bind(this))
                        }.bind(this))
                }, _registerUserChangedEvents: function _registerUserChangedEvents() {
                    if (!MS.Entertainment.Utilities.isApp2) {
                        this._unregisterLiveIdChangeEvent();
                        this._registerLiveIdChangeEvent()
                    }
                }, handleApp2CurrentUserChanged: function handleApp2CurrentUserChanged(eventArgs) {
                    var newUser = null;
                    if (eventArgs && eventArgs.detail)
                        newUser = eventArgs.detail.newCurrentUser;
                    if (!newUser || (newUser.isGuest || !newUser.isSignedIn)) {
                        this.signOut();
                        return
                    }
                    var previousUser = this.getAppCurrentUser();
                    if (!previousUser || (previousUser.xboxUserId !== newUser.xboxUserId))
                        this.signOut().then(function signOutComplete() {
                            this._signInProvider.currentUser = newUser;
                            this.signIn()
                        }.bind(this))
                }, _registerLiveIdChangeEvent: function _registerLiveIdChangeEvent() {
                    var trigger = new Windows.ApplicationModel.Background.SystemTrigger(Windows.ApplicationModel.Background.SystemTriggerType.onlineIdConnectedStateChange, false);
                    var taskBuilder = new Windows.ApplicationModel.Background.BackgroundTaskBuilder;
                    taskBuilder.name = this._liveIdChangeTaskName;
                    taskBuilder.taskEntryPoint = "LiveIdChange.js";
                    taskBuilder.setTrigger(trigger);
                    var task = taskBuilder.register();
                    task.addEventListener("completed", this._liveIdChangeCompleteHandler)
                }, _unregisterLiveIdChangeEvent: function _unregisterLiveIdChangeEvent() {
                    var iterator = Windows.ApplicationModel.Background.BackgroundTaskRegistration.allTasks.first();
                    var hasCurrentTask = iterator.hasCurrent;
                    while (hasCurrentTask) {
                        var currentTask = iterator.current.value;
                        if (currentTask.name === this._liveIdChangeTaskName)
                            currentTask.unregister(true);
                        hasCurrentTask = iterator.moveNext()
                    }
                }, _liveIdChangeCompleteHandler: function _liveIdChangeCompleteHandler() {
                    this.signOut().then(function signOutComplete() {
                        this.signInOnStart()
                    }.bind(this))
                }, getAppCurrentUser: function getAppCurrentUser() {
                    var user;
                    try {
                        user = this._signInProvider.currentUser
                    }
                    catch(ex) {}
                    return user
                }, getToBeProvisionedUserName: function getToBeProvisionedUserName() {
                    var user;
                    try {
                        user = this._signInProvider.signInName
                    }
                    catch(ex) {}
                    return user
                }, switchCurrentUser: function switchCurrentUser() {
                    MS.Entertainment.UI.Shell.AccountPicker.showAccountPickerAsync().done(function showAccountPickerAsyncComplete(result) {
                        if (!result || !result.user)
                            return;
                        var previousUser = this.getAppCurrentUser();
                        if (previousUser && previousUser.xboxUserId !== result.user.xboxUserId)
                            this.signOut().done(function signOutComplete() {
                                this._signInProvider.currentUser = result.user;
                                this.signIn()
                            }.bind(this))
                    }.bind(this), null)
                }, signInOnStart: function signInOnStart() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    return this.signIn(true, true, false, true, false).then(null, function signInError(){})
                }, signOut: function signOut(forceSignOut, persistUserDB, dontShowNotifications) {
                    if (this.isSigningOut)
                        return WinJS.Promise.wrap(MS.Entertainment.Utilities.SignIn.SignInResult.signingOut);
                    this.isSigningOut = true;
                    var signOutComplete = function signOutComplete(signOutResult, dontShowNotifications) {
                            if (this.isSignedIn) {
                                this.isSignedIn = false;
                                this.signInError = MS.Entertainment.Utilities.SignInErrors.ZEST_E_SIGNIN_REQUIRED;
                                this.isSigningIn = false;
                                (new Microsoft.Entertainment.Configuration.ConfigurationManager).generalSettings.alwaysPromptOnPurchase = true;
                                (new Microsoft.Entertainment.Configuration.ConfigurationManager).generalSettings.promptOnPurchaseFirstRun = true;
                                var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                signedInUser.refresh(null);
                                MS.Entertainment.Utilities.SignIn.dispatchEvent("signOutComplete", true);
                                if (!forceSignOut)
                                    this._resetNavigationState()
                            }
                            this.isSigningOut = false;
                            if (this._refreshSignInPromise) {
                                this._refreshSignInPromise.cancel();
                                this._refreshSignInPromise = null
                            }
                            if (!dontShowNotifications)
                                this._showSignInNotification();
                            if (!forceSignOut) {
                                this._lastSignedInUserRegion = null;
                                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                configurationManager.service.lastSignInAccountRegion = ""
                            }
                            var signOutResultText = signOutResult;
                            if (typeof signOutResult === "number")
                                signOutResultText = "0x" + (signOutResult + 0xFFFFFFFF + 1).toString(16);
                            var telemetryParameterArray = [{
                                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SignOutResult, parameterValue: signOutResultText
                                    }, {
                                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ForceSignOut, parameterValue: !!forceSignOut
                                    }];
                            MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SignOut, telemetryParameterArray);
                            return signOutResult
                        }.bind(this);
                    if (this.isSignedIn || forceSignOut)
                        return this._signOutInternal(persistUserDB).then(function(signIn) {
                                return signOutComplete(MS.Entertainment.Utilities.SignIn.SignInResult.success, dontShowNotifications)
                            }, function(err) {
                                return signOutComplete(err.number, dontShowNotifications)
                            });
                    else {
                        this.isSigningOut = false;
                        return WinJS.Promise.wrap()
                    }
                }, _resetNavigationState: function resetNavigationState() {
                    var navigationService = null;
                    var winJSNavigationService = null;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation)) {
                        navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        navigationService.navigateToDefaultPage()
                    }
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.winJSNavigation)) {
                        winJSNavigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.winJSNavigation);
                        winJSNavigationService.navigateToDefault()
                    }
                }, getPassportTicket: function getPassportTicket(policy, service, ignoreSignInState, promptType) {
                    var upgradeService;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.upgradeReminderDisplayer))
                        upgradeService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.upgradeReminderDisplayer);
                    if ((this.isSignedIn && (!upgradeService || !upgradeService.upgradeRequired)) || ignoreSignInState)
                        return this._getPassportTicketInternal(policy, service, ignoreSignInState, promptType).then(function(passport) {
                                if (passport)
                                    return passport.passportTicket
                            });
                    else
                        return WinJS.Promise.wrapError(null)
                }, getAuthHeader: function getAuthHeader() {
                    var upgradeService;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.upgradeReminderDisplayer))
                        upgradeService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.upgradeReminderDisplayer);
                    if (this.isSignedIn && (!upgradeService || !upgradeService.upgradeRequired))
                        return this._getAuthHeaderInternal().then(function complete(result) {
                                return result
                            }.bind(this), function error(err) {
                                if (err.number)
                                    this._sendXSTSTelemetry(err.number);
                                return WinJS.Promise.wrapError(err)
                            }.bind(this));
                    else
                        return WinJS.Promise.wrapError(null)
                }, getXToken: function getXToken(endpointId, ignoreSignInState) {
                    return this._getXToken(function() {
                            return this._getXTokenInternal(endpointId)
                        }.bind(this), ignoreSignInState)
                }, getXTokenByRelyingParty: function getXTokenByRelyingParty(relyingParty, ignoreSignInState) {
                    return this._getXToken(function() {
                            return this._getXTokenByRelyingPartyInternal(relyingParty)
                        }.bind(this), ignoreSignInState)
                }, _getXToken: function _getXToken(nativeOperation, ignoreSignInState) {
                    var upgradeService;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.upgradeReminderDisplayer))
                        upgradeService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.upgradeReminderDisplayer);
                    if ((this.isSignedIn || this.isApp2UserAvailable) && (!upgradeService || !upgradeService.upgradeRequired) || ignoreSignInState)
                        return nativeOperation().then(function complete(result) {
                                if (result)
                                    return {
                                            key: "Authorization", value: result.token
                                        }
                            }.bind(this), function error(err) {
                                return WinJS.Promise.wrapError(err)
                            }.bind(this));
                    else
                        return WinJS.Promise.wrapError(null)
                }, setIsSignInSupported: function setIsSignInSupported(isSupported) {
                    this._signInProvider.isSignInSupported = isSupported
                }, _sendXSTSTelemetry: function _sendXSTSTelemetry(result) {
                    var authHeaderResultText = result;
                    if (typeof result === "number")
                        authHeaderResultText = "0x" + (result + 0xFFFFFFFF + 1).toString(16);
                    var telemetryParameterArray = [{
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.AuthHeaderResultText, parameterValue: authHeaderResultText
                            }];
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.AuthHeaderResult, telemetryParameterArray)
                }, refreshSignInState: function refreshSignInState() {
                    return this._doSignIn(true, true, true, true, true)
                }, provisionUserAccount: function provisionUserAccount() {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.provisionUserAccount()
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _onSignInComplete: function _onSignInComplete(signInResult, dontShowErrors, dontShowAccountCreation, dontShowNotifications, dontShowTOS) {
                    this.isSigningIn = false;
                    this.isSignedIn = this._signInProvider.isSignedIn();
                    if (this.isSignedIn) {
                        this.signInError = 0;
                        if (this.appNotificationService) {
                            if (!dontShowNotifications)
                                this.appNotificationService.send(new MS.Entertainment.UI.Notification({
                                    notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(String.id.IDS_SIGNIN_COMPLETE), subTitle: "", moreDetails: null, icon: WinJS.UI.AppBarIcon.contact, action: null, secondaryActions: null, category: MS.Entertainment.Utilities.SignIn.NotificationCategory.signInInfo, isPersistent: false
                                }));
                            this.appNotificationService.removeNotificationByCategory(MS.Entertainment.Utilities.SignIn.NotificationCategory.signInError)
                        }
                    }
                    else {
                        if (this.appNotificationService)
                            this.appNotificationService.removeNotificationByCategory(MS.Entertainment.Utilities.SignIn.NotificationCategory.signInInfo);
                        this.signInError = signInResult
                    }
                    if (this.isSignedIn) {
                        var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                        signedInUser.refresh(this._signInProvider);
                        MS.Entertainment.Utilities.SignIn.dispatchEvent("signInComplete", true);
                        if (this._partnerToken)
                            this._sendPartnerTokenToMDS(this._partnerToken)
                    }
                    this._sendTelemetry(signInResult);
                    this._registerUserChangedEvents();
                    var that = this;
                    switch (signInResult) {
                        case MS.Entertainment.Utilities.SignIn.SignInResult.success:
                            var globalizationManager = new Microsoft.Entertainment.Util.GlobalizationManager;
                            var userXboxRegion = globalizationManager.getRegion();
                            if (this._lastSignedInUserRegion !== userXboxRegion)
                                if (this._checkUserRegionIsSupported(userXboxRegion)) {
                                    if (MS.Entertainment.Utilities.isApp1)
                                        MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_SIGNIN_MIXED_REGION_ERROR_TITLE), String.load(String.id.IDS_SIGNIN_MIXED_REGION_ERROR_DESC)).done(function() {
                                            MSApp.terminateApp(new Error("Region Changed because signed in user has different xbox live region"))
                                        })
                                }
                                else {
                                    if (this.appNotificationService)
                                        this.appNotificationService.removeNotificationByCategory(MS.Entertainment.Utilities.SignIn.NotificationCategory.signInInfo);
                                    this.signInError = MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION;
                                    this._lastSignedInUserRegion = null;
                                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                    configurationManager.service.lastSignInAccountRegion = String.empty;
                                    if (!dontShowErrors)
                                        return MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_SIGNIN_ERROR_CAPTION), MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION).then(function showSignInErrorComplete() {
                                                that.signOut(true, true, dontShowNotifications);
                                                return MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION
                                            });
                                    else {
                                        this.signOut(true, true, dontShowNotifications);
                                        return WinJS.Promise.wrapError(MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION)
                                    }
                                }
                            that._refreshSignIn();
                            return WinJS.Promise.wrap(signInResult);
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.XONLINE_E_WCMUSIC_ACCOUNT_NOT_PROVISIONED:
                        case MS.Entertainment.Utilities.SignInErrors.XO_E_ACCOUNT_CREATION_REQUIRED:
                            if (!dontShowAccountCreation)
                                if (MS.Entertainment.Utilities.isModernMPEnabled)
                                    return MS.Entertainment.Accounts.AccountProvisioningDialog.showAccountProvisioningDialog().then(function createAccountComplete() {
                                            return this.signIn(true, true, false, true, true)
                                        }.bind(this), function createAccountError(error) {
                                            return MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_SIGNIN_ERROR_CAPTION), error.number).then(function callSignIn() {
                                                    return this.signIn(true, true, false, true, true)
                                                }.bind(this))
                                        }.bind(this));
                                else
                                    return MS.Entertainment.Accounts.CreateAccount.doCreateAccount().then(function createAccountComplete() {
                                            return that.signIn(true, true, false, true, true)
                                        });
                            else {
                                this.signOut(true, true, dontShowNotifications);
                                return WinJS.Promise.wrapError(signInResult)
                            }
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_TERMS_OF_SERVICE:
                            if (!dontShowTOS)
                                return MS.Entertainment.Accounts.AcceptTermsOfService.doAcceptTermsOfService().then(function acceptTermsOfServiceComplete() {
                                        return that.signIn(true, true, false, true, true)
                                    });
                            else {
                                this.signOut(true, true);
                                return WinJS.Promise.wrapError(signInResult)
                            }
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_VERSION_NOT_SUPPORTED:
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NO_CONNECTED_ACCOUNT:
                            this._showSignInNotification();
                            var persistUserDB = true;
                            var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                            if (configurationManager.service.lastSignedInUserGamerTag && configurationManager.service.lastSignedInUserGamerTag !== String.empty)
                                persistUserDB = false;
                            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                            signedInUser.refresh(null);
                            this.signOut(true, persistUserDB, true);
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.ERROR_NETWORK_UNREACHABLE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_RESOURCE_NOT_FOUND:
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_WMPIM_USEROFFLINE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_DOWNLOAD_FAILURE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_CONNECTION_TIMEOUT:
                        case MS.Entertainment.Utilities.SignInErrors.XBL_SERVER_CONNECTION_FAILURE:
                            this._networkStatusBinding = WinJS.Binding.bind(MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState), {networkStatus: this._onNetworkStatusChanged.bind(this)});
                            if (!dontShowErrors)
                                return MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_SIGNIN_ERROR_CAPTION), MS.Entertainment.Utilities.SignInErrors.NS_E_WMPIM_USEROFFLINE).then(function showSignInErrorComplete() {
                                        return signInResult
                                    });
                            else
                                return WinJS.Promise.wrapError(signInResult);
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_NOT_SUPPORTED_REGION:
                            if (!dontShowErrors)
                                return MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_SIGNIN_ERROR_CAPTION), signInResult).then(function showSignInErrorComplete() {
                                        that.signOut(true, true, dontShowNotifications);
                                        return signInResult
                                    });
                            else {
                                this.signOut(true, true, dontShowNotifications);
                                return WinJS.Promise.wrapError(signInResult)
                            }
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_INVALID_USERNAME_AND_PASSWORD:
                            return this.signIn();
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_NO_ACCOUNT_PROOF:
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_ACCOUNT_PROOF_NOT_VERIFIED:
                            return this.signIn();
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.ZUNE_E_SIGNIN_ERROR_CANCELLED:
                            this._showSignInNotification();
                            return WinJS.Promise.wrapError(signInResult);
                        default:
                            var that = this;
                            var signInAction = WinJS.Utilities.markSupportedForProcessing(function() {
                                    that.signIn()
                                });
                            if (this.appNotificationService)
                                this.appNotificationService.send(new MS.Entertainment.UI.Notification({
                                    notificationType: MS.Entertainment.UI.Notification.Type.Critical, title: String.load(String.id.IDS_SIGNIN_ERROR), subTitle: String.load(String.id.IDS_SIGNIN_RETRY), moreDetails: null, icon: WinJS.UI.AppBarIcon.sync, action: signInAction, secondaryActions: null, category: MS.Entertainment.Utilities.SignIn.NotificationCategory.signInError, isPersistent: true
                                }));
                            this.signOut(true, true);
                            if (!dontShowErrors)
                                return MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_SIGNIN_ERROR_CAPTION), signInResult).then(function showSignInErrorComplete() {
                                        return signInResult
                                    });
                            else
                                return WinJS.Promise.wrapError(signInResult);
                            break
                    }
                    return WinJS.Promise.wrapError(signInResult)
                }, _checkUserRegionIsSupported: function _checkUserRegionIsSupported(userRegion) {
                    var config = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    var supportedRegions;
                    var isSignInSupported = true;
                    if (MS.Entertainment.Utilities.isMusicApp)
                        supportedRegions = config.features.musicSignInAvailable;
                    else if (MS.Entertainment.Utilities.isVideoApp)
                        supportedRegions = config.features.videoSignInAvailable;
                    else
                        isSignInSupported = true;
                    if (supportedRegions.toLowerCase().indexOf(userRegion.toLowerCase()) < 0)
                        isSignInSupported = false;
                    return isSignInSupported
                }, _onNetworkStatusChanged: function _onNetworkStatusChanged(newValue) {
                    switch (newValue) {
                        case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unknown:
                        case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unrestricted:
                        case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.throttled:
                            if (!this.isSignedIn)
                                WinJS.Promise.timeout(400).then(function _delay() {
                                    this.signIn(true, true, false, true, true).done(function success() {
                                        this._networkStatusBinding.cancel()
                                    }.bind(this), function error() {
                                        this._networkStatusBinding.cancel()
                                    }.bind(this))
                                }.bind(this));
                            break
                    }
                }, _launchStore: function _launchStore() {
                    var launchInfo = "ms-windows-store:Updates";
                    var appAction = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.launchApp);
                    appAction.automationId = MS.Entertainment.UI.AutomationIds.launchAppStoreUpgrade;
                    appAction.parameter = {
                        uri: launchInfo, appendSource: true, appendGamerTag: false
                    };
                    appAction.execute()
                }, _updateAgeAndGender: function _updateAgeAndGender() {
                    var that = this;
                    return this.getPassportTicket(MS.Entertainment.Utilities.SignIn.TicketType.HBI, MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_PassportTicket), true).then(function getPassportTicketSuccess(passportTicket) {
                            MS.Entertainment.Utilities.assert(passportTicket, "No passport ticket");
                            return that._updateAgeAndGenderInternal(passportTicket).then(function complete(model) {
                                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                    signedInUser.membershipLevel = model.membershipLevel;
                                    signedInUser.updateLastSignedInUserPropertyCache();
                                    var telemetryParameterArray = [{
                                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.LiveMembershipLevel, parameterValue: signedInUser.membershipLevel
                                            }];
                                    MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SignIn, telemetryParameterArray)
                                })
                        })
                }, _isNetworkError: function _isNetworkError(error) {
                    switch (error) {
                        case MS.Entertainment.Utilities.SignInErrors.ERROR_NETWORK_UNREACHABLE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_RESOURCE_NOT_FOUND:
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_WMPIM_USEROFFLINE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_DOWNLOAD_FAILURE:
                        case MS.Entertainment.Utilities.SignInErrors.INET_E_CONNECTION_TIMEOUT:
                        case MS.Entertainment.Utilities.SignInErrors.XBL_SERVER_CONNECTION_FAILURE:
                            return true;
                        default:
                            return false
                    }
                    return false
                }, _refreshSignIn: function _refreshSignIn(signInInterval) {
                    var refreshInterval = signInInterval ? signInInterval : MS.Entertainment.Utilities.SignIn.SIGNIN_REFRESH_INTERVAL;
                    if (this._refreshSignInPromise) {
                        this._refreshSignInPromise.cancel();
                        this._refreshSignInPromise = null
                    }
                    this._refreshSignInPromise = WinJS.Promise.timeout(refreshInterval).then(function _silentSignIn() {
                        var eventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Service;
                        eventProvider.traceServiceRefreshSignInStarted();
                        var requestNetwork = function requestNetwork() {
                                if (MS.Entertainment.Utilities.isMusicApp1) {
                                    var sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                                    return sessionManager.requestNetworkAndDelay("SignIn")
                                }
                                else
                                    return WinJS.Promise.as()
                            };
                        requestNetwork().then(function onNetworkRequested(networkReleaseHandle) {
                            this._doSignIn(true, true, true, true, true).then(function success() {
                                eventProvider.traceServiceRefreshSignInCompleted();
                                MS.Entertainment.Utilities.SignIn.dispatchEvent("signInRefreshed", true);
                                this._signInProvider.clearTokenMap();
                                MS.Entertainment.Utilities.SignIn._signInRefreshRetryCount = 3;
                                if (networkReleaseHandle)
                                    networkReleaseHandle.release()
                            }.bind(this), function error(signInResult) {
                                var telemetryParameterArray = [{
                                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.RefreshSignInResult, parameterValue: signInResult
                                        }];
                                MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SignIn, telemetryParameterArray);
                                this._signInProvider.clearTokenMap();
                                if (this._isNetworkError(signInResult))
                                    if (MS.Entertainment.Utilities.SignIn._signInRefreshRetryCount > 0) {
                                        MS.Entertainment.Utilities.SignIn._signInRefreshRetryCount--;
                                        this._refreshSignIn(MS.Entertainment.Utilities.SignIn.SIGNIN_REFRESH_INTERVAL_OVERRIDE)
                                    }
                                    else {
                                        MS.Entertainment.Utilities.SignIn._signInRefreshRetryCount = 3;
                                        this.signOut(true, true)
                                    }
                                if (networkReleaseHandle)
                                    networkReleaseHandle.release()
                            }.bind(this))
                        }.bind(this))
                    }.bind(this))
                }, _signInInternal: function _signInInternal(passportTicket) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.signInUser(passportTicket)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _signOutInternal: function _signOutInternal(persistUserDB) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.signOut(persistUserDB || false)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _getPassportTicketInternal: function _getPassportTicketInternal(policy, service, ignoreSignInState, promptType) {
                    var asyncSignInOp = null;
                    if (!promptType)
                        promptType = Microsoft.Entertainment.Util.SignInPromptType.promptIfNeeded;
                    try {
                        asyncSignInOp = this._signInProvider.getTicket(policy, service, ignoreSignInState, promptType)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _getAuthHeaderInternal: function _getAuthHeaderInternal() {
                    var asyncAuthHeaderOp = null;
                    try {
                        asyncAuthHeaderOp = this._signInProvider.getAuthHeader()
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncAuthHeaderOp
                }, _getAuthDataInternal: function _getAuthDataInternal(url) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.getAuthenticatedUrl(url)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _getXTokenInternal: function _getXTokenInternal(endpointId) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.getXTokenAsyncOp(endpointId)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _getXTokenByRelyingPartyInternal: function _getXTokenByRelyingPartyInternal(endpointId) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.getXTokenByRelyingPartyAsyncOp(endpointId)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _updateAgeAndGenderInternal: function _updateAgeAndGenderInternal(passportTicket) {
                    var asyncSignInOp = null;
                    try {
                        asyncSignInOp = this._signInProvider.updateAgeAndGender(passportTicket)
                    }
                    catch(err) {
                        return WinJS.Promise.wrapError(err)
                    }
                    return asyncSignInOp
                }, _sendTelemetry: function _sendTelemetry(signInResult) {
                    var signInResultText = signInResult;
                    if (typeof signInResult === "number")
                        signInResultText = "0x" + (signInResult + 0xFFFFFFFF + 1).toString(16);
                    var eventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell;
                    eventProvider.traceSignInResult(signInResultText);
                    var telemetryParameterArray = [{
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SignInResult, parameterValue: signInResultText
                            }];
                    switch (signInResult) {
                        case MS.Entertainment.Utilities.SignIn.SignInResult.success:
                            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ZunePass, parameterValue: signedInUser.isSubscription
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CanSignOut, parameterValue: signedInUser.canSignOut
                            });
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NO_CONNECTED_ACCOUNT:
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.NoConnectedAccount, parameterValue: true
                            });
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.XONLINE_E_WCMUSIC_ACCOUNT_NOT_PROVISIONED:
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CreateAccount, parameterValue: true
                            });
                            break;
                        case MS.Entertainment.Utilities.SignInErrors.NS_E_SIGNIN_TERMS_OF_SERVICE:
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.AcceptTermsOfService, parameterValue: true
                            });
                            break;
                        default:
                            break
                    }
                    var stopTime = new Date;
                    var durationMsec = stopTime.valueOf() - this._signInStartTime.valueOf();
                    telemetryParameterArray.push({
                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SignInDuration, parameterValue: durationMsec.toString()
                    });
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SignIn, telemetryParameterArray)
                }, _showSignInNotification: function _showSignInNotification() {
                    if (!this.appNotificationService)
                        return;
                    var signInAction = WinJS.Utilities.markSupportedForProcessing(function() {
                            this.signIn().done(null, function(){})
                        }.bind(this));
                    var notificationTitle;
                    var notificationSubtitle;
                    var notificationIcon;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.anonymousFreePlay) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.anonymousFreePlay).anonymousLimitReached) {
                        notificationTitle = String.load(String.id.IDS_MUSIC_STREAMING_KEEP_PLAYING_NOTIFICATION_LINE1);
                        notificationSubtitle = String.load(String.id.IDS_MUSIC_STREAMING_KEEP_PLAYING_NOTIFICATION_LINE2);
                        notificationIcon = MS.Entertainment.UI.Icon.notification
                    }
                    else {
                        notificationTitle = String.load(String.id.IDS_SIGNIN_NOTIFICATION_SIGNIN_TITLE);
                        notificationSubtitle = String.load(String.id.IDS_SIGNIN_NOTIFICATION_SIGNIN_TEXT);
                        notificationIcon = WinJS.UI.AppBarIcon.sync
                    }
                    this.appNotificationService.send(new MS.Entertainment.UI.Notification({
                        notificationType: MS.Entertainment.UI.Notification.Type.Critical, title: notificationTitle, subTitle: notificationSubtitle, moreDetails: null, icon: notificationIcon, action: signInAction, secondaryActions: null, category: MS.Entertainment.Utilities.SignIn.NotificationCategory.signInError, isPersistent: true
                    }))
                }, _sendPartnerTokenToMDS: function _sendPartnerTokenToMDS(partnerToken) {
                    var mdsCall = this._signInProvider.updatePartnerToken(partnerToken);
                    mdsCall.then(null, function(e) {
                        MS.Entertainment.Utilities.fail("Error trying to send partnerToken to MDS: " + (e & e.message))
                    }).done(function() {
                        this._partnerToken = null
                    }.bind(this))
                }, updatePartnerToken: function updatePartnerToken(partnerToken) {
                    MS.Entertainment.Utilities.assert(partnerToken, "No partner token provided to sign in");
                    if (!partnerToken)
                        return;
                    if (this.isSignedIn)
                        this._sendPartnerTokenToMDS(partnerToken);
                    else
                        this._partnerToken = partnerToken
                }
        }, {
            factory: function factory() {
                return new MS.Entertainment.Utilities.SignIn
            }, TicketType: {
                    MBI: "MBI", MBI_SSL: "MBI_SSL", HBI: "HBI", SA_20MIN: "SA_20MIN", JWT: "JWT"
                }, SignInResult: {
                    success: "success", cancel: "cancel", signingIn: "signingIn", signingOut: "signingOut"
                }, NotificationCategory: {
                    signInError: "signInError", signInInfo: "signInInfo"
                }, NotificationIconClass: "rotate360Animation", _instanceCount: 0, listeners: null, SIGNIN_REFRESH_INTERVAL: 3 * 3600 * 1000, SIGNIN_REFRESH_INTERVAL_OVERRIDE: 900 * 1000, _signInRefreshRetryCount: 3, addEventListener: function(eventType, listener, capture) {
                    if (MS.Entertainment.Utilities.SignIn.listeners === null) {
                        var ListenerType = WinJS.Class.mix(WinJS.Class.define(null), WinJS.Utilities.eventMixin);
                        MS.Entertainment.Utilities.SignIn.listeners = new ListenerType
                    }
                    MS.Entertainment.Utilities.SignIn.listeners.addEventListener(eventType, listener, capture)
                }, dispatchEvent: function(eventType, details) {
                    if (MS.Entertainment.Utilities.SignIn.listeners !== null)
                        return MS.Entertainment.Utilities.SignIn.listeners.dispatchEvent(eventType, details)
                }, removeEventListener: function(eventType, listener, capture) {
                    MS.Entertainment.Utilities.SignIn.listeners.removeEventListener(eventType, listener, capture)
                }
        })});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.signIn, MS.Entertainment.Utilities.SignIn.factory, true);
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {signIn: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.derive(MS.Entertainment.UI.Actions.Action, function signInAction() {
                    this.base()
                }, {
                    executed: function executed() {
                        var commandingPopOver = MS.Entertainment.UI.Controls.CommandingPopOver;
                        if (commandingPopOver)
                            commandingPopOver.hideCurrentCommandingPopover();
                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        return signIn.signIn()
                    }, canExecute: function canExecute(param) {
                            return true
                        }
                })
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {signInRequiredNavigate: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.derive(MS.Entertainment.UI.Actions.navigate, function signInRequiredNavigate_constructor() {
                    this.base();
                    MS.Entertainment.Utilities.SignIn.addEventListener("signInComplete", this.requeryCanExecute.bind(this), false);
                    MS.Entertainment.Utilities.SignIn.addEventListener("signOutComplete", this.requeryCanExecute.bind(this), false)
                }, {canExecute: function signInRequiredNavigate_canExecute(param) {
                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        return signIn.isSignedIn
                    }})
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {signInAndOnlineRequiredNavigate: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.derive(MS.Entertainment.UI.Actions.signInRequiredNavigate, function signInAndOnlineRequiredNavigate_constructor() {
                    this.base();
                    this._networkStatusBinding = WinJS.Binding.bind(MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState), {networkStatus: this.onNetworkStatusChanged.bind(this)})
                }, {
                    _networkStatusBinding: null, _isOnline: null, canExecute: function signInAndOnlineRequiredNavigate_canExecute(param) {
                            var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                            return (signIn.isSignedIn && this._isOnline)
                        }, onNetworkStatusChanged: function onNetworkStatusChanged(newValue) {
                            var isOnline = this.isNetworkStatusCodeOnline(newValue);
                            if (isOnline !== this._isOnline)
                                this._isOnline = isOnline
                        }, isNetworkStatusCodeOnline: function isNetworkStatusCodeOnline(status) {
                            var isOnline = false;
                            switch (status) {
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unknown:
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.unrestricted:
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.throttled:
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.onDemand:
                                    isOnline = true;
                                    break;
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.localOnly:
                                case MS.Entertainment.UI.NetworkStatusService.NetworkStatus.none:
                                    isOnline = false;
                                    break
                            }
                            return isOnline
                        }
                })
        })});
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.signIn, function() {
        return new MS.Entertainment.UI.Actions.signIn
    });
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.signInRequiredNavigate, function() {
        return new MS.Entertainment.UI.Actions.signInRequiredNavigate
    });
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.signInAndOnlineRequiredNavigate, function() {
        return new MS.Entertainment.UI.Actions.signInAndOnlineRequiredNavigate
    })
})()
