﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(UI) {
            (function(Components) {
                (function(Shell) {
                    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Components.Shell");
                    var PinToStartScreenInterop = (function() {
                            function PinToStartScreenInterop(){}
                            PinToStartScreenInterop.prototype.findAllTilesAsync = function() {
                                return Windows.UI.StartScreen.SecondaryTile.findAllAsync()
                            };
                            PinToStartScreenInterop.prototype.getServiceImageUrlAsync = function(media, width, height, requestedImage, imageIdType, defaultImageUri, imageContentType) {
                                return MS.Entertainment.UI.Shell.ImageLoader.getServiceImageUrl(media, width, height, requestedImage, imageIdType, defaultImageUri, imageContentType)
                            };
                            PinToStartScreenInterop.prototype.requestCreateAsync = function(tile) {
                                return tile.requestCreateAsync()
                            };
                            PinToStartScreenInterop.prototype.requestCreateForSelectionAsync = function(tile, flyOverPosition, flyOverPlacement) {
                                return tile.requestCreateForSelectionAsync(flyOverPosition, flyOverPlacement)
                            };
                            PinToStartScreenInterop.prototype.requestDeleteAsync = function(tile) {
                                return tile.requestDeleteAsync()
                            };
                            PinToStartScreenInterop.prototype.requestDeleteForSelectionAsync = function(tile, flyOverPosition, flyOverPlacement) {
                                return tile.requestDeleteForSelectionAsync(flyOverPosition, flyOverPlacement)
                            };
                            PinToStartScreenInterop.prototype.updateTileBadge = function(tileId, xmlDocument) {
                                var badgeNotification = new Windows.UI.Notifications.BadgeNotification(xmlDocument);
                                Windows.UI.Notifications.BadgeUpdateManager.createBadgeUpdaterForSecondaryTile(tileId).update(badgeNotification)
                            };
                            PinToStartScreenInterop.prototype.updateTileMetadata = function(tileId, xmlDocument) {
                                var tileNotification = new Windows.UI.Notifications.TileNotification(xmlDocument);
                                Windows.UI.Notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tileId).update(tileNotification)
                            };
                            PinToStartScreenInterop.create = function() {
                                return new MS.Entertainment.UI.Components.Shell.PinToStartScreenInterop
                            };
                            return PinToStartScreenInterop
                        })();
                    Shell.PinToStartScreenInterop = PinToStartScreenInterop
                })(Components.Shell || (Components.Shell = {}));
                var Shell = Components.Shell
            })(UI.Components || (UI.Components = {}));
            var Components = UI.Components
        })(Entertainment.UI || (Entertainment.UI = {}));
        var UI = Entertainment.UI
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}));
if ((new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement).isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.pinToStart))
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.pinToStartScreenInterop, MS.Entertainment.UI.Components.Shell.PinToStartScreenInterop.create)
