﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/debug.js", "/Framework/corefx.js", "/Framework/servicelocator.js");
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Components.Shell");
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.UI.Components.Shell", {
        SnappedMode: MS.Entertainment.UI.Framework.defineUserControl("Components/Shell/SnappedMode.html#snappedModeTemplate", function snappedModeConstructor(element, options){}, {}), initializeSnappedMode: function initializeSnappedMode() {
                var snappedElement = document.getElementById("htmlSnapped");
                var unsnappedElement = document.getElementById("htmlUnsnapped");
                var snappedUserControlElement = null;
                var didMoveNowPlaying = false;
                var didBindToNowPlaying = false;
                var unsnappedFocusRoot = null;
                var unsnappedContentContainer = null;
                var unsnappedActiveElement = null;
                var _uiStateEventHandler = null;
                var controlsFrozen = false;
                var freezeControls = function freezeControls() {
                        var itemsToFreeze = [];
                        var currentPage = document.querySelector("#pageContainer .currentPage");
                        if (currentPage)
                            itemsToFreeze.push(currentPage);
                        var overlays = document.querySelectorAll(".overlayAnchor:not(.noFreeze)");
                        Array.prototype.forEach.call(overlays, function(overlay) {
                            itemsToFreeze.push(overlay)
                        });
                        itemsToFreeze.forEach(function(item) {
                            MS.Entertainment.Utilities.freezeControlsInSubtree(item)
                        });
                        controlsFrozen = true
                    };
                var thawControls = function thawControls() {
                        var itemsToThaw = [];
                        var currentPage = document.querySelector("#pageContainer .currentPage");
                        if (currentPage)
                            itemsToThaw.push(currentPage);
                        var overlays = document.querySelectorAll(".overlayAnchor:not(.noFreeze)");
                        Array.prototype.forEach.call(overlays, function(overlay) {
                            itemsToThaw.push(overlay)
                        });
                        itemsToThaw.forEach(function(item) {
                            MS.Entertainment.Utilities.thawControlsInSubtree(item)
                        });
                        controlsFrozen = false
                    };
                var navigateOnMedia = function navigateOnMedia(newValue, oldValue) {
                        if (newValue && !didMoveNowPlaying) {
                            snappedUserControlElement = document.createElement("div");
                            snappedUserControlElement.className = "musicSnappedNowPlaying snappedContainer win-ui-dark";
                            snappedElement.appendChild(snappedUserControlElement);
                            unsnappedContentContainer = MS.Entertainment.UI.Framework.currentFocusContainer;
                            MS.Entertainment.UI.Framework.currentContentContainer = snappedUserControlElement;
                            if (WinJS.UI.AutomaticFocus) {
                                unsnappedFocusRoot = WinJS.UI.AutomaticFocus.focusRoot;
                                MS.Entertainment.UI.Framework.setFocusRoot(snappedUserControlElement)
                            }
                            unsnappedActiveElement = document.activeElement;
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).nowPlayingTileVisible = false;
                            var nowPlayingControl = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.nowPlayingControlManager).getNowPlayingControl(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying);
                            MS.Entertainment.Utilities.empty(snappedUserControlElement);
                            snappedUserControlElement.appendChild(nowPlayingControl.domElement);
                            didMoveNowPlaying = true
                        }
                    };
                var snapMusic = function snapMusic() {
                        WinJS.Utilities.addClass(document.body, "snapped");
                        WinJS.Utilities.removeClass(snappedElement, "hideFromDisplay");
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        uiStateService.isSnapped = true;
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var snappedTemplate = MS.Entertainment.Utilities.isMusicApp2 ? "Components/Music/MusicSharedTemplates.html#music2SnappedTemplate" : "Components/Music/MusicSharedTemplates.html#musicSnappedTemplate";
                        if (sessionMgr.primarySession && sessionMgr.primarySession.currentMedia) {
                            var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                            if (!uiStateService.nowPlayingVisible || !navigationService.currentPage || !navigationService.currentPage.iaNode || !(navigationService.currentPage.iaNode.moniker === MS.Entertainment.UI.Monikers.immersiveDetails || navigationService.currentPage.iaNode.moniker === MS.Entertainment.UI.Monikers.fullScreenNowPlaying)) {
                                WinJS.Utilities.addClass(unsnappedElement, "hideFromDisplay");
                                freezeControls();
                                navigateOnMedia(true)
                            }
                            else
                                WinJS.Utilities.addClass(snappedElement, "hideFromDisplay")
                        }
                        else {
                            WinJS.Utilities.addClass(unsnappedElement, "hideFromDisplay");
                            if (Windows.UI.ViewManagement.ViewSizePreference && MS.Entertainment.Utilities.isMusicApp1)
                                snappedTemplate = "Components/Music1/lxSnappedMode.html#musicLXSnappedTemplate";
                            MS.Entertainment.UI.Framework.loadTemplate(snappedTemplate).then(function renderControl(controlInstance) {
                                var dataContext = WinJS.Binding.as({unsnapAction: MS.Entertainment.UI.Components.Shell.getUnsnapAction()});
                                snappedUserControlElement = document.createElement("div");
                                snappedElement.appendChild(snappedUserControlElement);
                                return controlInstance.render(dataContext, snappedUserControlElement)
                            }.bind(this)).done(function setFocus() {
                                unsnappedContentContainer = MS.Entertainment.UI.Framework.currentFocusContainer;
                                MS.Entertainment.UI.Framework.currentContentContainer = snappedUserControlElement;
                                unsnappedActiveElement = document.activeElement;
                                if (WinJS.UI.AutomaticFocus) {
                                    unsnappedFocusRoot = WinJS.UI.AutomaticFocus.focusRoot;
                                    MS.Entertainment.UI.Framework.setFocusRoot(snappedUserControlElement);
                                    WinJS.Promise.timeout(500).done(function setFocus() {
                                        MS.Entertainment.UI.Framework.focusFirstInSubTree(snappedUserControlElement)
                                    })
                                }
                            });
                            sessionMgr.primarySession.bind("currentMedia", navigateOnMedia);
                            didBindToNowPlaying = true;
                            freezeControls()
                        }
                    };
                var unSnapMusic = function unSnapMusic() {
                        WinJS.Utilities.removeClass(document.body, "snapped");
                        WinJS.Utilities.removeClass(unsnappedElement, "hideFromDisplay");
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        var appBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                        if (unsnappedContentContainer) {
                            MS.Entertainment.UI.Framework.currentContentContainer = unsnappedContentContainer;
                            unsnappedContentContainer = null
                        }
                        if (unsnappedFocusRoot) {
                            MS.Entertainment.UI.Framework.setFocusRoot(unsnappedFocusRoot);
                            unsnappedFocusRoot = null
                        }
                        if (MS.Entertainment.Utilities.isApp2 && unsnappedActiveElement)
                            MS.Entertainment.UI.Framework.focusElement(unsnappedActiveElement);
                        uiStateService.isSnapped = false;
                        if (didMoveNowPlaying) {
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.nowPlayingControlManager).releaseNowPlayingControl(MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying);
                            didMoveNowPlaying = false
                        }
                        if (controlsFrozen)
                            thawControls();
                        if (didBindToNowPlaying)
                            sessionMgr.primarySession.unbind("currentMedia", navigateOnMedia);
                        snappedUserControlElement = null;
                        WinJS.Utilities.addClass(snappedElement, "hideFromDisplay");
                        if (appBar)
                            appBar.hide()
                    };
                var snapVideo = function snapVideo() {
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var playbackSession = sessionMgr.primarySession;
                        if (MS.Entertainment.Utilities.isVideoApp2 && (uiStateService.nowPlayingVisible || playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.playing || playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.paused)) {
                            WinJS.Utilities.addClass(unsnappedElement, "app2NowPlayingSnappedMode");
                            WinJS.Utilities.addClass(document.body, "snapped");
                            var mainHeader = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.mainHeader);
                            mainHeader.visibility = false;
                            WinJS.Promise.timeout(1000).then(function delayFocus() {
                                MS.Entertainment.UI.Framework.focusFirstInSubTree(MS.Entertainment.UI.Framework.currentFocusContainer, true, true)
                            })
                        }
                        else {
                            snappedUserControlElement = document.createElement("div");
                            snappedElement.appendChild(snappedUserControlElement);
                            new MS.Entertainment.UI.Components.Shell.SnappedMode(snappedUserControlElement, {});
                            unsnappedContentContainer = MS.Entertainment.UI.Framework.currentFocusContainer;
                            MS.Entertainment.UI.Framework.currentContentContainer = snappedUserControlElement;
                            if (MS.Entertainment.Utilities.isVideoApp2 && WinJS.UI.AutomaticFocus) {
                                unsnappedFocusRoot = WinJS.UI.AutomaticFocus.focusRoot || MS.Entertainment.UI.Framework.currentFocusContainer;
                                MS.Entertainment.UI.Framework.setFocusRoot(snappedUserControlElement)
                            }
                            WinJS.Utilities.addClass(unsnappedElement, "hideFromDisplay");
                            freezeControls();
                            WinJS.Utilities.removeClass(snappedElement, "hideFromDisplay")
                        }
                    };
                var unSnapVideo = function unSnapVideo() {
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var playbackSession = sessionMgr.primarySession;
                        if (MS.Entertainment.Utilities.isVideoApp2 && (uiStateService.nowPlayingVisible || playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.playing || playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.paused)) {
                            WinJS.Utilities.removeClass(unsnappedElement, "app2NowPlayingSnappedMode");
                            WinJS.Utilities.removeClass(document.body, "snapped");
                            uiStateService.isSnapped = false;
                            var mainHeader = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.mainHeader);
                            mainHeader.visibility = true;
                            MS.Entertainment.UI.Framework.focusFirstInSubTree(MS.Entertainment.UI.Framework.currentFocusContainer, true, true)
                        }
                        else {
                            thawControls();
                            WinJS.Utilities.removeClass(unsnappedElement, "hideFromDisplay");
                            WinJS.Utilities.addClass(snappedElement, "hideFromDisplay");
                            snappedControlsToRemove.push(snappedUserControlElement);
                            snappedUserControlElement = null;
                            if (unsnappedContentContainer) {
                                MS.Entertainment.UI.Framework.currentContentContainer = unsnappedContentContainer;
                                unsnappedContentContainer = null
                            }
                            if (unsnappedFocusRoot) {
                                MS.Entertainment.UI.Framework.setFocusRoot(unsnappedFocusRoot);
                                unsnappedFocusRoot = null
                            }
                            uiStateService.updateAndNotify("isSnapped", false).done(function _delay() {
                                var actualControl = snappedControlsToRemove.pop();
                                while (actualControl) {
                                    snappedElement.removeChild(actualControl);
                                    actualControl = snappedControlsToRemove.pop()
                                }
                            }, function error() {
                                MS.Entertainment.fail("Error setting uiStateService.isSnapped")
                            })
                        }
                    };
                var matchSnappedWatcher = matchMedia("all and (min-width: 320px) and (max-width: 480px)");
                var onSnappedMode = function onSnappedMode(matchSnapped) {
                        if (matchSnapped.matches) {
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isSnapped = true;
                            if (MS.Entertainment.Utilities.isMusicApp)
                                snapMusic();
                            else {
                                var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                                if (uiStateService.stageThreeActivated)
                                    snapVideo();
                                else if (!_uiStateEventHandler)
                                    _uiStateEventHandler = MS.Entertainment.Utilities.addEventHandlers(uiStateService, {stageThreeActivatedChanged: function stageThreeActivatedChanged(activateEvent) {
                                            if (activateEvent.detail.newValue) {
                                                snapVideo();
                                                _uiStateEventHandler.cancel();
                                                _uiStateEventHandler = null
                                            }
                                        }})
                            }
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).switchedToSnappedMode()
                        }
                    };
                matchSnappedWatcher.addListener(onSnappedMode);
                if (matchSnappedWatcher.matches)
                    onSnappedMode(matchSnappedWatcher);
                var snappedControlsToRemove = [];
                var matchUnsnappedWatcher = matchMedia("all and (min-width: 481px)");
                var onUnsnappedMode = function onUnsnappedMode(matchUnsnapped) {
                        if (matchUnsnapped.matches) {
                            if (MS.Entertainment.Utilities.isMusicApp)
                                unSnapMusic();
                            else
                                unSnapVideo();
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).switchedToUnsnappedMode()
                        }
                    };
                matchUnsnappedWatcher.addListener(onUnsnappedMode);
                if (MS.Entertainment.Utilities.isApp2) {
                    var matchFilledWatcher = matchMedia("all and (min-width: 481px) and (max-width: 1919px)");
                    matchFilledWatcher.addListener(function onFilledMode(matchFilled) {
                        if (matchFilled.matches)
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isFilled = true
                    });
                    var matchNonfilledWatcher = matchMedia("all and (min-width: 1920px), all and (min-width: 320px) and (max-width: 480px)");
                    matchNonfilledWatcher.addListener(function onNonfilledMode(matchNonfilled) {
                        if (matchNonfilled.matches)
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isFilled = false
                    });
                    if (matchFilledWatcher.matches)
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isFilled = true
                }
            }, getUnsnapAction: function getUnsnapAction() {
                var UnsnapButtonAction = MS.Entertainment.derive(MS.Entertainment.UI.Actions.Action, function unsnapAction() {
                        this.base()
                    }, {
                        automationId: MS.Entertainment.UI.AutomationIds.unsnapButtonAction, executed: function executed(parameter) {
                                var appView = Windows.UI.ViewManagement.ApplicationView;
                                if (appView && Windows.Xbox)
                                    appView.tryUnsnapToFullscreen();
                                else if (appView)
                                    appView.tryUnsnap()
                            }, canExecute: function canExecute(parameter) {
                                return true
                            }
                    });
                var action = new UnsnapButtonAction;
                if (MS.Entertainment.Utilities.isApp2) {
                    action.title = String.load(String.id.IDS_GO_FULL_SCREEN_VUI_GUI);
                    action.voicePhrase = String.load(String.id.IDS_GO_FULL_SCREEN_VUI_ALM);
                    action.voicePhoneticPhrase = String.load(String.id.IDS_GO_FULL_SCREEN_VUI_PRON);
                    action.voiceConfidence = String.load(String.id.IDS_GO_FULL_SCREEN_VUI_CONF)
                }
                return action
            }
    })
})()
