﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(undefined) {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Actions");
    WinJS.Namespace.define("MS.Entertainment.UI.Actions", {DeleteMedia: MS.Entertainment.deferredDerive("MS.Entertainment.UI.Actions.Action", function deleteMedia() {
            this.base()
        }, {
            executed: function executed(param) {
                var mediaItems = MS.Entertainment.UI.Actions.extractMediaItemFromParam(param);
                var mediaContext = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar).currentMediaContext;
                var collectionFilter = mediaContext.collectionFilter;
                var options = mediaContext.options || {};
                if (!mediaItems)
                    mediaItems = mediaContext.mediaItem;
                return MS.Entertainment.UI.Controls.RemoveOverlay.show(mediaItems, collectionFilter).then(function overlayClosed(overlay) {
                        var deleteSucceeded = overlay && overlay.userControlInstance && overlay.userControlInstance.removed;
                        if (mediaContext && overlay)
                            mediaContext.dispatchEvent(MS.Entertainment.UI.AppBarActions.deleteMedia, {
                                deleted: deleteSucceeded, removedItem: mediaItems
                            });
                        if (deleteSucceeded)
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.mediaDeleted).mediaDeleted()
                    })
            }, canExecute: function canExecute(param) {
                    return !MS.Entertainment.Utilities.getRetailExperienceState()
                }
        })});
    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
    actionService.register(MS.Entertainment.UI.Actions.ActionIdentifiers.deleteMedia, function() {
        return new MS.Entertainment.UI.Actions.DeleteMedia
    });
    WinJS.Namespace.define("MS.Entertainment", {MediaDeleted: MS.Entertainment.UI.Framework.define(function MediaDeletedConstructor(){}, {mediaDeleted: function mediaDeleted() {
                this.dispatchEvent(MS.Entertainment.MediaDeleted.events.mediaDeleted)
            }}, {events: {mediaDeleted: "mediaDeleted"}})});
    WinJS.Class.mix(MS.Entertainment.MediaDeleted, WinJS.Utilities.eventMixin);
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.mediaDeleted, function getMediaDeletedService() {
        return new MS.Entertainment.MediaDeleted
    }, true)
})()
