﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(MSE, undefined) {
    var alias = MSE.Data.Property.alias;
    var augment = MSE.Data.Property.augment;
    var augmentNoDeflate = MSE.Data.Property.augmentNoDeflate;
    var convert = MSE.Data.Property.convert;
    var convertNoDeflate = MSE.Data.Property.convertNoDeflate;
    var convertOriginal = MSE.Data.Property.convertOriginal;
    var convertOriginalNoDeflate = MSE.Data.Property.convertOriginalNoDeflate;
    var containsRight = MSE.Data.Property.containsRight;
    var searchNoDeflate = MSE.Data.Property.searchNoDeflate;
    var list = MSE.Data.Property.list;
    var listWithContext = MSE.Data.Property.listWithContext;
    var format = MSE.Data.Property.format;
    var collect = MSE.Data.Property.collect;
    var filter = MSE.Data.Property.filter;
    var filterArray = MSE.Data.Property.filterArray;
    var sortArray = MSE.Data.Property.sortArray;
    var value = MSE.Data.Property.value;
    var hydrated = MSE.Data.Property.hydrated;
    var hydratedRequired = MSE.Data.Property.hydratedRequired;
    var convertFeatureOptionsMusic = {feature: Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace};
    var defaultVoiceConfidence = MSE.Data.Factory.defaultVoiceConfidence;
    WinJS.Namespace.defineWithParent(MSE, "Data.Filter.Marketplace", {
        filterUnsupportedAlbums: function filterUnsupportedAlbums(item) {
            return item && (MSE.Data.Factory.boolFromString(item.isPremium) || !MSE.Data.Factory.boolFromString(item.isActionable))
        }, filterSmartDJTracks: function filterSmartDJTracks(item) {
                var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                var userHasSubscription = signedInUserService.isSubscription;
                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                var isFreePlay = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay);
                if (item && item.Providers)
                    for (var i = 0; i < item.Providers.length; i++) {
                        var provider = item.Providers[i];
                        for (var j = 0; j < provider.ProviderContents.length; j++) {
                            var providerContents = provider.ProviderContents[j];
                            for (var k = 0; k < providerContents.OfferInstances.length; k++) {
                                var offerInstance = providerContents.OfferInstances[k];
                                if ((userHasSubscription && offerInstance.DistributionRight === MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Stream) || (isFreePlay && !userHasSubscription && offerInstance.DistributionRight === MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.FreeStream))
                                    return false
                            }
                        }
                    }
                return true
            }, filterUnsupportedMusicHubItems: function filterUnsupportedMusicHubItems(item) {
                return !item || !item.link || !(item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Album || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Artist || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Hub || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Track)
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Comparer.Marketplace", {edsCompareImageRankOnly: function edsCompareImageRankOnly(image1, image2) {
            var result;
            image1 = MS.Entertainment.Data.deflate(image1);
            image2 = MS.Entertainment.Data.deflate(image2);
            if (image1 === image2)
                result = 0;
            else if (!image2)
                result = -1;
            else if (!image1)
                result = 1;
            else if (image1.Order < image2.Order)
                result = -1;
            else if (image1.Order > image2.Order)
                result = 1;
            else
                result = 0;
            return result
        }});
    var alternativeCloudIcons = null;
    try {
        var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
        alternativeCloudIcons = configurationManager.sync.alternativeCloudIcons
    }
    catch(error) {
        MS.Entertainment.Data.fail("Failed to create configuration manager. Error: " + (error && error.message))
    }
    if (!alternativeCloudIcons)
        WinJS.Namespace.define("MS.Entertainment", {cloudIcons: {
                InCloudLocal: String.empty, InCloudNotLocal: MS.Entertainment.UI.Icon.cloud, NotInCloudLocal: MS.Entertainment.UI.Icon.cloudNotAvailable, NotInCloudNotLocal: String.empty, MarketplaceInCollection: MS.Entertainment.UI.Icon.musicInCollection, Downloading: MS.Entertainment.UI.Icon.downloading, PendingDownload: MS.Entertainment.UI.Icon.downloading, PendingSync: MS.Entertainment.UI.Icon.cloudSyncing
            }});
    else
        WinJS.Namespace.define("MS.Entertainment", {cloudIcons: {
                InCloudLocal: MS.Entertainment.UI.Icon.cloud, InCloudNotLocal: MS.Entertainment.UI.Icon.inlineStreaming, NotInCloudLocal: String.empty, NotInCloudNotLocal: String.empty, MarketplaceInCollection: MS.Entertainment.UI.Icon.musicInCollection, Downloading: MS.Entertainment.UI.Icon.downloading, PendingDownload: MS.Entertainment.UI.Icon.downloading, PendingSync: MS.Entertainment.UI.Icon.cloudSyncing
            }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory", {
        isMediaParentallyBlocked: function isMediaParentallyBlocked(media) {
            var isParentallyBlocked = false;
            if (media && media.isExplicit && !media.inCollection) {
                var signedIn = false;
                if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.signIn)) {
                    var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    signedIn = signInService.isSignedIn
                }
                if (!signedIn || !MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.signedInUser)) {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    isParentallyBlocked = !configurationManager.service.lastSignedInUserExplicitPrivilege
                }
                else {
                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    isParentallyBlocked = !signedInUser.xuid || !signedInUser.hasExplicitPrivilege
                }
            }
            return isParentallyBlocked
        }, createEventProxy: function createEventProxy() {
                return new MSE.Utilities.EventInvoker
            }, albumAndArtist: function albumAndArtist(sourceValue) {
                var value = String.empty;
                if (sourceValue)
                    if (sourceValue.artistName && sourceValue.albumName)
                        value = String.load(String.id.IDS_MUSIC_ALBUM_BY_ARTIST).format(sourceValue.albumName, sourceValue.artistName);
                    else if (sourceValue.artistName)
                        value = String.load(String.id.IDS_MUSIC_BY_ARTIST).format(sourceValue.artistName);
                    else if (sourceValue.albumName)
                        value = sourceValue.albumName;
                return value
            }, toCloudIcon: function toCloudIcon(sourceValue) {
                var icon = null;
                var cloudCollectionEnabled = (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection)).isEnabled;
                switch (sourceValue) {
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyPendingSync:
                        return (cloudCollectionEnabled ? MS.Entertainment.cloudIcons.PendingSync : MS.Entertainment.cloudIcons.InCloudNotLocal);
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyPendingSync:
                        return (cloudCollectionEnabled ? MS.Entertainment.cloudIcons.PendingSync : String.empty);
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyTakenDown:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionTakenDown:
                        return MS.Entertainment.cloudIcons.InCloudNotLocal;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnly:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyNoSmid:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalNoRights:
                        return (cloudCollectionEnabled ? MS.Entertainment.cloudIcons.NotInCloudLocal : String.empty);
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalTakenDown:
                        return (cloudCollectionEnabled ? MS.Entertainment.cloudIcons.InCloudLocal : String.empty);
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyNoSmidMdlcPending:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollection:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionNoRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyNoRights:
                    default:
                        return String.empty;
                        break
                }
                return icon
            }, toCloudIconOpacity: function toCloudIconOpacity(sourceValue) {
                var opacity = "1.0";
                return opacity
            }, toCloudIconTooltip: function toCloudIconTooltip(sourceValue) {
                var toolTip = String.empty;
                var cloudCollectionEnabled = (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection)).isEnabled;
                switch (sourceValue) {
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyPendingSync:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyTakenDown:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionTakenDown:
                        toolTip = String.load(String.id.IDS_COLLECTION_TOOLTIP_STREAMING);
                        break;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnly:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyNoSmid:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalNoRights:
                        toolTip = (cloudCollectionEnabled ? String.load(String.id.IDS_COLLECTION_TOOLTIP_UNMATCHED) : String.empty);
                        break;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyPendingSync:
                        toolTip = (cloudCollectionEnabled ? String.load(String.id.IDS_COLLECTION_CLOUD_SYNC_PENDING) : String.empty);
                        break;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalTakenDown:
                        toolTip = (cloudCollectionEnabled ? String.load(String.id.IDS_COLLECTION_TOOLTIP_MATCHED) : String.empty);
                        break;
                    default:
                        toolTip = String.empty;
                        break
                }
                return toolTip
            }, toCloudIconAriaString: function toCloudIconAriaString(sourceValue) {
                var ariaString = String.empty;
                var cloudCollectionEnabled = (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection)).isEnabled;
                switch (sourceValue) {
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyPendingSync:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyTakenDown:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionTakenDown:
                        ariaString = String.load(String.id.IDS_COLLECTION_STREAMING_FROM_CLOUD_FREE);
                        break;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.localOnlyPendingSync:
                        if (cloudCollectionEnabled)
                            ariaString = String.load(String.id.IDS_COLLECTION_CLOUD_SYNC_PENDING_ARIA);
                        break;
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalValidRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudAndLocalTakenDown:
                        if (cloudCollectionEnabled)
                            ariaString = String.load(String.id.IDS_COLLECTION_CLOUD_MATCHED_ARIA);
                        break;
                    default:
                        break
                }
                return ariaString
            }, inCollectionToCloudIcon: function inCollectionToCloudIcon(inCollection) {
                if (inCollection)
                    return MS.Entertainment.cloudIcons.MarketplaceInCollection;
                else
                    return MS.Entertainment.cloudIcons.NotInCloudNotLocal
            }, toPlaylistItemOpacity: function toPlaylistItemOpacity(itemCollectionState) {
                var opacity = "1.0";
                switch (itemCollectionState) {
                    case Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionNoRights:
                    case Microsoft.Entertainment.Queries.ItemCollectionState.cloudOnlyNoRights:
                        return "0.25"
                }
                return opacity
            }, createAlbumDetailString: function createAlbumDetailString(album, options) {
                if (!album)
                    return String.empty;
                var values = [];
                if (album.artistName)
                    values.push(album.artistName);
                if (album.releaseDate) {
                    var formattedYear = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).year;
                    values.push(formattedYear.format(album.releaseDate))
                }
                var genre;
                if (album.primaryGenre)
                    genre = album.primaryGenre.name || album.primaryGenre;
                else if (album.genreName)
                    genre = album.genreName;
                if (genre)
                    values.push(genre);
                if ((!options || options.includeLabel) && album.label)
                    values.push(album.label);
                if (options && options.includeExplicit && album.isExplicit)
                    values.push(String.load(String.id.IDS_DETAILS_EXPLICIT_LABEL));
                return values.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
            }, createArtistDetailString: function createArtistDetailString(artist, isCollection) {
                if (!artist)
                    return String.empty;
                var details = [];
                if (isCollection) {
                    MS.Entertainment.UI.assert(artist.inCollection, "media item in collection view is not in collection");
                    var formatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                    var albumCountFormatted;
                    var tracksCountFormatted;
                    if (artist.totalAlbumsCount === 1)
                        details.push(String.load(String.id.IDS_DETAILS_COLLECTION_ALBUM_COUNT));
                    else if (artist.totalAlbumsCount > 1) {
                        albumCountFormatted = formatter.format(artist.totalAlbumsCount);
                        details.push(String.load(String.id.IDS_DETAILS_COLLECTION_ALBUMS_COUNT).format(albumCountFormatted))
                    }
                    if (artist.totalTracksCount === 1)
                        details.push(String.load(String.id.IDS_DETAILS_COLLECTION_SONG_COUNT));
                    else if (artist.totalTracksCount > 1) {
                        tracksCountFormatted = formatter.format(artist.totalTracksCount);
                        details.push(String.load(String.id.IDS_DETAILS_COLLECTION_SONGS_COUNT).format(tracksCountFormatted))
                    }
                    else
                        details.push(String.load(String.id.IDS_DETAILS_COLLECTION_NO_SONGS))
                }
                else {
                    var genre;
                    if (artist.primaryGenre)
                        genre = artist.primaryGenre.title || artist.primaryGenre;
                    if (genre)
                        details.push(genre)
                }
                return details.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
            }, createAlbumSummaryString: function createAlbumSummaryString(album) {
                var summary = String.empty;
                if (album)
                    if (album.trackCount !== undefined && album.trackCount !== null)
                        if (album.releaseYear)
                            summary = MS.Entertainment.Utilities.Pluralization.getPluralizedString(String.id.IDS_FAI_ALBUM_SUMMARY_4_PLURAL, album.trackCount).format(album.artistName, album.trackCount, album.releaseYear, album.primaryGenreName);
                        else
                            summary = MS.Entertainment.Utilities.Pluralization.getPluralizedString(String.id.IDS_FAI_ALBUM_SUMMARY_3_PLURAL, album.trackCount).format(album.artistName, album.trackCount, album.primaryGenreName);
                    else if (album.releaseYear)
                        summary = String.load(String.id.IDS_FAI_ALBUM_SUMMARY_3).format(album.artistName, album.releaseYear, album.primaryGenreName);
                    else
                        summary = String.load(String.id.IDS_FAI_ALBUM_SUMMARY_2).format(album.artistName, album.primaryGenreName);
                return summary
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Library", {
        localizedYearOrMonthKey: function localizedYearOrMonthKey(source) {
            return MS.Entertainment.Utilities.trimCharacterDirection(MS.Entertainment.Data.Factory.Library.localizedYearOrMonth(source))
        }, localizedYearOrMonth: function localizedYearOrMonth(source) {
                source = MS.Entertainment.Utilities.trimCharacterDirection(source);
                if (String.isString(source) && !isNaN(parseInt(source)))
                    result = MSE.Data.Factory.localizedYear(source) || source;
                else
                    result = source;
                return result || String.load(String.id.IDS_UNKNOWN_VALUE)
            }, localizedYearOrMonthFromDate: function localizedYearOrMonthFromDate(source) {
                var result = String.empty;
                var formatter;
                if (source && source.getFullYear)
                    result = source.getFullYear();
                if ((new Date).getFullYear() === result)
                    formatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).monthYear;
                if (formatter)
                    result = formatter.format(source);
                return MS.Entertainment.Data.Factory.Library.localizedYearOrMonth(result + String.empty)
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {
        inMyMusicText: function inMyMusicText(inCollection) {
            return inCollection ? String.load(String.id.IDS_MUSIC_IN_MY_MUSIC_LABEL) : String.empty
        }, processArtistBio: function processArtistBio(text) {
                return MS.Entertainment.Utilities.processServiceLinks(text, {
                        $close: "</a>", Contributor: "<a href=\"microsoftmusic://details?id={0}&desiredMediaItemType=musicArtist&idType=zuneCatalog&dialogOnly=true&origin=music\">"
                    })
            }, edsAlbumRightsIEBProviders: function edsAlbumRightsIEBProviders(providers, provideType, deviceType) {
                return MS.Entertainment.Data.Factory.Marketplace.edsRights(providers, null, null, MS.Entertainment.Utilities.isModernMPEnabled ? MSE.Data.Augmenter.Marketplace.EDSModernAlbumOfferRight : MSE.Data.Augmenter.Marketplace.EDSAlbumOfferRight)
            }, edsConvertToAlbumRightType: function edsConvertToAlbumRightType(distributionRight) {
                return MS.Entertainment.Data.Factory.Marketplace.edsConvertToRightType(distributionRight, MS.Entertainment.Data.Augmenter.Marketplace.edsDistributionRightToAlbumRightTypeMappings)
            }, edsCreateGenreQueryOptions: function edsCreateGenreQueryOptions(genre) {
                var rootGenre;
                var childGenre;
                if (genre)
                    if (genre.isRoot)
                        rootGenre = genre;
                    else {
                        childGenre = genre;
                        rootGenre = genre.parent
                    }
                var result = {subGenreId: (childGenre) ? childGenre.serviceId : null};
                if (rootGenre && rootGenre.serviceId)
                    result.genreId = rootGenre.serviceId;
                return result
            }, edsCreateGenreTrackQueryOptions: function edsCreateGenreTrackQueryOptions(genre) {
                var options = MSE.Data.Factory.Marketplace.edsCreateGenreQueryOptions(genre);
                if (options)
                    options.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.store, Microsoft.Entertainment.Platform.AcquisitionContextType.genre, genre && genre.serviceId);
                return options
            }, edsCrossMediaToMusicFactory: function edsCrossMediaToMusicFactory(item) {
                var mediaType = item.type || item.MediaItemType;
                if (mediaType in MS.Entertainment.Data.Query.edsMediaTypeIntegerToStringMappings)
                    mediaType = MS.Entertainment.Data.Query.edsMediaTypeIntegerToStringMappings[mediaType];
                var augmenter;
                if (mediaType === MS.Entertainment.Data.Query.edsMediaType.album)
                    augmenter = MS.Entertainment.Data.Augmenter.Marketplace.Music.SearchAlbum;
                else if (mediaType === MS.Entertainment.Data.Query.edsMediaType.musicArtist)
                    augmenter = MS.Entertainment.Data.Augmenter.Marketplace.Music.SearchArtist;
                else if (mediaType === MS.Entertainment.Data.Query.edsMediaType.track)
                    augmenter = MS.Entertainment.Data.Augmenter.Marketplace.Music.SearchTrack;
                else
                    MS.Entertainment.UI.Actions.fail("Unknown media type returned from crossMedia search: " + mediaType);
                if (augmenter)
                    item = MS.Entertainment.Data.augment(WinJS.Binding.unwrap(item), augmenter);
                return item
            }, setListMaxCount: function setListMaxCount(list) {
                if (list)
                    list.maxCount = 100;
                return list
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        Artist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {
                    libraryId: hydratedRequired(convert("ObjectId", MSE.Data.Factory.intNumber, -1)), localAlbumsCount: convert("LocalAlbumsCount", MSE.Data.Factory.intNumber, -1), localTracksCount: convert("LocalTracksCount", MSE.Data.Factory.intNumber, -1), name: hydratedRequired(convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortName: convertOriginal("SortName", MSE.Data.Factory.normalizeTextDirection, String.empty), title: hydratedRequired(convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), remoteAlbumsCount: convert("RemoteAlbumsCount", MSE.Data.Factory.intNumber, -1), remoteTracksCount: convert("RemoteTracksCount", MSE.Data.Factory.intNumber, -1), serviceId: hydratedRequired(convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), totalAlbumsCount: convert("TotalAlbumsCount", MSE.Data.Factory.intNumber, -1), totalTracksCount: convert("TotalTracksCount", MSE.Data.Factory.intNumber, -1), hasSmartDJ: hydratedRequired(alias("CanSmartDJ", false)), primaryGenre: hydrated(convertNoDeflate("genre.name", MSE.Data.Factory.self, String.empty)), genre: hydrated(value(String.empty)), description: hydratedRequired(value(String.empty)), descriptionNoTags: hydratedRequired(value(String.empty)), backgroundImageUri: hydratedRequired(value(null)), backgroundImageResizeUri: hydratedRequired(value(null)), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.artist
                })
        }), Playlist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {
                        count: convert("PlaylistItemsCount", MSE.Data.Factory.intNumber, -1), duration: convert("Duration", MSE.Data.Factory.secondsToMilliseconds, -1), libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), name: convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty), type: convert("Type", MSE.Data.Factory.intNumber, -1), dateAdded: convert("DateAdded", MSE.Data.Factory.databaseDate, null), yearOrMonthAdded: convertNoDeflate("dateAdded", MSE.Data.Factory.Library.localizedYearOrMonthFromDate, null), dateEdited: convert("DateEdited", MSE.Data.Factory.databaseDate, null), yearOrMonthEdited: convertNoDeflate("dateEdited", MSE.Data.Factory.Library.localizedYearOrMonthFromDate, null), isExplicit: false, authorName: String.empty, shortText: String.empty, mediaType: Microsoft.Entertainment.Queries.ObjectType.playlist, tracks: hydratedRequired(value(null)), recentlyPlayedDate: convert("RecentlyPlayedDate", MSE.Data.Factory.databaseDate, null), cloudSyncItemId: convert("CloudSyncItemId", MSE.Data.Factory.guid, String.empty), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), smartDjSeed: convert("SmartDjSeed", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), currentItemIndex: convert("CurrentItemIndex", MSE.Data.Factory.intNumber, -1), onHydrated: MS.Entertainment.Hydrator.playlistCollection
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {AlbumArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Artist, null, {
                    name: hydratedRequired(convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null)), sortName: convertOriginal("ArtistSortName", MSE.Data.Factory.normalizeTextDirection, null), title: hydratedRequired(convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null)), libraryId: hydratedRequired(convert("ArtistId", MSE.Data.Factory.intNumber, -1)), serviceId: convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), zuneId: hydratedRequired(convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist, imageUri: hydratedRequired(convert("ArtistImageUrl", MSE.Data.Factory.self, null)), imageResizeUri: hydratedRequired(convert("ArtistImageUrl", MSE.Data.Factory.self, null)), hasSmartDJ: hydratedRequired(alias("ArtistCanSmartDJ", false)), canonicalId: hydratedRequired(convert("ArtistBingId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), voicePhrase: convert("ArtistName", MSE.Data.Factory.normalizeStringForVoice, String.empty), hasSmartDJ: hydrated(convert("ArtistCanSmartDJ", MSE.Data.Factory.self, false)), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {Album: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItemContainer, null, {
                    artist: augment(String.empty, MSE.Data.Augmenter.Library.AlbumArtist), parent: convertNoDeflate("artist", MSE.Data.Factory.self, null), artistId: convert("ArtistId", MSE.Data.Factory.intNumber, -1), artistGroupId: convert("ArtistId", MSE.Data.Factory.string, null), artistName: convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null), artistSortName: convertOriginal("ArtistSortName", MSE.Data.Factory.normalizeTextDirection, null), artistServiceId: convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), dateAdded: convert("DateAdded", MSE.Data.Factory.databaseDate, null), yearOrMonthAdded: convertNoDeflate("dateAdded", MSE.Data.Factory.Library.localizedYearOrMonthFromDate, null), description: convertOriginal("Description", MSE.Data.Factory.normalizeTextDirection, String.empty), filePath: alias("AlbumArtFileName", String.empty), genreId: convert("GenreId", MSE.Data.Factory.intNumber, -1), genreGroupId: convert("GenreId", MSE.Data.Factory.string, null), genreName: convertOriginal("GenreName", MSE.Data.Factory.normalizeTextDirection, String.empty), libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), localTracksCount: convert("LocalTracksCount", MSE.Data.Factory.intNumber, -1), name: convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), sortName: convertOriginal("SortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), releaseDate: convert("ReleaseDate", MSE.Data.Factory.databaseDate, null), remoteTracksCount: convert("RemoteTracksCount", MSE.Data.Factory.intNumber, -1), serviceId: convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), totalTracksCount: convert("TotalTracksCount", MSE.Data.Factory.intNumber, -1), trackCount: convert("TotalTracksCount", MSE.Data.Factory.intNumber, -1), userStarRating: convert("StarRating", MSE.Data.Factory.intNumber, -1), releaseYear: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null), label: hydrated(value(String.empty)), isExplicit: hydrated(value(false)), rights: hydrated(value(null)), tracks: hydrated(value(null)), primaryGenre: hydrated(value(null)), hasPurchasableTracks: hydrated(value(false)), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, canPurchase: alias("CanPurchase", false), canPurchaseStream: alias("CanPurchaseStream", false), canPurchaseDownload: alias("CanPurchaseDownload", false), canFreeStream: alias("CanFreeStream", false), canSubscriptionStream: alias("CanSubscriptionStream", false), canSubscriptionDownload: alias("CanSubscriptionDownload", false), canPlayLocally: alias("CanPlayLocally", false), canPreview: alias("CanPreview", false), hasPurchased: alias("HasPurchased", false), recentlyPlayedDate: convert("RecentlyPlayedDate", MSE.Data.Factory.databaseDate, null), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), hasArtistServiceId: {get: function() {
                                return this.artistServiceId && this.artistServiceId !== MS.Entertainment.Utilities.EMPTY_GUID
                            }}, cloudIcon: convert("CollectionState", MSE.Data.Factory.toCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: convert("CollectionState", MSE.Data.Factory.toCloudIconOpacity, "1.0"), cloudIconTooltip: convert("CollectionState", MSE.Data.Factory.toCloudIconTooltip, String.empty), cloudIconAriaString: convert("CollectionState", MSE.Data.Factory.toCloudIconAriaString, String.empty), onHydrated: MS.Entertainment.Hydrator.album
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {TrackArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Artist, null, {
                    name: hydratedRequired(convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null)), sortName: convertOriginal("ArtistSortName", MSE.Data.Factory.normalizeTextDirection, null), title: hydratedRequired(convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null)), libraryId: hydratedRequired(convert("ArtistId", MSE.Data.Factory.intNumber, -1)), serviceId: convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), zuneId: hydratedRequired(convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist, imageUri: hydratedRequired(convert("ArtistImageUrl", MSE.Data.Factory.self, null)), imageResizeUri: hydratedRequired(convert("ArtistImageUrl", MSE.Data.Factory.self, null)), hasSmartDJ: hydratedRequired(alias("ArtistCanSmartDJ", false)), canonicalId: hydratedRequired(convert("ArtistBingId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), voicePhrase: convert("ArtistName", MSE.Data.Factory.normalizeStringForVoice, String.empty), hasSmartDJ: hydrated(convert("ArtistCanSmartDJ", MSE.Data.Factory.self, false)), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {TrackAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Album, null, {
                    name: convertOriginal("AlbumName", MSE.Data.Factory.normalizeTextDirection, null), sortName: convertOriginal("AlbumSortName", MSE.Data.Factory.normalizeTextDirection, null), artist: augment(String.empty, MSE.Data.Augmenter.Library.TrackArtist), libraryId: convert("AlbumId", MSE.Data.Factory.intNumber, -1), serviceId: convert("AlbumServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), zuneId: convert("AlbumServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, imageUri: convert("AlbumImageUrl", MSE.Data.Factory.self, null), imageResizeUri: convert("AlbumImageUrl", MSE.Data.Factory.self, null), canonicalId: convert("AlbumBingId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), voicePhrase: convert("AlbumName", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {TrackPlaylist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Playlist, null, {
                    libraryId: convert("PlaylistId", MSE.Data.Factory.intNumber, -1), cloudSyncItemId: convert("PlaylistCloudId", MSE.Data.Factory.guid, String.empty), name: convertOriginal("PlaylistName", MSE.Data.Factory.normalizeTextDirection, String.empty)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {AcquisitionData: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    acquisitionContext: alias("AcquisitionContext", null), acquisitionContextType: alias("AcquisitionContextType", null), acquisitionContextID: alias("acquisitionContextID", null)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {Track: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {
                    acquisitionData: augment(String.empty, MSE.Data.Augmenter.Library.AcquisitionData), artist: hydrated(augment(String.empty, MSE.Data.Augmenter.Library.TrackArtist)), artistId: convert("ArtistId", MSE.Data.Factory.intNumber, -1), artistGroupId: convert("ArtistId", MSE.Data.Factory.string, null), artistName: hydrated(convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, null), MSE.Data.Comparer.notFalsy), artistSortName: convertOriginal("ArtistSortName", MSE.Data.Factory.normalizeTextDirection, null), artistServiceId: hydrated(convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), album: hydrated(augment(String.empty, MSE.Data.Augmenter.Library.TrackAlbum)), parent: convertNoDeflate("album", MSE.Data.Factory.self, null), albumId: convert("AlbumId", MSE.Data.Factory.intNumber, -1), albumGroupId: convert("AlbumId", MSE.Data.Factory.string, null), albumServiceId: hydrated(convert("AlbumServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), albumName: hydrated(convertOriginal("AlbumName", MSE.Data.Factory.normalizeTextDirection, null)), albumSortName: convertOriginal("AlbumSortName", MSE.Data.Factory.normalizeTextDirection, null), _albumAndArtistName: convertNoDeflate(String.empty, MSE.Data.Factory.albumAndArtist, String.empty), albumAndArtistName: convertOriginalNoDeflate("_albumAndArtistName", MSE.Data.Factory.normalizeTextDirection, String.empty), copyright: convertOriginal("Copyright", MSE.Data.Factory.normalizeTextDirection, null), dateAdded: convert("DateAdded", MSE.Data.Factory.databaseDate, null), yearOrMonthAdded: convertNoDeflate("dateAdded", MSE.Data.Factory.Library.localizedYearOrMonthFromDate, null), filePath: convert("FilePath", MSE.Data.Factory.string, null), genreId: convert("GenreId", MSE.Data.Factory.intNumber, -1), genreGroupId: convert("GenreId", MSE.Data.Factory.string, null), genreName: hydrated(convert("GenreName", MSE.Data.Factory.string, null)), primaryGenre: hydrated(convert("GenreName", MSE.Data.Factory.string, null)), label: hydratedRequired(value(null)), libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), localFilesCount: convert("LocalFilesCount", MSE.Data.Factory.intNumber, -1), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), mainTitle: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), sortName: convertOriginal("SortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), offlineFilesCount: convert("OfflineFilesCount", MSE.Data.Factory.intNumber, -1), playlist: augment(String.empty, MSE.Data.Augmenter.Library.TrackPlaylist), playlistCloudSyncId: convert("PlaylistCloudId", MSE.Data.Factory.guid, String.empty), playlistId: convert("PlaylistId", MSE.Data.Factory.intNumber, -1), playlistName: convertOriginal("PlaylistName", MSE.Data.Factory.normalizeTextDirection, String.empty), playlistItemId: convert("PlaylistItemId", MSE.Data.Factory.intNumber, -1), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.databaseDate, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, String.empty)), remoteFilesCount: convert("RemoteFilesCount", MSE.Data.Factory.intNumber, -1), serviceId: hydrated(convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic)), trackNumber: convert("TrackNumber", MSE.Data.Factory.intNumber, -1), userStarRating: convert("StarRating", MSE.Data.Factory.intNumber, -1), duration: hydrated(convert("Duration", MSE.Data.Factory.intNumber, -1), MSE.Data.Comparer.inverseDefaultComparer), durationString: convert("Duration", MSE.Utilities.millisecondsToTimeCode, String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.track, eventProxy: convert(String.empty, MSE.Data.Factory.createEventProxy), images: hydratedRequired(value(null)), imageUri: hydrated(alias("AlbumImageUrl", null)), imageResizeUri: hydrated(alias("AlbumImageUrl", null)), rights: hydrated(value(null)), hasSmartDJ: hydrated(alias("ArtistCanSmartDJ", false)), canPurchase: alias("CanPurchase", false), canPurchaseStream: alias("CanPurchaseStream", false), canPurchaseDownload: alias("CanPurchaseDownload", false), canFreeStream: alias("CanFreeStream", false), canSubscriptionStream: alias("CanSubscriptionStream", false), canSubscriptionDownload: alias("CanSubscriptionDownload", false), canPlayLocally: alias("CanPlayLocally", false), canPreview: alias("CanPreview", false), hasPurchased: alias("HasPurchased", false), isFreeStreamRestrictedByIndividualLimit: alias("IsFreeStreamRestrictedByIndividualLimit", false), isFreeStreamRestrictedByMonthlyLimit: alias("IsFreeStreamRestrictedByMonthlyLimit", false), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), canPurchaseAlbum: {get: function() {
                                return (this.album && this.album.canPurchaseAlbum())
                            }}, hasArtistServiceId: {get: function() {
                                return this.artistServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.artistServiceId)
                            }}, hasAlbumServiceId: {get: function() {
                                return this.albumServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.albumServiceId)
                            }}, hasNonMarketplaceImage: {get: function() {
                                return !!(!this.hasServiceId && this.imageUri)
                            }}, hasNonAlbumArtistName: {get: function() {
                                return (!this.album || this.artistName !== this.album.artistName)
                            }}, playlistItemOpacity: convert("CollectionState", MSE.Data.Factory.toPlaylistItemOpacity, "1.0"), cloudIcon: convert("CollectionState", MSE.Data.Factory.toCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: convert("CollectionState", MSE.Data.Factory.toCloudIconOpacity, "1.0"), cloudIconTooltip: convert("CollectionState", MSE.Data.Factory.toCloudIconTooltip, String.empty), cloudIconAriaString: convert("CollectionState", MSE.Data.Factory.toCloudIconAriaString, String.empty), onHydrated: MS.Entertainment.Hydrator.track
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        AlbumGroupData: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Album, null, {
                    name: convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty), libraryId: convert("GroupId", MSE.Data.Factory.intNumber, -1)
                })
        }), AlbumGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHint, null, {description: convert("ItemsCount", MS.Entertainment.Formatters.albumCountText, String.empty)})
            }), ArtistGroupData: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.Artist, null, {
                        name: convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty), libraryId: convert("GroupId", MSE.Data.Factory.intNumber, -1)
                    })
            }), ArtistGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHint, null, {description: convert("ItemsCount", MS.Entertainment.Formatters.artistCountText, String.empty)})
            }), TrackGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHint, null, {description: convert("ItemsCount", MS.Entertainment.Formatters.trackCountText, String.empty)})
            }), PlaylistGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHint, null, {description: convert("ItemsCount", MS.Entertainment.Formatters.playlistCountText, String.empty)})
            }), AlbumByArtistSubGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHintBase, null, {artist: augment(String.empty, MSE.Data.Augmenter.Library.ArtistGroupData, null)})
            }), TrackByArtistSubGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHintBase, null, {artist: augment(String.empty, MSE.Data.Augmenter.Library.ArtistGroupData, null)})
            }), TrackByAlbumSubGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHintBase, null, {album: augment(String.empty, MSE.Data.Augmenter.Library.AlbumGroupData, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        AlbumByYearOrMonthGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.AlbumGroupItemHint, null, {
                    groupKey: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonthKey), yearOrMonthAdded: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonth)
                })
        }), AlbumByArtistGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.AlbumGroupItemHint, null, {subGroupHints: augment("SubGroups", MSE.Data.Augmenter.Library.AlbumByArtistSubGroupItemHint, null)})
            }), AlbumByGenreGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.AlbumGroupItemHint, null, {
                        _genreName: convert("Name", MSE.Data.Factory.stringOrUnknown), genreName: convertOriginalNoDeflate("_genreName", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            }), TrackByYearOrMonthGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.TrackGroupItemHint, null, {
                        groupKey: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonthKey), yearOrMonthAdded: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonth)
                    })
            }), TrackByArtistGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.TrackGroupItemHint, null, {subGroupHints: augment("SubGroups", MSE.Data.Augmenter.Library.TrackByArtistSubGroupItemHint, null)})
            }), TrackByAlbumGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.TrackGroupItemHint, null, {subGroupHints: augment("SubGroups", MSE.Data.Augmenter.Library.TrackByAlbumSubGroupItemHint, null)})
            }), TrackByGenreGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.TrackGroupItemHint, null, {
                        _genreName: convert("Name", MSE.Data.Factory.stringOrUnknown), genreName: convertOriginalNoDeflate("_genreName", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            }), PlaylistByYearOrMonthGroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.PlaylistGroupItemHint, null, {
                        groupKey: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonthKey), yearOrMonthAdded: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonth), yearOrMonthEdited: convert("Name", MSE.Data.Factory.Library.localizedYearOrMonth)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        TracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Augmenter.Library.Track, null)})
        }), ArtistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.Artist, null), itemsArray: augment("ResultSet", MSE.Data.Augmenter.Library.Artist, null), totalTracksCount: alias("ResultSet[0].TotalTracksCount", 0), totalAlbumsCount: alias("ResultSet[0].TotalAlbumsCount", 0)
                    })
            }), AlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.Album, null), itemsArray: augment("ResultSet", MSE.Data.Augmenter.Library.Album, null), primaryAlbum: augment("ResultSet[0]", MSE.Data.Augmenter.Library.Album)
                    })
            }), AlbumsLimitedResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        _items: list("ResultSet", MSE.Data.Augmenter.Library.Album, null), items: convertNoDeflate("_items", MSE.Data.Factory.Marketplace.setListMaxCount, null), primaryAlbum: augment("ResultSet[0]", MSE.Data.Augmenter.Library.Album)
                    })
            }), PlaylistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Augmenter.Library.Playlist, null)})
            }), AlbumsGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.AlbumGroupItemHint))})
            }), AlbumsByYearOrMonthGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.AlbumByYearOrMonthGroupItemHint))})
            }), AlbumsByArtistGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.AlbumByArtistGroupItemHint))})
            }), AlbumsByGenreGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.AlbumByGenreGroupItemHint))})
            }), ArtistsGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.ArtistGroupItemHint))})
            }), TracksGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.TrackGroupItemHint))})
            }), TracksByArtistGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.TrackByArtistGroupItemHint))})
            }), TracksByAlbumGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.TrackByAlbumGroupItemHint))})
            }), TracksByGenreGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.TrackByGenreGroupItemHint))})
            }), TracksByYearOrMonthGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.TrackByYearOrMonthGroupItemHint))})
            }), PlaylistsGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.PlaylistGroupItemHint))})
            }), PlaylistsByYearOrMonthGroupHintsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupsAugmentation, null, {items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.PlaylistByYearOrMonthGroupItemHint))})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        AlbumReview: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                    serviceId: convert("id", MSE.Data.Factory.guid, String.empty), name: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), content: convertOriginal("content", MSE.Data.Factory.normalizeTextDirection, String.empty)
                })
        }), ArtistBio: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), name: convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty), content: convertOriginal("content.$value", MSE.Data.Factory.normalizeTextDirection, String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.bio
                    })
            }), ArtistImage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), url: alias("instances.imageInstance[0].url", String.empty)
                    })
            }), Playlist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: hydrated(convert("id", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("sortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty)), isExplicit: hydrated(convert("isExplicit", MSE.Data.Factory.boolFromString, false)), authorName: hydrated(convertOriginal("authorName", MSE.Data.Factory.normalizeTextDirection, String.empty)), shortText: hydrated(convertOriginal("shortText", MSE.Data.Factory.normalizeTextDirection, String.empty)), count: hydrated(value(0)), duration: hydrated(value(0)), mediaType: Microsoft.Entertainment.Queries.ObjectType.playlist, type: -1, voicePhrase: hydrated(convert("sortTitle", MSE.Data.Factory.normalizeStringForVoice, String.empty)), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.playlist
                    })
            }), Artist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), libraryId: hydratedRequired(alias("libraryId", -1)), name: hydratedRequired(convertOriginal(["title.$value", "name"], MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydratedRequired(convertOriginal(["title.$value", "name"], MSE.Data.Factory.normalizeTextDirection, String.empty)), genre: hydrated(augment("primaryGenre", MSE.Data.Augmenter.Marketplace.Genre, null)), primaryGenre: hydrated(convertNoDeflate("genre.name", MSE.Data.Factory.self, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, null), latestAlbumImageId: convert("latestAlbumImage.id", MSE.Data.Factory.guid, null), hasSmartDJ: hydratedRequired(convert("hasRadioChannel", MSE.Data.Factory.boolFromString, false)), description: hydratedRequired(value(String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.artist
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {Album: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItemContainer, null, {
                    serviceId: hydrated(convert("id", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), artistName: hydrated(convertOriginal("primaryArtist.name", MSE.Data.Factory.normalizeTextDirection, String.empty)), label: hydrated(convertOriginal("label", MSE.Data.Factory.normalizeTextDirection, String.empty)), artist: hydrated(augment("primaryArtist", MS.Entertainment.Data.Augmenter.Marketplace.Artist, null)), parent: convertNoDeflate("artist", MSE.Data.Factory.self, null), artistServiceId: hydrated(convert("primaryArtist.id", MSE.Data.Factory.guid, String.empty)), primaryGenre: hydrated(augment("primaryGenre", MSE.Data.Augmenter.Marketplace.Genre, null)), primaryGenreName: hydrated(alias("primaryGenre.title", String.empty)), playCount: convert("playCount", MSE.Data.Factory.intNumber, -1), playRank: convert("playRank", MSE.Data.Factory.intNumber, -1), isExplicit: convert("isExplicit", MSE.Data.Factory.boolFromString, false), isPremium: convert("isPremium", MSE.Data.Factory.boolFromString, false), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, [])), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), tracks: hydratedRequired(value(null)), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, dateAdded: null, description: null, voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), hasArtistServiceId: {get: function() {
                                return this.artistServiceId && this.artistServiceId !== MS.Entertainment.Utilities.EMPTY_GUID
                            }}, hasLibraryId: {get: function() {
                                return this.libraryId > 0
                            }}, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, summary: convertNoDeflate(String.empty, MSE.Data.Factory.createAlbumSummaryString), onHydrated: MS.Entertainment.Hydrator.album
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EditorialMusicHub: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EditorialHub, null, {
                    voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        }), EditorialArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Artist, null, {
                        serviceType: null, serviceId: convert("link.target", MSE.Data.Factory.guid, String.empty), name: hydratedRequired(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydratedRequired(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydratedRequired(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydratedRequired(value(MSE.Data.Factory.guid)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), SearchArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Artist, null, {
                        serviceId: alias("serviceId", String.empty), name: hydratedRequired(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydratedRequired(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty)), hcrSecondaryText: String.empty, hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyMusicText, 0), voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EditorialAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Album, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydratedRequired(value(MSE.Data.Factory.guid)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), SearchAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Album, null, {
                        serviceId: hydrated(alias("serviceId", String.empty)), name: hydrated(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty)), hcrSecondaryText: convertOriginalNoDeflate("artistName", MSE.Data.Factory.normalizeTextDirection, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyMusicText, 0), voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), MergedAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Album, null, {
                        serviceId: hydrated(convert("primary.id", MSE.Data.Factory.guid, String.empty)), libraryId: convert("source[1].ObjectId", MSE.Data.Factory.self, -1), name: hydrated(convertOriginal("primary.title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), artistName: hydrated(convertOriginal("primary.primaryArtist.name", MSE.Data.Factory.normalizeTextDirection, String.empty)), label: hydrated(convertOriginal("primary.label", MSE.Data.Factory.normalizeTextDirection, String.empty)), artist: hydrated(augment("primary.primaryArtist", MS.Entertainment.Data.Augmenter.Marketplace.Artist, null)), artistServiceId: hydrated(convert("primary.primaryArtist.id", MSE.Data.Factory.guid, String.empty)), primaryGenre: hydrated(augment("primary.primaryGenre", MSE.Data.Augmenter.Marketplace.Genre, null)), playCount: convert("primary.playCount", MSE.Data.Factory.intNumber, -1), playRank: convert("primary.playRank", MSE.Data.Factory.intNumber, -1), isExplicit: convert("primary.isExplicit", MSE.Data.Factory.boolFromString, false), isPremium: convert("primary.isPremium", MSE.Data.Factory.boolFromString, false), rights: hydrated(augment("primary.rights.right", MSE.Data.Augmenter.Marketplace.Right, [])), releaseDate: hydrated(convert("primary.releaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), voicePhrase: convert("primary.title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), Track: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: hydrated(convert("id", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), duration: hydrated(convert("length", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), durationString: convertNoDeflate("duration", MSE.Utilities.millisecondsToTimeCode, String.empty), trackNumber: convert("trackNumber", MSE.Data.Factory.intNumber, -1), date: convert("updated", MSE.Data.Factory.date), artist: hydrated(augment("primaryArtist", MSE.Data.Augmenter.Marketplace.Artist, null)), artistServiceId: hydrated(convert("primaryArtist.id", MSE.Data.Factory.guid, String.empty)), artistName: hydrated(convertOriginal("primaryArtist.name", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), album: hydrated(augment("album", MSE.Data.Augmenter.Marketplace.Album, null)), parent: convertNoDeflate("album", MSE.Data.Factory.self, null), albumName: hydrated(convertOriginal("album.title", MSE.Data.Factory.normalizeTextDirection, String.empty)), _albumAndArtistName: convertNoDeflate(String.empty, MSE.Data.Factory.albumAndArtist, String.empty), albumAndArtistName: convertOriginalNoDeflate("_albumAndArtistName", MSE.Data.Factory.normalizeTextDirection, String.empty), albumServiceId: hydrated(convert("album.id", MSE.Data.Factory.guid, String.empty)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, [])), hasPreview: convertNoDeflate("rights", MSE.Data.Factory.Marketplace.Rights.hasPreviewRight, false), genreName: hydrated(alias("primaryGenre.title", String.empty)), primaryGenre: hydrated(alias("primaryGenre.title", String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.track, isExplicit: convert("isExplicit", MSE.Data.Factory.boolFromString, false), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, String.empty)), label: hydrated(convertOriginal("label", MSE.Data.Factory.normalizeTextDirection, String.empty)), eventProxy: convert(String.empty, MSE.Data.Factory.createEventProxy), dateAdded: null, filePath: null, releaseDate: hydrated(value(null)), hasRights: true, images: hydratedRequired(value(null)), imageUri: hydratedRequired(value(null)), imageResizeUri: hydratedRequired(value(null)), voicePhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), isAudioAd: alias("isAudioAd", false), source: alias("source", null), hasArtistServiceId: {get: function() {
                                    return this.artistServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.artistServiceId)
                                }}, hasAlbumServiceId: {get: function() {
                                    return this.albumServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.albumServiceId)
                                }}, isParentallyBlocked: {get: function() {
                                    return MS.Entertainment.Data.Factory.isMediaParentallyBlocked(this)
                                }}, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, onHydrated: MS.Entertainment.Hydrator.track
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        PinnedArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EditorialArtist, null, {
                    provider: alias("Provider", null), canonicalId: hydrated(convert("ItemId", MSE.Data.Factory.guid, String.empty))
                })
        }), PinnedAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EditorialAlbum, null, {
                        provider: alias("Provider", null), canonicalId: hydrated(convert("ItemId", MSE.Data.Factory.guid, String.empty))
                    })
            }), PinnedPlaylist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Playlist, null, {
                        provider: alias("Provider", null), cloudSyncItemId: hydrated(convert("ProviderId", MSE.Data.Factory.guid, String.empty))
                    })
            })
    }),
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        RecentArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSArtist, null, {
                    serviceId: alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), serviceIdType: MS.Entertainment.Data.Query.edsIdType.canonical, canonicalId: hydratedRequired(alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), imageResizeUri: alias("ImageUrl"), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        }), RecentSmartDJ: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSArtist, null, {
                        smartDJ: true, serviceId: alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), serviceIdType: MS.Entertainment.Data.Query.edsIdType.canonical, canonicalId: hydratedRequired(alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), mediaType: Microsoft.Entertainment.Queries.ObjectType.smartDJ, artist: augment(["Item", String.empty], MSE.Data.Augmenter.Marketplace.EDSSmartDJArtist, null), artistServiceId: alias(["ItemId"], MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), imageResizeUri: alias("ImageUrl"), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), RecentAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                        canonicalId: hydrated(convert("ItemId", MSE.Data.Factory.guid, String.empty)), serviceIdType: MS.Entertainment.Data.Query.edsIdType.canonical, name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), imageResizeUri: alias("ImageUrl"), serviceId: hydrated(convert("ItemId", MSE.Data.Factory.guid, String.empty)), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), RecentPlaylist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Playlist, null, {
                        cloudSyncItemId: hydrated(convert("ItemId", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), location: MS.Entertainment.Data.ItemLocation.collection, voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            })
    }),
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EditorialTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Track, null, {
                    serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), imageId: hydrated(convert("image.id", MSE.Data.Factory.guid, String.empty)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        SearchTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Track, null, {
                    serviceId: hydrated(alias("serviceId", String.empty)), name: hydrated(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), hcrSecondaryText: convertOriginalNoDeflate("album.title", MSE.Data.Factory.normalizeTextDirection, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyMusicText, 0), voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        }), RichAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Album, null, {
                        _name: alias(["title.$value", "title"], String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), tracks: hydrated(augment("entry", MSE.Data.Augmenter.Marketplace.Track, null)), voicePhrase: convertNoDeflate("_name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), MusicVideo: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Track, null, {})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.WMIS", {Track: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    name: hydrated(alias("Title", String.empty), MSE.Data.Comparer.notFalsy), trackNumber: convert("TrackNum", MSE.Data.Factory.intNumber, 0), uniqueFileId: alias("UniqueFileId"), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.track
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.WMIS", {
        Album: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    name: hydrated(alias("albumFullTitle", String.empty)), id: alias("id_album"), serviceType: MSE.Data.Augmenter.ServiceTypes.wmis, artistName: alias("albumPerformer", String.empty), primaryGenreName: alias("albumGenre", String.empty), releaseDate: convert("albumReleaseDate", MSE.Data.Factory.date, null), releaseYear: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null), trackCount: convert("numberOfTracks", MSE.Data.Factory.intNumber, 0), tracks: hydratedRequired(value(null)), artist: hydratedRequired(value(null)), voicePhrase: convert("albumFullTitle", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), albumCover: alias("albumCover", null), imageUri: {
                            get: (function() {
                                var imageEndpoint;
                                return function getImageUri() {
                                        if (this._imageUrl === null) {
                                            if (!imageEndpoint)
                                                imageEndpoint = MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_WMISImage) + "/";
                                            if (this.albumCover)
                                                this._imageUrl = imageEndpoint + this.albumCover;
                                            else
                                                this._imageUrl = String.Empty
                                        }
                                        return this._imageUrl
                                    }
                            })(), set: function(value) {
                                    this._imageUrl = value
                                }
                        }, summary: convertNoDeflate(String.empty, MSE.Data.Factory.createAlbumSummaryString), _imageUrl: null, onHydrated: MS.Entertainment.Hydrator.album
                })
        }), AlbumWithTracks: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        name: alias("Title", String.empty), artistName: alias("PerformerName", String.empty), primaryGenreName: alias("Genre", String.empty), releaseDate: convert("ReleaseDate", MSE.Data.Factory.date, null), releaseYear: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null), tracks: augment("track", MSE.Data.Augmenter.WMIS.Track, null), uniqueFileId: alias("UniqueFileId"), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), largeCoverArtURL: alias("LargeCoverArtURL", null), imageUri: {get: (function() {
                                    var imageEndpoint;
                                    return function getImageUri() {
                                            if (!imageEndpoint)
                                                imageEndpoint = MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_WMISImage) + "/";
                                            if (this.largeCoverArtURL)
                                                return imageEndpoint + this.largeCoverArtURL;
                                            else
                                                return String.Empty
                                        }
                                })()}
                    })
            }), Endpoint: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        name: alias("Name", String.empty), uri: alias("URI", String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.WMIS", {
        AlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    count: alias("METADATA.MDSR-CD.SearchResultCount", 0), items: list("METADATA.MDSR-CD.SearchResult.Result", MSE.Data.Augmenter.WMIS.Album, null)
                })
        }), AlbumWithTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("METADATA.MDAR-CD", MSE.Data.Augmenter.WMIS.AlbumWithTracks, null)})
            }), EndpointsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        getAlbumDetailsEndpoint: {get: function() {
                                return this._findEndpointUrl("GetAlbumDetailsFromAlbumId")
                            }}, queryEndpoint: {get: function() {
                                    return this._findEndpointUrl("Search")
                                }}, _features: augment("METADATA.ENDPOINTS.ENDPOINT", MSE.Data.Augmenter.WMIS.Endpoint, null), _findEndpointUrl: function _findEndpointUrl(name) {
                                for (var i = 0; i < this._features.length; i++)
                                    if (this._features[i].name === name)
                                        return this._features[i].uri;
                                return String.empty
                            }
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.MusicMatch", {
        ArtistRole: {
            main: "Main", secondary: "Secondary"
        }, MatchType: {
                fullMatch: "FullMatch", metadataMatch: "MetadataMatch", noMatch: "NoMatch", notInRequest: "NotInRequest"
            }, extractPrimaryArtist: function extractPrimaryArtist(contributions) {
                if (contributions)
                    for (var key in contributions) {
                        var artist = contributions[key];
                        if (artist && artist.Role === MS.Entertainment.Data.Augmenter.MusicMatch.ArtistRole.main)
                            return MSE.Data.augment(artist, MSE.Data.Augmenter.MusicMatch.Artist)
                    }
                return null
            }, Artist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        name: convert("ArtistName", MSE.Data.Factory.normalizeTextDirection, String.empty), zuneId: convert("ArtistId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), role: alias("Role", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, voicePhrase: convert("ArtistName", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.artist
                    })
            }), Track: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mainTitle: hydrated(alias("Title", String.empty), MSE.Data.Comparer.notFalsy), subTitle: alias("SubTitle", String.empty), zuneId: convert("MetadataMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), _name: convertNoDeflate(String.empty, MSE.Data.Factory.Common.combineTitleAndSubTitle, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), trackNumber: convert("TrackNumber", MSE.Data.Factory.intNumber, 0), requestId: alias("TrackRequestId", String.empty), matchType: alias("MatchType", String.empty), artists: augment("Contributions", MSE.Data.Augmenter.MusicMatch.Artist), artist: convert("Contributions", MSE.Data.Augmenter.MusicMatch.extractPrimaryArtist, null), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), mediaType: Microsoft.Entertainment.Queries.ObjectType.track, actionableMediaId: alias("ActionableMediaId", String.empty), isInMusicCatalog: alias("IsInXboxMusicCatalog", false), onHydrated: MS.Entertainment.Hydrator.track
                    })
            }), AlbumWithTracks: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        zuneId: convert("AlbumId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusic), mainTitle: alias("Title", String.empty), subTitle: alias("SubTitle", String.empty), _name: convertNoDeflate(String.empty, MSE.Data.Factory.Common.combineTitleAndSubTitle, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty), artistName: alias("ArtistDisplayName", String.empty), artists: augment("Contributions", MSE.Data.Augmenter.MusicMatch.Artist), artist: convert("Contributions", MSE.Data.Augmenter.MusicMatch.extractPrimaryArtist, null), primaryGenreName: alias("Genre", String.empty), releaseDate: convert("ReleaseDate", MSE.Data.Factory.date, null), releaseYear: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null), tracks: augment("Tracks", MSE.Data.Augmenter.MusicMatch.Track), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), imageUri: alias("Url"), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, trackCount: hydrated(convert("Tracks.length", MSE.Data.Factory.intNumber, 0)), isInMusicCatalog: alias("IsInXboxMusicCatalog"), summary: convertNoDeflate(String.empty, MSE.Data.Factory.createAlbumSummaryString), onHydrated: MS.Entertainment.Hydrator.album, hasZuneId: {get: function() {
                                    return !MS.Entertainment.Utilities.isEmptyGuid(this.zuneId)
                                }}
                    })
            }), AlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        xCorrelationId: alias("XCorrelationId", String.empty), items: list("Albums", MSE.Data.Augmenter.MusicMatch.AlbumWithTracks, null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        MergedCollectionMarketplaceResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    marketplaceItems: filterArray("source[0].feed.entry", MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.MediaItem), collectionItems: augment("source[1].ResultSet", MSE.Data.Augmenter.Library.MediaItem, null)
                })
        }), TracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Track, null), itemsArray: augment("feed.entry", MSE.Data.Augmenter.Marketplace.Track, null)
                    })
            }), TrackDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.Track, null)})
            }), MusicVideoDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.MusicVideo, null)})
            }), AlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        count: alias("feed.entry.length"), items: filter("feed.entry", MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.RichAlbum)
                    })
            }), FeaturedGenreAlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        count: alias(["feed.entry[1].albums.album.length", "feed.entry.length"]), items: filter(["feed.entry[1].albums.album", "feed.entry"], MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.RichAlbum)
                    })
            }), AlbumDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("feed", MSE.Data.Augmenter.Marketplace.RichAlbum, null)})
            }), AlbumReviewResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.AlbumReview, null)})
            }), ArtistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Artist, null)})
            }), ArtistDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.Artist, null)})
            }), ArtistBioResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.ArtistBio, null)})
            }), ArtistImagesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: augment("feed.entry", MSE.Data.Augmenter.Marketplace.ArtistImage, null)})
            }), PlaylistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Playlist, null)})
            }), TopAlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        count: alias("feed.entry.length"), entries: filter("feed.entry", MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.RichAlbum)
                    })
            }), TopAlbumsResultWithItems: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        count: alias("feed.entry.length"), items: filter("feed.entry", MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.RichAlbum)
                    })
            }), TopArtistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Artist, null)})
            }), TopTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Track, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Spotlight", {
        SpotlightArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Artist, null, {
                    serviceId: convert("actionTarget", MSE.Data.Factory.guid, String.empty), name: hydratedRequired(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydratedRequired(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null)
                })
        }), SpotlightAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Album, null, {
                        serviceId: convert("actionTarget", MSE.Data.Factory.guid, String.empty), name: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EditorialEntriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    entries: list("feed.entry", MSE.Data.Augmenter.Marketplace.EditorialItemsEntry, null), itemsArray: augment("feed.entry", MSE.Data.Augmenter.Marketplace.EditorialItemsEntry, null), editorialItems: filterArray("feed.entry[0].editorialItems.editorialItem", MSE.Data.Filter.Marketplace.filterUnsupportedMusicHubItems, MS.Entertainment.Data.Factory.Common.createMediaItemFromEditorialItem, MS.Entertainment.Data.Factory.array)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        AlbumSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    mediaId: alias("serviceId", String.empty), mediaType: alias("mediaType", Microsoft.Entertainment.Queries.ObjectType.album), mediaTitle: alias("name", String.empty), title: alias("name", String.empty), description: alias("artistName", String.empty), text: alias("name", String.empty), uri: alias("webUri", String.empty), htmlUri: alias("webUri", String.empty), htmlImages: collect(["imageUri", "primaryImageUri"], null, String.empty), htmlLines: collect(["name", "artistName", "releaseYear"], null, String.empty), emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_ALBUM
                })
        }), TrackSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaId: alias("serviceId", String.empty), mediaType: alias("mediaType", Microsoft.Entertainment.Queries.ObjectType.track), mediaTitle: alias("name", String.empty), title: alias("name", String.empty), description: alias("artistName", String.empty), text: alias("name", String.empty), uri: alias("webUri", String.empty), htmlUri: alias("webUri", String.empty), htmlImages: collect(["imageUri", "primaryImageUri"], null, String.empty), htmlLines: collect(["name", "artistName"], null, String.empty), emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_TRACK
                    })
            }), ArtistSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MS.Entertainment.Data.Augmenter.Marketplace.MediaSharePackage, null, {
                        emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_ARTIST, description: alias("descriptionNoTags", String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSMediaItem, null, {
                    genre: hydrated(augment("Genres[0]", MSE.Data.Augmenter.Marketplace.EDSGenre, null)), genreName: hydrated(convertNoDeflate("genre.name", MSE.Data.Factory.self, String.empty)), primaryGenre: hydrated(convertNoDeflate("genre.name", MSE.Data.Factory.self, String.empty)), _description: convertOriginal("Description", MSE.Data.Factory.normalizeTextDirection, String.empty), descriptionNoTags: hydratedRequired(convertNoDeflate("_description", MS.Entertainment.Utilities.processServiceTextBlob, String.empty)), description: hydratedRequired(convertNoDeflate("_description", MS.Entertainment.Data.Factory.Marketplace.processArtistBio, String.empty)), content: hydratedRequired(convertNoDeflate("_description", MS.Entertainment.Data.Factory.Marketplace.processArtistBio, String.empty)), images: sortArray("Images", MSE.Data.Comparer.Marketplace.edsCompareImageRankOnly, MSE.Data.Augmenter.Marketplace.EDSImage, MSE.Data.Factory.array), primaryImage: searchNoDeflate("images", MSE.Data.Filter.Marketplace.edsFilterNonCoversNonThumbnailsWideOrTall, null), largeImages: filterArray("Images", MSE.Data.Filter.Marketplace.edsFilterNonNowPlayingBackgrounds, MSE.Data.Augmenter.Marketplace.EDSImage, MSE.Data.Factory.array), primaryLargeImage: convertNoDeflate("largeImages[0]", MSE.Data.Factory.self, null), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist, hasSmartDJ: hydrated(alias("HasTrackMediaGuide", false)), hasDescription: true, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, sortName: alias("SortName", String.empty), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.artist, catalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.EDS, sourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.App
                })
        }), EDSAlbumOfferRight: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSOfferRight, null, {licenseRight: convert("offer.DistributionRight", MSE.Data.Factory.Marketplace.edsConvertToAlbumRightType, String.empty)})
            }), EDSModernAlbumOfferRight: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSModernOfferRight, null, {licenseRight: convert("offer.DistributionRight", MSE.Data.Factory.Marketplace.edsConvertToAlbumRightType, String.empty)})
            }), EDSSubscription: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                        title: convertOriginalNoDeflate("_displayData.availabilityTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), price: convertOriginalNoDeflate("_displayData.displayPrice", MSE.Data.Factory.normalizeTextDirection, String.empty), offerId: convertNoDeflate("_displayData.offerId", MSE.Data.Factory.self, String.empty), signedOffer: alias("SignedOffer", String.empty), mediaType: MS.Entertainment.Data.Query.edsMediaType.subscription, _displayData: convert("OfferDisplayData", MSE.Data.Factory.parseJSON, String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EDSSmartDJArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSArtist, null, {
                    name: convertOriginal(["Item.Title", "Title"], MSE.Data.Factory.normalizeTextDirection, String.empty), hasSmartDJ: hydratedRequired(alias("HasTrackMediaGuide", false)), imageResizeUri: alias("ImageUrl", String.empty), serviceId: alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), canonicalId: hydratedRequired(alias("ItemId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), voicePhrase: convert("Item.Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSSmartDJResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    name: convertOriginal(["Item.Title", "Title"], MSE.Data.Factory.normalizeTextDirection, String.empty), subtitle: convertOriginal(["Item.SubTitle", "SubTitle"], MSE.Data.Factory.normalizeTextDirection, String.empty), serviceId: alias(["Item.ItemId", "ItemId"], MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), artist: augment(["Item", String.empty], MSE.Data.Augmenter.Marketplace.EDSSmartDJArtist, null), artistServiceId: alias(["Item.ItemId", "ItemId"], MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), imageResizeUri: alias(["Item.ImageUrl", "ImageUrl"], String.empty), index: alias("Index", -1), recentlyPlayedDate: convert(["Item.EventDateTimeUtc", "EventDateTimeUtc"], MSE.Data.Factory.databaseDate, null), smartDJ: true, mediaType: Microsoft.Entertainment.Queries.ObjectType.smartDJ, voicePhrase: convert("Item.Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), listVersion: -1, catalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.EDS, sourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.App
                })
        }), EDSAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSMediaItem, null, {
                        mainTitle: alias(["Name", "name"], String.empty), subTitle: alias("SubTitle", String.empty), _name: convertNoDeflate(String.empty, MSE.Data.Factory.Common.combineTitleAndSubTitle, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty), artistName: hydrated(convertOriginal("PrimaryArtist.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), label: hydrated(convertOriginal("Label", MSE.Data.Factory.normalizeTextDirection, String.empty)), _artist: augment("PrimaryArtist", MSE.Data.Augmenter.Marketplace.EDSArtist, null), artist: hydrated(convertNoDeflate([["impressionGuid", "_artist"]], MSE.Data.Factory.Marketplace.edsSetImpressionGuid)), parent: convertNoDeflate("artist", MSE.Data.Factory.self, null), artistServiceId: hydrated(convert("PrimaryArtist.ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), hasSmartDJ: hydrated(alias("PrimaryArtist.HasTrackMediaGuide", false)), primaryGenre: hydrated(augment("Genres[0]", MSE.Data.Augmenter.Marketplace.EDSGenre, null)), primaryGenreName: hydrated(alias("Genres[0].Name", String.empty)), trackCount: hydrated(convert("TrackCount", MSE.Data.Factory.intNumber, 0)), totalTracksCount: hydrated(convert("TrackCount", MSE.Data.Factory.intNumber, -1)), isExplicit: hydrated(convert("IsExplicit", MSE.Data.Factory.boolFromString, false)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), durationSeconds: convertNoDeflate("duration", MSE.Utilities.secondsFromTimeSpan, null), genre: hydrated(augment("Genres[0]", MSE.Data.Augmenter.Marketplace.EDSGenre, null)), genreName: hydrated(convertNoDeflate("genre.name", MSE.Data.Factory.self, String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, dateAdded: null, rights: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsAlbumRightsIEBProviders, null)), tracks: hydrated(value(null)), hasPurchasableTracks: hydrated(value(false)), cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, isPremium: false, voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), hasArtistServiceId: {get: function() {
                                    return this.artistServiceId && this.artistServiceId !== MS.Entertainment.Utilities.EMPTY_GUID
                                }}, hasLibraryId: {get: function() {
                                    return this.libraryId > 0
                                }}, summary: convertNoDeflate(String.empty, MSE.Data.Factory.createAlbumSummaryString), isParentallyBlocked: {get: function() {
                                    return MS.Entertainment.Data.Factory.isMediaParentallyBlocked(this)
                                }}, onHydrated: MS.Entertainment.Hydrator.album, catalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.EDS, sourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.App
                    })
            }), EDSGenreBrowseQueryOptions: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {genreId: alias("Name", String.empty)})
            }), EDSSubGenreQueryOptions: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {genreId: alias("Name", String.empty)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EDSTrackAlbumBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.mix({ParentAlbum: MSE.Data.Augmenter.Marketplace.EDSAlbum})
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EDSTrackAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSTrackAlbumBase, null, {
                    name: hydrated(convertOriginal("ParentAlbum.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), artistName: hydrated(convertOriginal("PrimaryArtist.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), artist: hydrated(augment("PrimaryArtist", MSE.Data.Augmenter.Marketplace.EDSArtist, null)), artistServiceId: hydrated(convert("PrimaryArtist.ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), hasSmartDJ: hydrated(alias("PrimaryArtist.HasTrackMediaGuide", false)), parent: convertNoDeflate("artist", MSE.Data.Factory.self, null), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, webUri: convertNoDeflate(String.empty, MSE.Data.Factory.Common.webDetailsUri, String.empty), voicePhrase: convert("ParentAlbum.Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSMergedAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                    serviceId: hydrated(convert(["primary.ZuneId", "primary.ID"], MSE.Data.Factory.guid, String.empty)), libraryId: convert("source[1].ObjectId", MSE.Data.Factory.self, -1), serviceIdType: hydrated(convert("primary", MSE.Data.Factory.Marketplace.edsServiceIdType, null)), zuneId: hydrated(alias(["primary.ZuneId", "primary.ID"], MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), canonicalId: hydrated(alias("primary.ID", MS.Entertainment.Utilities.EMPTY_GUID)), mainTitle: alias("primary.Name", String.empty), subTitle: alias("primary.SubTitle", String.empty), impressionGuid: alias("primary.impressionGuid", String.empty), _name: convertNoDeflate(String.empty, MSE.Data.Factory.Common.combineTitleAndSubTitle, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _artist: augment("primary.PrimaryArtist", MSE.Data.Augmenter.Marketplace.EDSArtist, null), artist: hydrated(convertNoDeflate([["impressionGuid", "_artist"]], MSE.Data.Factory.Marketplace.edsSetImpressionGuid)), artistName: hydrated(convertOriginal("primary.PrimaryArtist.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), label: hydrated(convertOriginal("primary.Label", MSE.Data.Factory.normalizeTextDirection, String.empty)), artistServiceId: hydrated(convert(["primary.PrimaryArtist.ZuneID", "primary.PrimaryArtist.ID"], MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), primaryGenre: hydrated(augment("primary.Genres[0]", MSE.Data.Augmenter.Marketplace.EDSGenre, null)), trackCount: hydrated(convert("primary.TrackCount", MSE.Data.Factory.intNumber, 0)), isExplicit: hydrated(convert("primary.IsExplicit", MSE.Data.Factory.boolFromString, false)), releaseDate: hydrated(convert("primary.ReleaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), duration: hydrated(convert("primary.Duration", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), durationSeconds: convertNoDeflate("duration", MSE.Utilities.secondsFromTimeSpan, null), edsMediaGroup: alias("primary.MediaGroup", null), edsMediaItemType: alias("primary.MediaItemType", null), mediaType: Microsoft.Entertainment.Queries.ObjectType.album, images: hydrated(sortArray("primary.Images", MSE.Data.Comparer.Marketplace.edsCompareImage, MSE.Data.Augmenter.Marketplace.EDSImage, MSE.Data.Factory.array)), rights: hydrated(convert("primary.Providers", MSE.Data.Factory.Marketplace.edsAlbumRightsIEBProviders, null)), cloudIcon: convert("primary.CollectionState", MSE.Data.Factory.toCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: convert("primary.CollectionState", MSE.Data.Factory.toCloudIconOpacity, "1.0"), cloudIconTooltip: convert("primary.CollectionState", MSE.Data.Factory.toCloudIconTooltip, String.empty), cloudIconAriaString: convert("CollectionState", MSE.Data.Factory.toCloudIconAriaString, String.empty), voicePhrase: convert("primary.Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        }), EDSTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSMediaItem, null, {
                        mainTitle: alias(["Name", "name"], String.empty), subTitle: alias("SubTitle", String.empty), _name: convertNoDeflate(String.empty, MSE.Data.Factory.Common.combineTitleAndSubTitle, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), title: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), durationSeconds: convertNoDeflate("duration", MSE.Utilities.secondsFromTimeSpan, null), durationString: convertNoDeflate("duration", MSE.Utilities.millisecondsToTimeCode, String.empty), trackNumber: hydrated(convert("TrackNumber", MSE.Data.Factory.intNumber, -1)), _artist: augment("PrimaryArtist", MSE.Data.Augmenter.Marketplace.EDSArtist, null), artist: hydrated(convertNoDeflate([["impressionGuid", "_artist"]], MSE.Data.Factory.Marketplace.edsSetImpressionGuid)), artistServiceId: hydrated(convert("PrimaryArtist.ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), artistName: hydrated(convertOriginal("PrimaryArtist.Name", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), hasSmartDJ: hydrated(alias("PrimaryArtist.HasTrackMediaGuide", false)), _album: augment(String.empty, MSE.Data.Augmenter.Marketplace.EDSTrackAlbum, null), album: hydrated(convertNoDeflate([["impressionGuid", "_album"]], MSE.Data.Factory.Marketplace.edsSetImpressionGuid)), parent: convertNoDeflate("album", MSE.Data.Factory.self, null), albumName: hydrated(convertOriginal("ParentAlbum.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _albumAndArtistName: convertNoDeflate(String.empty, MSE.Data.Factory.albumAndArtist, String.empty), albumAndArtistName: convertOriginalNoDeflate("_albumAndArtistName", MSE.Data.Factory.normalizeTextDirection, String.empty), albumServiceId: hydrated(convert("ParentAlbum.ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), genreName: hydrated(alias("Genres[0].Name", String.empty)), primaryGenre: hydrated(alias("Genres[0].Name", String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.track, isExplicit: hydrated(convert("IsExplicit", MSE.Data.Factory.boolFromString, false)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, String.empty)), eventProxy: convert(String.empty, MSE.Data.Factory.createEventProxy), label: hydrated(convertOriginal("Label", MSE.Data.Factory.normalizeTextDirection, String.empty)), hasPurchased: alias("HasPurchased", false), isFreeStreamRestrictedByIndividualLimit: alias("IsFreeStreamRestrictedByIndividualLimit", false), isFreeStreamRestrictedByMonthlyLimit: alias("IsFreeStreamRestrictedByMonthlyLimit", false), canPlayLocally: alias("CanPlayLocally", false), canFreeStream: containsRight(MSE.Data.Augmenter.Marketplace.RightType.freeStream), canSubscriptionStream: containsRight(MSE.Data.Augmenter.Marketplace.RightType.stream), canPreview: containsRight(MSE.Data.Augmenter.Marketplace.RightType.preview), canPurchase: containsRight(MSE.Data.Augmenter.Marketplace.RightType.purchase), canPurchaseAlbum: containsRight(MSE.Data.Augmenter.Marketplace.RightType.albumPurchase), canDelete: {get: function() {
                                    return (this.libraryId >= 0)
                                }}, voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), isPremium: false, dateAdded: null, filePath: null, genreId: -1, userStarRating: -1, cloudIcon: convertNoDeflate("inCollection", MSE.Data.Factory.inCollectionToCloudIcon, MS.Entertainment.cloudIcons.NotInCloudNotLocal), cloudIconOpacity: "1.0", cloudIconTooltip: String.empty, hasArtistServiceId: {get: function() {
                                    return this.artistServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.artistServiceId)
                                }}, hasAlbumServiceId: {get: function() {
                                    return this.albumServiceId && !MS.Entertainment.Utilities.isEmptyGuid(this.albumServiceId)
                                }}, hasNonMarketplaceImage: {get: function() {
                                    return !(this.hasServiceId || this.imageUri)
                                }}, hasNonAlbumArtistName: {get: function() {
                                    return (!this.album || this.artistName !== this.album.artistName)
                                }}, isParentallyBlocked: {get: function() {
                                    return MS.Entertainment.Data.Factory.isMediaParentallyBlocked(this)
                                }}, onHydrated: MS.Entertainment.Hydrator.track
                    })
            }), EDSGenrePivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        queryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateGenreQueryOptions, null), itemQueryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateGenreQueryOptions, null), itemQuery: {get: function() {
                                    return MS.Entertainment.Data.Query.Music.SubGenres
                                }}, minItems: 2, trackQueryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateGenreTrackQueryOptions, null), isRoot: alias("isRoot", false), serviceId: alias("serviceId", null)
                    })
            }), EDSSubGenrePivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        queryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateGenreQueryOptions, null), trackQueryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateGenreTrackQueryOptions, null), isRoot: alias("isRoot", false), serviceId: alias("serviceId", null), parent: alias("parent", null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSRichTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSTrack, null, {hasRights: {get: function get_hasRights() {
                            var hasRights = false;
                            if (this.rights && this.rights.length)
                                for (var i = 0; i < this.rights.length; i++) {
                                    hasRights = this.rights[i].isFullRight;
                                    if (hasRights)
                                        break
                                }
                            return hasRights
                        }}})
        }), EDSRichGenre: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSGenre, null, {
                        isRoot: true, label: alias("Name", String.empty), value: augmentNoDeflate(String.empty, MSE.Data.Augmenter.Marketplace.EDSGenrePivotValue), items: null, selected: false, expanded: false, tabPanelId: null, childIds: null, ariaLevel: 1
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSTopSongsAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                    serviceId: convertNoDeflate("artist.serviceId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID), serviceIdType: convertNoDeflate("artist.serviceIdType", MSE.Data.Factory.Marketplace.edsServiceIdType, null), zuneId: hydrated(convertNoDeflate("artist.zuneId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), canonicalId: hydrated(convertNoDeflate("artist.canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: format(null, String.id.IDS_DETAILS_TOP_SONGS, String.empty), secondaryText: hydrated(convertNoDeflate("artist.name", MSE.Data.Factory.self, String.empty)), _tracks: list("Items", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null), tracks: hydrated(convertNoDeflate("_tracks", MSE.Data.Factory.Marketplace.setListMaxCount, null)), groupKey: "topSongs", trackCount: 100, isTopSongs: true, releaseYear: String.empty, onHydrated: MS.Entertainment.Hydrator.topSongsAlbum
                })
        }), EDSMusicVideo: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSRichTrack, null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.video, videoType: Microsoft.Entertainment.Queries.VideoType.musicVideo
                    })
            }), EDSSubRichGenre: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSRichGenre, null, {
                        isRoot: false, value: augmentNoDeflate(String.empty, MSE.Data.Augmenter.Marketplace.EDSSubGenrePivotValue), items: undefined, expanded: undefined, ariaLevel: 2
                    })
            }), EDSEditorialTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSTrack, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialTrack, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), MSE.Data.Comparer.notFalsy), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), artist: hydrated(augment("primaryArtist", MS.Entertainment.Data.Augmenter.Marketplace.Artist, null)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EDSEditorialArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSArtist, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialArtist, name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EDSEditorialAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialAlbum, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), artist: hydrated(augment("primaryArtist", MS.Entertainment.Data.Augmenter.Marketplace.Artist, null)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("text", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), name: hydrated(value(String.empty))
                    })
            }), EDSEditorialAlbumEntry: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                        _name: alias(["title.$value", "title"], String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), serviceId: hydrated(convert("id", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialAlbum, artistName: hydrated(convertOriginal("primaryArtist.name", MSE.Data.Factory.normalizeTextDirection, String.empty)), label: hydrated(convertOriginal("label", MSE.Data.Factory.normalizeTextDirection, String.empty)), artist: hydrated(augment("primaryArtist", MS.Entertainment.Data.Augmenter.Marketplace.Artist, null)), artistServiceId: hydrated(convert("primaryArtist.id", MSE.Data.Factory.guid, String.empty)), primaryGenre: hydrated(augment("primaryGenre", MSE.Data.Augmenter.Marketplace.Genre, null)), primaryGenreName: hydrated(alias("primaryGenre.title", String.empty)), playCount: convert("playCount", MSE.Data.Factory.intNumber, -1), playRank: convert("playRank", MSE.Data.Factory.intNumber, -1), isExplicit: hydrated(convert("isExplicit", MSE.Data.Factory.boolFromString, false)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, null)), releaseYear: hydrated(convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, null)), voicePhrase: convertNoDeflate("_name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), zuneId: hydrated(convert("id", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), catalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.EDS, sourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.Compass
                    })
            }), EDSSpotlightArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSArtist, null, {
                        zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialArtist, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), primaryText: convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.string, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null)
                    })
            }), EDSSpotlightAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSAlbum, null, {
                        zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialAlbum, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.string, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSArtistDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.mixNoDeflate({item: MSE.Data.Augmenter.Marketplace.EDSArtist})
        }), EDSAlbumDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mixNoDeflate({item: MSE.Data.Augmenter.Marketplace.EDSAlbum})
            }), EDSTrackDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mixNoDeflate({item: MSE.Data.Augmenter.Marketplace.EDSRichTrack})
            }), EDSArtistDetailResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EDSArtist, null)})
            }), EDSArtistImagesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: filterArray("Items[0].Images", MSE.Data.Filter.Marketplace.edsFilterNonNowPlayingBackgrounds, MSE.Data.Augmenter.Marketplace.EDSImage, null), itemsArray: filterArray("Items[0].Images", MSE.Data.Filter.Marketplace.edsFilterNonNowPlayingBackgrounds, MSE.Data.Augmenter.Marketplace.EDSImage, null)
                    })
            }), EDSAlbumDetailsResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EDSAlbum, null)})
            }), EDSTopSongsAlbumDetailsResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment(String.empty, MSE.Data.Augmenter.Marketplace.EDSTopSongsAlbum, null)})
            }), EDSTrackDetailsResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {
                        item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null), data: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null)
                    })
            }), EDSMusicVideoDetailsResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EDSMusicVideo, null)})
            }), EDSArtistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Augmenter.Marketplace.EDSArtist, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EDSArtist, null), total: alias(["Totals[0].Count", "Items.length"], -1), totalCount: alias(["Totals[0].Count", "Items.length"], -1)
                    })
            }), EDSAlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Augmenter.Marketplace.EDSAlbum, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EDSAlbum, null)
                    })
            }), EDSTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null)
                    })
            }), EDSArtistTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        _items: list("Items", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null), items: convertNoDeflate("_items", MSE.Data.Factory.Marketplace.setListMaxCount, null)
                    })
            }), EDSGenresResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EDSRichGenre, null), total: alias("MediaQueryRefiners[0].Refiners.length", 0)
                    })
            }), EDSAlbumTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        tracks: list("Items", MSE.Data.Augmenter.Marketplace.EDSRichTrack, null), items: convertNoDeflate("tracks", MSE.Data.Factory.self, null)
                    })
            }), EDSAlbumTracksOnAlbumResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {tracks: hydrated(convertOriginalNoDeflate("tracks", MSE.Data.Factory.self, null))})
            }), EDSSmartDJTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {items: filter("Items", MSE.Data.Filter.Marketplace.filterSmartDJTracks, MSE.Data.Augmenter.Marketplace.EDSRichTrack, null)})
            }), EDSSmartDJResults: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        items: list("ListItems", MSE.Data.Augmenter.Marketplace.EDSSmartDJResult, null), responseInfo: alias("ResponseInfo", null), responseStatus: alias("ResponseStatus", null), listVersion: alias("ListMetadata.ListVersion", 0), totalCount: alias("ListMetadata.ListCount", -1)
                    })
            }), EDSRecentListResults: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        itemsArray: augment("ListItems", MS.Entertainment.Data.Factory.Common.createMediaItemFromRecentItem), responseInfo: alias("ResponseInfo", null), responseStatus: alias("ResponseStatus", null), listVersion: alias("ListMetadata.ListVersion", 0), totalCount: alias("ListMetadata.ListCount", -1)
                    })
            }), EDSFeaturedGenreAlbumsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        count: alias(["feed.entry[1].albums.album.length", "feed.entry.length"]), items: filter(["feed.entry[1].albums.album", "feed.entry"], MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.EDSEditorialAlbumEntry), itemsArray: filterArray(["feed.entry[1].albums.album", "feed.entry"], MSE.Data.Filter.Marketplace.filterUnsupportedAlbums, MSE.Data.Augmenter.Marketplace.EDSEditorialAlbumEntry)
                    })
            }), EDSRelatedResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {
                        items: list("Items[0].RelatedMedia", MSE.Data.Augmenter.Marketplace.EDSArtist, null), itemsArray: augment("Items[0].RelatedMedia", MSE.Data.Augmenter.Marketplace.EDSArtist, null), totalCount: alias("Items[0].RelatedMedia.length", -1), total: alias("Items[0].RelatedMedia.length", -1)
                    })
            }), EDSMusicSearchResult: MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                items: list("Items", MS.Entertainment.Data.Factory.Marketplace.edsCrossMediaToMusicFactory, null), total: alias("Totals[0].Count", 0)
            }), EDSSubscriptionDetailResultItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {itemsArray: augment("Items[0].Availabilities", MSE.Data.Augmenter.Marketplace.EDSSubscription, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSSubGenresResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSGenresResult, null, {items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EDSSubRichGenre, null)})
        }), EDSAlbumWithTracks: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.BrowseDetailQuery.mixAugmentation(MSE.Data.Augmenter.Marketplace.EDSAlbumTracksOnAlbumResult, MSE.Data.Augmenter.Marketplace.EDSAlbumDetailsResult)
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSAlbumWithTracksResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {item: augment(String.empty, MSE.Data.Augmenter.Marketplace.EDSAlbumWithTracks, null)})
        }), EDSMergedCollectionMarketplaceResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        marketplaceItems: augment("source[0].Items", MSE.Data.Augmenter.Marketplace.EDSMediaItem, null), collectionItems: augment("source[1].ResultSet", MSE.Data.Augmenter.Library.MediaItem, null), total: alias("source[0].Totals[0].Count", 0)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace.Music", {
        Artist: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.Data.Augmenter.Marketplace.EDSArtist
        }), EditorialAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialAlbum
            }), EditorialArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialArtist
            }), EditorialTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialTrack
            }), MergedCollectionMarketplaceResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSMergedCollectionMarketplaceResult
            }), MergedAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSMergedAlbum
            }), SearchAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSAlbum
            }), SearchArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSArtist
            }), SearchTrack: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSTrack
            }), SpotlightArtist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightArtist
            }), SpotlightAlbum: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightAlbum
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.FileActivation", {Track: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Track, null, {
                    _albumName: convert("musicProps.album", MSE.Data.Factory.stringOrEmpty, String.empty), albumName: hydrated(convertOriginalNoDeflate("_albumName", MSE.Data.Factory.normalizeTextDirection, String.empty)), _artistName: convert("musicProps.artist", MSE.Data.Factory.stringOrEmpty, String.empty), artistName: hydrated(convertOriginalNoDeflate("_artistName", MSE.Data.Factory.normalizeTextDirection, String.empty)), duration: hydrated(convert("musicProps.duration", MSE.Data.Factory.intNumber, -1), MSE.Data.Comparer.inverseDefaultComparer), imageUri: hydrated(convert("thumbnail", MSE.Data.Factory.oneTimeUseBlob, null)), mediaType: Microsoft.Entertainment.Queries.ObjectType.track, _title: convert("musicProps.title", MSE.Data.Factory.stringOrEmpty, String.empty), name: hydrated(convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), mainTitle: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), trackNumber: convert("musicProps.trackNumber", MSE.Data.Factory.intNumber, -1), activationFilePath: convert("fileItem.path", MSE.Data.Factory.string, String.empty), genreName: hydrated(value(String.empty)), fileItem: alias("fileItem", null), filePath: alias("FilePath", null), onHydrated: MS.Entertainment.Hydrator.track
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.EchoNest", {
        MediaItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                    echoNestId: convert("id", MSE.Data.Factory.self, String.empty), _name: convert("name", MSE.Data.Factory.self, String.empty), name: convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty), familiarity: convert("familiarity", MSE.Data.Factory.floatNumber, 0.0), sortName: alias("name", String.empty)
                })
        }), Artist: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.EchoNest.MediaItem, null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.person, personType: Microsoft.Entertainment.Queries.PersonType.artist
                    })
            }), ArtistsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("response.artists", MSE.Data.Augmenter.EchoNest.Artist, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.WebPlaylist", {
        WebSite: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                    name: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), description: convertOriginal("description", MSE.Data.Factory.normalizeTextDirection, String.empty), url: alias("url", String.empty)
                })
        }), WebSitesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        items: list("sites", MSE.Data.Augmenter.WebPlaylist.WebSite, null), itemsArray: augment("sites", MSE.Data.Augmenter.WebPlaylist.WebSite, null)
                    })
            })
    })
})(MS.Entertainment)
