﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {LibraryQueryBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.LibraryWrapperQuery, null, {
                    groupsAugmentation: MSE.Data.Augmenter.Library.GroupsAugmentation, executeCount: function executeCount() {
                            var innerQuery = this.createInnerQuery();
                            return innerQuery.getCountAsync()
                        }
                }, {isLibraryQuery: function LibraryQuery_isLibraryQuery(object) {
                        return MS.Entertainment.Data.Query.LibraryQueryBase.prototype.isPrototypeOf(object)
                    }})
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.undefined, videoType: -1, sort: Microsoft.Entertainment.Queries.GenresSortBy.none, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.GenresQuery;
                            query.mediaType = this.mediaType;
                            if (this.videoType !== -1)
                                query.videoType = this.videoType;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.GenresResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        libraryVideoMusic: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryVideos, null, {
                    category: Microsoft.Entertainment.Queries.VideoType.musicVideo, resultAugmentation: MSE.Data.Augmenter.Library.MusicVideosResult
                })
        }), libraryAlbumGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.libraryGenres, null, {mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.album})
            }), libraryTrackGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.libraryGenres, null, {mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.track})
            }), libraryMusicVideoGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.libraryGenres, null, {
                        mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.video, videoType: Microsoft.Entertainment.Queries.VideoType.musicVideo
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryTracks: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    albumId: -1, artistId: -1, trackId: -1, sort: Microsoft.Entertainment.Queries.TracksSortBy.none, keyword: null, autoUpdateProperties: null, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.TracksQuery;
                            var id = parseInt(this.albumId);
                            if (id !== -1)
                                query.albumId = id;
                            id = parseInt(this.artistId);
                            if (id !== -1)
                                query.artistId = id;
                            id = parseInt(this.trackId);
                            if (id !== -1)
                                query.trackId = id;
                            query.primarySortBy = this.sort;
                            if (this.mediaAvailability && this.mediaAvailability !== Microsoft.Entertainment.Platform.MediaAvailability.available)
                                query.mediaAvailability = this.mediaAvailability;
                            if (this.keyword)
                                if (!Array.isArray(this.keyword))
                                    query.keyword = [this.keyword];
                                else
                                    query.keyword = this.keyword;
                            if (this.trackUrl)
                                query.trackUrl = this.trackUrl;
                            switch (this.sort) {
                                case Microsoft.Entertainment.Queries.TracksSortBy.dateAddedAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.dateAddedDescending:
                                    this.groupsAugmentation = MSE.Data.Augmenter.Library.TracksByYearOrMonthGroupHintsResult;
                                    break;
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingAlbumReleaseYearAscendingNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingAlbumReleaseYearDescendingNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingReleaseYearDescending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumArtistDescendingReleaseYearDescending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumDateAddedAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumDateAddedDescending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumGenreNameTitleAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumGenreNameTitleDescending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumReleaseYearAscendingNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumReleaseYearAscendingTitleAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumReleaseYearDescendingNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumReleaseYearDescendingTitleAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumTitleAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDescending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberDescending:
                                    this.groupsAugmentation = MSE.Data.Augmenter.Library.TracksByAlbumGroupHintsResult;
                                    break;
                                case Microsoft.Entertainment.Queries.TracksSortBy.artistAscendingAlbumReleaseYearAscendingNumberAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.artistAscendingAlbumReleaseYearDescendingNumberAscending:
                                    this.groupsAugmentation = MSE.Data.Augmenter.Library.TracksByArtistGroupHintsResult;
                                    break;
                                case Microsoft.Entertainment.Queries.TracksSortBy.genreAscendingTitleAscending:
                                case Microsoft.Entertainment.Queries.TracksSortBy.genreDescendingTitleDescending:
                                    this.groupsAugmentation = MSE.Data.Augmenter.Library.TracksByGenreGroupHintsResult;
                                    break;
                                default:
                                    this.groupsAugmentation = MSE.Data.Augmenter.Library.TracksGroupHintsResult;
                                    break
                            }
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.TracksResult, groupsAugmentation: MSE.Data.Augmenter.Library.TracksGroupHintsResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryArtists: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    artistOf: Microsoft.Entertainment.Queries.ArtistOf.undefined, keyword: null, sort: Microsoft.Entertainment.Queries.PeopleSortBy.none, personId: -1, autoUpdateProperties: null, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.PeopleQuery;
                            query.artistOf = this.artistOf;
                            query.primarySortBy = this.sort;
                            if (this.mediaAvailability && this.mediaAvailability !== Microsoft.Entertainment.Platform.MediaAvailability.available)
                                query.mediaAvailability = this.mediaAvailability;
                            if (this.keyword)
                                if (!Array.isArray(this.keyword))
                                    query.keyword = [this.keyword];
                                else
                                    query.keyword = this.keyword;
                            if (this.personId !== -1)
                                query.personId = this.personId;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.ArtistsResult, groupsAugmentation: MSE.Data.Augmenter.Library.ArtistsGroupHintsResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        libraryAlbumArtists: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryArtists, null, {artistOf: Microsoft.Entertainment.Queries.ArtistOf.album})
        }), libraryAlbums: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                        genreId: -1, albumId: -1, artistId: -1, playlistId: -1, sort: Microsoft.Entertainment.Queries.AlbumsSortBy.none, keyword: null, autoUpdateProperties: null, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                                var query = new Microsoft.Entertainment.Queries.AlbumsQuery;
                                var id = parseInt(this.genreId);
                                if (id !== -1)
                                    query.genreId = this.genreId;
                                id = parseInt(this.albumId);
                                if (id !== -1)
                                    query.albumId = this.albumId;
                                id = parseInt(this.artistId);
                                if (id !== -1)
                                    query.artistId = this.artistId;
                                id = parseInt(this.playlistId);
                                if (id !== -1)
                                    query.playlistId = this.playlistId;
                                query.primarySortBy = this.sort;
                                if (this.mediaAvailability && this.mediaAvailability !== Microsoft.Entertainment.Platform.MediaAvailability.available)
                                    query.mediaAvailability = this.mediaAvailability;
                                if (this.keyword)
                                    if (!Array.isArray(this.keyword))
                                        query.keyword = [this.keyword];
                                    else
                                        query.keyword = this.keyword;
                                switch (this.sort) {
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.releaseYearAscendingTitleAscending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.releaseYearDescendingTitleAscending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.dateAddedAscending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.dateAddedDescending:
                                        this.groupsAugmentation = MSE.Data.Augmenter.Library.AlbumsByYearOrMonthGroupHintsResult;
                                        break;
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.artistAscending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.artistDescending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.artistAscendingReleaseYearDescending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.artistDescendingReleaseYearDescending:
                                        this.groupsAugmentation = MSE.Data.Augmenter.Library.AlbumsByArtistGroupHintsResult;
                                        break;
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.genreNameTitleAscending:
                                    case Microsoft.Entertainment.Queries.AlbumsSortBy.genreNameTitleDescending:
                                        this.groupsAugmentation = MSE.Data.Augmenter.Library.AlbumsByGenreGroupHintsResult;
                                        break;
                                    default:
                                        this.groupsAugmentation = MSE.Data.Augmenter.Library.AlbumsGroupHintsResult;
                                        break
                                }
                                return query
                            }, resultAugmentation: MSE.Data.Augmenter.Library.AlbumsResult, groupsAugmentation: MSE.Data.Augmenter.Library.AlbumsGroupHintsResult, aggregateChunks: true
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryAlbumsLimited: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryAlbums, null, {resultAugmentation: MSE.Data.Augmenter.Library.AlbumsLimitedResult})
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryPlaylists: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    playlistType: Microsoft.Entertainment.Platform.PlaylistType.static, sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.none, keyword: null, playlistId: -1, autoUpdateProperties: null, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.PlaylistsQuery;
                            if (this.playlistType)
                                query.playlistType = this.playlistType;
                            var id = parseInt(this.playlistId);
                            if (id !== -1)
                                query.playlistId = this.playlistId;
                            var cloudSyncItemId = this.cloudSyncItemId;
                            if (MS.Entertainment.Utilities.isValidServiceId(cloudSyncItemId))
                                query.cloudSyncItemId = this.cloudSyncItemId;
                            if (this.sort && this.sort !== Microsoft.Entertainment.Queries.PlaylistsSortBy.none)
                                query.primarySortBy = this.sort;
                            if (this.mediaAvailability && this.mediaAvailability !== Microsoft.Entertainment.Platform.MediaAvailability.available)
                                query.mediaAvailability = this.mediaAvailability;
                            if (this.keyword)
                                query.keyword = this.keyword;
                            if (this.sort === Microsoft.Entertainment.Queries.PlaylistsSortBy.dateEditedAscending || this.sort === Microsoft.Entertainment.Queries.PlaylistsSortBy.dateEditedDescending || this.sort === Microsoft.Entertainment.Queries.PlaylistsSortBy.dateAddedAscending || this.sort === Microsoft.Entertainment.Queries.PlaylistsSortBy.dateAddedDescending)
                                this.groupsAugmentation = MSE.Data.Augmenter.Library.PlaylistsByYearOrMonthGroupHintsResult;
                            else
                                this.groupsAugmentation = MSE.Data.Augmenter.Library.PlaylistsGroupHintsResult;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.PlaylistsResult, groupsAugmentation: MSE.Data.Augmenter.Library.PlaylistsGroupHintsResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryPlaylistMediaItems: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    playlistId: -1, sort: Microsoft.Entertainment.Queries.PlaylistItemsSortBy.ordinalAscending, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.PlaylistMediaItemsQuery;
                            var id = parseInt(this.playlistId);
                            if (id !== -1)
                                query.playlistId = id;
                            if (this.mediaAvailability && this.mediaAvailability !== Microsoft.Entertainment.Platform.MediaAvailability.available)
                                query.mediaAvailability = this.mediaAvailability;
                            if (this.sort)
                                query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.TracksResult, aggregateChunks: true
                })
        })})
})()
