﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    var VER_CLIENTTYPE_STR = "PC/Windows";
    var BROWSE_CHUNK_SIZE = 50;
    var BROWSE_TOP_CHUNK_SIZE = 100;
    var SEARCH_CHUNK_SIZE = 20;
    var EXTRAS_CHUNK_SIZE = 30;
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {errorCodeWrapperQuery: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.ServiceWrapperQuery, function errorCodeWrapperQuery(errorCode) {
                    this.base();
                    if (errorCode < 0)
                        errorCode += 0xFFFFFFFF + 1;
                    var languageName = MS.Entertainment.Utilities.getResourceLanguage();
                    this.postData = {
                        contentType: MSE.Data.Query.errorCodeWrapperQuery.contentType, data: MSE.Data.Query.errorCodeWrapperQuery.postDataFormat.format(errorCode.toString(16), languageName)
                    };
                    this.requestType = MS.Entertainment.Data.ServiceWrapperQuery.RequestTypes.post
                }, {
                    createResourceURI: function() {
                        return MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_XboxSupport) + "/Services/ErrorCodeLookupService.asmx"
                    }, headers: {SOAPAction: "\"ErrorCodeLookup/LookupFullParam\""}, useCache: false, resultAugmentation: MS.Entertainment.Data.Augmenter.Common.ErrorCode
                }, {
                    postDataFormat: "<?xml version=\"1.0\" encoding=\"utf-8\"?><soap:Envelope xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"><soap:Body><LookupFullParam xmlns=\"ErrorCodeLookup\"><errorCode>{0}</errorCode><searchMode>ExactOnly</searchMode><locale>{1}</locale></LookupFullParam></soap:Body></soap:Envelope>", contentType: "text/xml; charset=utf-8"
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryVideos: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    category: -1, genreId: -1, seasonId: -1, seriesId: -1, folderId: null, sort: Microsoft.Entertainment.Queries.VideosSortBy.none, studio: null, keyword: null, objectIds: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.VideosQuery;
                            if (this.category !== -1)
                                query.category = this.category;
                            if (this.genreId !== -1)
                                query.genreId = this.genreId;
                            if (this.seasonId !== -1)
                                query.seasonId = this.seasonId;
                            if (this.seriesId !== -1)
                                query.seriesId = this.seriesId;
                            if (this.folderId !== null)
                                query.folderId = this.folderId;
                            if (this.studio !== null)
                                query.studio = this.studio;
                            if (this.keyword)
                                query.keyword = this.keyword;
                            if (this.objectIds)
                                query.objectIds = this.objectIds;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.VideosResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        libraryVideoMovies: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryVideos, null, {
                    category: Microsoft.Entertainment.Queries.VideoType.movie, resultAugmentation: MSE.Data.Augmenter.Library.MoviesResult
                })
        }), libraryVideoTV: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.libraryVideos, null, {
                        category: Microsoft.Entertainment.Queries.VideoType.tvEpisode, resultAugmentation: MSE.Data.Augmenter.Library.TVEpisodesResult
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    keyword: null, sort: Microsoft.Entertainment.Queries.TVSeriesSortBy.none, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.TVSeriesQuery;
                            if (this.keyword)
                                query.keyword = this.keyword;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.TVSeriesResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryVideoOther: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryVideos, null, {category: Microsoft.Entertainment.Queries.VideoType.other})
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {MovieHub: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.marketplaceWrapperQuery, null, {
                    createHeaders: function createHeaders() {
                        return MS.Entertainment.Data.Query.createEditorialHeaders()
                    }, getResourceEndpointID: function getResourceEndpointID() {
                            return MS.Entertainment.Endpoint.id.seid_MediaDiscovery
                        }, createResourceURI: function() {
                            var serviceConfig = (new Microsoft.Entertainment.Configuration.ConfigurationManager).service;
                            var uri = MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), serviceConfig.videoAppMovieHubSuffix);
                            return uri
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.channelPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotGroupPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotPluralizer], resultAugmentation: MSE.Data.Augmenter.Video.MovieHubContent, aggregateChunks: false, supportsContentNotifications: true, queryType: "MovieHub"
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {TvHub: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.marketplaceWrapperQuery, null, {
                    createHeaders: function createHeaders() {
                        return MS.Entertainment.Data.Query.createEditorialHeaders()
                    }, getResourceEndpointID: function getResourceEndpointID() {
                            return MS.Entertainment.Endpoint.id.seid_MediaDiscovery
                        }, createResourceURI: function() {
                            var serviceConfig = (new Microsoft.Entertainment.Configuration.ConfigurationManager).service;
                            var uri = MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), serviceConfig.videoAppTvHubSuffix);
                            return uri
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.channelPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotGroupPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotPluralizer], queryType: "TvHub", resultAugmentation: MSE.Data.Augmenter.Video.TvHubContent, aggregateChunks: false
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        marketplaceOrderBy: {
            downloadRank: "downloadRank", none: "", playRank: "playRank", releaseDate: "releaseDate", rentalRank: "rentalRank", salesRank: "salesRank", title: "title"
        }, marketplaceWrapperQuery: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.ServiceWrapperQuery, null, {
                        getResourceEndpointID: function getResourceEndpointID() {
                            return MS.Entertainment.Endpoint.id.seid_RootCatalog
                        }, createParameters: function createParameters() {
                                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                if (configurationManager.service.enableTimeTravel)
                                    return {instant: (new Microsoft.Entertainment.Configuration.ConfigurationManager).service.timeTravelStartDate};
                                else
                                    return null
                            }
                    }, {
                        entriesPluralizer: "entry", rightsPluralizer: "rights/right", closedCaptionPluralizer: "closedCaptionFiles/closedCaptionFile", clientTypesPluralizer: "clientTypes/clientType", genresPluralizer: "genres/genre", peerGenresPluralizer: "peerGenres/genre", subGenresPluralizer: "subGenres/genre", categoriesPluralizer: "categories/category", imagesPluralizer: "entry/instances/imageInstance", editorialItemsPluralizer: "editorialItems/editorialItem", channelPluralizer: "Content/Channel", slotGroupPluralizer: "Channel/SlotGroup", slotPluralizer: "SlotGroup/Slot", featuresPluralizer: "features/feature", albumsPluralizer: "albums/album", paymentTypesPluralizer: "paymentTypes/paymentType"
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {BrowseZestFlexHub: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.marketplaceWrapperQuery, null, {
                    target: "", genreId: "", orderBy: MSE.Data.Query.marketplaceOrderBy.none, chunkSize: 0, createResourceURI: function() {
                            var suffix;
                            if (this.target)
                                suffix = "hubs/" + window.encodeURI(this.target) + "/";
                            return MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), suffix)
                        }, createParameters: function createParameters() {
                            return {
                                    chunkSize: this.chunkSize, orderBy: this.orderBy, clientType: VER_CLIENTTYPE_STR
                                }
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.entriesPluralizer, MSE.Data.Query.marketplaceWrapperQuery.rightsPluralizer, MSE.Data.Query.marketplaceWrapperQuery.clientTypesPluralizer, MSE.Data.Query.marketplaceWrapperQuery.editorialItemsPluralizer], resultAugmentation: MSE.Data.Augmenter.Marketplace.EditorialResult, aggregateChunks: false
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {prefixQuery: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.marketplaceWrapperQuery, null, {
                    keyword: "", createResourceURI: function() {
                            return this.getResourceEndpoint()
                        }, createParameters: function createParameters() {
                            return {
                                    prefix: this.keyword, includeTracks: true, includeAlbums: true, includeArtists: true, includeMovies: true, includeTVSeries: true, isActionable: true, clientType: VER_CLIENTTYPE_STR
                                }
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.entriesPluralizer], resultAugmentation: MSE.Data.Augmenter.Marketplace.PrefixResult
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {HubsOverride: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.ServiceWrapperQuery, null, {
                    getResourceEndpointID: function getResourceEndpointID() {
                        return MS.Entertainment.Endpoint.id.seid_WinPhoneXboxDotCom
                    }, getSpotlightFeedVersionSubPath: function getSpotlightFeedVersionSubPath() {
                            return String.empty
                        }, createResourceURI: function() {
                            return this.getResourceEndpoint() + this.getSpotlightFeedVersionSubPath() + this.appString
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.slotGroupPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotPluralizer], resultAugmentation: MSE.Data.Augmenter.Spotlight.EditorialOverrideContent, supportsContentNotifications: true
                })
        })})
})()
