﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        SpotlightQueryType: {
            SpotlightMusic: "spotlight", SpotlightVideo: "spotlight"
        }, recommendationBrowseFields: [MS.Entertainment.Data.Query.edsFields.allTimeAverageRating, MS.Entertainment.Data.Query.edsFields.explanations, MS.Entertainment.Data.Query.edsFields.id, MS.Entertainment.Data.Query.edsFields.images, MS.Entertainment.Data.Query.edsFields.mediaGroup, MS.Entertainment.Data.Query.edsFields.mediaItemType, MS.Entertainment.Data.Query.edsFields.name, MS.Entertainment.Data.Query.edsFields.vuiDisplayName, MS.Entertainment.Data.Query.edsFields.zuneId], createEditorialHeaders: function createEditorialHeaders() {
                var architectureStringMap = {
                        0: "x86", 5: "arm", 9: "x64"
                    };
                var currentPackage = Windows.ApplicationModel.Package.current;
                var architecture = currentPackage.id.architecture;
                var mappedArchitecture = architectureStringMap[architecture];
                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                if (configurationManager.service.targetedProgrammingArchitecture)
                    mappedArchitecture = configurationManager.service.targetedProgrammingArchitecture;
                var spotlightHeaders = {
                        "User-Agent": configurationManager.service.targetedProgrammingClientOs, "X-Application": MS.Entertainment.Utilities.isVideoApp ? "Video" : "Music", "X-Membership-Level": configurationManager.service.lastSignedInUserMembership || "Free", "X-Parent-Control": configurationManager.service.lastSignedInUserParentControl.toString(), "X-Client-Version": configurationManager.service.targetedProgrammingClientVersion, "X-Client-Architecture": mappedArchitecture
                    };
                if (MS.Entertainment.Utilities.isMusicApp)
                    spotlightHeaders["X-Music-Subscription"] = configurationManager.service.lastSignedInUserSubscription.toString();
                return spotlightHeaders
            }
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {spotlightContentQuery: MSE.derive(MSE.Data.ServiceWrapperQuery, null, {
            spotlight: String.empty, getResourceEndpointID: function getResourceEndpointID() {
                    return MS.Entertainment.Endpoint.id.seid_CdfXboxLiveDotCom
                }, createHeaders: function createHeaders() {
                    return MS.Entertainment.Data.Query.createEditorialHeaders()
                }, createParameters: function createParameters() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    if (configurationManager.service.enableTimeTravel)
                        return {StartDate: configurationManager.service.timeTravelStartDate};
                    else
                        return null
                }, getSpotlightFeedVersionSubPath: function getSpotlightFeedVersionSubPath() {
                    return String.empty
                }, createResourceURI: function() {
                    return this.getResourceEndpoint() + this.getSpotlightFeedVersionSubPath() + this.spotlight
                }, pluralizers: ["Content/SlotGroup", "SlotGroup/Slot"], resultAugmentation: MSE.Data.Augmenter.Spotlight.SpotlightContent
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {musicSpotlightQuery: MSE.derive(MSE.Data.Query.spotlightContentQuery, null, {
            spotlight: MSE.Data.Query.SpotlightQueryType.SpotlightMusic, getSpotlightFeedVersionSubPath: function getSpotlightFeedVersionSubPath() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    var subPath = String.empty;
                    if (MS.Entertainment.Utilities.isMusicApp1)
                        subPath = configurationManager.service.musicApp1SpotlightVersion;
                    else
                        subPath = configurationManager.service.musicApp2SpotlightVersion;
                    return subPath
                }
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {videoSpotlightQuery: MSE.derive(MSE.Data.Query.spotlightContentQuery, null, {
            spotlight: MSE.Data.Query.SpotlightQueryType.SpotlightVideo, getResourceEndpointID: function getResourceEndpointID() {
                    return MS.Entertainment.Endpoint.id.seid_MediaDiscovery
                }, createResourceURI: function createResourceURI() {
                    var serviceConfig = (new Microsoft.Entertainment.Configuration.ConfigurationManager).service;
                    var uri = MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), serviceConfig.videoAppSpotlightSuffix);
                    return uri
                }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.slotGroupPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotPluralizer], resultAugmentation: MSE.Data.Augmenter.Spotlight.VideoSpotlightContent
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {EdsVideoRecommendations: MSE.derive(MSE.Data.Query.EDSDeviceQuery, null, {
            chunkSize: 20, requestFields: MS.Entertainment.Data.Query.recommendationBrowseFields, createResourceURI: function() {
                    return this.getResourceEndpoint(MS.Entertainment.Data.Query.edsEndpointType.recommendations)
                }, createParameters: function createParameters() {
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var tvMarketplaceEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace);
                    var typeArray = null;
                    if (tvMarketplaceEnabled)
                        typeArray = MS.Entertainment.Data.Query.edsArray([MS.Entertainment.Data.Query.edsMediaType.movie, MS.Entertainment.Data.Query.edsMediaType.tvSeries]);
                    else
                        typeArray = MS.Entertainment.Data.Query.edsArray([MS.Entertainment.Data.Query.edsMediaType.movie]);
                    return {
                            desiredMediaItemTypes: typeArray, firstPartyOnly: true
                        }
                }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsRecommendedVideoList, useCache: true
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        MusicUpdatePanel: MSE.deferredDerive(MS.Entertainment.Data.ServiceWrapperQuery, null, {
            chunked: false, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.IntroPanelResult, createResourceURI: function() {
                    return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_WinPhoneXboxDotCom, "x8/feeds/1.1/Upgrade-Music")
                }, pluralizers: ["BodyText/p"]
        }), VideoUpdatePanel: MS.Entertainment.deferredDerive(MS.Entertainment.Data.ServiceWrapperQuery, null, {
                chunked: false, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.IntroPanelResult, createResourceURI: function() {
                        return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_WinPhoneXboxDotCom, "x8/feeds/1.1/Upgrade-Video")
                    }, pluralizers: ["BodyText/p"]
            })
    })
})()
