﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/utilities.js");
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Formatters");
WinJS.Namespace.define("MS.Entertainment.Formatters", {DateTimeFormatters: MS.Entertainment.UI.Framework.define(function dateTimeFormatters(){}, {
        _year: null, _monthYear: null, _abbreviatedMonthYear: null, _abbreviatedMonth: null, _dayMonthYear: null, _shortDate: null, _decimalNumber: null, _groupedDecimalNumber: null, _percentNumber: null, year: {get: function() {
                    if (!this._year)
                        try {
                            this._year = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("year")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"year\") object.  Error: " + error);
                            this._year = this._defaultFormatter
                        }
                    return this._year
                }}, abbreviatedMonthYear: {get: function() {
                    if (!this._abbreviatedMonthYear)
                        try {
                            this._abbreviatedMonthYear = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("month.abbreviated year")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"month.abbreviated year\") object.  Error: " + error);
                            this._abbreviatedMonthYear = this._defaultFormatter
                        }
                    return this._abbreviatedMonthYear
                }}, abbreviatedMonth: {get: function() {
                    if (!this._abbreviatedMonth)
                        try {
                            this._abbreviatedMonth = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("month.abbreviated")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"month.abbreviated\") object.  Error: " + error);
                            this._abbreviatedMonth = this._defaultFormatter
                        }
                    return this._abbreviatedMonth
                }}, monthYear: {get: function() {
                    if (!this._monthYear)
                        try {
                            this._monthYear = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("month year")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"month year\") object.  Error: " + error);
                            this._abbreviatedMonth = this._defaultFormatter
                        }
                    return this._monthYear
                }}, shortDate: {get: function() {
                    if (!this._shortDate)
                        try {
                            this._shortDate = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("shortdate")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"shortdate\") object.  Error: " + error);
                            this._shortDate = this._defaultFormatter
                        }
                    return this._shortDate
                }}, dayMonthYear: {get: function() {
                    if (!this._dayMonthYear)
                        try {
                            this._dayMonthYear = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter("day month year")
                        }
                        catch(e) {
                            var error = e && e.message;
                            MS.Entertainment.Formatters.fail("Could not instantiate new DateTimeFormatter(\"day month year\") object.  Error: " + error);
                            this._dayMonthYear = this._defaultFormatter
                        }
                    return this._dayMonthYear
                }}, decimalNumber: {get: function() {
                    if (!this._decimalNumber) {
                        this._decimalNumber = new Windows.Globalization.NumberFormatting.DecimalFormatter;
                        this._decimalNumber.fractionDigits = 0;
                        this._decimalNumber.isGrouped = false;
                        this._decimalNumber.integerDigits = MS.Entertainment.Formatters.DateTimeFormatters.defaultDecimalDigits
                    }
                    return this._decimalNumber
                }}, groupedDecimalNumber: {get: function() {
                    if (!this._groupedDecimalNumber) {
                        this._groupedDecimalNumber = new Windows.Globalization.NumberFormatting.DecimalFormatter;
                        this._groupedDecimalNumber.fractionDigits = 0;
                        this._groupedDecimalNumber.isGrouped = true;
                        this._groupedDecimalNumber.integerDigits = MS.Entertainment.Formatters.DateTimeFormatters.defaultDecimalDigits
                    }
                    return this._groupedDecimalNumber
                }}, percentNumber: {get: function() {
                    if (!this._percentNumber) {
                        this._percentNumber = new Windows.Globalization.NumberFormatting.PercentFormatter;
                        this._percentNumber.fractionDigits = 0;
                        this._percentNumber.integerDigits = 0;
                        this._percentNumber.isDecimalPointAlwaysDisplayed = false;
                        this._percentNumber.isGrouped = true
                    }
                    return this._percentNumber
                }}, _defaultFormatter: {get: function() {
                    return {format: function format() {
                                return String.empty
                            }}
                }}
    }, {
        create: function create() {
            return new MS.Entertainment.Formatters.DateTimeFormatters
        }, defaultDecimalDigits: 1
    })});
MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.dateTimeFormatters, MS.Entertainment.Formatters.DateTimeFormatters.create);
WinJS.Namespace.define("MS.Entertainment.Formatters", {
    MediaSortFormatter: MS.Entertainment.defineOptionalObservable(function mediaSortFormatter() {
        this.bind("totalCount", this._updateResult.bind(this))
    }, {
        _emptyStringId: null, _singularStringId: null, _pluralStringId: null, _unknownStringId: null, _countOnly: null, _filter: null, initialize: function initialize(emptyStringId, singularStringId, pluralStringId, unknownStringId, countOnly, filter) {
                this._emptyStringId = emptyStringId;
                this._singularStringId = singularStringId;
                this._pluralStringId = pluralStringId;
                this._unknownStringId = unknownStringId;
                this._countOnly = countOnly;
                this._filter = filter;
                this._updateResult()
            }, _updateResult: function _updateResult() {
                var countFormatter;
                var mediaStringIdWithCount;
                var mediaStringIdWithoutCount;
                if (this.totalCount === 0)
                    mediaStringIdWithCount = this._emptyStringId;
                else if (this.totalCount === 1)
                    mediaStringIdWithCount = this._singularStringId;
                else if (this.totalCount > 0)
                    mediaStringIdWithCount = this._pluralStringId;
                else
                    mediaStringIdWithoutCount = this._unknownStringId;
                if (mediaStringIdWithCount) {
                    countFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                    countFormatter.isGrouped = true;
                    this.result = String.load(this._filter ? String.id.IDS_N_FILTER_IN : String.id.IDS_N_SORTED_BY).format(countFormatter.format(this.totalCount), String.load(mediaStringIdWithCount));
                    countFormatter.isGrouped = false
                }
                else if (mediaStringIdWithoutCount)
                    this.result = String.load(this._filter ? String.id.IDS_FILTER_IN : String.id.IDS_SORTED_BY).format(String.load(mediaStringIdWithoutCount));
                else if (this._countOnly) {
                    countFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                    this.result = countFormatter.format(this.totalCount)
                }
                else
                    this.result = null
            }
    }, {
        totalCount: 0, result: null
    }), formatDestinationHelper: WinJS.Utilities.markSupportedForProcessing(function formatHelper(destination, destinationProperty, value) {
            if (destinationProperty.length > 1) {
                var prop = destination[destinationProperty[0]];
                for (var x = 1; x < destinationProperty.length - 1; x++)
                    prop = prop[destinationProperty[x]];
                prop[destinationProperty[x]] = value
            }
            else
                destination[destinationProperty] = value
        }), formatSourceHelper: WinJS.Utilities.markSupportedForProcessing(function formatSourceHelper(source, sourceProperty) {
            var sourceData;
            if (Array.isArray(sourceProperty)) {
                sourceData = source[sourceProperty[0]];
                for (var i = 1; i < sourceProperty.length; i++)
                    sourceData = sourceData[sourceProperty[i]]
            }
            else
                sourceData = source[sourceProperty];
            return sourceData
        }), formatStringOrStringId: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function(value) {
            var sourceDataType = typeof value;
            var result = String.empty;
            if (sourceDataType === "string")
                result = (String.id[value]) ? String.load(value) : value;
            else if (value)
                MS.Entertainment.Formatters.fail("Unrecognized string type in formatter: " + sourceDataType);
            return result
        })), formatStringId: WinJS.Utilities.markSupportedForProcessing(function formatStringOrStringId(source, sourceProperty, destination, destinationProperty) {
            MS.Entertainment.Formatters.assert(sourceProperty[0] === "String", "Formatters_formatStringId must be passed a valid string id");
            var len = sourceProperty.length;
            var data = String;
            for (var i = 1; i < len && data; i++)
                data = data[sourceProperty[i]];
            MS.Entertainment.Formatters.assert(String.id[data], "Formatters_formatStringId must be passed a valid string id");
            var result = (String.id[data] && String.load(data)) || String.empty;
            MS.Entertainment.Formatters.formatDestinationHelper(destination, destinationProperty, result)
        }), formatStringIdNoAssert: WinJS.Utilities.markSupportedForProcessing(function formatStringIdNoAssert(source, sourceProperty, destination, destinationProperty) {
            MS.Entertainment.Formatters.assert(sourceProperty[0] === "String", "Formatters_formatStringId must be passed a valid string id");
            var len = sourceProperty.length;
            var data = String;
            for (var i = 1; i < len && data; i++)
                data = data[sourceProperty[i]];
            var result = (String.id[data] && String.load(data)) || String.empty;
            MS.Entertainment.Formatters.formatDestinationHelper(destination, destinationProperty, result)
        }), formatYearFromDateNonConverter: function formatYearFromDateNonConverter(sourceData) {
            var date = null;
            var year = null;
            if (sourceData) {
                date = new Date(sourceData);
                if (date) {
                    var formattedYear = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).year;
                    year = formattedYear.format(date)
                }
            }
            return year || String.empty
        }, formatYearFromDate: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatReleaseYear(sourceData) {
            return MS.Entertainment.Formatters.formatYearFromDateNonConverter(sourceData)
        })), formatDatabaseDataFromReleaseDate: function formatDatabaseDataFromReleaseDate(sourceData) {
            var date = null;
            if (sourceData && sourceData.toISOString)
                date = sourceData.toISOString().replace("T", " ").substring(0, 19);
            else
                MS.Entertainment.Formatters.fail("Expected date to be provided as source data.  Cannot format releaseDate");
            return date || String.empty
        }, formatShortDate: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatYearMonthDate(sourceValue) {
            if (sourceValue) {
                var dateFormat = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).shortDate;
                sourceValue = dateFormat.format(sourceValue)
            }
            return sourceValue || String.empty
        })), formatDurationFromDate: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatDurationFromDate(sourceData) {
            return MS.Entertainment.Formatters.formatDurationFromDateNonConverter(sourceData)
        })), formatDurationFromDateNonConverter: function formatDurationFromDateNonConverter(sourceData) {
            var date = sourceData;
            if (typeof sourceData !== "number")
                date = new Date(sourceData);
            var duration = MS.Entertainment.Utilities.formatTimeString(date);
            return duration
        }, formatDurationGreaterThanZeroFromDate: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatDurationGreaterThanZeroFromDate(sourceData) {
            return MS.Entertainment.Formatters.formatDurationGreaterThanZeroFromDateNonConverter(sourceData)
        })), formatDurationGreaterThanZeroFromDateNonConverter: function formatDurationGreaterThanZeroFromDateNonConverter(sourceData) {
            var date = null;
            var forceEmptyString = false;
            if (typeof sourceData === "number")
                if (sourceData > 0)
                    date = MS.Entertainment.Utilities._millisecondsToDate(sourceData);
                else
                    forceEmptyString = true;
            else
                date = new Date(sourceData);
            var duration = sourceData && !forceEmptyString ? MS.Entertainment.Utilities.formatTimeString(date) : String.empty;
            return duration
        }, milliSecondsFromTimeSpan: function milliSecondsFromTimeSpan(days, hours, minutes, seconds, milliseconds) {
            return ((((days ? days : 0) * 24 + (hours ? hours : 0)) * 60 + (minutes ? minutes : 0)) * 60 + (seconds ? seconds : 0)) * 1000 + (milliseconds ? milliseconds : 0)
        }, formatCount: function formatCount(count, countTextFunction) {
            if (count === undefined || count === -1)
                return String.empty;
            return countTextFunction(count)
        }, countText: function countText(count, zeroLabel, singleLabel, pluralLabel) {
            var numberFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
            return MS.Entertainment.Formatters.countTextWithCustomFormatter(numberFormatter, count, zeroLabel, singleLabel, pluralLabel)
        }, countTextWithoutOrderFormat: function countTextWithoutOrderFormat(count, zeroLabel, singleLabel, pluralLabel) {
            var formatString = String.load(String.id.IDS_MUSIC_RELATED_PANEL_FORMAT);
            var formattedCount = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(count);
            var countLabel;
            if (count === 0)
                countLabel = String.load(zeroLabel);
            else if (count === 1)
                countLabel = String.load(singleLabel);
            else
                countLabel = String.load(pluralLabel);
            return formatString.format(formattedCount, countLabel)
        }, countTextWithCustomFormatter: function countTextWithCustomFormatter(numberFormatter, count, zeroLabel, singleLabel, pluralLabel) {
            var formattedCount = numberFormatter.format(count);
            if (count === 0)
                return String.load(zeroLabel).format(formattedCount);
            else if (count === 1)
                return String.load(singleLabel).format(formattedCount);
            else
                return String.load(pluralLabel).format(formattedCount)
        }, formatGenresList: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatGenresList(genres) {
            return MS.Entertainment.Formatters.formatGenresListNonConverter(genres)
        })), formatGenresListNonConverter: function formatGenresListNonConverter(genres) {
            if (!genres)
                return String.empty;
            var genreNames = [];
            if (Array.isArray(genres)) {
                genres.forEach(function forEachGenresList(genre) {
                    if (genre)
                        genreNames.push(genre.name)
                });
                return genreNames.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
            }
            else if (typeof genres !== "string" && genres.forEach) {
                MS.Entertainment.Formatters.fail("Supplied with virtual list. Don't know how to handle this. Don't think it's used any more");
                return String.empty
            }
            else if (typeof genres === "string")
                return genres
        }, formatStringOrUnknown: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatStringOrUnknown(result) {
            if (!result || result === "null")
                result = String.load(String.id.IDS_UNKNOWN_VALUE);
            return result
        })), formatStringOrEmpty: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatStringOrEmpty(result) {
            if (!result || result === "null")
                result = String.empty;
            return result
        })), formatStringOrEmptyOneTime: WinJS.Utilities.markSupportedForProcessing(function formatStringOrEmptyOneTime(source, sourceProperties, dest, destProperties) {
            var result = MS.Entertainment.Utilities.valueFromPropertyPathFragments(source, sourceProperties);
            if (!result || result === "null")
                result = String.empty;
            MS.Entertainment.Utilities.setFromPropertyPathFragments(dest, destProperties, result)
        }), formatDecimalNumber: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatDecimalNumber(num) {
            if (num === undefined || num === null || typeof(num) !== "number")
                return String.empty;
            var formattedNum;
            formattedNum = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(num);
            return formattedNum
        })), formatDecimalNumberIncrement: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatDecimalNumberIncrement(num) {
            if (num === undefined || num === null || typeof(num) !== "number")
                return String.empty;
            var formattedNum;
            formattedNum = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(num + 1);
            return formattedNum
        })), formatDecimalNumberIncrementOneTime: WinJS.Utilities.markSupportedForProcessing(function formatDecimalNumberIncrementOneTime(source, sourceProperties, dest, destProperties) {
            var formattedNum = String.empty;
            var number = MS.Entertainment.Utilities.valueFromPropertyPathFragments(source, sourceProperties);
            if (typeof number === "number" && !isNaN(number))
                formattedNum = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(number + 1);
            MS.Entertainment.Utilities.setFromPropertyPathFragments(dest, destProperties, formattedNum)
        }), formatIcon: WinJS.Utilities.markSupportedForProcessing(function formatIcon(source, sourceProperty, destination, destinationProperty) {
            var icon = MS.Entertainment.Utilities.valueFromPropertyPathFragments(WinJS.Utilities.getMember(sourceProperty[0]), sourceProperty.slice(1));
            MS.Entertainment.Formatters.formatDestinationHelper(destination, destinationProperty, icon)
        }), setPropertyFromStatic: WinJS.Utilities.markSupportedForProcessing(function setPropertyFromStatic(source, sourceProperty, destination, destinationProperty) {
            var valueFromProperty = MS.Entertainment.Utilities.valueFromPropertyPathFragments(WinJS.Utilities.getMember(sourceProperty[0]), sourceProperty.slice(1));
            MS.Entertainment.Formatters.formatDestinationHelper(destination, destinationProperty, valueFromProperty)
        }), formatGenre: function formatGenre(sourceValue) {
            var result = String.empty;
            if (sourceValue.genre)
                if (Array.isArray(sourceValue.genre)) {
                    var genreNames = [];
                    sourceValue.genre.forEach(function(genre) {
                        if (genre)
                            genreNames.push(genre.name)
                    });
                    result = genreNames.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
                }
                else if (sourceValue.genre.name)
                    result = sourceValue.genre.name;
                else
                    result = sourceValue.genre;
            else if (sourceValue.genreName)
                result = sourceValue.genreName;
            return result
        }, formatAlbumAndArtist: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function(sourceValue) {
            return MS.Entertainment.Formatters.formatAlbumAndArtistHelper(sourceValue)
        })), formatAlbumAndArtistHelper: function formatAlbumAndArtistHelper(sourceValue, showArtistIfDifferent) {
            var value = String.empty;
            if (sourceValue) {
                var artistName = (!showArtistIfDifferent || sourceValue.hasNonAlbumArtistName) ? sourceValue.artistName : String.empty;
                if (artistName && sourceValue.albumName)
                    value = String.load(String.id.IDS_MUSIC_ALBUM_BY_ARTIST).format(sourceValue.albumName, artistName);
                else if (artistName)
                    value = String.load(String.id.IDS_MUSIC_BY_ARTIST).format(artistName);
                else if (sourceValue.albumName)
                    value = sourceValue.albumName
            }
            return value
        }, formatArtist: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatArtist(count) {
            return MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.artistCountText)
        })), formatTracks: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatTracks(count) {
            return MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.trackCountText)
        })), formatTracksOneTime: WinJS.Utilities.markSupportedForProcessing(function formatTracksOneTime(source, sourceProperties, dest, destProperties) {
            var count = MS.Entertainment.Utilities.valueFromPropertyPathFragments(source, sourceProperties);
            count = MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.trackCountText);
            MS.Entertainment.Utilities.setFromPropertyPathFragments(dest, destProperties, count)
        }), formatAlbumCount: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatAlbumCount(count) {
            return MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.albumCountText)
        })), formatAlbumCountOneTime: WinJS.Utilities.markSupportedForProcessing(function formatAlbumCountOneTime(source, sourceProperties, dest, destProperties) {
            var count = MS.Entertainment.Utilities.valueFromPropertyPathFragments(source, sourceProperties);
            count = MS.Entertainment.Formatters.formatCount(count, MS.Entertainment.Formatters.albumCountText);
            MS.Entertainment.Utilities.setFromPropertyPathFragments(dest, destProperties, count)
        }), formatTrackAndAlbumCount: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatTrackAndAlbumCount(artist) {
            if (artist) {
                var details = [];
                var formatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                var albumCountFormatted;
                var tracksCountFormatted;
                if (artist.totalAlbumsCount === 1)
                    details.push(String.load(String.id.IDS_DETAILS_COLLECTION_ALBUM_COUNT));
                else if (artist.totalAlbumsCount > 1) {
                    albumCountFormatted = formatter.format(artist.totalAlbumsCount);
                    details.push(String.load(String.id.IDS_DETAILS_COLLECTION_ALBUMS_COUNT).format(albumCountFormatted))
                }
                if (artist.totalTracksCount === 1)
                    details.push(String.load(String.id.IDS_DETAILS_COLLECTION_SONG_COUNT));
                else if (artist.totalTracksCount > 1) {
                    tracksCountFormatted = formatter.format(artist.totalTracksCount);
                    details.push(String.load(String.id.IDS_DETAILS_COLLECTION_SONGS_COUNT).format(tracksCountFormatted))
                }
                return details.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
            }
            else
                return String.empty
        })), formatPlaylistDetailsTrackCount: function formatPlaylistDetailsTrackCount(playlist) {
            var playlistDetailsTrackCount = String.empty;
            if (playlist)
                if (playlist.count === 1)
                    playlistDetailsTrackCount = String.load(String.id.IDS_DETAILS_PLAYLIST_SONG_COUNT);
                else if (playlist.count > 1) {
                    var formattedCount = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(playlist.count);
                    playlistDetailsTrackCount = String.load(String.id.IDS_DETAILS_PLAYLIST_SONGS_COUNT).format(formattedCount)
                }
                else
                    playlistDetailsTrackCount = String.load(String.id.IDS_PLAYLIST_PAGE_EMPTY_TEXT);
            return playlistDetailsTrackCount
        }, trackCountText: function trackCountText(count) {
            return MS.Entertainment.Formatters.countText(count, String.id.IDS_MUSIC_NOTRACKS_LABEL, String.id.IDS_MUSIC_TRACK_LABEL, String.id.IDS_MUSIC_TRACKS_LABEL)
        }, artistCountText: function artistCountText(count) {
            return MS.Entertainment.Formatters.countTextWithoutOrderFormat(count, String.id.IDS_MUSIC_TYPE_ARTIST_0, String.id.IDS_MUSIC_TYPE_ARTIST_1, String.id.IDS_MUSIC_TYPE_ARTIST_N)
        }, albumCountText: function albumCountText(count) {
            return MS.Entertainment.Formatters.countTextWithoutOrderFormat(count, String.id.IDS_MUSIC_TYPE_ALBUM_0, String.id.IDS_MUSIC_TYPE_ALBUM_1, String.id.IDS_MUSIC_TYPE_ALBUM_N)
        }, playlistCountText: function playlistCountText(count) {
            return MS.Entertainment.Formatters.countTextWithoutOrderFormat(count, String.id.IDS_MUSIC_TYPE_PLAYLIST_0, String.id.IDS_MUSIC_TYPE_PLAYLIST_1, String.id.IDS_MUSIC_TYPE_PLAYLIST_N)
        }, playlistsAddedCountText: function playlistsAddedCountText(count) {
            return MS.Entertainment.Formatters.countText(count, String.id.IDS_PLAYLIST_0_PLAYLISTS_ADDED, String.id.IDS_PLAYLIST_1_PLAYLISTS_ADDED, String.id.IDS_PLAYLIST_N_PLAYLISTS_ADDED)
        }, formatTrackNumber: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatTrackNumber(num) {
            var formattedNum = String.empty;
            if (num)
                formattedNum = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(num);
            return formattedNum
        })), formatTrackNumberOneTime: WinJS.Utilities.markSupportedForProcessing(function formatTrackNumberOneTime(source, sourceProperties, dest, destProperties) {
            var formattedNum = String.empty;
            var trackNumber = MS.Entertainment.Utilities.valueFromPropertyPathFragments(source, sourceProperties);
            if (trackNumber)
                formattedNum = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber.format(trackNumber);
            MS.Entertainment.Utilities.setFromPropertyPathFragments(dest, destProperties, formattedNum)
        }), formatTrackDuration: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatTrackDuration(duration) {
            if (duration)
                duration = MS.Entertainment.Utilities.millisecondsToTimeCode(duration);
            else
                duration = String.empty;
            return duration
        })), formatIsDownloaded: WinJS.Binding.converter(WinJS.Utilities.markSupportedForProcessing(function formatCanPlayLocally(source) {
            var result = String.empty;
            if (!source && MS.Entertainment.Utilities.isApp1)
                result = MS.Entertainment.UI.Icon.inlineStreaming;
            return result
        }))
})
