﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/debug.js", "/Framework/utilities.js");
(function() {
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI");
    WinJS.Namespace.define("MS.Entertainment.UI", {PurchaseHistoryService: MS.Entertainment.defineObservable(function PurchaseHistoryServiceConstructor() {
            this._grovelTimer = null;
            this._grovelTimerStartDate = null;
            this._sessionPurchaseFlowActivityCount = 0
        }, {
            inPurchaseFlow: false, isGroveling: false, _grovelTimer: null, _grovelTimerStartDate: null, _sessionPurchaseFlowActivityCount: null, grovel: function grovel(resetLastUpdateDateTime, restoringPurchases, ignoreIfWithinMinimumIncrement) {
                    if (this.isGroveling || !MS.Entertainment.UI.PurchaseHistoryService.isFeatureEnabled)
                        return;
                    if (ignoreIfWithinMinimumIncrement && this._grovelTimerStartDate) {
                        var configuration = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                        var minimumIncrement = configuration.service.purchaseHistoryMinimumIncrementInSeconds * 1000;
                        if ((this._grovelTimerStartDate.valueOf() + minimumIncrement) > (new Date).valueOf())
                            return
                    }
                    this._stopGrovelTimer();
                    if (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).isSignedIn && (MS.Entertainment.Utilities.isMusicApp || MS.Entertainment.Utilities.isVideoApp)) {
                        this.isGroveling = true;
                        var resetIsGroveling = function resetIsGroveling() {
                                this.isGroveling = false
                            }.bind(this);
                        var promise = WinJS.Promise.wrap();
                        promise.then(function grovel() {
                            if (resetLastUpdateDateTime)
                                MS.Entertainment.UI.PurchaseHistoryService._resetLastUpdateDateTime();
                            var config = MS.Entertainment.UI.PurchaseHistoryService._getConfig();
                            var signInProvider = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                            return signInProvider.getPassportTicket(MS.Entertainment.Utilities.SignIn.TicketType.MBI_SSL, MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_Passport)).then(function getPassportTicketComplete(ticket) {
                                    var startDate = "";
                                    var lastUpdateDateTime = config.lastUpdateDateTime;
                                    if (config.lastUpdateDateTimeIsIncremented) {
                                        startDate = lastUpdateDateTime;
                                        lastUpdateDateTime = ""
                                    }
                                    else if (lastUpdateDateTime)
                                        startDate = MS.Entertainment.UI.PurchaseHistoryService._incrementMarketplaceDate(lastUpdateDateTime);
                                    else
                                        lastUpdateDateTime = "";
                                    var aggressiveGrovel = config.incompletePurchaseFlows !== 0 || (restoringPurchases && MS.Entertainment.Utilities.isVideoApp);
                                    return Microsoft.Entertainment.Marketplace.Marketplace.grovelPastPurchasedMedia(ticket, MS.Entertainment.Utilities.isVideoApp ? Microsoft.Entertainment.Queries.ObjectType.video : Microsoft.Entertainment.Queries.ObjectType.track, startDate, lastUpdateDateTime, !!restoringPurchases, !!aggressiveGrovel).then(function grovelPastPurchasedMediaComplete(result) {
                                            if (!result.hasFailures)
                                                MS.Entertainment.UI.PurchaseHistoryService._setConfig(result.lastUpdateDateTime, false, 0);
                                            this._startGrovelTimer(result.hasFailures);
                                            return WinJS.Promise.wrap()
                                        }.bind(this))
                                }.bind(this));
                            return WinJS.Promise.wrap()
                        }.bind(this)).done(resetIsGroveling, function onGrovelingError(error) {
                            if (error && error.number && typeof error.number === "number")
                                error = error.number;
                            if (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).isSignedIn)
                                this._startGrovelTimer(true);
                            resetIsGroveling()
                        }.bind(this))
                    }
                }, _startGrovelTimer: function _startGrovelTimer(previousAttemptFailed) {
                    var configuration = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    var secondsBeforeNextGrovel = previousAttemptFailed ? configuration.service.purchaseHistoryReattemptAfterFailureInSeconds : configuration.service.purchaseHistoryFrequencyInSeconds;
                    this._stopGrovelTimer();
                    this._grovelTimerStartDate = new Date;
                    this._grovelTimer = WinJS.Promise.timeout(secondsBeforeNextGrovel * 1000).then(this.grovel.bind(this))
                }, _stopGrovelTimer: function _stopGrovelTimer() {
                    if (this._grovelTimer) {
                        var timer = WinJS.Binding.unwrap(this._grovelTimer);
                        if (timer)
                            timer.cancel();
                        this._grovelTimer = null
                    }
                }
        }, {
            isFeatureEnabled: {get: function isFeatureEnabled() {
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    if (MS.Entertainment.Utilities.isMusicApp)
                        return featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace);
                    if (MS.Entertainment.Utilities.isVideoApp)
                        return featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace) || featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace);
                    return false
                }}, enterPurchaseFlowActivity: function enterPurchaseFlowActivity() {
                    if (!MS.Entertainment.UI.PurchaseHistoryService.isFeatureEnabled)
                        return;
                    var service = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                    service._stopGrovelTimer();
                    if (++service._sessionPurchaseFlowActivityCount === 1) {
                        service.inPurchaseFlow = true;
                        var config = MS.Entertainment.UI.PurchaseHistoryService._getConfig();
                        MS.Entertainment.UI.PurchaseHistoryService._setConfig(config.lastUpdateDateTime, config.lastUpdateDateTimeIsIncremented, config.incompletePurchaseFlows + 1)
                    }
                }, leavePurchaseFlowActivity: function leavePurchaseFlowActivity(failureOccurred) {
                    if (!MS.Entertainment.UI.PurchaseHistoryService.isFeatureEnabled)
                        return;
                    var service = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                    service._stopGrovelTimer();
                    var purchaseFlowSessionClosed = (service._sessionPurchaseFlowActivityCount !== 0 && --service._sessionPurchaseFlowActivityCount === 0);
                    if (failureOccurred) {
                        var config = MS.Entertainment.UI.PurchaseHistoryService._getConfig();
                        MS.Entertainment.UI.PurchaseHistoryService._setConfig(config.lastUpdateDateTime, config.lastUpdateDateTimeIsIncremented, config.incompletePurchaseFlows + 1)
                    }
                    if (purchaseFlowSessionClosed) {
                        service.inPurchaseFlow = false;
                        var config = MS.Entertainment.UI.PurchaseHistoryService._getConfig();
                        if (config.incompletePurchaseFlows !== 0)
                            MS.Entertainment.UI.PurchaseHistoryService._setConfig(config.lastUpdateDateTime, config.lastUpdateDateTimeIsIncremented, config.incompletePurchaseFlows - 1);
                        service.grovel()
                    }
                }, initialize: function initialize() {
                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).bind("isSignedIn", MS.Entertainment.UI.PurchaseHistoryService._onSignInChange);
                    MS.Entertainment.Utilities.SignIn.addEventListener("signInRefreshed", function _onSignInRefreshed() {
                        MS.Entertainment.UI.PurchaseHistoryService._onSignInChange(true)
                    })
                }, _onSignInChange: function _onSignInChange(isSignedIn) {
                    if (!MS.Entertainment.UI.PurchaseHistoryService.isFeatureEnabled)
                        return;
                    var service = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                    if (isSignedIn)
                        service.grovel();
                    else
                        service._stopGrovelTimer()
                }, _resetLastUpdateDateTime: function _resetLastUpdateDateTime() {
                    var config = this._getConfig();
                    MS.Entertainment.UI.PurchaseHistoryService._setConfig(null, false, config.incompletePurchaseFlows);
                    return config
                }, _getConfig: function _getConfig() {
                    var configuration = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    var configString = configuration.service.pastPurchaseData;
                    var config = configString ? JSON.parse(configString) : {};
                    if (!config.lastUpdateDateTime) {
                        config.lastUpdateDateTime = null;
                        config.lastUpdateDateTimeIsIncremented = false;
                        config.incompletePurchaseFlows = 1
                    }
                    if (!(typeof config.lastUpdateDateTimeIsIncremented === "boolean"))
                        config.lastUpdateDateTimeIsIncremented = true;
                    if (!config.incompletePurchaseFlows && !(typeof config.incompletePurchaseFlows === "number"))
                        config.incompletePurchaseFlows = 1;
                    return config
                }, _setConfig: function _setConfig(lastUpdateDateTime, lastUpdateDateTimeIsIncremented, incompletePurchaseFlows) {
                    var config = {
                            lastUpdateDateTime: lastUpdateDateTime, lastUpdateDateTimeIsIncremented: lastUpdateDateTimeIsIncremented, incompletePurchaseFlows: incompletePurchaseFlows
                        };
                    var configuration = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    configuration.service.pastPurchaseData = JSON.stringify(config)
                }, _incrementMarketplaceDate: function _incrementMarketplaceDate(dateString) {
                    var maxFractionDigits = 7;
                    var re = /^(.+?)(\.(\d+)?)?Z$/;
                    var fraction = null;
                    var matches = dateString.match(re);
                    if (!matches)
                        return null;
                    var dateStringNoZ = matches[1];
                    var fraction = matches[3];
                    if (!fraction)
                        fraction = "";
                    else
                        fraction = fraction.substr(0, maxFractionDigits);
                    if (fraction.length === maxFractionDigits) {
                        var newFraction = (parseInt(fraction) + 1).toString();
                        if (newFraction.length > maxFractionDigits) {
                            var date = new Date(dateStringNoZ + "Z");
                            date.setUTCSeconds(date.getUTCSeconds() + 1);
                            return date.toISOString()
                        }
                        else {
                            var prefixFraction = new Array(fraction.length - newFraction.length + 1).join("0");
                            return dateStringNoZ + "." + prefixFraction + newFraction + "Z"
                        }
                    }
                    else {
                        var concatFraction = new Array(maxFractionDigits - fraction.length).join("0") + "1";
                        return dateStringNoZ + "." + fraction + concatFraction + "Z"
                    }
                }
        })});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.purchaseHistory, function PurchaseHistoryServiceFactory() {
        return new MS.Entertainment.UI.PurchaseHistoryService
    })
})()
