﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var transferService = MS.Entertainment.UI.FileTransferService;
    var notifiers = MS.Entertainment.UI.FileTransferNotifiers;
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {MusicCollectionAutomationIds: {
            collectionAlbumsDateAdded: "collectionAlbumsDateAdded_modifier", collectionAlbumsAlpha: "collectionAlbumsAlpha_modifier", collectionAlbumsReleaseYear: "collectionAlbumsReleaseYear_modifier", collectionAlbumsGenre: "collectionAlbumsGenre_modifier", collectionAlbumsArtists: "collectionAlbumsArtists_modifier", collectionArtistsAlpha: "collectionArtistsAlpha_modifier", collectionSongsDateAdded: "collectionSongsDateAdded_modifier", collectionSongsAlpha: "collectionSongsAlpha_modifier", collectionSongsGenre: "collectionSongsGenre_modifier", collectionSongsArtist: "collectionSongsArtist_modifier", collectionSongsAlbum: "collectionSongsAlbum_modifier", collectionPlaylistDateEdited: "collectionPlaylistDateEdited_modifier", collectionPlaylistDateAdded: "collectionPlaylistDateAdded_modifier", collectionPlaylistAlpha: "collectionPlaylistAlpha_modifier", collectionSmartDJDatePlayed: "collectionSmartDJDatePlayed_modifier", collectionNewlyAdded: "collectionNewlyAdded_modifier", collectionCreatePlaylistAction: "collectionCreatePlaylistAction", shuffleAllMusicAction: "shuffleAllMusicAction", playAllMusicAction: "playAllMusicAction", refreshCollectionAction: "refreshCollectionAction", playAnyArtistAction: "playAnyArtistAction", newSmartDjAction: "newSmartDjAction", searchPlayArtist: "searchPlayArtist", searchSmartDjArtist: "searchSmartDjArtist", searchCollection: "searchCollection", collectionFilterAll: "collectionFilterAll", collectionFilterAvailableOffline: "collectionFilterAvailableOffline", collectionFilterNotAvailableOffline: "collectionFilterNotAvailableOffline", collectionFilterInCloud: "collectionFilterInCloud", collectionFilterNotInCloud: "collectionFilterNotInCloud"
        }});
    MusicCollectionTemplateSelector:MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryTemplateSelector", function galleryTemplateSelector() {
        MS.Entertainment.UI.Controls.GalleryTemplateSelector.prototype.constructor.call(this)
    }, {onSelectTemplate: function onSelectTemplate(item) {
            var data = (item && item.data) ? item.data : {};
            if (item.isAction)
                return this.getTemplateProvider(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.action);
            else
                return MS.Entertainment.UI.Controls.GalleryTemplateSelector.prototype.onSelectTemplate.apply(this, arguments)
        }});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {MusicCollectionBase: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.Music", function musicCollectionBaseConstructor(view) {
            MS.Entertainment.ViewModels.Music.prototype.constructor.apply(this, arguments);
            this._iconActions = [];
            this.modifierDescriptionFormatter = new MS.Entertainment.Formatters.MediaSortFormatter;
            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits))
                this._filterSelectionManagerBinding = WinJS.Binding.bind(this, {filterSelectionManager: this._handleFilterSelectionManagerChanged.bind(this)});
            this.addActionCellsToList = !MS.Entertainment.Utilities.isMusicApp2;
            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.listNotification))
                this._listNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.listNotification)
        }, {
            _viewModelId: "musicCollection", _recreateQueries: true, _collectionQueryBindings: null, _subscriptionBindings: null, _iconActions: null, _filterSelectionManagerBinding: null, _freePlayLimitsFilterBinding: null, _listNotificationService: null, _notificationEventHandlers: null, totalCount: 0, modifierDescriptionFormatter: null, enableDelayInitialize: true, totalCountString: MS.Entertainment.UI.Framework.observableProperty("totalCountString", null), notificationCells: MS.Entertainment.UI.Framework.observableProperty("notificationCells", null), dispose: function dispose() {
                    MS.Entertainment.ViewModels.Music.prototype.dispose.call(this);
                    if (this._iconActions)
                        this._iconActions.forEach(function iconActionIterator(currentAction) {
                            if (currentAction && currentAction.dispose)
                                currentAction.dispose()
                        });
                    this._iconActions = null;
                    if (this._subscriptionBindings) {
                        this._subscriptionBindings.cancel();
                        this._subscriptionBindings = null
                    }
                    if (this._notificationEventHandlers) {
                        this._notificationEventHandlers.cancel();
                        this._notificationEventHandlers = null
                    }
                    if (this._filterSelectionManagerBinding) {
                        this._filterSelectionManagerBinding.cancel();
                        this._filterSelectionManagerBinding = null
                    }
                    if (this._freePlayLimitsFilterBinding) {
                        this._freePlayLimitsFilterBinding.cancel();
                        this._freePlayLimitsFilterBinding = null
                    }
                }, _onNotificationsChanged: function _onNotificationsChanged() {
                    this.dispatchEvent(MS.Entertainment.ViewModels.MusicCollectionBase.Events.notificationsChanged, this._listNotificationService.notifications)
                }, _showFilters: function _showFilters() {
                    var showFilters = false;
                    if (MS.Entertainment.Utilities.isMusicApp1) {
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay))
                            showFilters = true;
                        else {
                            var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                            if (signIn.isSignedIn && signedInUser.isSubscription)
                                showFilters = true;
                            else {
                                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                if (!signIn.isSignedIn && configurationManager.service.lastSignedInUserSubscription)
                                    showFilters = true;
                                if (!signIn.isSignedIn && this._subscriptionBindings === null)
                                    this._subscriptionBindings = WinJS.Binding.bind(signedInUser, {isSubscription: function onSubscriptionChange() {
                                            if (signIn.isSignedIn)
                                                this._refresh()
                                        }.bind(this)})
                            }
                        }
                    }
                    return showFilters
                }, clearFilter: function clearFilter() {
                    if (this.filterSelectionManager)
                        this.filterSelectionManager.selectedIndex = 0
                }, _supportsNotifications: function _supportsNotifications() {
                    return false
                }, createNotificationActionCell: function createNotificationActionCell(notification) {
                    var notificationCell = new MS.Entertainment.ViewModels.NotificationActionCell(notification.category, notification.action, notification.actionParams, notification.dismissAction);
                    notificationCell.icon = notification.icon;
                    notificationCell.text = notification.title;
                    notificationCell.subText = notification.subTitle;
                    notificationCell.groupHeader = String.id.IDS_FILTER_ALL;
                    return notificationCell
                }, createNotificationActionCells: function createNotificationActionCells() {
                    var notificationCells = [];
                    if (this._supportsNotifications()) {
                        var notifications = this._listNotificationService && this._listNotificationService.notifications;
                        if (notifications)
                            notificationCells = notifications.map(function(notification) {
                                return this.createNotificationActionCell(notification)
                            }.bind(this))
                    }
                    return notificationCells
                }, createActionCells: function createActionCells() {
                    var showIfEmptyModifiers = null;
                    if (this.selectedTemplate && this.selectedTemplate.strings && this.selectedTemplate.strings.showIfEmptyModifiers)
                        showIfEmptyModifiers = this.selectedTemplate.strings.showIfEmptyModifiers;
                    var actionCells = [];
                    if (MS.Entertainment.Utilities.isMusicApp1) {
                        this._initializeNotifications();
                        actionCells = actionCells.concat(this.notificationCells)
                    }
                    if (MS.Entertainment.Utilities.isMusicApp2 && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing) {
                        var actionCell = new MS.Entertainment.ViewModels.ActionCell(MS.Entertainment.UI.Actions.ActionIdentifiers.refreshCollection, {
                                automationId: MS.Entertainment.ViewModels.MusicCollectionAutomationIds.refreshCollectionAction, icon: MS.Entertainment.UI.Icon.restart, voiceGuiTextStringId: String.id.IDS_MUSIC2_REFRESH_BUTTON_VUI_GUI, voicePhraseStringId: String.id.IDS_MUSIC2_REFRESH_BUTTON_VUI_ALM, voicePhoneticPhraseStringId: String.id.IDS_MUSIC2_REFRESH_BUTTON_VUI_PRON, voiceConfidence: String.id.IDS_MUSIC2_REFRESH_BUTTON_VUI_CONF
                            }, this);
                        actionCell.stringId = String.id.IDS_ACC_REFRESH_BUTTON;
                        actionCell.groupHeader = String.id.IDS_FILTER_ALL
                    }
                    else {
                        var actionCell = new MS.Entertainment.ViewModels.ActionCell(MS.Entertainment.UI.Actions.ActionIdentifiers.playQuery, {
                                automationId: MS.Entertainment.ViewModels.MusicCollectionAutomationIds.playAllMusicAction, icon: MS.Entertainment.UI.Icon.play, voiceGuiTextStringId: String.id.IDS_MUSIC_PLAY_ALL_BUTTON_VUI_GUI, voicePhraseStringId: String.id.IDS_MUSIC_PLAY_ALL_BUTTON_VUI_ALM, voicePhoneticPhraseStringId: String.id.IDS_MUSIC_PLAY_ALL_BUTTON_VUI_PRON, voiceConfidence: String.id.IDS_MUSIC_PLAY_ALL_BUTTON_VUI_CONF
                            });
                        actionCell.icon = MS.Entertainment.UI.Icon.play;
                        actionCell.stringId = String.id.IDS_PLAY_ALL_LABEL;
                        actionCell.groupHeader = String.id.IDS_FILTER_ALL
                    }
                    this._iconActions.push(actionCell.action);
                    actionCells.push(actionCell);
                    return actionCells
                }, _initializeNotifications: function _initializeNotifications() {
                    if (this._supportsNotifications()) {
                        if (!this.notificationCells)
                            this.notificationCells = this.createNotificationActionCells();
                        if (!this._notificationEventHandlers)
                            this._notificationEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this._listNotificationService, {
                                sendNotificationReceived: this._handleNotificationServiceInsert.bind(this), clearNotificationReceived: this._handleNotificationServiceRemove.bind(this)
                            })
                    }
                }, _insertNotificationCell: function _insertNotificationCell(notificationCell, insertIndex) {
                    if (this.notificationCells && insertIndex >= 0 && insertIndex <= this.notificationCells.length)
                        this.notificationCells.splice(insertIndex, 0, notificationCell)
                }, _removeNotificationCell: function _removeNotificationCell(notificationCell) {
                    var removeIndex = -1;
                    if (this.notificationCells) {
                        removeIndex = this.notificationCells.indexOf(notificationCell);
                        this.notificationCells.splice(removeIndex, 1)
                    }
                    return removeIndex
                }, _handleNotificationServiceInsert: function _handleNotificationServiceInsert(eventData) {
                    this._onNotificationsChanged();
                    if (!this.notificationCells)
                        return null;
                    var notification = eventData.detail;
                    var notificationCell = this._getNotificationActionCell(notification.category);
                    if (notificationCell)
                        notificationCell.setNotification(notification);
                    else {
                        notificationCell = this.createNotificationActionCell(notification);
                        var insertIndex = this._listNotificationService.notifications.indexOf(notification);
                        this._insertNotificationCell(notificationCell, insertIndex)
                    }
                }, _handleNotificationServiceRemove: function _handleNotificationServiceRemove(eventData) {
                    this._onNotificationsChanged();
                    if (!this.notificationCells)
                        return null;
                    var category = eventData.detail;
                    var notificationCell = this._getNotificationActionCell(category);
                    if (notificationCell)
                        this._removeNotificationCell(notificationCell)
                }, cloneCurrentQuery: function cloneCurrentQuery() {
                    if (!this._lastUsedQuery)
                        return null;
                    var clonedQuery = this._lastUsedQuery.clone();
                    if (clonedQuery)
                        clonedQuery.allowGroupHints = false;
                    return clonedQuery
                }, _clearQueryBindings: function _clearQueryBindings() {
                    if (this._collectionQueryBindings) {
                        this._collectionQueryBindings.cancel();
                        this._collectionQueryBindings = null
                    }
                }, _getNotificationActionCell: function _getNotificationActionCell(category) {
                    if (!this.notificationCells)
                        return null;
                    var matches = this.notificationCells.filter(function(item) {
                            return item && item.category && item.category.name === category.name
                        });
                    return matches && matches.length > 0 ? matches[0] : null
                }, _onBeginQuery: function _onBeginQuery(query) {
                    this._clearQueryBindings();
                    var template = this.selectedTemplate;
                    this.modifierDescriptionFormatter.totalCount = -1;
                    this.modifierDescriptionFormatter.initialize(template && template.strings ? template.strings.emptyName : null, template && template.strings ? template.strings.singularName : null, template && template.strings ? template.strings.pluralName : null, null, null, this._showFilters());
                    if (this._iconActions)
                        this._updateAllIconQueryFactories(null)
                }, _onTotalCountChanged: function _onTotalCountChanged(newValue) {
                    this.modifierDescriptionFormatter.totalCount = newValue;
                    this.totalCount = newValue;
                    var countFormatter = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).decimalNumber;
                    this.totalCountString = countFormatter.format(this.totalCount);
                    if (this.totalCount > 0 && this._iconActions)
                        this._updateAllIconQueryFactories(this.createTrackQuery.bind(this))
                }, _updateAllIconQueryFactories: function _updateIconQueryFactories(newQueryFactory) {
                    if (this._iconActions)
                        this._iconActions.forEach(function iconActionIterator(currentAction) {
                            if (typeof currentAction === "object") {
                                currentAction.queryFactory = newQueryFactory;
                                if (currentAction.requeryCanExecute)
                                    currentAction.requeryCanExecute()
                            }
                        })
                }, _onQueryCompleted: function _onQueryCompleted(query) {
                    MS.Entertainment.ViewModels.Music.prototype._onQueryCompleted.apply(this, arguments);
                    this._clearQueryBindings();
                    this._collectionQueryBindings = WinJS.Binding.bind(query, {totalCount: this._onTotalCountChanged.bind(this)})
                }, _handleFilterSelectionManagerChanged: function _handleFilterSelectionManagerChanged() {
                    if (this.filterSelectionManager && !this._freePlayLimitsFilterBinding) {
                        var freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                        this._freePlayLimitsFilterBinding = freePlayLimits.addCollectionFilterListener(this._onFreePlayLimitsSelectFilter.bind(this))
                    }
                }, _onFreePlayLimitsSelectFilter: function _onFreePlayLimitsSelectFilter(filterId) {
                    if (this.filterSelectionManager)
                        for (var i = 0; i < this.filterSelectionManager.dataSource.length; i++)
                            if (this.filterSelectionManager.dataSource[i].id === filterId) {
                                this.filterSelectionManager.selectedIndex = i;
                                break
                            }
                }
        }, {Events: {notificationsChanged: "notificationsChanged"}})});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {MusicCollection: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.MusicCollectionBase", function musicCollectionConstructor(view) {
            MS.Entertainment.ViewModels.MusicCollectionBase.prototype.constructor.apply(this, arguments)
        }, {
            delayInitialize: function delayInitialize() {
                MS.Entertainment.ViewModels.MusicCollectionBase.prototype.delayInitialize.call(this);
                this._initializeNotifications()
            }, getViewDefinition: function(view) {
                    return MS.Entertainment.ViewModels.MusicCollection.Views[view]
                }, getModifierDefinition: function(view) {
                    return MS.Entertainment.ViewModels.MusicCollection.Modifiers[view]
                }, getFilterDefinition: function(view) {
                    var filters = null;
                    if (this._showFilters())
                        if (view === MS.Entertainment.ViewModels.MusicCollection.ViewTypes.smartDJs)
                            filters = MS.Entertainment.ViewModels.MusicCollection.SmartDJFilters;
                        else
                            filters = MS.Entertainment.ViewModels.MusicCollection.Filters;
                    return filters
                }, getFilterOptions: function getFilterOptions(view) {
                    var options;
                    if (view === MS.Entertainment.ViewModels.MusicCollection.ViewTypes.smartDJs)
                        options = {
                            settingsKey: "SmartDJCollectionFilters", isRoamingSetting: false
                        };
                    else
                        options = {
                            settingsKey: "CollectionFilters", isRoamingSetting: false
                        };
                    return options
                }, createActionCells: function createActionCells() {
                    var actionCells = MS.Entertainment.ViewModels.MusicCollectionBase.prototype.createActionCells.apply(this, arguments);
                    if (MS.Entertainment.Utilities.isMusicApp2) {
                        var actionCell = new MS.Entertainment.ViewModels.ActionCell(MS.Entertainment.UI.Actions.ActionIdentifiers.search, {
                                automationId: MS.Entertainment.ViewModels.MusicCollectionAutomationIds.searchCollection, icon: WinJS.UI.AppBarIcon.find, voiceGuiTextStringId: String.id.IDS_MUSIC2_SEARCH_COLLECTION_BUTTON_VUI_GUI, voicePhraseStringId: String.id.IDS_MUSIC2_SEARCH_COLLECTION_BUTTON_VUI_ALM, voicePhoneticPhraseStringId: String.id.IDS_MUSIC2_SEARCH_COLLECTION_BUTTON_VUI_PRON, voiceConfidence: String.id.IDS_MUSIC2_SEARCH_COLLECTION_BUTTON_VUI_CONF
                            });
                        actionCell.stringId = String.id.IDS_MUSIC2_SEARCH_COLLECTION_BUTTON_VUI_GUI;
                        actionCell.groupHeader = String.id.IDS_FILTER_ALL;
                        this._iconActions.push(actionCell.action);
                        actionCells.push(actionCell)
                    }
                    return actionCells
                }, _insertNotificationCell: function _insertNotificationCell(notificationCell, insertIndex) {
                    if (this.items && insertIndex >= 0 && insertIndex < this.items.count)
                        this.items.insertAt(insertIndex, new MS.Entertainment.Data.Factory.ListActionItemWrapper(notificationCell));
                    MS.Entertainment.ViewModels.MusicCollectionBase.prototype._insertNotificationCell.apply(this, arguments)
                }, _removeNotificationCell: function _removeNotificationCell(removeIndex) {
                    var removeIndex = MS.Entertainment.ViewModels.MusicCollectionBase.prototype._removeNotificationCell.apply(this, arguments);
                    if (this.items)
                        this.items.removeAt(removeIndex);
                    else
                        MS.Entertainment.ViewModels.fail("Failed to remove notification from notifications list");
                    return removeIndex
                }, _handleNotificationServiceInsert: function _handleNotificationServiceInsert(eventData) {
                    if (!this.items || this.items.count === 0)
                        return null;
                    return MS.Entertainment.ViewModels.MusicCollectionBase.prototype._handleNotificationServiceInsert.apply(this, arguments)
                }, _handleNotificationServiceRemove: function _handleNotificationServiceRemove(eventData) {
                    if (!this.items || this.items.count === 0)
                        return null;
                    return MS.Entertainment.ViewModels.MusicCollectionBase.prototype._handleNotificationServiceRemove.apply(this, arguments)
                }, _supportsNotifications: function _supportsNotifications() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    return MS.Entertainment.Utilities.isMusicApp1 && (this._view === MS.Entertainment.ViewModels.MusicCollection.ViewTypes.artists || this._view === MS.Entertainment.ViewModels.MusicCollection.ViewTypes.songs || this._view === MS.Entertainment.ViewModels.MusicCollection.ViewTypes.albums) && !configurationManager.shell.retailExperience
                }, _onQueryCompleted: function _onQueryCompleted(query) {
                    MS.Entertainment.ViewModels.MusicCollectionBase.prototype._onQueryCompleted.apply(this, arguments);
                    this.delayInitialize()
                }
        }, {
            ViewTypes: {
                albums: "albums", artists: "artists", songs: "songs", playlists: "playlists", musicVideos: "musicVideos", smartDJs: "smartDJs", albums2: "albums2", newlyAdded: "newlyAdded", playlists2: "playlists2"
            }, Modifiers: {
                    albums: {itemFactory: function() {
                            return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsDateAdded, String.id.IDS_MUSIC_COLLECTION_DATEADDED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.dateAddedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsDateAdded}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                        isLive: true, sort: Microsoft.Entertainment.Queries.TracksSortBy.albumDateAddedDescending
                                    })), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsAlpha, String.id.IDS_MUSIC_COLLECTION_ALPHA_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.titleAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsAlpha}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                        isLive: true, sort: Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberAscending
                                    })), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsReleaseYear, String.id.IDS_MUSIC_COLLECTION_RELEASEYEAR_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.releaseYearDescendingTitleAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsReleaseYear}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                        isLive: true, sort: Microsoft.Entertainment.Queries.TracksSortBy.albumReleaseYearDescendingTitleAscending
                                    })), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsGenre, String.id.IDS_MUSIC_GENRE_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.genreNameTitleAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsGenre}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                        isLive: true, sort: Microsoft.Entertainment.Queries.TracksSortBy.albumGenreNameTitleAscending
                                    })), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsArtists, String.id.IDS_MUSIC_COLLECTION_ARTIST_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.artistAscendingReleaseYearDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsArtists}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                        isLive: true, sort: Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingReleaseYearDescending
                                    }))]
                        }}, albums2: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionAlbumsArtists, String.id.IDS_MUSIC_COLLECTION_ARTIST_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.AlbumsSortBy.artistAscendingReleaseYearDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.albumsArtists}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                            isLive: !(MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), sort: Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingReleaseYearDescending
                                        }))]
                            }}, artists: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionArtistsAlpha, String.id.IDS_MUSIC_COLLECTION_ALPHA_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PeopleSortBy.nameAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.artists}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                            isLive: !(MS.Entertainment.Utilities.isMusicApp2 && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), sort: Microsoft.Entertainment.Queries.TracksSortBy.albumArtistAscendingAlbumReleaseYearAscendingNumberAscending
                                        }))]
                            }}, songs: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSongsDateAdded, String.id.IDS_MUSIC_COLLECTION_DATEADDED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.dateAddedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.songsDateAdded}, null, null, null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.dateAddedDescending})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSongsAlpha, String.id.IDS_MUSIC_COLLECTION_ALPHA_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.titleAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.songsAlpha}, null, null, null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.titleAscending})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSongsGenre, String.id.IDS_MUSIC_GENRE_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.genreAscendingTitleAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.songsGenre}, null, null, null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.genreAscendingTitleAscending})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSongsArtist, String.id.IDS_MUSIC_COLLECTION_ARTIST_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.artistAscendingAlbumReleaseYearAscendingNumberAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.songsArtist}, null, null, null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.artistAscendingAlbumReleaseYearAscendingNumberAscending})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSongsAlbum, String.id.IDS_MUSIC_ALBUM_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.songsAlbum}, null, null, null, {sort: Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberAscending})), ]
                            }}, playlists: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistDateEdited, String.id.IDS_MUSIC_COLLECTION_DATEEDITED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.dateEditedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistEdited})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistDateAdded, String.id.IDS_MUSIC_COLLECTION_DATEADDED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.dateAddedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistAdded})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistAlpha, String.id.IDS_MUSIC_COLLECTION_ALPHA_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.nameAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistAlpha})), ]
                            }}, playlists2: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistDateEdited, String.id.IDS_MUSIC2_COLLECTION_DATEEDITED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.dateEditedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistEdited}), String.id.IDS_MUSIC2_COLLECTION_DATEEDITED_SORT_TC), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistDateAdded, String.id.IDS_MUSIC2_COLLECTION_DATEADDED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.dateAddedDescending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistAdded}), String.id.IDS_MUSIC2_COLLECTION_DATEADDED_SORT_TC), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionPlaylistAlpha, String.id.IDS_MUSIC2_COLLECTION_ALPHA_SORT, new MS.Entertainment.ViewModels.NodeValues(null, {sort: Microsoft.Entertainment.Queries.PlaylistsSortBy.nameAscending}, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.playlistAlpha}), String.id.IDS_MUSIC2_COLLECTION_ALPHA_SORT_TC), ]
                            }}, smartDJs: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionSmartDJDatePlayed, String.id.IDS_MUSIC_COLLECTION_DATEPLAYED_SORT, new MS.Entertainment.ViewModels.NodeValues(null, null, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.smartDJ}))]
                            }}, newlyAdded: {itemFactory: function() {
                                return [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionNewlyAdded, String.id.IDS_MUSIC_COLLECTION_ARTIST_SORT, new MS.Entertainment.ViewModels.NodeValues(null, null, {selectedTemplate: MS.Entertainment.ViewModels.MusicCollectionTemplates.newlyAdded}, null, null, MS.Entertainment.Data.Query.libraryTracks, {
                                            isLive: !(MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), sort: Microsoft.Entertainment.Queries.TracksSortBy.albumDateAddedDescending, maxAlbumsCount: 5, acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.playAll)
                                        }))]
                            }}
                }, Filters: {options: [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionFilterAll, String.id.IDS_COLLECTION_FILTER_ALL, new MS.Entertainment.ViewModels.NodeValues(null, {mediaAvailability: Microsoft.Entertainment.Platform.MediaAvailability.available})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionFilterAvailableOffline, String.id.IDS_COLLECTION_FILTER_AVAILABLE_OFFLINE, new MS.Entertainment.ViewModels.NodeValues(null, {mediaAvailability: Microsoft.Entertainment.Platform.MediaAvailability.availableOffline})), new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionFilterInCloud, String.id.IDS_COLLECTION_FILTER_IN_CLOUD, new MS.Entertainment.ViewModels.NodeValues(null, {mediaAvailability: Microsoft.Entertainment.Platform.MediaAvailability.availableFromCloud}))]}, SmartDJFilters: {options: [new MS.Entertainment.ViewModels.Node(MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionFilterAll, String.id.IDS_COLLECTION_FILTER_ALL, new MS.Entertainment.ViewModels.NodeValues(null, {mediaAvailability: Microsoft.Entertainment.Platform.MediaAvailability.available})), ]}, Views: {
                    albums: new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryAlbums, {
                        isLive: true, allowGroupHints: true, allowReset: true, chunkSize: 25
                    }, {
                        propertyKey: "libraryId", taskKeyGetter: transferService && transferService.keyFromProperty("albumLibraryId"), notifier: notifiers && notifiers.trackCollection
                    }, {settingsKey: "collection-albums-modifier-selection"}, null, null, {acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.album)}), get albums2() {
                            return new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryAlbums, {
                                    isLive: !(MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), allowGroupHints: true, allowReset: true, chunkSize: 25
                                }, {
                                    propertyKey: "libraryId", taskKeyGetter: transferService && transferService.keyFromProperty("albumLibraryId"), notifier: notifiers && notifiers.trackCollection
                                }, {settingsKey: "collection-albums-modifier-selection"}, null, null, {acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.album)})
                        }, get artists() {
                            return new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryArtists, {
                                    isLive: !(MS.Entertainment.Utilities.isMusicApp2 && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), allowGroupHints: true, allowReset: true, chunkSize: 25, artistOf: Microsoft.Entertainment.Queries.ArtistOf.album
                                }, {
                                    propertyKey: "libraryId", taskKeyGetter: transferService && transferService.keyFromProperty("albumArtistLibraryId"), notifier: notifiers && notifiers.trackCollection
                                }, {settingsKey: "collection-artists-modifier-selection"}, null, null, {acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.artist)})
                        }, songs: new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryTracks, {
                            isLive: true, allowGroupHints: true, allowReset: true, chunkSize: 100, acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.track)
                        }, {
                            propertyKey: "libraryId", taskKeyGetter: transferService && transferService.keyFromProperty("libraryId"), notifier: notifiers && notifiers.trackCollection
                        }, {settingsKey: "collection-songs-modifier-selection"}, null, MS.Entertainment.Data.Query.libraryTracks, {acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.playAll)}), playlists: new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryPlaylists, {
                            isLive: true, allowGroupHints: true, allowReset: true, chunkSize: 25, playlistType: Microsoft.Entertainment.Platform.PlaylistType.static
                        }, {notifier: null}, {settingsKey: "collection-playlists-modifier-selection"}), playlists2: new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryPlaylists, {
                            isLive: true, allowGroupHints: true, allowReset: true, chunkSize: 25, playlistType: Microsoft.Entertainment.Platform.PlaylistType.static
                        }, {notifier: null}, {settingsKey: "collection-playlists-modifier-selection"}), smartDJs: new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.ViewModels.SmartDJListQueryType, {}, {notifier: null}, {settingsKey: "collection-smartdjs-modifier-selection"}), get newlyAdded() {
                            return new MS.Entertainment.ViewModels.NodeValues(MS.Entertainment.Data.Query.libraryAlbumsLimited, {
                                    isLive: !(MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData) && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing), sort: Microsoft.Entertainment.Queries.AlbumsSortBy.dateAddedDescending, chunkSize: 25, allowReset: true
                                }, {
                                    propertyKey: "libraryId", taskKeyGetter: transferService && transferService.keyFromProperty("albumLibraryId"), notifier: notifiers && notifiers.trackCollection
                                }, null, null, null, {acquisitionData: new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.album)})
                        }
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {ShuffleAllMusicAction: MS.Entertainment.deferredDerive("MS.Entertainment.Platform.PlayAction", null, {
            automationId: MS.Entertainment.ViewModels.MusicCollectionAutomationIds.shuffleAllMusicAction, canExecutePlay: function canExecute() {
                    return true
                }, executedPlay: function() {
                    var query = new MS.Entertainment.Data.Query.libraryTracks;
                    query.sort = Microsoft.Entertainment.Queries.TracksSortBy.shuffle;
                    query.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.playAll);
                    var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    if (!MS.Entertainment.UI.NetworkStatusService.isOnline() || !signInService.isSignedIn)
                        query.mediaAvailability = Microsoft.Entertainment.Platform.MediaAvailability.availableOffline;
                    MS.Entertainment.Platform.PlaybackHelpers.playMedia2(query, {
                        sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, autoPlay: true, saveNowPlaying: false, showImmersive: false, showAppBar: true, shuffle: false
                    });
                    return true
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {MusicPlaylistCollection: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.MusicCollection", function musicPlaylistCollection(view) {
            MS.Entertainment.ViewModels.MusicCollection.prototype.constructor.apply(this, arguments)
        }, {
            updateQuery: function updateQuery() {
                if (this.pausableQuery && this.pausableQuery.forceLiveRefresh)
                    this.pausableQuery.forceLiveRefresh()
            }, createActionCells: function createActionCells() {
                    var actionCells = [];
                    var actionCell = new MS.Entertainment.ViewModels.ActionCell(MS.Entertainment.UI.Actions.ActionIdentifiers.createPlaylist, {
                            automationId: MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionCreatePlaylistAction, icon: WinJS.UI.AppBarIcon.add, voiceGuiTextStringId: String.id.IDS_PLAYLIST_GALLERY_ACTION_BUTTON_VUI_GUI, voicePhraseStringId: String.id.IDS_PLAYLIST_GALLERY_ACTION_BUTTON_VUI_ALM, voicePhoneticPhraseStringId: String.id.IDS_PLAYLIST_GALLERY_ACTION_BUTTON_VUI_PRON
                        }, {completeAction: this.updateQuery.bind(this)});
                    actionCell.icon = WinJS.UI.AppBarIcon.add;
                    actionCell.stringId = String.id.IDS_PLAYLIST_CREATE_LABEL;
                    actionCell.groupHeader = String.id.IDS_FILTER_ALL;
                    actionCells.push(actionCell);
                    return actionCells
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {MusicSmartDJCollection: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.MusicCollection", function musicSmartDJCollection(view) {
            MS.Entertainment.ViewModels.MusicCollection.prototype.constructor.apply(this, arguments);
            var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
            this._signInBindings = WinJS.Binding.bind(signIn, {isSignedIn: this._lockResultsIfNeeded.bind(this)});
            MS.Entertainment.Utilities.addEventHandlers(this, {itemsChanged: this._lockResultsIfNeeded.bind(this)})
        }, {
            error: null, errorModel: null, _signInBindings: null, dispose: function dispose() {
                    MS.Entertainment.ViewModels.MusicCollection.prototype.dispose.call(this);
                    if (this._signInBindingsbv) {
                        this._signInBindings.cancel();
                        this._signInBindings = null
                    }
                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList).lockResult = false
                }, createActionCells: function createActionCells() {
                    var actionCell;
                    var actionIndentifier;
                    var actionOptions;
                    if (MS.Entertainment.Utilities.isMusicApp2) {
                        actionIndentifier = MS.Entertainment.UI.Actions.ActionIdentifiers.searchArtist;
                        actionOptions = {
                            parameter: {
                                hasSmartDJ: true, galleryClass: "smartDjActionGallery"
                            }, icon: MS.Entertainment.UI.Icon.smartDj, voiceGuiTextStringId: String.id.IDS_RADIO_GALLERY_ACTION_BUTTON_VUI_GUI, voicePhraseStringId: String.id.IDS_RADIO_GALLERY_ACTION_BUTTON_VUI_ALM, voicePhoneticPhraseStringId: String.id.IDS_RADIO_GALLERY_ACTION_BUTTON_VUI_PRON
                        };
                        actionCell = new MS.Entertainment.ViewModels.ActionCell(actionIndentifier, actionOptions);
                        actionCell.hideDefaultRing = true
                    }
                    return actionCell
                }, cloneCurrentQuery: function cloneCurrentQuery() {
                    return this._lastUsedQuery
                }, _lockResultsIfNeeded: function _lockResultsIfNeeded() {
                    if (this._disposed)
                        return;
                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    var lockResult = signIn.isSignedIn && !!this.items && this.items.count > 0;
                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList).lockResult = lockResult
                }, _onQueryCompleted: function _onQueryCompleted(query) {
                    this.errorModel = null;
                    this.error = null;
                    MS.Entertainment.ViewModels.MusicCollection.prototype._onQueryCompleted.apply(this, arguments)
                }, _onQueryFailed: function _onQueryFailed(error) {
                    MS.Entertainment.ViewModels.MusicCollection.prototype._onQueryFailed.apply(this, arguments);
                    this.error = error;
                    this.errorModel = new MS.Entertainment.UI.Controls.DefaultFailedPanelModel;
                    if ((this.error.errorCode === MS.Entertainment.Utilities.SignInErrors.INET_E_RESOURCE_NOT_FOUND) || !MS.Entertainment.UI.NetworkStatusService.isOnline()) {
                        this.errorModel.primaryStringId = String.id.IDS_RADIO_OFFINE_ERROR_TITLE;
                        this.errorModel.secondaryStringId = String.id.IDS_SMARTDJ_OFFINE_ERROR_DESC
                    }
                    else if ((this.error.errorCode === MS.Entertainment.Utilities.SignInErrors.HTTP_E_STATUS_DENIED) || !MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).isSignedIn) {
                        this.errorModel.primaryStringId = String.id.IDS_RADIO_PAGE_ERROR_GALLERY_TITLE;
                        this.errorModel.secondaryStringId = String.id.IDS_RADIO_PAGE_SIGN_IN_SUBTITLE
                    }
                    else {
                        this.errorModel.primaryStringId = String.id.IDS_RADIO_PAGE_ERROR_GALLERY_TITLE;
                        this.errorModel.secondaryStringId = String.id.IDS_SMARTDJ_OFFINE_ERROR_DESC
                    }
                    var refreshOnAdd = function refreshOnAdd() {
                            this.refresh()
                        }.bind(this);
                    this.errorModel.details = MS.Entertainment.Pages.MusicCollection.getEmptySmartDJCollectionDetails(refreshOnAdd)
                }
        })});
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.shuffleAllMusic, function() {
        return new MS.Entertainment.ViewModels.ShuffleAllMusicAction
    });
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {CreateFlyoutAction: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Actions.Action", function CreateFlyoutActionConstructor() {
            MS.Entertainment.UI.Actions.Action.prototype.constructor.apply(this)
        }, {
            action: null, referenceContainer: null, left: "auto", top: "auto", right: "auto", bottom: "auto", flyoutWidth: 0, template: String.empty, canExecute: function canExecute() {
                    return true
                }, executed: function(parameter) {
                    var screenWidth = MS.Entertainment.Utilities.getWindowWidth();
                    if (this.referenceContainer && this.referenceContainer.domElement) {
                        var paddingFromElement = 10;
                        var boundingRectangle = WinJS.Binding.unwrap(this.referenceContainer).domElement.getBoundingClientRect();
                        var boundingTop = boundingRectangle.top;
                        var anchorPoint = "top";
                        var anchorPosition = Math.round(boundingRectangle.top) + "px";
                        if (this.flyoutHeight && ((boundingTop + this.flyoutHeight) > MS.Entertainment.Utilities.getWindowHeight())) {
                            anchorPoint = "bottom";
                            anchorPosition = "20px"
                        }
                        this[anchorPoint] = anchorPosition;
                        if (MS.Entertainment.Utilities.getTextDirection() === MS.Entertainment.Utilities.TextDirections.RightToLeft) {
                            this.right = screenWidth - Math.round(boundingRectangle.left) + paddingFromElement;
                            if (this.flyoutWidth)
                                this.right = MS.Entertainment.Utilities.getEdgeWithinViewport(this.right, this.flyoutWidth, screenWidth);
                            this.right += "px"
                        }
                        else {
                            this.left = Math.round(boundingRectangle.right) + paddingFromElement;
                            if (this.flyoutWidth)
                                this.left = MS.Entertainment.Utilities.getEdgeWithinViewport(this.left, this.flyoutWidth, screenWidth);
                            this.left += "px"
                        }
                    }
                    else if (this.referenceContainer) {
                        var leftDefined = this.referenceContainer.left >= 0;
                        var rightDefined = this.referenceContainer.right >= 0;
                        MS.Entertainment.ViewModels.assert(!leftDefined || !rightDefined || !this.flyoutWidth, "Width cannot be used when the left and right edges of the flyout are already defined.");
                        if (leftDefined) {
                            this.left = this.referenceContainer.left;
                            if (this.flyoutWidth)
                                this.left = MS.Entertainment.Utilities.getEdgeWithinViewport(this.left, this.flyoutWidth, screenWidth);
                            this.left += "px"
                        }
                        else
                            this.left = "auto";
                        if (rightDefined) {
                            this.right = this.referenceContainer.right;
                            if (this.flyoutWidth)
                                this.right = MS.Entertainment.Utilities.getEdgeWithinViewport(this.right, this.flyoutWidth, screenWidth);
                            this.right += "px"
                        }
                        else
                            this.right = "auto";
                        this.top = this.referenceContainer.top >= 0 ? this.referenceContainer.top + "px" : "auto";
                        this.bottom = this.referenceContainer.bottom >= 0 ? this.referenceContainer.bottom + "px" : "auto"
                    }
                    var userControlOptions = this.populateUserControlOptions ? this.populateUserControlOptions(parameter) : {};
                    var overlayOptions = {
                            left: this.left, bottom: this.bottom, right: this.right, top: this.top, referenceContainer: this.referenceContainer, dontWaitForContent: true, showAnimation: function showAnimation() {
                                    return WinJS.Promise.as()
                                }
                        };
                    this.openPopup = MS.Entertainment.UI.Shell.createOverlay(this.template, userControlOptions, overlayOptions);
                    this.openPopup.show().then(function onPopupDismissed() {
                        this.openPopup = null
                    }.bind(this))
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {CreatePlaylistAction: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.CreateFlyoutAction", function CreatePlaylistActionConstructor() {
            MS.Entertainment.ViewModels.CreateFlyoutAction.prototype.constructor.apply(this);
            this.automationId = MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionCreatePlaylistAction
        }, {
            flyoutWidth: 300, flyoutHeight: 175, template: "MS.Entertainment.UI.Controls.CreatePlaylistFlyout", populateUserControlOptions: function populateUserControlOptions(parameter) {
                    return {
                            actionParameters: parameter, action: this.action || new MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction
                        }
                }, canExecute: function canExecute() {
                    return !MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {CreatePlaylistActionTextInput: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Actions.Action", function searchArtistActionConstructor() {
            MS.Entertainment.UI.Actions.Action.prototype.constructor.apply(this);
            this.automationId = MS.Entertainment.ViewModels.MusicCollectionAutomationIds.collectionCreatePlaylistAction
        }, {
            param: null, executed: function executed(param) {
                    param = param || {};
                    this.param = param;
                    if (WinJS.Utilities.getMember("UI.ViewManagement.InputPaneInternal", Windows)) {
                        var inputPaneInternal = Windows.UI.ViewManagement.InputPaneInternal.getForCurrentView();
                        inputPaneInternal.suggestions.clear()
                    }
                    MS.Entertainment.UI.Controls.TextInputOverlay.getTextInput({
                        submitText: String.load(String.id.IDS_SAVE_BUTTON), errorSubmitText: String.load(String.id.IDS_PLAYLIST_CREATE_REPLACE), watermark: String.load(String.id.IDS_PLAYLIST_NAME_TITLE), initialText: param.defaultPlaylistName, validateInput: this.validatePlaylistName.bind(this), validateError: this.attemptReplacePlaylistName.bind(this)
                    }).done(function success(textInput) {
                        if (param.completeAction && textInput)
                            param.completeAction()
                    }, function cancel(){})
                }, validatePlaylistName: function validatePlaylistName(playlistName) {
                    return this.attemptCreatePlaylist(playlistName, false)
                }, attemptReplacePlaylistName: function attemptReplacePlaylistName(playlistName) {
                    return this.attemptCreatePlaylist(playlistName, true)
                }, attemptCreatePlaylist: function attemptCreatePlaylist(playlistName, hadError) {
                    var parameters = this.param || {};
                    this.action = this.action || new MS.Entertainment.UI.Actions.Playlists.CreatePlaylistAction;
                    this.action.parameter = this.action.parameter || {};
                    this.action.parameter.name = playlistName;
                    this.action.parameter.playlist = parameters.playlist;
                    this.action.parameter.mediaItems = parameters.mediaItems;
                    this.action.parameter.overwrite = hadError && this.action.supportsOverwrite;
                    this.action.automationId = MS.Entertainment.UI.AutomationIds.playlistNewPlaylistNameEntry;
                    var completion;
                    var error;
                    var promise = new WinJS.Promise(function(c, e, p) {
                            completion = c;
                            error = e
                        });
                    this.action.parameter.completeCallback = function succeeded() {
                        completion()
                    };
                    this.action.parameter.failedCallback = function retryOnFail() {
                        if (this.action.supportsOverwrite)
                            error(new Error(String.load(String.id.IDS_PLAYLIST_CREATE_DUPLICATE_MESSAGE)));
                        else
                            error(new Error(String.load(String.id.IDS_PLAYLIST_EXISTING_NAME)))
                    }.bind(this);
                    this.action.execute();
                    return promise
                }, canExecute: function canExecute() {
                    return true
                }
        })});
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.createPlaylist, function() {
        if (MS.Entertainment.Utilities.isMusicApp1)
            return new MS.Entertainment.ViewModels.CreatePlaylistAction;
        else
            return new MS.Entertainment.ViewModels.CreatePlaylistActionTextInput
    });
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {SelectArtistAction: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.CreateFlyoutAction", function SelectArtistActionConstructor() {
            MS.Entertainment.ViewModels.CreateFlyoutAction.prototype.constructor.apply(this);
            this.automationId = MS.Entertainment.ViewModels.MusicCollectionAutomationIds.playAnyArtistAction
        }, {
            height: "650px", width: "670px", template: "MS.Entertainment.UI.Controls.SelectArtistFlyout", isSmartDJ: false, successCallback: null, _centeredStyle: "calc(50% - {0}px)", populateUserControlOptions: function populateUserControlOptions(parameter) {
                    return {
                            isSmartDJ: this.isSmartDJ, successCallback: this.successCallback
                        }
                }, executed: function executed(parameter, referenceElement) {
                    this.referenceContainer = null;
                    this.left = this.right = this._centeredStyle.format(parseInt(this.width) / 2);
                    this.top = this._centeredStyle.format(parseInt(this.height) / 2);
                    var stateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    if (!stateService.servicesEnabled)
                        return MS.Entertainment.UI.Shell.showAppUpdateDialog();
                    if (parameter && parameter.isSmartDJ !== undefined) {
                        this.isSmartDJ = parameter.isSmartDJ;
                        this.successCallback = parameter.successCallback
                    }
                    this.automationId = this.isSmartDJ ? MS.Entertainment.ViewModels.MusicCollectionAutomationIds.newSmartDjAction : MS.Entertainment.ViewModels.MusicCollectionAutomationIds.playAnyArtistAction;
                    if (referenceElement)
                        MS.Entertainment.Utilities.Telemetry.logPageAction({domElement: referenceElement}, {
                            uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.SmartDJ
                        });
                    MS.Entertainment.ViewModels.CreateFlyoutAction.prototype.executed.apply(this, parameter)
                }
        })});
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.selectArtist, function() {
        return new MS.Entertainment.ViewModels.SelectArtistAction
    });
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {SearchArtistAction: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Actions.Action", function searchArtistActionConstructor() {
            MS.Entertainment.UI.Actions.Action.prototype.constructor.apply(this);
            this.automationId = MS.Entertainment.ViewModels.MusicCollectionAutomationIds.searchPlayArtist
        }, {
            isSmartDJ: false, popupOpened: false, _populateSearchSuggestions: function _populateSearchSuggestions(searchString) {
                    if (WinJS.Utilities.getMember("UI.ViewManagement.InputPaneInternal", Windows)) {
                        var maxWordWheelCount = 10;
                        var inputPaneInternal = Windows.UI.ViewManagement.InputPaneInternal.getForCurrentView();
                        var suggestions = inputPaneInternal.suggestions;
                        suggestions.clear();
                        var query = new MS.Entertainment.Data.Query.Music.AutoSuggest;
                        query.mediaType = MS.Entertainment.Data.Query.bbxMediaType.artistSmartDj;
                        query.keyword = MS.Entertainment.Utilities.sanitizeString(searchString);
                        query.execute().then(function querySuccess(q) {
                            if (q.result.items)
                                return q.result.items.itemsFromIndex(0, 0, maxWordWheelCount)
                        }, function queryFail(q) {
                            return WinJS.Promise.wrap()
                        }).done(function gotResults(results) {
                            if (results)
                                for (var i = 0; i < results.items.length; i++) {
                                    var item = results.items[i].data;
                                    suggestions.append(item.name)
                                }
                        })
                    }
                }, executed: function executed(param) {
                    this.galleryClass = param.galleryClass;
                    this.hasSmartDJ = param.hasSmartDJ;
                    this.initialText = param.initialText;
                    this.automationId = this.hasSmartDJ ? MS.Entertainment.ViewModels.MusicCollectionAutomationIds.searchSmartDjArtist : MS.Entertainment.ViewModels.MusicCollectionAutomationIds.searchPlayArtist;
                    if (!this.popupOpened) {
                        this.popupOpened = true;
                        return MS.Entertainment.UI.Controls.TextInputOverlay.getTextInput({
                                submitText: String.load(String.id.IDS_MUSIC_ENGAGE_ARTIST_ENTER_BUTTON_UC), watermark: String.load(String.id.IDS_MUSIC_ENGAGE_ARTIST_ENTER), initialText: this.initialText, valueChanged: this._populateSearchSuggestions
                            }).then(function searchEntered(query) {
                                var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                var _actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                var actionIdentifier = this.hasSmartDJ ? MS.Entertainment.UI.Actions.ActionIdentifiers.playSmartDJ : MS.Entertainment.UI.Actions.ActionIdentifiers.playArtist;
                                var action = _actionService.getAction(actionIdentifier);
                                action.automationId = this.automationId;
                                var options = {
                                        search: query, action: action, hasSmartDJ: this.hasSmartDJ, galleryClass: this.galleryClass
                                    };
                                navigationService.navigateTo(MS.Entertainment.UI.Monikers.artistSearchAction, null, null, options);
                                this.popupOpened = false
                            }.bind(this), function searchCancelled() {
                                this.popupOpened = false
                            }.bind(this))
                    }
                }, canExecute: function canExecute() {
                    return true
                }
        })});
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.searchArtist, function() {
        return new MS.Entertainment.ViewModels.SearchArtistAction
    })
})()
