﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.ViewModels");
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {Music: MS.Entertainment.UI.Framework.derive("MS.Entertainment.ViewModels.QueryViewModel", function musicConstructor(view) {
            this._queryWatcherString = "music-marketplace-";
            this._loadingDoneString = "music";
            var currentPage;
            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation))
                currentPage = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).currentPage;
            var options = currentPage && currentPage.options || {};
            if (options.defaultModifierIndex > -1) {
                this._defaultModifierSelection = options.defaultModifierIndex;
                if (options.overrideModifierSetting !== undefined && options.overrideModifierSetting !== null)
                    this._overrideModifierSetting = options.overrideModifierSetting
            }
            if (options.defaultSecondaryModifierIndex > -1)
                this._defaultSecondaryModifierSelection = options.defaultSecondaryModifierIndex;
            if (options.filterIndex > -1)
                this._defaultFilterIndex = options.filterIndex;
            if (options.pivotIndex > -1)
                this._defaultPivotIndex = options.pivotIndex;
            MS.Entertainment.ViewModels.QueryViewModel.prototype.constructor.apply(this, arguments)
        }, {createTrackQuery: function createTrackQuery() {
                var query;
                var QueryType;
                var options;
                var view = this.getViewDefinition(this.view);
                var pivot = this._workingPivotsSelectionManager.selectedItem;
                var modifier = this._workingModifierSelectionManager.selectedItem;
                var secondaryModifier = this._workingSecondaryModifierSelectionManager.selectedItem;
                var filter = this._workingFilterSelectionManager.selectedItem;
                pivot = pivot || {value: {}};
                modifier = modifier || {value: {}};
                secondaryModifier = secondaryModifier || {value: {}};
                filter = filter || {value: {}};
                if (view.trackQuery)
                    QueryType = view.trackQuery;
                else if (modifier.value.trackQuery)
                    QueryType = modifier.value.trackQuery;
                else if (pivot.value.trackQuery)
                    QueryType = pivot.value.trackQuery;
                if (QueryType) {
                    query = new QueryType;
                    options = MS.Entertainment.Utilities.uniteObjects(WinJS.Binding.unwrap(pivot.value.trackQueryOptions), WinJS.Binding.unwrap(modifier.value.trackQueryOptions));
                    options = MS.Entertainment.Utilities.uniteObjects(options, WinJS.Binding.unwrap(secondaryModifier.value.trackQueryOptions));
                    options = MS.Entertainment.Utilities.uniteObjects(options, WinJS.Binding.unwrap(filter.value.queryOptions));
                    options = MS.Entertainment.Utilities.uniteObjects(options, WinJS.Binding.unwrap(view.trackQueryOptions));
                    MS.Entertainment.Utilities.BindingAgnostic.setProperties(query, options)
                }
                if (!query) {
                    if (view.query)
                        QueryType = view.query;
                    else if (modifier.value.query)
                        QueryType = modifier.value.query;
                    else if (pivot.value.query)
                        QueryType = pivot.value.query;
                    if (QueryType) {
                        query = new QueryType;
                        options = MS.Entertainment.Utilities.uniteObjects(WinJS.Binding.unwrap(pivot.value.queryOptions), WinJS.Binding.unwrap(modifier.value.queryOptions));
                        options = MS.Entertainment.Utilities.uniteObjects(options, WinJS.Binding.unwrap(filter.value.queryOptions));
                        options = MS.Entertainment.Utilities.uniteObjects(options, WinJS.Binding.unwrap(view.queryOptions));
                        MS.Entertainment.Utilities.BindingAgnostic.setProperties(query, options)
                    }
                }
                MS.Entertainment.ViewModels.assert(query, "No track query was created, when we expected one");
                return query
            }})});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {
        PlayQueryAction: MS.Entertainment.deferredDerive("MS.Entertainment.Platform.PlayAction", function playQueryAction(queryFactory) {
            this.base();
            this.queryFactory = queryFactory;
            this.title = String.load(String.id.IDS_PLAY_ALL_LABEL)
        }, {
            automationId: MS.Entertainment.UI.AutomationIds.playQueryAction, preRollVideoAdIfNeeded: null, _queryFactory: null, _disposed: false, isEnabled: false, dispose: function dispose() {
                    this._queryFactory = null;
                    this.requeryCanExecute();
                    this._disposed = true
                }, queryFactory: {
                    get: function() {
                        return this._queryFactory
                    }, set: function(value) {
                            if (!this._disposed)
                                this._queryFactory = value
                        }
                }, executedPlay: function executedPlay(param) {
                    var playMedia;
                    var query = this.queryFactory();
                    var adService;
                    var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.adService))
                        adService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.adService);
                    MS.Entertainment.ViewModels.assert(query, "QueryFactory returned a null query");
                    if (query) {
                        query.isLive = false;
                        var playOptions = {
                                sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, autoPlay: true, showImmersive: false, showAppBar: true, shuffle: this.shuffle, saveNowPlaying: false
                            };
                        if (MS.Entertainment.Data.ServiceWrapperQuery.isServiceWrapperQuery(query))
                            playOptions.offset = 0;
                        playMedia = function playMedia() {
                            MS.Entertainment.Platform.PlaybackHelpers.playMedia2(query, playOptions)
                        };
                        if (adService && this.preRollVideoAdIfNeeded && signInService.isSignedIn && !signedInUserService.isSubscription)
                            adService.playVideoAdIfRequired(query).done(function playVideoAdIfRequired_complete(adPlayedIfNeeded) {
                                if (adPlayedIfNeeded)
                                    playMedia()
                            }, function playVideoAdIfRequired_failed(error) {
                                MS.Entertainment.ViewModels.fail("playVideoAdIfRequired_failed: " + error && error.message);
                                playMedia()
                            });
                        else
                            playMedia()
                    }
                    return !!query
                }, canExecutePlay: function canExecutePlay(param) {
                    return !!this.queryFactory
                }
        }), refreshCollectionAction: MS.Entertainment.deferredDerive("MS.Entertainment.Platform.PlayAction", function refreshCollectionAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.refreshCollectionAction, executed: function executed(param) {
                        param.refreshQuery()
                    }, canExecute: function canExecute(param) {
                        return true
                    }
            }), PlayArtistAction: MS.Entertainment.deferredDerive("MS.Entertainment.Platform.PlayAction", function playArtistAction() {
                this.base()
            }, {
                executedPlay: function executedPlay(param) {
                    MS.Entertainment.Instrumentation.PerfTrack.setStartTime(MS.Entertainment.Instrumentation.PerfTrack.StartPoints.PlayCommand);
                    var isImmersive = false;
                    var query,
                        id;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation)) {
                        var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        isImmersive = navigationService.checkUserLocation(MS.Entertainment.UI.Monikers.immersiveDetails)
                    }
                    MS.Entertainment.ViewModels.assert(param.mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.person && param.mediaItem.personType === Microsoft.Entertainment.Queries.PersonType.artist, "Invalid media type. Was expecting an artist media object");
                    if (param.playCollectionItemsOnly) {
                        id = MS.Entertainment.Utilities.isValidLibraryId(param.mediaItem.libraryId) ? param.mediaItem.libraryId : param.libraryId;
                        query = new MS.Entertainment.Data.Query.libraryTracks;
                        query.artistId = param.mediaItem.libraryId;
                        query.mediaAvailability = param.collectionFilter;
                        query.sort = Microsoft.Entertainment.Queries.TracksSortBy.albumTitleDiscNumberNumberAscending;
                        query.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.collection, Microsoft.Entertainment.Platform.AcquisitionContextType.artist);
                        if (param.librarySort)
                            query.sort = param.librarySort
                    }
                    else {
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits)) {
                            var freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                            if (freePlayLimits.isMonthlyFreeLimitExceeded)
                                return freePlayLimits.showMonthlyFreeLimitExceededDialog()
                        }
                        id = (!MS.Entertainment.Utilities.isEmptyGuid(param.mediaItem.canonicalId)) ? param.mediaItem.canonicalId : param.serviceId;
                        query = new MS.Entertainment.Data.Query.Music.ArtistTopSongs;
                        query.hasTotalCount = true;
                        query.id = param.mediaItem.canonicalId;
                        query.impressionGuid = param.mediaItem.impressionGuid;
                        query.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.store, Microsoft.Entertainment.Platform.AcquisitionContextType.artist, MS.Entertainment.Utilities.isValidServiceId(param.mediaItem.canonicalId) ? param.mediaItem.canonicalId : String.empty)
                    }
                    if (MS.Entertainment.Utilities.Telemetry.isCurrentPageSearchPage())
                        MS.Entertainment.Utilities.Telemetry.logSearchExit(param.mediaItem, false, "Play");
                    var playMedia = function playMedia() {
                            MS.Entertainment.Instrumentation.PerfTrack.enableScenarioPlayProtectedInApp();
                            MS.Entertainment.Instrumentation.PerfTrack.enableScenarioPlayNonProtectedInApp();
                            MS.Entertainment.Platform.PlaybackHelpers.playMedia2(query, {
                                sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, autoPlay: true, startPositionMsec: param.startPositionMS, showImmersive: !!param.showImmersive, showAppBar: (!!param.showAppBar && !isImmersive), automationId: param.automationId, playPreviewOnly: param.playPreviewOnly, enableFallbackToPreview: !!param.enableFallbackToPreview, immersiveOptions: {
                                        sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, startFullScreen: !param.showDetails, overridePageChange: param.overridePageChange
                                    }, playContext: {
                                        artistSeed: param.mediaItem, isSmartDJ: false
                                    }
                            })
                        };
                    var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    var adService;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.adService))
                        adService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.adService);
                    if (adService && !param.playCollectionItemsOnly && signInService.isSignedIn && !signedInUserService.isSubscription)
                        adService.playVideoAdIfRequired(query).done(function playVideoAdIfRequired_complete(adPlayedIfNeeded) {
                            if (adPlayedIfNeeded) {
                                MS.Entertainment.Instrumentation.PerfTrack.setStartTime(MS.Entertainment.Instrumentation.PerfTrack.StartPoints.PlayCommand);
                                playMedia()
                            }
                        }, function playVideoAdIfRequired_failed(error) {
                            MS.Entertainment.ViewModels.fail("playVideoAdIfRequired_failed: " + error && error.message);
                            playMedia()
                        });
                    else
                        playMedia();
                    return true
                }, canExecutePlay: function canExecutePlay(param) {
                        return param && param.mediaItem && ((param.playCollectionItemsOnly && (MS.Entertainment.Utilities.isValidLibraryId(param.mediaItem.libraryId) || MS.Entertainment.Utilities.isValidLibraryId(param.libraryId))) || (!param.playCollectionItemsOnly && (!MS.Entertainment.Utilities.isEmptyGuid(param.mediaItem.serviceId) || !MS.Entertainment.Utilities.isEmptyGuid(param.serviceId))))
                    }
            }), PlaySmartDJAction: MS.Entertainment.deferredDerive("MS.Entertainment.Platform.PlayAction", function playSmartDJAction() {
                this.base();
                this._uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState)
            }, {
                _addSmartDJTimeout: 5000, _uiStateService: null, _numberOfFeaturedArtistNamesToFind: 2, _numberOfArtistNamesToCheck: 8, _appendArtistName: function _appendArtistName(item, mediaNameLowercase, featuredArtists) {
                        var newArtistNameLowerCase = featuredArtists.length < this._numberOfFeaturedArtistNamesToFind && item && item.data.artist && item.data.artist.name && item.data.artist.name.toLowerCase();
                        if (newArtistNameLowerCase !== mediaNameLowercase) {
                            var matchFound = false;
                            for (var i = 0; i < featuredArtists.length; i++)
                                if (featuredArtists[i] && (newArtistNameLowerCase === featuredArtists[i].toLowerCase()))
                                    matchFound = true;
                            if (!matchFound && item && item.data && item.data.artist && item.data.artist.name)
                                featuredArtists.push(item.data.artist.name)
                        }
                        return WinJS.Promise.wrap(item)
                    }, _addSmartDJ: function _addSmartDJ(mediaItem) {
                        var promise;
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var playbackSession = sessionMgr.nowPlayingSession;
                        var playbackError = playbackSession.playerState === MS.Entertainment.Platform.Playback.PlayerState.error;
                        if (playbackError)
                            promise = WinJS.Promise.wrapError(new Error("Playback failed"));
                        else if (playbackSession.smartDJSeed !== mediaItem)
                            promise = WinJS.Promise.wrap();
                        else if (playbackSession.mediaCollection) {
                            var featuredArtists = [];
                            var mediaNameLowercase = mediaItem.name.toLowerCase();
                            var appendArtistName = function appendArtistName(item) {
                                    return this._appendArtistName(item, mediaNameLowercase, featuredArtists)
                                }.bind(this);
                            promise = MS.Entertainment.Platform.Playback.Playlist.PlaylistCore.forEachItemSequentially(playbackSession.mediaCollection, appendArtistName, this._numberOfArtistNamesToCheck).then(function combineArtists() {
                                var smartDJAddQuery = new MS.Entertainment.Data.Query.Music.SmartDJAdd(mediaItem, featuredArtists);
                                return smartDJAddQuery.execute()
                            }).then(function refreshOnAdd() {
                                var smartDJList = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList);
                                smartDJList.add(mediaItem, featuredArtists);
                                smartDJList.refresh()
                            })
                        }
                        else {
                            var smartDJAddQuery = new MS.Entertainment.Data.Query.Music.SmartDJAdd(mediaItem);
                            return smartDJAddQuery.execute().then(function refreshOnAdd() {
                                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList).refresh()
                                })
                        }
                        return promise.then(null, function smartDJAddFailed(error) {
                                MS.Entertainment.ViewModels.assert(WinJS.Promise.isCanceledError(error), "SmartDJ add failed. Error message: " + (error && error.message));
                                if (MS.Entertainment.Utilities.isMusicApp2) {
                                    var domEvent = document.createEvent("Event");
                                    domEvent.initEvent("dismissoverlay", true, true);
                                    var smartDJOverlay = document.querySelector(".overlayAnchor .overlayContainer");
                                    if (smartDJOverlay)
                                        smartDJOverlay.dispatchEvent(domEvent)
                                }
                            })
                    }, _addSmartDJAfterPlayback: function _addSmartDJAfterPlayback(mediaItem) {
                        var bindings;
                        var completed;
                        var playbackSession = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).nowPlayingSession;
                        function onPlaybackChanged() {
                            if (!bindings)
                                return;
                            var playbackError = playbackSession.playerState === MS.Entertainment.Platform.Playback.PlayerState.error;
                            if (playbackError)
                                completed();
                            else if (playbackSession.smartDJSeed === mediaItem && playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.playing && playbackSession.mediaCollection)
                                playbackSession.mediaCollection.getCount().then(function checkAddedCount(count) {
                                    if (bindings && count > 1)
                                        completed()
                                }, function ignoreError() {
                                    completed()
                                })
                        }
                        var promise = new WinJS.Promise(function initializePromise(c) {
                                completed = c;
                                bindings = WinJS.Binding.bind(playbackSession, {
                                    currentTransportState: onPlaybackChanged, playerState: onPlaybackChanged
                                })
                            }, function canceled(){});
                        promise.then(this._addSmartDJCallback(mediaItem), function ignoreError(){}).done(function clearBindings() {
                            if (bindings) {
                                bindings.cancel();
                                bindings = null
                            }
                        });
                        return promise
                    }, _addSmartDJCallback: function _addSmartDJCallback(mediaItem) {
                        return function addSmartDJ() {
                                this._addSmartDJ(mediaItem)
                            }.bind(this)
                    }, _defaultPlaybackOptions: function _defaultPlaybackOptions(param, artist) {
                        return {
                                sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, autoPlay: true, showImmersive: !!param.showImmersive, showAppBar: (!!param.showAppBar && !this._uiStateService.nowPlayingVisible), shuffle: false, automationId: param.automationId, immersiveOptions: {
                                        sessionId: MS.Entertainment.Platform.Playback.WellKnownPlaybackSessionId.nowPlaying, startFullScreen: !param.showDetails, overridePageChange: param.overridePageChange
                                    }, smartDJSeed: artist, playContext: {
                                        artistSeed: artist, isSmartDJ: true
                                    }
                            }
                    }, _openSmartDjOverlay: function _openSmartDjOverlay(media) {
                        MS.Entertainment.Framework.assert(media, "Clicked media was null");
                        var mediaName = media.artistName || media.name;
                        var overlayContent;
                        MS.Entertainment.UI.Controls.Overlay.showLoadingOverlay({
                            userControl: "MS.Entertainment.UI.Controls.FailedPanel", hideOnNowPlaying: true, onInitialize: function processOverlay(overlayContent) {
                                    return WinJS.UI.process(overlayContent).then(function setModel() {
                                            overlayContent.winControl.model = {
                                                primaryStringId: null, primaryText: String.load(String.id.IDS_SMARTDJ_LOADING_TEXT).format(mediaName), closeTimeoutMS: this._addSmartDJTimeout
                                            }
                                        }.bind(this))
                                }.bind(this)
                        })
                    }, executedPlay: function executedPlay(param) {
                        var primaryStringId;
                        var secondaryStringId;
                        var error = false;
                        var networkStatus = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).networkStatus;
                        if (networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.localOnly || networkStatus === MS.Entertainment.UI.NetworkStatusService.NetworkStatus.none) {
                            error = true;
                            primaryStringId = String.id.IDS_SMARTDJ_OFFINE_ERROR_TITLE;
                            secondaryStringId = String.id.IDS_SMARTDJ_OFFINE_ERROR_DESC
                        }
                        var sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        if (sessionManager.primarySession && sessionManager.primarySession.isRemoteSession && sessionManager.primarySession.isRemoteSession() && !(Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToByRef && MS.Entertainment.Utilities.isWindowsBlue)) {
                            error = true;
                            primaryStringId = String.id.IDS_MUSIC_PLAY_TO_DISABLED_TEXT
                        }
                        if (error) {
                            var size = MS.Entertainment.Utilities.popOverDefaultSize;
                            var options = {
                                    userControl: MS.Entertainment.UI.Controls.FailedPanel, width: size.width ? size.width.toString() : String.empty, height: size.height ? size.height.toString() : String.empty, userControlOptions: {model: {
                                                primaryStringId: primaryStringId, secondaryStringId: secondaryStringId
                                            }}
                                };
                            return new MS.Entertainment.UI.Controls.PopOver(document.createElement("div"), options).show()
                        }
                        var query,
                            id;
                        if (MS.Entertainment.Utilities.Telemetry.isCurrentPageSearchPage())
                            MS.Entertainment.Utilities.Telemetry.logSearchExit(mediaItem, false, "Play");
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits)) {
                            var freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                            if (freePlayLimits.isMonthlyFreeLimitExceeded)
                                return freePlayLimits.showMonthlyFreeLimitExceededDialog()
                        }
                        var mediaItem = param.mediaItem;
                        var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        var playbackSession = sessionMgr.nowPlayingSession;
                        var adService;
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.adService))
                            adService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.adService);
                        var playActionPromise = function playActionPromise() {
                                var adPromise;
                                if (adService)
                                    adPromise = adService.playVideoAdIfRequired(mediaItem, null, true).then(function playVideoAdIfRequired_complete(adPlayedIfNeeded) {
                                        return adPlayedIfNeeded
                                    }, function playVideoAdIfRequired_failed(error) {
                                        MS.Entertainment.ViewModels.fail("playVideoAdIfRequired_failed: " + error);
                                        return true
                                    });
                                else
                                    adPromise = WinJS.Promise.as(true);
                                return adPromise.then(function onAdPlayed_Complete(adPlayedIfNeeded) {
                                        if (!adPlayedIfNeeded)
                                            return false;
                                        if (MS.Entertainment.Utilities.isMusicApp2)
                                            this._openSmartDjOverlay(mediaItem);
                                        if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.person && mediaItem.personType === Microsoft.Entertainment.Queries.PersonType.artist) {
                                            query = new MS.Entertainment.Data.Query.Music.SmartDJ;
                                            query.id = mediaItem.canonicalId;
                                            query.impressionGuid = mediaItem.impressionGuid;
                                            query.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.smartDJ, Microsoft.Entertainment.Platform.AcquisitionContextType.artist, MS.Entertainment.Utilities.isValidServiceId(mediaItem.canonicalId) ? mediaItem.canonicalId : String.empty);
                                            var defaultOptions = this._defaultPlaybackOptions(param, mediaItem);
                                            MS.Entertainment.Platform.PlaybackHelpers.playMedia2(query, defaultOptions);
                                            var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                            if (signInService.isSignedIn)
                                                WinJS.Promise.timeout(this._addSmartDJTimeout, this._addSmartDJAfterPlayback(mediaItem)).then(null, this._addSmartDJCallback(mediaItem));
                                            return true
                                        }
                                        else
                                            return this._playTrackOrAlbum(param)
                                    }.bind(this))
                            }.bind(this);
                        return playActionPromise()
                    }, _playTrackOrAlbum: function _playTrackOrAlbum(param) {
                        var trackPromise;
                        var mediaPlayed = false;
                        var mediaItem = param.mediaItem;
                        var defaultOptions = this._defaultPlaybackOptions(param, mediaItem.artist || mediaItem);
                        var trackQuery = null;
                        var canPlayLocallyOrStreamFromCloud = false;
                        if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.track)
                            if (!mediaItem.rights && mediaItem.inCollection) {
                                if (mediaItem.canPlayLocally || mediaItem.hasPurchased || !mediaItem.isFreeStreamRestrictedByIndividualLimit)
                                    canPlayLocallyOrStreamFromCloud = true;
                                else {
                                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                    if (signedInUser && signedInUser.isSubscription)
                                        canPlayLocallyOrStreamFromCloud = true
                                }
                                canPlayLocallyOrStreamFromCloud = true;
                                trackPromise = mediaItem
                            }
                            else
                                trackPromise = mediaItem;
                        else if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.album && mediaItem.canonicalId) {
                            trackQuery = new MS.Entertainment.Data.Query.Music.AlbumSongs;
                            trackQuery.id = mediaItem.canonicalId;
                            trackQuery.orderBy = MS.Entertainment.Data.Query.edsSortOrder.mostPopular;
                            trackQuery.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.smartDJ, Microsoft.Entertainment.Platform.AcquisitionContextType.artist);
                            trackPromise = trackQuery.execute().then(function getTracks(queryResult) {
                                return queryResult.getItems().then(function getTopTrack(trackList) {
                                        if (trackList !== null && trackList.count)
                                            return trackList.itemsFromIndex(0, 0, 0).then(function unwrapTopTrack(trackList) {
                                                    return trackList.items[trackList.offset].data
                                                })
                                    })
                            }, function handleFailure(error) {
                                MS.Entertainment.ViewModels.fail("Failed to get a list of tracks from the album. Error message: " + error && error.message);
                                return null
                            })
                        }
                        return WinJS.Promise.as(trackPromise).then(function gotTrack(track) {
                                if (track) {
                                    var hasSubscriptionStreamingRights = MS.Entertainment.ViewModels.SmartBuyStateHandlers._mediaHasAnyRight(track, MS.Entertainment.ViewModels.SmartBuyStateHandlers.Tuner.Windows, [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Stream]);
                                    var hasFreeStreamingRights = MS.Entertainment.ViewModels.SmartBuyStateHandlers._mediaHasAnyRight(track, MS.Entertainment.ViewModels.SmartBuyStateHandlers.Tuner.Windows, [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.FreeStream]);
                                    var signedInUserService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                    var signedInUserHasSubscription = signedInUserService.isSubscription;
                                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                                    var freeStreamEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay);
                                    if (canPlayLocallyOrStreamFromCloud || (signedInUserHasSubscription && hasSubscriptionStreamingRights) || (freeStreamEnabled && hasFreeStreamingRights)) {
                                        var trackOptions = this._defaultPlaybackOptions(param, track.artist);
                                        trackOptions.queueMedia = false;
                                        var currentSession = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).primarySession;
                                        if (currentSession.currentMedia && currentSession.currentMedia.serviceId === track.serviceId)
                                            trackOptions.startPositionMsec = currentSession.currentPosition;
                                        MS.Entertainment.Platform.PlaybackHelpers.playMedia2(track, trackOptions);
                                        defaultOptions.queueMedia = true;
                                        defaultOptions.autoPlay = null;
                                        mediaPlayed = true
                                    }
                                }
                                mediaItem = MS.Entertainment.ViewModels.MediaItemModel.augment(mediaItem.artist);
                                return mediaItem.hydrate()
                            }.bind(this)).then(function smartDJHydrateCompleted() {
                                var query = new MS.Entertainment.Data.Query.Music.SmartDJ;
                                query.id = mediaItem.canonicalId;
                                query.impressionGuid = mediaItem.impressionGuid;
                                var acquisitionContextID = MS.Entertainment.Utilities.isValidServiceId(mediaItem.canonicalId) ? mediaItem.canonicalId : String.empty;
                                if (trackQuery && trackQuery.acquisitionData)
                                    trackQuery.acquisitionData.acquisitionContextID = acquisitionContextID;
                                query.acquisitionData = new MS.Entertainment.Utilities.AcquisitionData(Microsoft.Entertainment.Platform.AcquisitionContext.smartDJ, Microsoft.Entertainment.Platform.AcquisitionContextType.artist, acquisitionContextID);
                                MS.Entertainment.Platform.PlaybackHelpers.playMedia2(query, defaultOptions);
                                mediaPlayed = true;
                                var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                if (signInService.isSignedIn)
                                    WinJS.Promise.timeout(this._addSmartDJTimeout, this._addSmartDJAfterPlayback(mediaItem)).then(null, this._addSmartDJCallback(mediaItem));
                                return mediaPlayed
                            }.bind(this), function smartDJHydrateFailed(error) {
                                MS.Entertainment.ViewModels.fail("SmartDJ artist hydrate failed. Error message: " + error && error.message);
                                return mediaPlayed
                            })
                    }, canExecutePlay: function canExecutePlay(param) {
                        return true
                    }
            }), DeleteSmartDJAction: MS.Entertainment.deferredDerive(MS.Entertainment.UI.Actions.Action, function deleteSmartDJAction() {
                this.base()
            }, {
                automationId: MS.Entertainment.UI.AutomationIds.smartButtonDeleteSmartDj, executed: function executed(param) {
                        var selectionIndices;
                        var selectionSourceIndices;
                        var itemPromise;
                        if (MS.Entertainment.Data.List.isList(param.mediaItems)) {
                            selectionIndices = param.mediaItems.originalSelectionIndices;
                            selectionSourceIndices = param.mediaItems.originalSelectionSourceIndices;
                            itemPromise = param.mediaItems.itemsFromIndex(0, 0, 0).then(function gotFirstItem(args) {
                                var item = args.items[args.offset];
                                return item.data
                            })
                        }
                        else if (param.mediaItems && param.mediaItems.index >= 0) {
                            selectionSourceIndices = [param.mediaItems.index];
                            itemPromise = WinJS.Promise.wrap(param.mediaItems)
                        }
                        else
                            return WinJS.Promise.wrapError("We only support deleting SmartDJ items via a selection list or a SmartDJ item");
                        return itemPromise.then(function gotFirstItem(mediaItem) {
                                return mediaItem && mediaItem.listVersion
                            }, function failedToGetFirstItem(error) {
                                MS.Entertainment.ViewModels.fail("Failed to get first item from SmartDJ selection. error: " + (error && error.message));
                                return 0
                            }).then(function gotListVersion(listVersion) {
                                MS.Entertainment.ViewModels.assert(listVersion >= 0, "Invalid list version in delete action.");
                                var smartDJDeleteQuery = new MS.Entertainment.Data.Query.Music.SmartDJDelete(selectionSourceIndices, listVersion || 0);
                                return smartDJDeleteQuery.execute()
                            }).then(function refreshQueryOnDelete() {
                                var smartDJList = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList);
                                smartDJList.remove(selectionIndices);
                                smartDJList.refresh()
                            }, function refreshQueryOnDelete() {
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList).refresh()
                            })
                    }, canExecute: function canExecute() {
                        return true
                    }
            })
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.playArtist, function() {
        return new MS.Entertainment.ViewModels.PlayArtistAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.playSmartDJ, function() {
        return new MS.Entertainment.ViewModels.PlaySmartDJAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.playQuery, function() {
        return new MS.Entertainment.ViewModels.PlayQueryAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.refreshCollection, function() {
        return new MS.Entertainment.ViewModels.refreshCollectionAction
    });
    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).register(MS.Entertainment.UI.Actions.ActionIdentifiers.deleteSmartDJ, function() {
        return new MS.Entertainment.ViewModels.DeleteSmartDJAction
    });
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {SmartDJList: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.AugmentationWrapperQuery", function smartDJListConstructor(addNewSmartDJAction) {
            this._addNewSmartDJAction = addNewSmartDJAction;
            var query = this._createQuery();
            MS.Entertainment.Data.AugmentationWrapperQuery.prototype.constructor.call(this, query);
            if (this.autoUpdateProperties)
                this.autoUpdateProperties.enabled = false;
            this.enabled = true;
            this._listVersion = {version: null};
            var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
            this._signInHandler = WinJS.Binding.bind(signInService, {isSignedIn: function(value, oldValue) {
                    if (this._signInHandler)
                        this.refresh()
                }.bind(this)})
        }, {
            _queryActivePromise: null, _queryCompletedPromise: null, _updateResults: true, _listVersion: null, _lockedResult: null, _lockResult: false, _listOwnerXuid: null, _addNewSmartDJAction: false, dispose: function dispose() {
                    MS.Entertainment.Data.AugmentationWrapperQuery.prototype.dispose.call(this);
                    if (this._signInHandler) {
                        this._signInHandler.cancel();
                        this._signInHandler = null
                    }
                }, lockResult: {
                    get: function get_lockResult() {
                        return this._lockResult
                    }, set: function set_lockResult(value) {
                            if (value !== this._lockResult) {
                                this._lockResult = value;
                                if (value)
                                    this._lockedResult = this.innerResult;
                                else
                                    this._lockedResult = null
                            }
                        }
                }, add: function add(mediaItem, featuredArtists) {
                    if (mediaItem && this.result && this.result.items) {
                        var smartDJ = MS.Entertainment.Data.Query.Music.SmartDJAdd.convertArtistToSmartDJ(mediaItem, featuredArtists);
                        var matchingIndex = -1;
                        this.result.items.forEachAll(function findMatchingArtist(args) {
                            if (args.item.data && args.item.data.artist && args.item.data.artist.isEqual(mediaItem)) {
                                matchingIndex = args.item.itemIndex;
                                args.stop = true
                            }
                        }).done(function intsertNewOrMoveOld() {
                            var insertIndex = -1;
                            if (this.result && this.result.items)
                                insertIndex = this.result.items.indexFromSourceIndex(0);
                            if (insertIndex >= 0)
                                if (matchingIndex >= 0)
                                    this.result.items.moveAt(matchingIndex, insertIndex);
                                else
                                    this.result.items.insertAt(insertIndex, smartDJ, {isSourceData: true})
                        }.bind(this), function handleError(error) {
                            MS.Entertainment.ViewModels.fail("forEachAll failed. Failed to find a matching artist. error: " + (error & error.message))
                        })
                    }
                }, remove: function remove(indices) {
                    if (indices && indices.length && this.result && this.result.items)
                        this.result.items.removeIndices(indices).done(null, function ignoreError(error) {
                            MS.Entertainment.ViewModels.fail("Failed to remove items in smart dj list. error: " + (error && error.message))
                        })
                }, result: {
                    get: function() {
                        return this._lockedResult ? this._lockedResult : this.innerResult
                    }, set: function(value) {
                            this.innerResult = value
                        }
                }, innerResult: {
                    get: function() {
                        return this.query ? this.query.result : null
                    }, set: function(value) {
                            if (this.query && this.query.result)
                                this.query.result = value
                        }
                }, _createQuery: function _createQuery() {
                    var query = new MS.Entertainment.Data.Query.Music.SmartDJList;
                    if (query.autoUpdateProperties)
                        query.autoUpdateProperties.enabled = false;
                    query.enabled = true;
                    return query
                }, _getXuid: function _getXuid() {
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    return configurationManager.service.lastSignedInUserXuid
                }, execute: function execute(cookie, avoidRefresh) {
                    var queryPromise;
                    var newListOwner = this._getXuid();
                    if (newListOwner !== this._listOwnerXuid) {
                        this._queryCompletedPromise = null;
                        this._queryActivePromise = null
                    }
                    if (this._queryActivePromise)
                        queryPromise = this._queryActivePromise;
                    else if (this._queryCompletedPromise && avoidRefresh)
                        queryPromise = this._queryCompletedPromise;
                    else {
                        this._listOwnerXuid = newListOwner;
                        if (this.lockResult || !this.query)
                            this.query = this._createQuery();
                        if (this.query)
                            this.query.xuid = this._listOwnerXuid;
                        queryPromise = MS.Entertainment.Data.AugmentationWrapperQuery.prototype.execute.call(this, cookie).then(function changeResult() {
                            return this
                        }.bind(this));
                        this._queryActivePromise = queryPromise;
                        this._queryCompletedPromise = null;
                        queryPromise.done(function setCompletedPromiseOnSuccess() {
                            if (this._queryActivePromise === queryPromise) {
                                this._queryCompletedPromise = this._queryActivePromise;
                                this._queryActivePromise = null
                            }
                        }.bind(this), function clearCompletedPromiseOnError(error) {
                            if (this._queryActivePromise === queryPromise) {
                                this._queryCompletedPromise = null;
                                this._queryActivePromise = null;
                                MS.Entertainment.ViewModels.assert(!this._listOwnerXuid || WinJS.Promise.isCanceledError(error), "Executing SmartDJList query has failed. error: " + (error && error.description), null, MS.Entertainment.UI.Debug.errorLevel.low)
                            }
                        }.bind(this))
                    }
                    return queryPromise
                }, _queryResultChanged: function _queryResultChanged(args) {
                    if (args.detail && !args.detail.error) {
                        this._updateResultItemFactory();
                        this._addNewSmartDJActionIfNeeded();
                        if (this._query) {
                            var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                            configurationManager.mdlc.radioCollectionSize = this._query.totalCount
                        }
                    }
                    if (!this.lockResult)
                        MS.Entertainment.Data.AugmentationWrapperQuery.prototype._queryResultChanged.apply(this, arguments)
                }, _addNewSmartDJActionIfNeeded: function _addNewSmartDJActionIfNeeded() {
                    if (this._addNewSmartDJAction && this.innerResult && this.innerResult.items)
                        this.innerResult.items.itemsFromIndex(0, 0, 0).done(function gotFirstItem(args) {
                            var item = args.items[args.offset];
                            if (!item || !item.isAction)
                                this._addNewSmartDJActionWorker();
                            else
                                MS.Entertainment.ViewModels.fail("Action cell already exists. We shouldn't even be asking to add another action cell to the list.")
                        }.bind(this), function ignoreError(error) {
                            MS.Entertainment.ViewModels.fail("Failed to get first list item when checking for action cell. Error: " + (error && error.message))
                        })
                }, _addNewSmartDJActionWorker: function _addNewSmartDJActionWorker() {
                    var actionIndentifier;
                    var actionOptions;
                    var actionCell;
                    if (MS.Entertainment.Utilities.isMusicApp1) {
                        actionIndentifier = MS.Entertainment.UI.Actions.ActionIdentifiers.selectArtist;
                        actionOptions = {isSmartDJ: true};
                        var actionCell = new MS.Entertainment.ViewModels.ActionCell(actionIndentifier, actionOptions);
                        actionCell.icon = MS.Entertainment.UI.Icon.smartDj;
                        actionCell.stringId = String.id.IDS_MUSIC_ENGAGE_NEW_SMARTDJ_ACTION;
                        actionCell.hideDefaultRing = true;
                        if (this.innerResult && this.innerResult.items)
                            this.innerResult.items.insertAt(0, new MS.Entertainment.Data.Factory.ListActionItemWrapper(actionCell))
                    }
                    return this
                }, _createItemFactory: function _createItemFactory(originalFactory, listVersion) {
                    var itemFactory = function itemFactory(source) {
                            var item = originalFactory(source);
                            if (item && item.data)
                                Object.defineProperty(item.data, "listVersion", {
                                    get: function() {
                                        var version = listVersion && listVersion.version;
                                        return version || 0
                                    }, configurable: true
                                });
                            return item
                        };
                    itemFactory.listItemFactory = true;
                    return itemFactory
                }, _updateResultItemFactory: function _updateResultItemFactory() {
                    if (this.innerResult) {
                        this._listVersion.version = this.innerResult.listVersion;
                        if (this.innerResult.items)
                            this.innerResult.items.setItemFactory(this._createItemFactory(this.innerResult.items.itemFactory, this._listVersion))
                    }
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.ViewModels", {SmartDJListQueryType: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.AugmentationWrapperQuery", function smartDJListQueryType() {
            var smartDJListService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList);
            MS.Entertainment.Data.AugmentationWrapperQuery.prototype.constructor.call(this, smartDJListService)
        }, {
            autoDisposeQuery: false, chunkSize: {
                    get: function get_chunkSize() {
                        return 25
                    }, set: function set_chunkSize() {
                            MS.Entertainment.ViewModels.fail("Shouldn't be changing chunkSize for the SmartDJ query")
                        }
                }, aggregateChunks: {
                    get: function get_aggregateChunks() {
                        return true
                    }, set: function set_aggregateChunks() {
                            MS.Entertainment.ViewModels.fail("Shouldn't be changing aggregateChunks for the SmartDJ query")
                        }
                }, execute: function execute(cookie) {
                    var result;
                    if (this.query)
                        result = this.query.execute(cookie, !cookie).then(function changeResult() {
                            return this
                        }.bind(this));
                    else
                        result = WinJS.Promise.wrapError(new Error("Invalid state for executing. The query property was not set to a valid value."));
                    return result
                }
        })});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.smartDJList, function getSmartDJListService() {
        var addNewSmartDJAction = !window.onNewMusicPage;
        return new MS.Entertainment.ViewModels.SmartDJList(addNewSmartDJAction)
    })
})()
