﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
    LibraryFeaturedDataNotificationHandler: MS.Entertainment.UI.Framework.define(function libraryFeaturedDataNotificationHandler(listUpdateCallback, itemUpdateCallback) {
        this._listUpdateCallback = listUpdateCallback;
        this._itemUpdateCallback = itemUpdateCallback
    }, {
        _listUpdateCallback: null, _itemUpdateCallback: null, dispose: function dispose() {
                this._listUpdateCallback = null;
                this._itemUpdateCallback = null
            }, inserted: function inserted(item, previousKey, nextKey, index) {
                if (this._listUpdateCallback)
                    this._listUpdateCallback(index)
            }, changed: function changed(newItem, oldItem) {
                if (this._itemUpdateCallback)
                    this._itemUpdateCallback(newItem, oldItem)
            }, moved: function moved(item, previousKey, nextKey, oldIndex, newIndex){}, removed: function removed(key, index) {
                if (this._listUpdateCallback)
                    this._listUpdateCallback(index, key)
            }, countChanged: function countChanged(newCount, oldCount){}
    }), NoContentPane: MS.Entertainment.UI.Framework.defineUserControl("Controls/LibraryFeaturedContent.html#noContentPaneTemplate", null, {
            _modelBindings: null, initialize: function initialize() {
                    if (this.model) {
                        if (this.model.primaryText)
                            this.title = this.model.primaryText;
                        else if (this.model.primaryStringId)
                            this.title = String.load(this.model.primaryStringId);
                        if (this.model.secondaryText)
                            this.description = this.model.secondaryText;
                        else if (this.model.secondaryStringId)
                            this.description = String.load(this.model.secondaryStringId);
                        this._modelBindings = WinJS.Binding.bind(this.model, {details: this._onDetailsChanged.bind(this)})
                    }
                }, unload: function unload() {
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this);
                    if (this._modelBindings) {
                        this._modelBindings.cancel();
                        this._modelBindings = null
                    }
                }, _onDetailsChanged: function _onDetailsChanged(newValue) {
                    this.details = newValue
                }
        }, {
            title: null, description: null, details: null, model: null
        })
});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryFeaturedContent: MS.Entertainment.UI.Framework.defineUserControl(null, function libraryFeaturedContentConstructor(element, options) {
        this._queryWatcher = new MS.Entertainment.Framework.QueryWatcher("libraryFeaturedContent");
        this._rebuildDataOnWindowSizeChange = this._rebuildDataOnWindowSizeChange.bind(this)
    }, {
        _queryResults: null, _itemsVisible: -1, _queryWatcher: null, _populateTimeout: null, controlName: "LibraryFeaturedContent", _fileTransferListenerId: null, _pendingLoadPromises: null, _onScreen: true, _queryEventHandlers: null, _currentlySelectedItem: null, hidePanelWhenEmpty: false, _maxItems: {get: function get_maxItems() {
                    return MS.Entertainment.Utilities.HIGH_RESOLUTION_ROWS * 3
                }}, initialize: function initialize() {
                this.bind("libraryQuery", function libraryQueryChanged() {
                    this._cancelPendingLoads();
                    this._unregisterContentNotificationListeners();
                    var pendingLoadPromisesArray = [];
                    var pendingLoadPromises;
                    if (this.libraryQuery && this._loadFeaturedItems)
                        if (Array.isArray(this.libraryQuery)) {
                            this._queryResults = [];
                            this._fileTransferListenerId = [];
                            for (var i = 0; i < this.libraryQuery.length; i++) {
                                this._fileTransferListenerId[i] = "LibraryFeaturedContent_" + Date.now() + "_" + Math.random();
                                pendingLoadPromisesArray.push(this._loadFeaturedItems(i))
                            }
                        }
                        else {
                            this._fileTransferListenerId = "LibraryFeaturedContent_" + Date.now() + "_" + Math.random();
                            pendingLoadPromisesArray.push(this._loadFeaturedItems())
                        }
                    pendingLoadPromises = WinJS.Promise.join(pendingLoadPromisesArray);
                    this._pendingLoadPromises = pendingLoadPromises;
                    pendingLoadPromises.done(function loadingComplete() {
                        if (pendingLoadPromises === this._pendingLoadPromises)
                            this._pendingLoadPromises = null
                    }.bind(this), function loadingFailed() {
                        if (pendingLoadPromises === this._pendingLoadPromises) {
                            this._pendingLoadPromises = null;
                            if (!this._queryResults || !this._queryResults.length)
                                this._updateItems([])
                        }
                    }.bind(this))
                }.bind(this))
            }, unload: function unload() {
                this._cancelPendingLoads();
                if (this._populateTimeout) {
                    this._populateTimeout.cancel();
                    this._populateTimeout = null
                }
                if (this._queryEventHandlers) {
                    this._queryEventHandlers.cancel();
                    this._queryEventHandlers = null
                }
                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).removeEventListener("windowresize", this._rebuildDataOnWindowSizeChange);
                MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
            }, freeze: function freeze() {
                this.onOffScreen();
                MS.Entertainment.UI.Framework.UserControl.prototype.freeze.call(this)
            }, thaw: function thaw() {
                MS.Entertainment.UI.Framework.UserControl.prototype.thaw.call(this);
                this.onOnScreen()
            }, onOffScreen: function onOffScreen() {
                if (this._onScreen)
                    this._pauseQueries();
                this._onScreen = false
            }, onOnScreen: function onOnScreen() {
                if (!this._onScreen)
                    this._unPauseQueries();
                this._onScreen = true
            }, onItemSelected: function onItemSelected(e) {
                this._pauseQueries();
                this._currentlySelectedItem = e.srcElement
            }, onItemDeselected: function onItemDeselected(e) {
                if (e.srcElement === this._currentlySelectedItem) {
                    this._unPauseQueries();
                    this._currentlySelectedItem = null
                }
            }, _pauseQueries: function _pauseQueries() {
                if (this.libraryQuery)
                    if (Array.isArray(this.libraryQuery))
                        this.libraryQuery.forEach(function unpauseQuery(query) {
                            if (query.pause)
                                query.pause()
                        });
                    else if (this.libraryQuery.pause)
                        this.libraryQuery.pause()
            }, _unPauseQueries: function _unPauseQueries() {
                if (this.libraryQuery)
                    if (Array.isArray(this.libraryQuery))
                        this.libraryQuery.forEach(function unpauseQuery(query) {
                            if (query.unpause)
                                query.unpause()
                        });
                    else if (this.libraryQuery.unpause)
                        this.libraryQuery.unpause()
            }, _cancelPendingLoads: function _cancelPendingLoads() {
                if (this._pendingLoadPromises) {
                    this._pendingLoadPromises.cancel();
                    this._pendingLoadPromises = null
                }
            }, _loadFeaturedItems: function _loadFeaturedItems(index) {
                var query = (index >= 0) ? this.libraryQuery[index] : this.libraryQuery;
                var listenerId = (index >= 0) ? this._fileTransferListenerId[index] : this._fileTransferListenerId;
                var sender = this._modifyQueryForContentNotifications(query);
                this._queryWatcher.registerQuery(query);
                if ("isLive" in query)
                    query.isLive = true;
                if (this._queryEventHandlers) {
                    this._queryEventHandlers.cancel();
                    this._queryEventHandlers = null
                }
                return query.execute().then(function libraryFeaturedContentQueryComplete(q) {
                        if (index >= 0)
                            this._queryResults[index] = q.result.items;
                        else
                            this._queryResults = q.result.items;
                        this._registerContentNotificationListener(sender, listenerId);
                        if (q.isLive)
                            q.result.items.setNotificationHandler(new MS.Entertainment.UI.Controls.LibraryFeaturedDataNotificationHandler(this._handleDataNotifications.bind(this), this._handleDataUpdates.bind(this)));
                        this._queryEventHandlers = MS.Entertainment.Utilities.addEventHandlers(q, {resultChanged: function handleQueryResultChanged() {
                                this._handleQueryResultChanged(query, index)
                            }.bind(this)});
                        this._populateContent();
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).addEventListener("windowresize", this._rebuildDataOnWindowSizeChange)
                    }.bind(this), function libraryFeaturedContentQueryError(q) {
                        return null
                    }.bind(this))
            }, _handleQueryResultChanged: function _handleQueryResultChanged(query, index) {
                if (index >= 0)
                    this._queryResults[index] = query.result && query.result.items;
                else
                    this._queryResults = query.result && query.result.items;
                this._populateContent()
            }, _rebuildDataOnWindowSizeChange: function _rebuildDataOnWindowSizeChange() {
                this._populateContent(true)
            }, _handleDataUpdates: function _handleDateUpdates(newItem, oldItem){}, _handleDataNotifications: function _handleDataNotifications(index, key) {
                MS.Entertainment.UI.Controls.assert(this._populateContent, "For db updates, LibraryFeaturedContent requires _populateContent defined");
                if (index > this._maxItems)
                    return;
                if (!key) {
                    if (!this.items || this._itemsVisible <= 0 || this.items.length < this._itemsVisible || index < this._itemsVisible)
                        this._deferredPopulateContent()
                }
                else
                    for (var i = 0; i < this.items.length; i++)
                        if (this.items[i].key === key) {
                            this._deferredPopulateContent();
                            break
                        }
            }, _deferredPopulateContent: function _deferredPopulateContent() {
                if (this._populateTimeout) {
                    this._populateTimeout.cancel();
                    this._populateTimeout = null
                }
                this._populateTimeout = WinJS.Promise.timeout(300).then(this._populateContent.bind(this), function cancelledHandler(error){})
            }, _updateItems: function _updateItems(libraryItems) {
                if (!this._content || !this._emptyContent)
                    return;
                var hasItems = libraryItems && libraryItems.length > 0;
                if (!hasItems) {
                    WinJS.Utilities.addClass(this._content.domElement, "removeFromDisplay");
                    WinJS.Utilities.removeClass(this._emptyContent.noContentPane, "removeFromDisplay");
                    WinJS.Utilities.addClass(this._emptyContent.noContentPane, this.emptyLibraryStyle)
                }
                else {
                    WinJS.Utilities.removeClass(this._content.domElement, "removeFromDisplay");
                    WinJS.Utilities.addClass(this._emptyContent.noContentPane, "removeFromDisplay");
                    WinJS.Utilities.removeClass(this._emptyContent.noContentPane, this.emptyLibraryStyle)
                }
                if (this.hidePanelWhenEmpty) {
                    var rootElement = MS.Entertainment.Utilities.findParentElementByClassName(this.domElement, "dashboardPanel");
                    if (hasItems)
                        WinJS.Utilities.removeClass(rootElement, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(rootElement, "removeFromDisplay")
                }
                this.items = libraryItems;
                MS.Entertainment.UI.Controls.Panel.raisePanelReady(this.domElement)
            }, _unregisterContentNotificationListeners: function _unregisterContentNotificationListeners() {
                if (this._fileTransferListenerId && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.fileTransfer)) {
                    var fileTransferService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransfer);
                    if (Array.isArray(this._fileTransferListenerId))
                        for (var i = 0; i < this._fileTransferListenerId.length; i++) {
                            fileTransferService.unregisterListener(this._fileTransferListenerId[i]);
                            this._fileTransferListenerUnregistered(fileTransferService, this._fileTransferListenerId[i])
                        }
                    else {
                        fileTransferService.unregisterListener(this._fileTransferListenerId);
                        this._fileTransferListenerUnregistered(fileTransferService, this._fileTransferListenerId)
                    }
                }
            }, _modifyQueryForContentNotifications: function _modifyQueryForContentNotifications(query) {
                var sender = null;
                return sender
            }, _registerContentNotificationListener: function _registerContentNotificationListener(sender, listenerId){}, _fileTransferListenerUnregistered: function _fileTransferListenerUnregistered(fileTransferService, listenerId){}, _filterNotifications: function _filterNotifications(notificationId) {
                return false
            }
    }, {
        items: undefined, emptyLibraryStyle: null, emptyLibraryModel: null, libraryClicked: null, libraryQuery: null
    })});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryVideoFeaturedContent: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.LibraryFeaturedContent", "Controls/LibraryFeaturedContent.html#libraryVideoContentTemplate", function(element, options) {
        this.emptyLibraryStyle = "noVideoContentPane"
    }, {
        _itemsVisible: 0, itemsColumns: 2, propertyName: ['videoType', 'mediaType'], containerStyle: 'dashboardGridPersonalItemContent', itemSize: MS.Entertainment.Utilities.personalTileSize, showNavigateToCollectionButton: true, viewMoreInfo: {
                icon: WinJS.UI.AppBarIcon.more, title: null
            }, _notifications: null, initialize: function initialize() {
                this.updateSettings();
                MS.Entertainment.UI.Controls.LibraryFeaturedContent.prototype.initialize.call(this)
            }, updateSettings: function updateSettings() {
                if (this._content) {
                    this._content.itemSize = this.itemSize;
                    this._content.propertyName = this.propertyName;
                    this._content.containerStyle = this.containerStyle;
                    this._content.itemTemplates = MS.Entertainment.Utilities.isVideoApp1 ? [{
                            value: Microsoft.Entertainment.Queries.VideoType.movie, template: '/Components/Video/VideoStartupTemplates.html#moviePosterTile'
                        }, {
                            value: Microsoft.Entertainment.Queries.VideoType.other, template: '/Components/Video/VideoStartupTemplates.html#personalFileTileL1Small'
                        }, {
                            value: Microsoft.Entertainment.Queries.ObjectType.tvSeries, template: '/Components/Video/VideoStartupTemplates.html#tvSeriesTile'
                        }, {
                            value: 'actionButton', template: '/Components/Video/VideoStartupTemplates.html#dashboardEngagePanelButton'
                        }] : [{
                            value: Microsoft.Entertainment.Queries.VideoType.movie, template: '/Components/Video/VideoStartupTemplates2.html#moviePosterTile'
                        }, {
                            value: Microsoft.Entertainment.Queries.ObjectType.tvSeries, template: '/Components/Video/VideoStartupTemplates2.html#tvSeriesTile'
                        }, {
                            value: 'actionButton', template: '/Components/Video/VideoStartupTemplates2.html#dashboardEngagePanelButton'
                        }]
                }
            }, _maxItems: {get: function get_maxItems() {
                    return MS.Entertainment.Utilities.HIGH_RESOLUTION_VIDEO_ROWS * this.itemsColumns
                }}, _updateItems: function _updateItems(libraryItems) {
                var totalItems = this.itemsColumns * MS.Entertainment.Utilities.getRowCountForResolution();
                this.viewMoreButtonVisible = (MS.Entertainment.Utilities.isApp2 && this.showNavigateToCollectionButton && libraryItems && libraryItems.length > 0 && libraryItems.length >= totalItems);
                MS.Entertainment.UI.Controls.LibraryFeaturedContent.prototype._updateItems.apply(this, arguments)
            }, _viewMoreClicked: function _viewMoreClicked() {
                if (this.panelAction && this.panelAction.action)
                    this.panelAction.action.execute()
            }, _getRowCountForResolution: function _getRowCountForResolution() {
                return MS.Entertainment.Utilities.getRowCountForResolution()
            }, _populateContent: function _populateContent(validateItemsNeeded) {
                var totalItems = this.itemsColumns * this._getRowCountForResolution();
                var setProperty = MS.Entertainment.Utilities.BindingAgnostic.setProperty;
                this.updateSettings();
                if (validateItemsNeeded && (totalItems === this._itemsVisible) && (this.items && this.items.length > 0))
                    return;
                this._itemsVisible = totalItems;
                var goodItems = [];
                return this._queryResults.forEachAll(function populateData(args) {
                        var item = args.item.data;
                        setProperty(item, "doclick", this.libraryClicked);
                        if (this.libraryQuery.queryId)
                            setProperty(item, "queryId", this.libraryQuery.queryId);
                        item.key = args.item.key;
                        if (item.mediaType === Microsoft.Entertainment.Queries.ObjectType.video || item.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeries)
                            goodItems.push(item);
                        if (goodItems.length >= this._itemsVisible)
                            args.stop = true
                    }.bind(this)).then(function updateItems() {
                        this._updateItems(goodItems)
                    }.bind(this))
            }, _modifyQueryForContentNotifications: function _modifyQueryForContentNotifications(query) {
                var sender = null;
                if (query && query.status === MS.Entertainment.Data.queryStatus.idle) {
                    this._notifications = new MS.Entertainment.UI.ContentNotification.NotificationModification(MS.Entertainment.UI.ContentNotification.listResult(), MS.Entertainment.UI.ContentNotification.idFromProperty("libraryId"));
                    this._notifications.modifyQuery(query);
                    sender = this._notifications.createSender()
                }
                return sender
            }, _handleDataUpdates: function _handleDataUpdates(newItem) {
                MS.Entertainment.UI.Controls.LibraryFeaturedContent.prototype._handleDataUpdates.apply(this, arguments);
                if (!newItem || !newItem.data || !this.items)
                    return;
                var oldItem = null;
                if (newItem.itemIndex >= 0 && this.items.length > newItem.itemIndex && this.items[newItem.itemIndex].libraryId === newItem.data.libraryId && this.items[newItem.itemIndex].mediaType === newItem.data.mediaType)
                    oldItem = this.items[newItem.itemIndex];
                else
                    for (i in this.items) {
                        var currentItem = this.items[i];
                        if (currentItem.libraryId === newItem.data.libraryId && currentItem.mediaType === newItem.data.mediaType) {
                            oldItem = currentItem;
                            break
                        }
                    }
                if (oldItem) {
                    if (oldItem.canPlayLocally !== newItem.data.canPlayLocally)
                        MS.Entertainment.Utilities.BindingAgnostic.setProperty(oldItem, "canPlayLocally", newItem.data.canPlayLocally);
                    if (oldItem.downloadedEpisodesCount !== newItem.data.downloadedEpisodesCount)
                        MS.Entertainment.Utilities.BindingAgnostic.setProperty(oldItem, "downloadedEpisodesCount", newItem.data.downloadedEpisodesCount)
                }
            }
    }, {viewMoreButtonVisible: false})});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryPersonalFeaturedContent: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.LibraryVideoFeaturedContent", "Controls/LibraryFeaturedContent.html#libraryVideoContentTemplate", function(element, options) {
        this.emptyLibraryStyle = "noVideoContentPane"
    }, {
        rowCount: 3, itemsColumns: 2, containerStyle: 'dashboardGridPersonalItemContentSmall', itemSize: MS.Entertainment.Utilities.personalTileSize, _getRowCountForResolution: function _getRowCountForResolution() {
                return this.rowCount
            }, updateSettings: function updateSettings() {
                if (this._content) {
                    var previousResolution = this._content.itemSize;
                    this._content.propertyName = this.propertyName;
                    if (MS.Entertainment.Utilities.isHighResolution()) {
                        this._content.itemSize = MS.Entertainment.Utilities.personalTileSize;
                        this._content.containerStyle = 'dashboardGridPersonalItemContentLarge';
                        this._content.itemTemplates = [{
                                value: Microsoft.Entertainment.Queries.VideoType.other, template: '/Components/Video/VideoStartupTemplates.html#personalFileTileL1Large'
                            }, {
                                value: 'actionButton', template: '/Components/Video/VideoStartupTemplates.html#dashboardEngagePanelButton'
                            }]
                    }
                    else {
                        this._content.itemSize = MS.Entertainment.Utilities.personalTileSizeL1Small;
                        this._content.containerStyle = 'dashboardGridPersonalItemContentSmall';
                        this._content.itemTemplates = [{
                                value: Microsoft.Entertainment.Queries.VideoType.other, template: '/Components/Video/VideoStartupTemplates.html#personalFileTileL1Small'
                            }, {
                                value: 'actionButton', template: '/Components/Video/VideoStartupTemplates.html#dashboardEngagePanelButton'
                            }]
                    }
                    if (previousResolution && previousResolution !== this._content.itemSize) {
                        this._content.applyPanelTemplate();
                        this._content.resetItemTemplate();
                        this._content.render(true)
                    }
                }
            }
    })});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryMovieFeaturedContent: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.LibraryVideoFeaturedContent", "Controls/LibraryFeaturedContent.html#libraryMovieContentTemplate", function(element, options) {
        this.emptyLibraryStyle = "noVideoContentPane";
        this.itemSize = MS.Entertainment.Utilities.isVideoApp1 ? MS.Entertainment.Utilities.movieTileSize : MS.Entertainment.Utilities.movieLargeTileSize;
        this._uiStateEventHandler = MS.Entertainment.Utilities.addEventHandlers(MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState), {isFilledChanged: function isFilledChanged() {
                this._populateContent()
            }.bind(this)})
    }, {
        _itemsColumns: 2, itemsColumns: {get: function get_itemsColumns() {
                    this._itemsColumns = MS.Entertainment.Utilities.isApp1 ? 2 : (MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).isFilled) ? 2 : 3;
                    return this._itemsColumns
                }}, containerStyle: 'dashboardGridMovieItemContent', unload: function unload() {
                if (this._uiStateEventHandler) {
                    this._uiStateEventHandler.cancel();
                    this._uiStateEventHandler = null
                }
                MS.Entertainment.UI.Controls.LibraryVideoFeaturedContent.prototype.unload.call(this)
            }, _registerContentNotificationListener: function _registerContentNotificationListener(sender, listenerId) {
                if (sender && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.fileTransfer)) {
                    var fileTransferService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransfer);
                    fileTransferService.registerListener(listenerId, function getTaskKey(task) {
                        return (task && (!task.seriesMediaId || MS.Entertainment.Utilities.isEmptyGuid(task.seriesMediaId)) && task.libraryTypeId === Microsoft.Entertainment.Queries.ObjectType.video) ? task.libraryId : null
                    }, sender, MS.Entertainment.UI.FileTransferNotifiers.genericFile)
                }
            }
    })});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryTvFeaturedContent: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.LibraryVideoFeaturedContent", "Controls/LibraryFeaturedContent.html#libraryTvContentTemplate", function(element, options) {
        this.emptyLibraryStyle = "noVideoContentPane";
        this.itemSize = MS.Entertainment.Utilities.isVideoApp1 ? MS.Entertainment.Utilities.tvTileSize : MS.Entertainment.Utilities.tvLargeTileSize
    }, {
        itemsColumns: 1, containerStyle: 'dashboardGridTvItemContent', _registerContentNotificationListener: function _registerContentNotificationListener(sender, listenerId) {
                if (sender && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.fileTransfer)) {
                    var fileTransferService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransfer);
                    fileTransferService.registerListener(listenerId, function getTaskKey(task) {
                        return (task && task.seriesMediaId && task.libraryTypeId === Microsoft.Entertainment.Queries.ObjectType.video && !MS.Entertainment.Utilities.isEmptyGuid(task.seriesMediaId)) ? task.seriesLibraryId : null
                    }, sender, MS.Entertainment.UI.FileTransferNotifiers.episodeCollection)
                }
            }
    })});
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {LibraryMusicFeaturedContent: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.LibraryFeaturedContent", "Controls/LibraryFeaturedContent.html#libraryMusicContentTemplate", function(element, options) {
        this.emptyLibraryStyle = "noMusicContentPane";
        this._itemMap = {}
    }, {
        _itemsVisible: 0, _itemColumns: 3, _playlistsVisible: 2, _visibleItemCache: null, _loadSmartDJQueryBinding: null, _itemMap: null, initialize: function initialize() {
                MS.Entertainment.UI.Controls.LibraryFeaturedContent.prototype.initialize.call(this);
                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                var musicSmartDJEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.smartDJMarketplace);
                var freeStreamEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicFreePlay);
                var subscriptionEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicSubscription);
                if (musicSmartDJEnabled && (subscriptionEnabled || freeStreamEnabled)) {
                    var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                    var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    if (musicSmartDJEnabled && (subscriptionEnabled || freeStreamEnabled))
                        var loadSmartDJQuery = function loadSmartDJQuery() {
                                if (signInService.isSignedIn && this.libraryQuery.length < 3) {
                                    var newArray = this.libraryQuery.splice(0);
                                    var smartDJQuery = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.smartDJList);
                                    newArray.push(smartDJQuery);
                                    this.libraryQuery = newArray
                                }
                                else if (!signInService.isSignedIn && this.libraryQuery.length === 3 && !configurationManager.service.lastSignedInUserXuid)
                                    this.libraryQuery = this.libraryQuery.slice(0, 2)
                            }.bind(this);
                    this._loadSmartDJQueryBinding = WinJS.Binding.bind(signInService, {isSignedIn: loadSmartDJQuery})
                }
            }, unload: function unload() {
                MS.Entertainment.UI.Controls.LibraryFeaturedContent.prototype.unload.call(this);
                if (this._loadSmartDJQueryBinding) {
                    this._loadSmartDJQueryBinding.cancel();
                    this._loadSmartDJQueryBinding = null
                }
            }, _handleDataUpdates: function _handleDateUpdates(newItem, oldItem) {
                switch (newItem.data.mediaType) {
                    case Microsoft.Entertainment.Queries.ObjectType.playlist:
                        var item = this._visibleItemCache.playlists ? this._visibleItemCache.playlists[newItem.key] : null;
                        if (item) {
                            item.name = newItem.data.name;
                            item.count = newItem.data.count;
                            item.duration = newItem.data.duration
                        }
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.album:
                        var item = this._visibleItemCache.albums ? this._visibleItemCache.albums[newItem.key] : null;
                        var previousItem = (this._visibleItemCache.albums && oldItem && oldItem.key) ? this._visibleItemCache.albums[oldItem.key] : null;
                        if (item) {
                            item.instance = newItem.data.instance;
                            item.name = newItem.data.name;
                            if (item.hasServiceId)
                                this._itemMap[item.serviceId.toLowerCase()] = true;
                            if (previousItem && previousItem.hasServiceId && previousItem.serviceId !== item.serviceId)
                                delete this._itemMap[previousItem.serviceId.toLowerCase()]
                        }
                        break
                }
            }, _actionButtons: (function() {
                var shuffleAll;
                return {get: function() {
                            if (!shuffleAll) {
                                var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                shuffleAll = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.shuffleAllMusic);
                                shuffleAll.title = String.load(String.id.IDS_PLAY_ALL_LABEL);
                                shuffleAll.icon = MS.Entertainment.UI.Icon.shuffleOn;
                                shuffleAll.mediaType = "actionButton"
                            }
                            if (MS.Entertainment.Utilities.isMusicApp2)
                                return {
                                        action1: this.panelAction.action, mediaType: "actionButton", action2: shuffleAll
                                    };
                            else
                                return {
                                        action1: shuffleAll, mediaType: "actionButton"
                                    }
                        }}
            })(), _populateContent: function _populateContent(validateItemsNeeded) {
                var goodItems = [];
                var otherItems = [];
                var totalItems = this._itemColumns * MS.Entertainment.Utilities.getRowCountForResolution();
                if (validateItemsNeeded && (totalItems === this._itemsVisible) && (this.items && this.items.length > 0))
                    return;
                this._itemsVisible = totalItems;
                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                var musicSmartDJEnabled = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.smartDJMarketplace);
                var albums = this._queryResults[0];
                var playlists = this._queryResults[1];
                if (musicSmartDJEnabled)
                    var smartDJs = this._queryResults[2];
                this._visibleItemCache = {};
                if (albums)
                    albums.itemsFromIndex(0, 0, this._maxItems - 1).done(function populateData(content) {
                        var setProperty = MS.Entertainment.Utilities.BindingAgnostic.setProperty;
                        this._visibleItemCache.albums = {};
                        for (var i = 0; i < content.items.length; i++) {
                            var item = content.items[i].data;
                            item.key = content.items[i].key;
                            this._visibleItemCache.albums[item.key] = item;
                            if (!item.doclick) {
                                setProperty(item, "doclick", this.libraryClicked);
                                setProperty(item, "primaryText", item.name);
                                setProperty(item, "secondaryText", item.artistName);
                                setProperty(item, "itemQuery", this.libraryQuery)
                            }
                            if (item.hasServiceId) {
                                this._itemMap[item.serviceId.toLowerCase()] = true;
                                goodItems.push(item);
                                if (goodItems.length >= totalItems)
                                    break
                            }
                            else
                                otherItems.push(item)
                        }
                        if (playlists)
                            if (smartDJs) {
                                var playlistContent = null;
                                playlists.itemsFromIndex(0, 0, this._maxItems - 1).then(function indexSmartDJThenCombine(playlistContentItems) {
                                    playlistContent = playlistContentItems;
                                    return smartDJs.itemsFromIndex(0, 0, this._maxItems - 1)
                                }.bind(this), function handlePlaylistsErrorWithSmartDJs(e) {
                                    MS.Entertainment.UI.Controls.assert(MS.Entertainment.Data.List.ErrorMessage.isListChangedError(e), "Playlist query did not return a list: " + (e && e.message))
                                }).done(function combineContent(smartDJContent) {
                                    this.populateLastColumnData(playlistContent, smartDJContent, goodItems, otherItems)
                                }.bind(this), function handleSmartDJErrorWithPlaylists(e) {
                                    this.populateLastColumnData(playlistContent, null, goodItems, otherItems);
                                    MS.Entertainment.UI.Controls.assert(MS.Entertainment.Data.List.ErrorMessage.isListChangedError(e), "SmartDJ query did not return a list: " + (e && e.message))
                                }.bind(this))
                            }
                            else
                                playlists.itemsFromIndex(0, 0, this._maxItems - 1).done(function callPopulateLastColumnData(playlistContent) {
                                    this.populateLastColumnData(playlistContent, null, goodItems, otherItems)
                                }.bind(this), function handlePlaylistsError(e) {
                                    this.populateLastColumnData(null, null, goodItems, otherItems);
                                    MS.Entertainment.UI.Controls.assert(MS.Entertainment.Data.List.ErrorMessage.isListChangedError(e), "Playlist query did not return a list: " + (e && e.message))
                                }.bind(this));
                        else if (smartDJs)
                            smartDJs.itemsFromIndex(0, 0, this._maxItems - 1).done(function callPopulateLastColumnData(smartDJContent) {
                                this.populateLastColumnData(null, smartDJContent, goodItems, otherItems)
                            }.bind(this), function handleSmartDJError(e) {
                                this.populateLastColumnData(null, null, goodItems, otherItems);
                                MS.Entertainment.UI.Controls.assert(MS.Entertainment.Data.List.ErrorMessage.isListChangedError(e), "SmartDJ query did not return a list: " + (e && e.message))
                            }.bind(this))
                    }.bind(this), function ignoreError(error) {
                        MS.Entertainment.UI.Controls.assert(MS.Entertainment.Data.List.ErrorMessage.isListChangedError(error), "An unknown error has occurred when populating library feature content. Error message = " + (error && error.message))
                    })
            }, populateLastColumnData: function populateLastColumnData(playlistContent, smartDJContent, goodItems, otherItems) {
                var rowCount = MS.Entertainment.Utilities.getRowCountForResolution();
                var lastRowCount = rowCount;
                var totalItems = this._itemColumns * rowCount;
                var setProperty = MS.Entertainment.Utilities.BindingAgnostic.setProperty;
                var lastColumnItems = [];
                var numberSmartDJs = 0;
                var smartDJsToSkip = 0;
                this._visibleItemCache.playlists = {};
                this._visibleItemCache.smartDJs = {};
                var actionButtons;
                if (goodItems.length > 0) {
                    actionButtons = this._actionButtons;
                    if (MS.Entertainment.Utilities.isMusicApp1)
                        lastRowCount--
                }
                if (smartDJContent)
                    if (smartDJContent.items[0] && !smartDJContent.items[0].data.mediaType)
                        if (smartDJContent.items[1] && !smartDJContent.items[1].data.mediaType)
                            smartDJsToSkip = 2;
                        else
                            smartDJsToSkip = 1;
                var storedItems = null;
                if (MS.Entertainment.Utilities.isMusicApp1) {
                    var numberPlaylists = Math.min((playlistContent && playlistContent.items.length) || 0, lastRowCount);
                    if (smartDJContent) {
                        var minNumberSmartDJs = Math.min(smartDJContent.items.length - smartDJsToSkip, Math.floor(lastRowCount / 2));
                        numberPlaylists = Math.min(numberPlaylists, lastRowCount - minNumberSmartDJs);
                        numberSmartDJs = Math.min(smartDJContent.items.length - smartDJsToSkip, lastRowCount - numberPlaylists)
                    }
                    for (var i = 0; i < numberPlaylists; i++) {
                        var item = playlistContent.items[i].data;
                        if (item) {
                            item.key = playlistContent.items[i].key;
                            this._wrapItem(item, String.load(String.id.IDS_MUSIC_PLAYLIST_LABEL), item.name);
                            lastColumnItems.push(item);
                            this._visibleItemCache.playlists[item.key] = item
                        }
                    }
                    if (smartDJContent)
                        for (var i = smartDJsToSkip; i < numberSmartDJs + smartDJsToSkip; i++) {
                            var item = smartDJContent.items[i].data;
                            if (item) {
                                item.key = smartDJContent.items[i].key;
                                this._wrapItem(item, String.load(String.id.IDS_MUSIC_TYPE_SMARTDJ_1), item.name);
                                lastColumnItems.push(item);
                                this._visibleItemCache.smartDJs[item.key] = item
                            }
                        }
                    storedItems = goodItems.concat(otherItems)
                }
                else {
                    storedItems = [];
                    var currentAlbumIndex = 0;
                    var currentPlaylistIndex = 0;
                    var currentSmartDJIndex = smartDJsToSkip;
                    do {
                        var currentAlbum = (goodItems && currentAlbumIndex < goodItems.length) ? goodItems[currentAlbumIndex] : null;
                        var albumIndexIncrementation = 0;
                        var currentPlaylist = (playlistContent && currentPlaylistIndex < playlistContent.items.length) ? playlistContent.items[currentPlaylistIndex].data : null;
                        var playlistIndexIncrementation = 0;
                        var currentSmartDJ = (smartDJContent && currentSmartDJIndex < smartDJContent.items.length) ? smartDJContent.items[currentSmartDJIndex].data : null;
                        var smartDJIndexIncrementation = 0;
                        var currentItemToInsert = null;
                        if (currentAlbum) {
                            currentItemToInsert = currentAlbum;
                            albumIndexIncrementation = 1
                        }
                        if (currentPlaylist && (!currentItemToInsert || currentPlaylist.recentlyPlayedDate > currentItemToInsert.recentlyPlayedDate)) {
                            currentItemToInsert = currentPlaylist;
                            this._wrapItem(currentItemToInsert, String.load(String.id.IDS_MUSIC_PLAYLIST_LABEL), currentItemToInsert.name);
                            albumIndexIncrementation = 0;
                            playlistIndexIncrementation = 1
                        }
                        if (currentSmartDJ && (!currentItemToInsert || currentSmartDJ.recentlyPlayedDate > currentItemToInsert.recentlyPlayedDate)) {
                            currentItemToInsert = currentSmartDJ;
                            this._wrapItem(currentItemToInsert, String.load(String.id.IDS_MUSIC_TYPE_SMARTDJ_1), currentItemToInsert.name);
                            albumIndexIncrementation = 0;
                            playlistIndexIncrementation = 0;
                            smartDJIndexIncrementation = 1
                        }
                        if (currentItemToInsert) {
                            storedItems.push(currentItemToInsert);
                            currentAlbumIndex += albumIndexIncrementation;
                            currentPlaylistIndex += playlistIndexIncrementation;
                            currentSmartDJIndex += smartDJIndexIncrementation
                        }
                    } while ((goodItems && currentAlbumIndex < goodItems.length) || (playlistContent && currentPlaylistIndex < playlistContent.items.length) || (smartDJContent && currentSmartDJIndex < smartDJContent.items.length))
                }
                if (actionButtons)
                    if (MS.Entertainment.Utilities.isMusicApp1 && lastColumnItems.length)
                        lastColumnItems.push(actionButtons);
                    else if (MS.Entertainment.Utilities.isMusicApp2 && (storedItems.length || lastColumnItems.length)) {
                        var maxListIndex = (MS.Entertainment.Utilities.getRowCountForResolution() - 1);
                        var index = Math.min(maxListIndex, storedItems.length);
                        storedItems.splice(index, 0, actionButtons)
                    }
                var itemsToShow = [];
                var newTotal = totalItems;
                var lastRowItems = Math.min(rowCount, lastColumnItems.length);
                if (storedItems.length < totalItems - lastRowItems) {
                    for (var i = 1; i <= this._itemColumns; i++)
                        if (storedItems.length < (i * rowCount)) {
                            if (i > 1) {
                                itemsToShow = storedItems.slice(0, (i - 1) * rowCount);
                                newTotal = lastColumnItems.length > 0 ? i * rowCount : (i - 1) * rowCount
                            }
                            else {
                                itemsToShow = storedItems;
                                newTotal = lastColumnItems.length > 0 ? i * rowCount : rowCount
                            }
                            break
                        }
                }
                else
                    itemsToShow = storedItems.slice(0, totalItems - lastColumnItems.length);
                itemsToShow = itemsToShow.concat(lastColumnItems);
                if (actionButtons && MS.Entertainment.Utilities.isMusicApp1)
                    if (itemsToShow[itemsToShow.length - 1] !== actionButtons)
                        itemsToShow[itemsToShow.length - 1] = actionButtons;
                this._updateItems(itemsToShow)
            }, _wrapItem: function _wrapItem(item, primaryText, secondaryText) {
                var setProperty = MS.Entertainment.Utilities.BindingAgnostic.setProperty;
                if (!item.doclick) {
                    setProperty(item, "doclick", this.libraryClicked);
                    setProperty(item, "primaryText", primaryText);
                    setProperty(item, "secondaryText", secondaryText);
                    setProperty(item, "itemQuery", this.libraryQuery)
                }
            }, _modifyQueryForContentNotifications: function _modifyQueryForContentNotifications(query) {
                var sender = null;
                if (query.resultAugmentation === MS.Entertainment.Data.Augmenter.Library.AlbumsResult) {
                    var notifications = new MS.Entertainment.UI.ContentNotification.NotificationModification(MS.Entertainment.UI.ContentNotification.listResult(), MS.Entertainment.UI.FileTransferService.keyFromProperty("serviceId", false, true));
                    sender = notifications.createSender();
                    notifications.modifyQuery(query)
                }
                return sender
            }, _registerContentNotificationListener: function _registerContentNotificationListener(sender, listenerId) {
                if (sender) {
                    var fileTransferService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransfer);
                    fileTransferService.registerListener(listenerId, MS.Entertainment.UI.FileTransferService.keyFromProperty("albumMediaId", false, true), sender, MS.Entertainment.UI.FileTransferNotifiers.trackCollection, null, this._filterNotifications.bind(this))
                }
            }, _filterNotifications: function _filterNotifications(notificationId) {
                return (!notificationId || !this._itemMap || !this._itemMap[notificationId.toLowerCase()])
            }
    })})
