﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {CreatePlaylistFlyout: MS.Entertainment.UI.Framework.defineUserControl("Controls/Music/CreatePlaylistFlyout.html#createPlaylistFlyoutTemplate", function createPlaylistFlyout(){}, {
        _dialog: null, _eventHandlers: null, _appBar: null, _appBarEventHandlers: null, _replacePlaylist: false, actionParameters: null, overrideActionFunction: null, saveButtonString: {get: function _getSaveButtonString() {
                    var saveButtonStringId = this._replacePlaylist ? String.id.IDS_PLAYLIST_CREATE_REPLACE : String.id.IDS_SAVE_BUTTON;
                    return String.load(saveButtonStringId)
                }}, initialize: function initialize() {
                MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened = true;
                this._editBox.bind("isValid", this._updateState.bind(this));
                this._eventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {
                    keypress: function onKeyPress(event) {
                        if (event.keyCode === WinJS.Utilities.Key.enter) {
                            this.onClick();
                            event.stopPropagation();
                            event.preventDefault()
                        }
                        else if (event.keyCode === WinJS.Utilities.Key.escape) {
                            this._dialog.hide();
                            MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened = false
                        }
                    }.bind(this), keydown: function onKeyDown(event) {
                            if (event.keyCode === WinJS.Utilities.Key.dismissButton)
                                this._dialog.hide()
                        }.bind(this)
                });
                this._editBox.setFocus(true);
                this._appBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                this._appBarEventHandlers = WinJS.Binding.bind(this._appBar, {visible: function dismissOnAppBar(newValue, oldValue) {
                        if (oldValue !== undefined && newValue) {
                            this._dialog.hide();
                            MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened = false
                        }
                    }.bind(this)})
            }, unload: function unload() {
                if (this._eventHandlers) {
                    this._eventHandlers.cancel();
                    this._eventHandlers = null
                }
                if (this._appBarEventHandlers) {
                    this._appBarEventHandlers.cancel();
                    this._appBarEventHandlers = null
                }
                MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this);
                MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened = false
            }, onClick: function onClick(event) {
                this._editBox.onChanged();
                if (this._editBox.isValid && this._editBox.value) {
                    var parameter = {
                            name: this._editBox.value, mediaItems: (this.actionParameters ? this.actionParameters.mediaItems : null), playlist: (this.actionParameters ? this.actionParameters.playlist : null), showPlaylistPopover: (this.actionParameters ? this.actionParameters.showPlaylistPopover : true), completeCallback: this._completedCallback.bind(this), failedCallback: this._failedCallback.bind(this), overwrite: this._replacePlaylist
                        };
                    this.action.parameter = parameter;
                    this.action.execute()
                }
            }, setOverlay: function setOverlay(dialog) {
                this._dialog = dialog;
                this._dialog.customStyle = "addPlaylistFlyout";
                dialog.setAccessibilityTitle(String.load(String.id.IDS_PLAYLIST_NAME_TITLE));
                if (this.actionParameters && this.actionParameters.defaultPlaylistName) {
                    this._editBox.value = this.actionParameters.defaultPlaylistName;
                    this._button.disabled = false
                }
            }, _updateState: function _updateState(valid, wasValid) {
                this._button.disabled = !valid && !this._editBox.value;
                if (this.action.supportsOverwrite && valid && !wasValid) {
                    var oldValue = this.saveButtonString;
                    this._replacePlaylist = false;
                    this.notify("saveButtonString", this.saveButtonString, oldValue)
                }
            }, _completedCallback: function _completedCallback() {
                if (this.actionParameters && this.actionParameters.completeAction)
                    this.actionParameters.completeAction();
                if (this._dialog) {
                    this._dialog.hide();
                    MS.Entertainment.UI.Controls.CreatePlaylistFlyout.flyoutOpened = false
                }
            }, _failedCallback: function _failedCallback() {
                if (!this._editBox)
                    return;
                if (this.action.supportsOverwrite) {
                    this._editBox.setError(String.load(String.id.IDS_PLAYLIST_CREATE_DUPLICATE_MESSAGE));
                    var oldValue = this.saveButtonString;
                    this._replacePlaylist = true;
                    this.notify("saveButtonString", this.saveButtonString, oldValue)
                }
                else
                    this._editBox.setError(String.load(String.id.IDS_PLAYLIST_EXISTING_NAME))
            }
    }, {flyoutOpened: false}, {getMaxTitleLength: {get: function() {
                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                var length = configurationManager.groveler.maxPlaylistTitleLength;
                if (length < 10)
                    length = 10;
                return length
            }}})})
