﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {MediaPropertiesFlyout: MS.Entertainment.UI.Framework.defineUserControl("Controls/Music/MediaPropertiesFlyout.html#mediaPropertiesFlyoutTemplate", function mediaPropertiesFlyoutConstructor(){}, {
        _dialog: null, _eventHandlers: null, mediaItem: null, overrideActionFunction: null, initialize: function initialize() {
                this._eventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {
                    keypress: function onKeyPress(event) {
                        if (event.keyCode === WinJS.Utilities.Key.escape)
                            this._dialog.hide()
                    }.bind(this), keydown: function onKeyDown(event) {
                            if (event.keyCode === WinJS.Utilities.Key.dismissButton) {
                                event.stopPropagation();
                                this._dialog.hide()
                            }
                        }.bind(this)
                });
                if (!(new Microsoft.Entertainment.Configuration.ConfigurationManager).shell.retailExperience)
                    this.showBuyLink = this.mediaItem.hasNonMarketplaceImage;
                this.getCollectionState().done(function getCollectionState(state) {
                    if (state !== null && state !== undefined) {
                        this.cloudIcon = MS.Entertainment.Data.Factory.toCloudIcon(state);
                        this.cloudIconOpacity = MS.Entertainment.Data.Factory.toCloudIconOpacity(state);
                        this.cloudIconTooltip = MS.Entertainment.Data.Factory.toCloudIconTooltip(state)
                    }
                }.bind(this), function getCollectionStateError(error) {
                    MS.Entertainment.UI.Controls.fail("Failed to get collection state. Error: " + (error && error.message))
                })
            }, getCollectionState: function getCollectionState() {
                var promise;
                if (this.mediaItem.inCollection && (this.mediaItem.collectionState === null || this.mediaItem.collectionState === undefined)) {
                    var trackQuery = new MS.Entertainment.Data.Query.libraryTracks;
                    trackQuery.trackId = this.mediaItem.libraryId;
                    trackQuery.chunkSize = 1;
                    trackQuery.aggregateChunks = false;
                    promise = trackQuery.getItemsArrayAndIgnoreErrors().then(function getTrack(trackArray) {
                        if (trackArray) {
                            MS.Entertainment.UI.Actions.assert(trackArray.length <= 1, "libraryTracks query using trackId should not return more then 1 items");
                            if (trackArray.length === 1)
                                return trackArray[0].collectionState
                        }
                    })
                }
                else
                    promise = WinJS.Promise.as(this.mediaItem.collectionState);
                return promise
            }, unload: function unload() {
                if (this._eventHandlers) {
                    this._eventHandlers.cancel();
                    this._eventHandlers = null
                }
                MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
            }, setOverlay: function setOverlay(dialog) {
                this._dialog = dialog;
                dialog.setAccessibilityTitle(String.load(String.id.IDS_MUSIC_PROPERTIES_DIALOG_TEXT))
            }
    }, {
        showBuyLink: false, cloudIcon: null, cloudIconOpacity: null, cloudIconTooltip: null
    })})
