﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {MusicFlexHubBigItem: MS.Entertainment.UI.Framework.defineUserControl("Controls/Music/MusicFlexHubBigItem.html#musicFlexHubBigItem", function musicFlexHubBigItemConstructor(element, viewModel) {
        this.viewModel = viewModel;
        if (this.viewModel)
            this.viewModel.querySuccessCallback = this._setupMediaItem.bind(this)
    }, {
        viewModel: null, initialize: function initialize(){}, mediaItem: {set: function(value) {
                    if (value.data) {
                        if (value.data.text)
                            this.text = value.data.text;
                        if (value.data.editorialTitle)
                            this.editorialTitle = value.data.editorialTitle;
                        this.targetItem = value.data
                    }
                }}, _setupMediaItem: function _setupMediaItem(itemPromise) {
                itemPromise.then(function setupBigItem(mediaItem) {
                    this.mediaItem = mediaItem
                }.bind(this))
            }, onKeyDown: function onKeyDown(event) {
                if (event.keyCode === WinJS.Utilities.Key.enter || event.keyCode === WinJS.Utilities.Key.space)
                    this.onClick()
            }, onClick: function onClick() {
                if (!this.popOverConstructor && this.targetItem)
                    switch (this.targetItem.type) {
                        case MS.Entertainment.Data.Augmenter.Marketplace.EditorialType.Artist:
                            this.popOverConstructor = "MS.Entertainment.Pages.MusicArtistInlineDetails";
                            break;
                        case MS.Entertainment.Data.Augmenter.Marketplace.EditorialType.Album:
                            this.popOverConstructor = "MS.Entertainment.Pages.MusicAlbumInlineDetails";
                            break;
                        case MS.Entertainment.Data.Augmenter.Marketplace.EditorialType.Track:
                            this.popOverConstructor = "MS.Entertainment.Pages.MusicArtistInlineDetails";
                            break;
                        default:
                            MS.Entertainment.Pages.assert(false, "no template defined");
                            return null
                    }
                if (this.popOverConstructor) {
                    var popOverParameters = {itemConstructor: this.popOverConstructor};
                    if (this.targetItem.type === MS.Entertainment.Data.Augmenter.Marketplace.EditorialType.Track) {
                        query = new MS.Entertainment.Data.Query.Music.SongDetails;
                        if (query) {
                            query.id = item.serviceId;
                            query.execute().done(function querySuccess(q) {
                                popOverParameters.dataContext = {
                                    data: q.result.item, location: MS.Entertainment.Data.ItemLocation.marketplace
                                };
                                this._showPopOver(popOverParameters)
                            }.bind(this), null)
                        }
                    }
                    else {
                        popOverParameters.dataContext = {
                            data: this.targetItem, location: MS.Entertainment.Data.ItemLocation.marketplace
                        };
                        this._showPopOver(popOverParameters)
                    }
                }
            }, _showPopOver: function _showPopOver(parameters) {
                if (parameters)
                    MS.Entertainment.Platform.PlaybackHelpers.showItemDetails(parameters)
            }
    }, {
        text: String.empty, editorialTitle: String.empty, targetItem: null, popOverConstructor: null
    })})
