﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {PlaylistImageCollage: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.MediaImageCollage", null, null, {
        _albumResultsLength: -1, initialize: function initialize() {
                MS.Entertainment.UI.Controls.MediaImageCollage.prototype.initialize.apply(this, arguments);
                this.timerTickInterval = 30000;
                this.timerDelayPeriod = Math.floor(Math.random() * this.timerTickInterval);
                this.cellAddPeriod = 0;
                this.cellSwapPeriod = 20 + Math.floor(Math.random() * this.timerTickInterval - 20);
                this.artShowPeriod = 30000;
                this.artSwapPeriod = 11000;
                this.artVisiblePeriod = 30000;
                this.colorChangePeriod = 0;
                this.cellRepeatBuffer = 0;
                this.minimumSize = {
                    width: 60, height: 60
                }
            }, _loadImages: function _loadImages() {
                if (!this.media)
                    return;
                WinJS.Promise.timeout(500).then(function getAlbums() {
                    var inDom = MS.Entertainment.Utilities.checkIfInDom(this.domElement);
                    if (this._unloaded || !inDom)
                        return;
                    if (this._queryPromise)
                        this._queryPromise.cancel();
                    var localAlbumQuery = new MS.Entertainment.Data.Query.libraryAlbums;
                    localAlbumQuery.aggregateChunks = false;
                    localAlbumQuery.chunkSize = 8;
                    localAlbumQuery.playlistId = this.media.libraryId;
                    this._queryPromise = localAlbumQuery.execute().then(function(q) {
                        if (q.result && q.result.items)
                            q.result.items.toArray(0, 8).then(function processResults(albums) {
                                if (this._unloaded)
                                    return;
                                this._albumResultsLength = albums.length;
                                this._setCellDefinitions(albums.length);
                                if (albums.length === 0)
                                    albums.push(MS.Entertainment.UI.Shell.ImageLoader.MediaDefaultUrls.album);
                                if (albums.length < 4) {
                                    var modifiedAlbums = [];
                                    switch (albums.length) {
                                        case 1:
                                            modifiedAlbums.push(albums[0]);
                                            break;
                                        case 2:
                                            modifiedAlbums.push(albums[0]);
                                            modifiedAlbums.push(albums[0]);
                                            modifiedAlbums.push(albums[1]);
                                            modifiedAlbums.push(albums[1]);
                                            break;
                                        case 3:
                                            modifiedAlbums.push(albums[0]);
                                            modifiedAlbums.push(albums[1]);
                                            modifiedAlbums.push(albums[2]);
                                            modifiedAlbums.push(albums[0]);
                                            break
                                    }
                                    this.cellIdList = modifiedAlbums
                                }
                                else
                                    this.cellIdList = albums
                            }.bind(this));
                        this._queryPromise = null
                    }.bind(this))
                }.bind(this))
            }, _setCellImages: function _setCellImages() {
                if (this._albumResultsLength >= 0) {
                    if (this.domElement && this.domElement.clientWidth && this.domElement.clientHeight)
                        this.size = {
                            width: this.domElement.clientWidth, height: this.domElement.clientHeight
                        };
                    this._setCellDefinitions(this._albumResultsLength)
                }
                MS.Entertainment.UI.Controls.ImageCollage.prototype._setCellImages.apply(this, arguments)
            }
    }, {
        size: {
            width: 135, height: 135
        }, columns: 2, rows: 2, cellOffset: 0
    })})
