﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var __extends = this.__extends || function(d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
        function __() {
            this.constructor = d
        }
        __.prototype = b.prototype;
        d.prototype = new __
    };
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(UI) {
            (function(Controls) {
                MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
                var SimpleActionButton = (function(_super) {
                        __extends(SimpleActionButton, _super);
                        function SimpleActionButton() {
                            _super.apply(this, arguments);
                            this.enableDelayInitialization = true;
                            this.actionParameter = null;
                            this._isDisabled = false
                        }
                        SimpleActionButton.prototype.delayInitialize = function() {
                            if (!this.domElement)
                                return;
                            if (!this._eventHandlers)
                                this._eventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {
                                    click: this._onClick.bind(this), keydown: this._onKeyDown.bind(this)
                                })
                        };
                        SimpleActionButton.prototype.unload = function() {
                            _super.prototype.unload.call(this);
                            if (this._eventHandlers) {
                                this._eventHandlers.cancel();
                                this._eventHandlers = null
                            }
                        };
                        Object.defineProperty(SimpleActionButton.prototype, "isDisabled", {
                            get: function() {
                                return this._isDisabled
                            }, set: function(value) {
                                    this.updateAndNotify("isDisabled", value)
                                }, enumerable: true, configurable: true
                        });
                        SimpleActionButton.prototype._onKeyDown = function(args) {
                            if (args.keyCode === WinJS.Utilities.Key.enter || args.keyCode === WinJS.Utilities.Key.space)
                                this._onClick()
                        };
                        SimpleActionButton.prototype._onClick = function() {
                            var canExecute = false;
                            if (this.action && !this.isDisabled) {
                                this.action.parameter = this.actionParameter;
                                this.action.requeryCanExecute();
                                canExecute = this.action.isEnabled
                            }
                            if (canExecute) {
                                this.isDisabled = true;
                                this.action.execute().then(function reenableAction() {
                                    this.isDisabled = false
                                }.bind(this))
                            }
                        };
                        return SimpleActionButton
                    })(MS.Entertainment.UI.Framework.UserControl);
                Controls.SimpleActionButton = SimpleActionButton
            })(UI.Controls || (UI.Controls = {}));
            var Controls = UI.Controls
        })(Entertainment.UI || (Entertainment.UI = {}));
        var UI = Entertainment.UI
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}))
