﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/corefx.js", "/Framework/debug.js", "/Framework/utilities.js");
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
WinJS.Namespace.define("MS.Entertainment.UI.Controls", {UserFeedbackDialog: MS.Entertainment.UI.Framework.defineUserControl("Controls/UserFeedbackDialog.html#userFeedbackDialogTemplate", function UserFeedbackDialog(){}, {
        optionalParameter: null, _overlay: null, _selectedRadioButton: null, _submitted: false, _issuesTypes: null, _suggestionIssueTypeIndex: 0, _errorIssueTypeIndex: 0, initialize: function initialize() {
                if (MS.Entertainment.Utilities.isMusicApp) {
                    this._issuesTypes = [{
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC_DETAILS), value: "BuyMusic"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "CantSignIn"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED_DETAILS), value: "ConnectedDevice"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_DOWNLOADINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC_DETAILS), value: "DownloadMusic"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGMUSIC_DETAILS), value: "MusicStreaming"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICFORMAT), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICFORMAT_DETAILS), value: "MusicFormat"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGMUSIC_DETAILS), value: "PlayMusic"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SYNC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "SyncCloud"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGMUSIC_DETAILS), value: "WrongMusicInfo"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICMETADATA), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGMUSIC_DETAILS), value: "MusicMetadata"
                        }, {
                            name: String.load(String.id.IDS_MUSIC_SHARE_SAS_FEEDBACK_TYPE), comment: String.load(String.id.IDS_MUSIC_SHARE_SAS_FEEDBACK_COMMENTS), value: "CreatingWebPlaylist"
                        }];
                    this._suggestionIssueTypeIndex = 8;
                    this._errorIssueTypeIndex = 5
                }
                else if (MS.Entertainment.Utilities.isVideoApp) {
                    this._issuesTypes = [{
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "BuyOrRent"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "CantSignIn"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED_DETAILS), value: "ConnectedDevice"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_DOWNLOADINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "DownloadingVideo"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGVIDEO_DETAILS), value: "StreamingVideo"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGVIDEO_DETAILS), value: "PlayVideo"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_VIDEOFORMAT), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_VIDEOFORMAT_DETAILS), value: "VideoFormat"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_TRAILER), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_TRAILER_DETAILS), value: "Trailer"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "WrongVideoInfo"
                        }];
                    this._suggestionIssueTypeIndex = 7;
                    this._errorIssueTypeIndex = 5
                }
                else {
                    this._issuesTypes = [{
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        }, {
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                        }];
                    this._suggestionIssueTypeIndex = 1;
                    this._errorIssueTypeIndex = 0
                }
                for (var i = 0; i < this._issuesTypes.length; i++) {
                    var opt = document.createElement("option");
                    opt.label = this._issuesTypes[i].name;
                    opt.value = i;
                    this._issueTypeSelector.options.add(opt)
                }
                var settingsFlyout = document.getElementById("SettingsFeedback");
                if (settingsFlyout) {
                    this._setInitialState();
                    settingsFlyout.winControl.addEventListener("beforeshow", this._setInitialState.bind(this))
                }
            }, setOverlay: function setOverlay(instance) {
                this._overlay = instance;
                var that = this;
                this._overlay.buttons = [WinJS.Binding.as({
                        title: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUBMIT), isEnabled: false, execute: function onSubmit() {
                                that._onSubmit()
                            }
                    }), WinJS.Binding.as({
                        title: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANCEL), isEnabled: true, execute: function onCancel() {
                                that._onCancel()
                            }
                    })];
                this._setInitialState();
                WinJS.Utilities.addClass(this._contentContainer, "settingsFeedbackContentDialog");
                WinJS.Utilities.addClass(this._optionsContainer, "settingsFeedbackOptionsDialog");
                WinJS.Utilities.addClass(this._editControl.domElement, "settingsFeedbackCommentBoxDialog");
                WinJS.Utilities.addClass(this._bottomContainer, "settingsFeedbackBottomDialog");
                WinJS.Utilities.addClass(this._connectionError.domElement, "settingsFeedbackPanelContentDialog");
                WinJS.Utilities.addClass(this._commentDescription.domElement, "settingsFeedbackPanelContentDialog");
                WinJS.Utilities.addClass(this._descriptionLabel.domElement, "settingsFeedbackPanelContentDialog");
                WinJS.Utilities.addClass(this._optionDescriptionLabel.domElement, "settingsFeedbackPanelContentDialog");
                WinJS.Utilities.addClass(this._feedbackButtonContainers, "removeFromDisplay")
            }, _enableSubmitButton: function _enableSubmitButton(enable) {
                if (this._overlay)
                    this._overlay.buttons[0].isEnabled = enable;
                else if (enable) {
                    this._submitButton.removeAttribute("disabled");
                    WinJS.Utilities.removeClass(this._submitButton, "disabled")
                }
                else {
                    this._submitButton.setAttribute("disabled", "disabled");
                    WinJS.Utilities.addClass(this._submitButton, "disabled")
                }
            }, _setInitialState: function _setInitialState() {
                var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                var gamerTag = signedInUser.gamerTag;
                if (gamerTag)
                    this._descriptionLabel.text = String.load(String.id.IDS_SETTINGS_FEEDBACK_DESCRIPTION_GAMERTAG).format(gamerTag);
                else
                    this._descriptionLabel.text = String.load(String.id.IDS_SETTINGS_FEEDBACK_DESCRIPTION);
                WinJS.Utilities.addClass(this._connectionError.domElement, "hidden");
                this._editControl.clearInput();
                this._enableSubmitButton(false);
                if (this._selectedRadioButton)
                    this._selectedRadioButton.checked = false;
                var initialIssueIndexToSelect = this._suggestionIssueTypeIndex;
                if (MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId) {
                    this._dislike.checked = true;
                    this._onRatingChange({target: this._dislike});
                    initialIssueIndexToSelect = this._errorIssueTypeIndex
                }
                this._issueTypeSelector.options.selectedIndex = initialIssueIndexToSelect;
                this._onIssueTypeChange(this._issuesTypes[initialIssueIndexToSelect])
            }, _onSubmit: function _onSubmit() {
                var currentLocation = null;
                var currentContentIssue = null;
                var currentMedia = null;
                var searchHCR = null;
                var telemetryParameterArray = [];
                var pageOptions = null;
                var inlineDetailsItem = MS.Entertainment.UI.Controls.UserFeedbackDialog.inlineDetailsItem;
                if (!window.navigator.onLine)
                    WinJS.Utilities.removeClass(this._connectionError.domElement, "hidden");
                else {
                    telemetryParameterArray.push({
                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.AppMode, parameterValue: MS.Entertainment.appMode
                    });
                    currentLocation = MS.Entertainment.Utilities.getCurrentUserLocation();
                    telemetryParameterArray.push({
                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.UIPath, parameterValue: currentLocation
                    });
                    telemetryParameterArray.push({
                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.FeedbackType, parameterValue: this._selectedRadioButton.value
                    });
                    telemetryParameterArray.push({
                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ContentIssueType, parameterValue: String.empty
                    });
                    if (WinJS.Utilities.getMember("MS.Entertainment.UI.Monikers") && currentLocation === MS.Entertainment.UI.Monikers.immersiveDetails) {
                        pageOptions = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).currentPage.options;
                        if (pageOptions && pageOptions.mediaItem) {
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: this._getMediaStringFromItem(pageOptions.mediaItem)
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItem, parameterValue: pageOptions.mediaItem.serviceId
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItemInstanceId, parameterValue: pageOptions.mediaItem.id || pageOptions.mediaItem.ID
                            })
                        }
                    }
                    else if (inlineDetailsItem) {
                        var mediaItem = inlineDetailsItem.mediaItem || inlineDetailsItem.media;
                        if (mediaItem) {
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: this._getMediaStringFromItem(mediaItem)
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItem, parameterValue: mediaItem.serviceId
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItemInstanceId, parameterValue: mediaItem.id || mediaItem.ID
                            })
                        }
                    }
                    if (MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId) {
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId
                        });
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorTimestamp, parameterValue: MS.Entertainment.UI.Controls.UserFeedbackDialog.timestamp
                        })
                    }
                    var comment = this._editControl.getValue();
                    if (comment.length <= 1024) {
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CommentText, parameterValue: comment
                        });
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.IssueType, parameterValue: this._issuesTypes[this._issueTypeSelector.options.selectedIndex].value
                        });
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SendASmile, telemetryParameterArray);
                        this._exitFeedback()
                    }
                }
            }, _getMediaStringFromItem: function _getMediaStringFromItem(mediaItem) {
                if (!mediaItem)
                    return "undefined";
                var mediaString = null;
                switch (mediaItem.mediaType) {
                    case Microsoft.Entertainment.Queries.ObjectType.video:
                        if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.musicVideo)
                            mediaString = "musicVideo";
                        else if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.tvEpisode)
                            mediaString = "episode";
                        else if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                            mediaString = "movie";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.tvSeries:
                        mediaString = "series";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.tvSeason:
                        mediaString = "season";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.person:
                        mediaString = "artist";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.genre:
                        mediaString = "genre";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.album:
                        mediaString = "album";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.track:
                        mediaString = "track";
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.game:
                        mediaString = "game";
                        break;
                    default:
                        mediaString = "undefined";
                        break
                }
                return mediaString
            }, _onCancel: function _onCancel() {
                this._exitFeedback()
            }, _setWatermarkText: function _setWatermarkText(watermarkText) {
                this._editControl.watermarkText = watermarkText;
                var currentTextValue = this._editControl.getValue();
                if (!currentTextValue || currentTextValue.length < 1)
                    this._editControl.reinitialize()
            }, _onIssueTypeChange: function _onIssueTypeChange(args) {
                this._setWatermarkText(this._issuesTypes[this._issueTypeSelector.options.selectedIndex].comment)
            }, _onRatingChange: function _onRatingChange(args) {
                this._selectedRadioButton = args.target;
                this._enableSubmitButton(true)
            }, _exitFeedback: function _exitFeedback() {
                if (this._overlay)
                    this._overlay.hide();
                else
                    document.getElementById("SettingsFeedback").winControl.hide();
                MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId = null;
                MS.Entertainment.UI.Controls.UserFeedbackDialog.timestamp = null;
                this.optionalParameter = null
            }
    }, null, {
        errorId: null, timestamp: null, inlineDetailsItem: null
    })})
