﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    scriptValidator("/Framework/debug.js", "/Framework/corefx.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ItemsControl: MS.Entertainment.UI.Framework.defineUserControl(null, function itemsControlConstructor(element, options) {
            this._handleChangesInDataSource = this._handleChangesInDataSource.bind(this);
            if (!this.keyboardNavigationManagerClass)
                this.keyboardNavigationManagerClass = MS.Entertainment.Framework.KeyboardNavigationManager;
            if (MS.Entertainment.UI.Framework.getTextDirection() === MS.Entertainment.UI.Framework.TextDirections.RightToLeft) {
                var left = this.bringIntoViewLeftMargin;
                var right = this.bringIntoViewRightMargin;
                this.bringIntoViewLeftMargin = right;
                this.bringIntoViewRightMargin = left
            }
            if (this.virtualize) {
                if (!this.itemSize && !this.getItemSize)
                    throw new Error("itemSize required when using virtualization");
                if (!this.virtualizationAxis)
                    throw new Error("virtualizationOrientation required when using virtualization");
                if (this._scroller.attachEvent)
                    this._scrollerAttachEvent = (function(handler, element) {
                        element.attachEvent("onresize", handler);
                        return {cancel: function() {
                                    element.detachEvent("onresize", handler)
                                }}
                    })(this._handleElementResizing.bind(this), this._scroller);
                this._scrollerEvents = MS.Entertainment.UI.Framework.addEventHandlers(this._scroller, {
                    mselementresize: this._handleElementResizing.bind(this), scroll: this._handleScrollingForVirtualization.bind(this)
                })
            }
            this._constructed = true
        }, {
            _constructed: false, keyboardNavigable: false, keyboardNavigationManagerClass: null, keyboardNavigationSetTabIndex: false, _keyboardNavigationManager: null, raisePanelReady: false, ignoreChildrenInitialization: true, deferForLongLists: false, longListDeferralItemLimit: 10, firstItemTabIndex: -1, itemSize: null, getItemSize: null, fireFirstTimeRenderedEventOnEmptyObservableArray: false, _firstTimeRenderCompleted: false, _internalDeclarativeRenderHelper: null, _declarativeRenderHelper: {get: function() {
                        if (!this._internalDeclarativeRenderHelper)
                            this._internalDeclarativeRenderHelper = new MS.Entertainment.UI.Controls.DeclarativeItemsControlRenderHelper;
                        return this._internalDeclarativeRenderHelper
                    }}, _scroller: {get: function() {
                        if (this.useParentAsScrollContainer)
                            if (this.parentScroller)
                                return this.parentScroller;
                            else
                                return this.domElement.parentElement;
                        return this.domElement
                    }}, _itemTemplate: null, _itemTemplateSet: null, itemTemplate: {
                    get: function() {
                        return this._itemTemplate
                    }, set: function(value) {
                            this._itemTemplate = value;
                            if (this._itemTemplate && this._itemTemplateSet) {
                                this._itemTemplateSet(value);
                                this._itemTemplateSet = null
                            }
                        }
                }, _virtualize: false, virtualize: {
                    get: function itemsControl_virtualize_get() {
                        return this._virtualize
                    }, set: function itemsControl_virtualize_set(value) {
                            if (this._constructed)
                                throw new Error("Can't set the virtualization setting after construction");
                            this._virtualize = value
                        }
                }, containerStyle: null, animateIn: true, bringIntoViewRightMargin: 0, bringIntoViewLeftMargin: 0, _highestIndexItemToRender: -1, _scrollPosition: -1, _scrollerSize: -1, _firstItemScrollOffset: -1, _itemTemplateProvider: null, _workingDataSource: null, _pendedBringItemIntoViewItem: null, controlName: "ItemsControl", _dataSource: undefined, _firstTimeRenderedCount: -1, dataSource: {
                    get: function() {
                        return this._dataSource
                    }, set: function(value) {
                            if (value === this._dataSource)
                                return;
                            var oldValue = this._dataSource;
                            this._dataSource = value;
                            if (this._dataBindingHandler)
                                this._dataBindingHandler(value, oldValue);
                            else
                                this._listChangedHandler(value, oldValue);
                            if (!oldValue && value)
                                this._initializeWithData();
                            this.notify("dataSource", value, oldValue)
                        }
                }, initialize: function initialize() {
                    if (this.dataSource)
                        this._initializeWithData()
                }, unload: function unload() {
                    if (this._workingDataSource) {
                        this._workingDataSource.removeChangeListener(this._handleChangesInDataSource);
                        this._workingDataSource = null
                    }
                    if (this._scrollerAttachEvents) {
                        this._scrollerAttachEvents.cancel();
                        this._scrollerAttachEvents = null
                    }
                    if (this._scrollerEvents) {
                        this._scrollerEvents.cancel();
                        this._scrollerEvents = null
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, _initializeWithData: function _initializeWithData() {
                    this._loadItemTemplateIgnoreErrors();
                    if (this.keyboardNavigable)
                        this._keyboardNavigationManager = new this.keyboardNavigationManagerClass(this.domElement, null, this.keyboardNavigationSetTabIndex)
                }, loadItemTemplate: function loadItemTemplate() {
                    var completePromise;
                    if (!this._itemTemplateProvider)
                        completePromise = this._loadTemplate(this.itemTemplate, null, true);
                    else
                        completePromise = WinJS.Promise.wrap(this._itemTemplateProvider);
                    completePromise = completePromise || WinJS.Promise.wrapError(new Error("No item template provided"));
                    return completePromise.then(function(template) {
                            this._itemTemplateProvider = template;
                            return template
                        }.bind(this))
                }, _loadItemTemplateIgnoreErrors: function _loadItemTemplateIgnoreErrors() {
                    this.loadItemTemplate().done(null, function(){})
                }, selectTemplate: function(item) {
                    return this.loadItemTemplate().then(function() {
                            return this._itemTemplateProvider
                        }.bind(this))
                }, render: function(sourceChanged) {
                    if (this.virtualize)
                        MS.Entertainment.UI.Controls.assert(this.domElement.children.length === 0, "List should not have items");
                    this._setSizeForScrolling();
                    if (this._workingDataSource && this._workingDataSource.length) {
                        if (this.applyPanelTemplate)
                            this.applyPanelTemplate();
                        var loadTemplatePromise = null;
                        if ((!this._firstTimeRenderCompleted && this.domElement.children.length) || !this.itemTemplate)
                            loadTemplatePromise = WinJS.Promise.as();
                        else
                            loadTemplatePromise = this.loadItemTemplate();
                        loadTemplatePromise.then(function renderOnceTemplateProviderLoaded() {
                            var workingLength = this._workingDataSource ? this._workingDataSource.length : 0;
                            if (this.virtualize && this.highestIndexItemToRender !== 0)
                                workingLength = Math.min(this.highestIndexItemToRender, workingLength);
                            if (this._firstTimeRenderCompleted)
                                MS.Entertainment.UI.Framework.empty(this.domElement);
                            if (this._firstTimeRenderedCount === -1) {
                                this._firstTimeRenderedCount = this.deferForLongLists ? Math.min(workingLength, this.longListDeferalItemLimit) : workingLength;
                                for (var i = this.domElement.children.length - 1; i >= this._firstTimeRenderedCount; i--)
                                    this.domElement.removeChild(this.domElement.children[i])
                            }
                            for (var i = 0; i < workingLength; i++) {
                                if (this.deferForLongLists && (i === this.longListDeferalItemLimit))
                                    break;
                                this._renderItem(this._workingDataSource.item(i), i)
                            }
                            if (this.deferForLongLists && i < workingLength)
                                window.requestAnimationFrame(function() {
                                    for (; i < workingLength; i++) {
                                        if ((i % (this.longListDeferalItemLimit * 2)) === 0)
                                            MS.Entertainment.UI.Framework.forceFullLayout();
                                        this._renderItem(this._workingDataSource.item(i))
                                    }
                                }.bind(this));
                            if (this.itemsRendered)
                                this.itemsRendered();
                            if (this.restoreFocus)
                                this.restoreFocus()
                        }.bind(this))
                    }
                    else {
                        if (sourceChanged)
                            MS.Entertainment.UI.Framework.empty(this.domElement);
                        var isEmptyArray = (this.dataSource && Array.isArray(this.dataSource) && this.dataSource.length === 0);
                        var isEmptyObservableArray = (this.dataSource && this.dataSource instanceof MS.Entertainment.ObservableArray && this.dataSource.length === 0);
                        if (isEmptyArray || (isEmptyObservableArray && this.fireFirstTimeRenderedEventOnEmptyObservableArray))
                            if (this._firstTimeRenderedCount === -1) {
                                this._firstTimeRenderedCount = 0;
                                this._sendFirstTimeRenderedEvent()
                            }
                    }
                    this._firstTimeRenderCompleted = true
                }, highestIndexItemToRender: {get: function highestIndexItemToRender_get() {
                        if (this._highestIndexItemToRender === -1)
                            if (!this.virtualize)
                                this._highestIndexItemToRender = this._workingDataSource.length;
                            else {
                                var itemCount = (this.scrollPosition + this.scrollerSize - this.firstItemScrollOffset) / this.itemSize;
                                this._highestIndexItemToRender = Math.ceil(itemCount)
                            }
                        return this._highestIndexItemToRender
                    }}, firstItemScrollOffset: {get: function itemsControl_firstItemScrollOffset() {
                        if (!this.useParentAsScrollContainer)
                            return 0;
                        if (this._firstItemScrollOffset === -1) {
                            var relativePosition = MS.Entertainment.Utilities.getRelativeOffset(this.domElement, this._scroller);
                            if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                                this._firstItemScrollOffset = relativePosition.left;
                            else if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.vertical)
                                this._firstItemScrollOffset = relativePosition.top
                        }
                        return this._firstItemScrollOffset
                    }}, scrollPosition: {get: function itemsControl_scrollposition() {
                        if (this._scrollPosition === -1)
                            if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                                this._scrollPosition = this._scroller.scrollLeft;
                            else if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.vertical)
                                this._scrollPosition = this._scroller.scrollTop;
                        return this._scrollPosition
                    }}, scrollerSize: {get: function itemsControl_scrollerSize() {
                        if (this._scrollerSize === -1) {
                            this._skipResize = true;
                            if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                                this._scrollerSize = this._scroller.clientWidth;
                            else if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.vertical)
                                this._scrollerSize = this._scroller.clientHeight;
                            this._skipResize = false
                        }
                        return this._scrollerSize
                    }}, _isIndexInRealizedArea: function _isIndexInRealizedArea(index) {
                    if (!this.virtualize)
                        return true;
                    if (index < this.highestIndexItemToRender)
                        return true;
                    return false
                }, _ensureRealizedToRealizedItemLimit: function _ensureRealizedToRealizedItemLimit() {
                    if (!this._workingDataSource || !this._workingDataSource.length)
                        return;
                    if (this.domElement.children.length > this.highestIndexItemToRender)
                        return;
                    if ((this._workingDataSource.length < this.highestIndexItemToRender) && (this.domElement.children.length === this._workingDataSource.length))
                        return;
                    if (this.virtualize)
                        this._firstTimeRenderedCount = Math.min(this._firstTimeRenderedCount, this.highestIndexItemToRender);
                    for (var i = this.domElement.children.length; i < this._workingDataSource.length; i++)
                        this._renderItem(this._workingDataSource.item(i), i)
                }, _handleElementResizing: function _handleElementResizing() {
                    if (this._skipResize)
                        return;
                    this._resetVirtualizationCaches();
                    this._ensureRealizedToRealizedItemLimit()
                }, _resetVirtualizationCaches: function _resetVirtualizatonCaches() {
                    this._scrollerSize = -1;
                    this._scrollPosition = -1;
                    this._firstItemScrollOffset = -1;
                    this._highestIndexItemToRender = -1
                }, _handleScrollingForVirtualization: function _handleScrollingForVirtualization() {
                    this._scrollPosition = -1;
                    this._highestIndexItemToRender = -1;
                    this._ensureRealizedToRealizedItemLimit()
                }, _setSizeForScrolling: function _setSizeForScrolling() {
                    if (!(this.useParentAsScrollContainer && this.virtualize))
                        return;
                    var size = String.empty;
                    if (this._workingDataSource && this._workingDataSource.length)
                        size = (this.itemSize * this._workingDataSource.length) + "px";
                    if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                        this.domElement.style.width = size;
                    else if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.vertical)
                        this.domElement.style.height = size
                }, processItemData: function processItemData(data, index) {
                    return data
                }, bringItemIntoView: function bringItemIntoView(item, options) {
                    options = options || {};
                    MS.Entertainment.UI.Controls.assert(item, "You need an item to bring into view");
                    var itemBroughtIntoView = WinJS.Promise.as();
                    if (!item)
                        return itemBroughtIntoView;
                    if (!this._workingDataSource) {
                        var pendeditem = {
                                item: item, completePromise: null
                            };
                        this._pendedBringItemIntoViewItem = pendeditem;
                        return new WinJS.Promise(function(c) {
                                pendeditem.completePromise = c
                            })
                    }
                    var index = this._workingDataSource ? this._workingDataSource.indexOf(item) : -1;
                    MS.Entertainment.assert(index > -1, "item not found in data source");
                    var element = this.domElement.children[index];
                    if (!element) {
                        var pendeditem = {
                                item: item, completePromise: null
                            };
                        this._pendedBringItemIntoViewItem = pendeditem;
                        return new WinJS.Promise(function(c) {
                                pendeditem.completePromise = c
                            })
                    }
                    if (!options.bringOnMinimally && !options.animated)
                        element.scrollIntoView();
                    else {
                        var targetPosition = this.getScrollPositionToShowItem(item, {
                                bringOnMinimally: options.bringOnMinimally, alwaysAlignLeftEdge: options.alwaysAlignLeftEdge
                            });
                        if (targetPosition != -1)
                            itemBroughtIntoView = this._performScroll(targetPosition, options.animated, options.ignoreMissingStarts)
                    }
                    return itemBroughtIntoView
                }, getScrollPositionToShowItem: function(item, options) {
                    options = options || {};
                    var result = -1;
                    MS.Entertainment.UI.Controls.assert(item, "Required an item");
                    if (!item)
                        return result;
                    var index = this._workingDataSource ? this._workingDataSource.indexOf(item) : -1;
                    MS.Entertainment.assert(index > -1, "item not found in data source");
                    var element = this.domElement.children[index];
                    if (!element)
                        return result;
                    var rightMargin = this.bringIntoViewRightMargin;
                    var leftMargin = this.bringIntoViewLeftMargin;
                    if (!options.bringOnMinimally) {
                        rightMargin = 0;
                        leftMargin = 0
                    }
                    var minRightEdgeOnScreen = (element.offsetLeft + element.clientWidth + rightMargin) - this._scroller.clientWidth;
                    var minLeftEdgeOnScreen = Math.max(0, element.offsetLeft - leftMargin);
                    if (MS.Entertainment.UI.Framework.getTextDirection() === MS.Entertainment.UI.Framework.TextDirections.RightToLeft) {
                        minLeftEdgeOnScreen = (this._scroller.clientWidth - element.offsetLeft - element.clientWidth - rightMargin);
                        minRightEdgeOnScreen = leftMargin - element.offsetLeft
                    }
                    var isRightEdgeOnScreen = this._scroller.scrollLeft >= minRightEdgeOnScreen;
                    var isLeftEdgeOnScreen = this._scroller.scrollLeft <= minLeftEdgeOnScreen;
                    var targetScrollPosition = -1;
                    if (options.alwaysAlignLeftEdge) {
                        minLeftEdgeOnScreen = Math.min(minLeftEdgeOnScreen, Math.max(0, (this._scroller.scrollWidth - this._scroller.clientWidth)));
                        targetScrollPosition = minLeftEdgeOnScreen
                    }
                    else if (!(isRightEdgeOnScreen && isLeftEdgeOnScreen))
                        if (!isRightEdgeOnScreen)
                            targetScrollPosition = minRightEdgeOnScreen;
                        else if (!isLeftEdgeOnScreen)
                            targetScrollPosition = minLeftEdgeOnScreen;
                    return targetScrollPosition
                }, getElementForItem: function getElementForItem(item) {
                    var index = this._workingDataSource ? this._workingDataSource.indexOf(item) : -1;
                    return this.domElement.children[index]
                }, _performScroll: function _performScroll(scrollLeft, animated, ignoreMissingStarts) {
                    if (!animated) {
                        this._scroller.scrollLeft = scrollLeft;
                        return WinJS.Promise.as()
                    }
                    return MS.Entertainment.UI.Framework.scrollIntoViewWithAnimation(this._scroller, scrollLeft, ignoreMissingStarts)
                }, _loadTemplate: function _loadTemplate(template) {
                    var completePromise = WinJS.Promise.as(template);
                    if (!template)
                        completePromise = new WinJS.Promise(function(c, e, p) {
                            this._itemTemplateSet = c
                        }.bind(this));
                    completePromise = completePromise.then(function(validTemplate) {
                        if (typeof validTemplate === "string")
                            return MS.Entertainment.UI.Framework.loadTemplate(validTemplate, null, true);
                        else if (validTemplate)
                            return WinJS.Promise.wrap(validTemplate.winControl)
                    });
                    return completePromise
                }, _listChangedHandler: function _listChangedHandler(newValue, oldValue) {
                    if (this._unloaded)
                        return;
                    if (!newValue) {
                        if (this._workingDataSource) {
                            this._workingDataSource.removeChangeListener(this._handleChangesInDataSource);
                            this._workingDataSource = null;
                            this._resetDomState()
                        }
                        if (newValue === null && this.itemsRendered)
                            this.itemsRendered();
                        return
                    }
                    if (this._workingDataSource)
                        this._workingDataSource.removeChangeListener(this._handleChangesInDataSource);
                    var tempWorkingData = WinJS.Binding.unwrap(newValue);
                    if (!(newValue instanceof MS.Entertainment.ObservableArray))
                        tempWorkingData = new MS.Entertainment.ObservableArray(newValue);
                    if (tempWorkingData)
                        tempWorkingData.addChangeListener(this._handleChangesInDataSource);
                    this._workingDataSource = tempWorkingData;
                    if (this.itemsChanged)
                        this.itemsChanged();
                    if (newValue || oldValue) {
                        if (this._firstTimeRenderCompleted)
                            this._resetDomState();
                        this.render(newValue && oldValue)
                    }
                }, _renderItem: function _renderItemToIndex(item, index) {
                    if (this.virtualize) {
                        MS.Entertainment.UI.Controls.assert(this.domElement.children.length <= this._workingDataSource.length, "Found more children that we should have had");
                        MS.Entertainment.UI.Controls.assert(this.domElement.children.length <= this.dataSource.length, "Found more children that we should have had")
                    }
                    if (!this._isIndexInRealizedArea(index))
                        return;
                    item = this.processItemData(item, index);
                    var container = null;
                    var selectionPromise = null;
                    if (!this._firstTimeRenderCompleted && index < this.domElement.children.length) {
                        container = this.domElement.children[index];
                        selectionPromise = WinJS.Promise.as(this._declarativeRenderHelper)
                    }
                    else
                        selectionPromise = this.selectTemplate(item);
                    selectionPromise.then(function withSelectedTemplate(itemTemplateProvider) {
                        var element;
                        if (!container)
                            container = document.createElement(itemTemplateProvider.element.tagName);
                        var that = this;
                        var upperBound = (this._workingDataSource && this._workingDataSource.length - 1) || 0;
                        var end;
                        var start;
                        if (upperBound < 0)
                            upperBound = 0;
                        end = (index >= upperBound) || (index === undefined);
                        start = (index < 1);
                        if (!end || !(end && start) && index)
                            element = this.domElement.children[index];
                        if (end || (end && start) || !element)
                            that.domElement.appendChild(container);
                        else
                            that.domElement.insertBefore(container, element);
                        if (that.containerStyle)
                            WinJS.Utilities.addClass(container, that.containerStyle);
                        if (this.virtualize) {
                            MS.Entertainment.UI.Controls.assert(this.domElement.children.length <= this._workingDataSource.length, "Found more children that we should have had");
                            MS.Entertainment.UI.Controls.assert(this.domElement.children.length <= this.dataSource.length, "Found more children that we should have had")
                        }
                        itemTemplateProvider.render(item, container).then(function(child) {
                            var animationPromise;
                            if (that.applyItemTemplate)
                                container = that.applyItemTemplate(container, item, index);
                            if (that._pendedBringItemIntoViewItem && that._pendedBringItemIntoViewItem.item === item) {
                                var complete = that._pendedBringItemIntoViewItem.completePromise;
                                that._pendedBringItemIntoViewItem = null;
                                that.bringItemIntoView(item, {bringOnMinimally: true}).then(complete)
                            }
                            if (container && that.animateIn && MS.Entertainment.UI.Framework.beginShowAnimations) {
                                var elementToAnimate = container;
                                if (that.useFirstChildForAnimations && container.children.length)
                                    elementToAnimate = container.children[0];
                                animationPromise = MS.Entertainment.UI.Framework.beginShowAnimations(elementToAnimate)
                            }
                            if (that._firstTimeRenderedCount > 0) {
                                that._firstTimeRenderedCount--;
                                if (that._firstTimeRenderedCount === 0)
                                    that._sendFirstTimeRenderedEvent()
                            }
                            if (index === 0 && that.firstItemTabIndex !== -1) {
                                var firstFocusElement = container.querySelector(".win-focusable");
                                if (firstFocusElement)
                                    firstFocusElement.tabIndex = that.firstItemTabIndex
                            }
                            if (index === 0 && that.focusFirstItemOnRender)
                                WinJS.Promise.as(animationPromise).done(function setFocusOnAnimationComplete() {
                                    var firstFocusElement = container.querySelector(".win-focusable");
                                    if (firstFocusElement)
                                        MS.Entertainment.UI.Framework.focusElement(firstFocusElement)
                                })
                        })
                    }.bind(this))
                }, itemsRendered: function itemsRendered() {
                    if (this.raisePanelReady)
                        MS.Entertainment.UI.Controls.Panel.raisePanelReady(this.domElement);
                    if (MS.Entertainment.UI.Controls.Panel)
                        MS.Entertainment.UI.Controls.Panel.raisePanelReadyTest(this.domElement);
                    if (this.itemsRenderedCallback)
                        this.itemsRenderedCallback()
                }, _sendFirstTimeRenderedEvent: function _sendFirstTimeRenderedEvent() {
                    WinJS.Promise.timeout(1).then(function sendFirstTimeRenderedEvent() {
                        if (this.domElement) {
                            var domEvent = document.createEvent("Event");
                            domEvent.initEvent("firstTimeRendered", true, true);
                            this.domElement.dispatchEvent(domEvent)
                        }
                    }.bind(this))
                }, _removeChildrenFromIndex: function _removeChildrenFromIndex(index) {
                    for (var i = this.domElement.children.length - 1; i >= index; i--)
                        this.domElement.removeChild(this.domElement.children[i])
                }, _resetDomState: function _resetDomState() {
                    MS.Entertainment.UI.Framework.empty(this.domElement);
                    this._resetVirtualizationCaches()
                }, _handleChangesInDataSource: function _handleChangesInDataSource(notification) {
                    if (this.itemsChanged)
                        this.itemsChanged(notification);
                    this._highestIndexItemToRender = -1;
                    switch (notification.type) {
                        case MS.Entertainment.ObservableArray.OperationTypes.add:
                            if (this.virtualize && !this._isIndexInRealizedArea(notification.index))
                                this._removeChildrenFromIndex(notification.index);
                            else
                                this._renderItem(notification.item, notification.index);
                            break;
                        case MS.Entertainment.ObservableArray.OperationTypes.remove:
                            MS.Entertainment.assert(notification.index < this.domElement.children.length, "Child to remove doesn't exist");
                            var child = this.domElement.children[notification.index];
                            if (child) {
                                this.domElement.removeChild(child);
                                if (this._handleItemRemoved)
                                    this._handleItemRemoved(child);
                                if (this.virtualize && !this._isIndexInRealizedArea(notification.index))
                                    this._removeChildrenFromIndex(notification.index)
                            }
                            if (this.virtualize)
                                this._ensureRealizedToRealizedItemLimit();
                            break;
                        case MS.Entertainment.ObservableArray.OperationTypes.reset:
                            this._resetDomState();
                            break;
                        default:
                            MS.Entertainment.assert(false, "unsupported notification type: " + notification.type);
                            break
                    }
                    this._setSizeForScrolling()
                }
        }, null, {
            waitForItemsControlRenderEvents: function waitForItemsControlRenderEvents(domElement, numEvents) {
                numEvents = numEvents || 1;
                var itemsControlBindings;
                return new WinJS.Promise(function initPromise(complete, error) {
                        itemsControlBindings = MS.Entertainment.UI.Framework.addEventHandlers(domElement, {firstTimeRendered: function() {
                                numEvents--;
                                if (numEvents === 0 && itemsControlBindings) {
                                    itemsControlBindings.cancel();
                                    itemsControlBindings = null;
                                    complete()
                                }
                            }})
                    }, function onCancel() {
                        if (itemsControlBindings) {
                            itemsControlBindings.cancel();
                            itemsControlBindings = null
                        }
                    })
            }, ContainerStyles: {
                    none: "", horizontalFlow: "horizontalFlow", verticalFlow: "verticalFlow", listFlowLeft: "listFlowLeft"
                }, VirtualizationAxis: {
                    horizontal: "horizontal", vertical: "vertical"
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {FlexibleItemsControl: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ItemsControl", null, function(element, options) {
            WinJS.Utilities.addClass(element, "flexibleItemsControlContainer");
            this.applyPanelTemplate = this.applyPanelTemplate.bind(this);
            this.onItemClicked = this._onItemClicked.bind(this)
        }, {
            dataContext: null, itemTemplates: null, itemSize: null, rowLayout: false, fixedRowCount: null, fixedColumnCount: null, skipSettingWidth: false, skipSettingHeight: false, reflowOnWindowSizeChanged: false, restoreFocusOnUpdate: false, restoreFocusAfterBackNavigate: false, enableClickEvents: false, _loadTemplatePromise: null, _restoreFocusAfterRender: false, _restoreFocusAfterBackNavigate: false, applyPanelTemplate: function applyPanelTemplate() {
                    var dataLength = this._workingDataSource ? this._workingDataSource.length : 1;
                    var rowCount;
                    var columnCount;
                    var hasFixedRowCount = typeof this.fixedRowCount === "number";
                    var hasFixedColumnCount = typeof this.fixedColumnCount === "number";
                    if (hasFixedRowCount && !hasFixedColumnCount) {
                        rowCount = this.fixedRowCount;
                        columnCount = Math.max(Math.ceil(dataLength / rowCount), 1)
                    }
                    else if (!hasFixedRowCount && hasFixedColumnCount) {
                        columnCount = this.fixedColumnCount;
                        rowCount = Math.max(Math.ceil(dataLength / columnCount), 1)
                    }
                    else if (hasFixedRowCount && hasFixedColumnCount) {
                        rowCount = this.fixedRowCount;
                        columnCount = this.fixedColumnCount
                    }
                    else {
                        rowCount = MS.Entertainment.Utilities.getRowCountForResolution();
                        columnCount = Math.max(Math.ceil(dataLength / rowCount), 1)
                    }
                    MS.Entertainment.UI.Controls.assert(dataLength <= (rowCount * columnCount), "FlexibleItemsControl_applyPanelTemplate: Items don't fit in the container.");
                    var explicitWidth = (columnCount * this.itemSize.width) + "px";
                    var explicitHeight = (rowCount * this.itemSize.height) + "px";
                    if (!this.skipSettingWidth && this.domElement.style.width !== explicitWidth)
                        this.domElement.style.width = explicitWidth;
                    if (!this.skipSettingHeight && this.domElement.style.height !== explicitHeight)
                        this.domElement.style.height = explicitHeight;
                    if (this.rowLayout)
                        WinJS.Utilities.addClass(this.domElement, "flexRowLayout");
                    var domEvent = document.createEvent("Event");
                    domEvent.initEvent("SizeAdjusted", true, true);
                    this.domElement.dispatchEvent(domEvent)
                }, itemsChanged: function itemsChanged() {
                    if (this.restoreFocusOnUpdate && this.domElement.contains(document.activeElement))
                        this._restoreFocusAfterRender = true;
                    this.applyPanelTemplate()
                }, restoreFocus: function restoreFocus() {
                    if ((this._restoreFocusAfterRender || this._restoreFocusAfterBackNavigate) && MS.Entertainment.UI.Framework.canMoveFocus(this.domElement)) {
                        MS.Entertainment.UI.Framework.focusFirstInSubTree(this.domElement);
                        this._restoreFocusAfterBackNavigate = false
                    }
                    this._restoreFocusAfterRender = false
                }, initialize: function initialize() {
                    MS.Entertainment.UI.Controls.ItemsControl.prototype.initialize.apply(this, arguments);
                    if (this.reflowOnWindowSizeChanged)
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).addEventListener("windowresize", this.applyPanelTemplate);
                    if (this.enableClickEvents)
                        this.domElement.addEventListener("click", this.onItemClicked)
                }, thaw: function thaw() {
                    MS.Entertainment.UI.Controls.ItemsControl.prototype.thaw.call(this);
                    if (this.dataContext && this.dataContext.thaw)
                        this.dataContext.thaw();
                    if (!document.activeElement && this.restoreFocusAfterBackNavigate)
                        this.restoreFocus()
                }, unload: function unload() {
                    if (this.reflowOnWindowSizeChanged)
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).removeEventListener("windowresize", this.applyPanelTemplate);
                    if (this.enableClickEvents)
                        this.domElement.removeEventListener("click", this.onItemClicked);
                    MS.Entertainment.UI.Controls.ItemsControl.prototype.unload.call(this)
                }, applyItemTemplate: function applyItemTemplate(container) {
                    WinJS.Utilities.addClass(container, "flexibleItemsControlItemContainer");
                    return container
                }, resetItemTemplate: function resetItemTemplate() {
                    if (this._loadTemplatePromise) {
                        this._loadTemplatePromise.cancel();
                        this._loadTemplatePromise = null
                    }
                    this.loadItemTemplate()
                }, loadItemTemplate: function() {
                    MS.Entertainment.UI.Controls.assert(!this.itemTemplate, "Do not support non-array template");
                    MS.Entertainment.UI.Controls.assert(Array.isArray(this.itemTemplates), "expected an array");
                    if (this._loadTemplatePromise)
                        return this._loadTemplatePromise;
                    var templateLoadPromises = [];
                    var loadedTemplates = {};
                    this.itemTemplates.forEach(function(item) {
                        var promise = MS.Entertainment.UI.Framework.loadTemplate(item.template, null, true).then(function(template) {
                                loadedTemplates[item.value] = template
                            });
                        templateLoadPromises.push(promise)
                    });
                    this._loadTemplatePromise = WinJS.Promise.join(templateLoadPromises).then(function() {
                        this._itemTemplateProviders = loadedTemplates
                    }.bind(this));
                    return this._loadTemplatePromise
                }, selectTemplate: function selectTemplate(item) {
                    return this.loadItemTemplate().then(function() {
                            var propertyValue = item[this._getPropertyToCheck(item)];
                            MS.Entertainment.UI.Controls.assert(propertyValue, "Couldn't find that property on the data, it was falsey.");
                            var template = this._itemTemplateProviders[propertyValue];
                            MS.Entertainment.UI.Controls.assert(template, "Couldn't find a template for property: " + this.propertyName + " with value: " + propertyValue);
                            return template
                        }.bind(this))
                }, _getPropertyToCheck: function _getPropertyToCheck(item) {
                    if (!Array.isArray(this.propertyName))
                        return this.propertyName;
                    var propertyName;
                    for (var i = 0; i < this.propertyName.length; i++)
                        if (item[this.propertyName[i]]) {
                            propertyName = this.propertyName[i];
                            break
                        }
                    return propertyName
                }, _onItemClicked: function _onItemClicked(e) {
                    var element = e.srcElement;
                    while (element && element !== this.domElement) {
                        if (element.clickDataContext && element.clickDataContext.doclick) {
                            element.clickDataContext.doclick({
                                target: element.clickDataContext, domElement: element
                            });
                            e.stopPropagation();
                            if (this.restoreFocusAfterBackNavigate)
                                this._restoreFocusAfterBackNavigate = true;
                            return
                        }
                        element = element.parentElement
                    }
                }
        }, {})});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
        DeclarativeItemsControl: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ItemsControl", null, null, null, {isDeclarativeControlContainer: true}), DeclarativeItemsControlRenderHelper: MS.Entertainment.UI.Framework.define(function DeclarativeItemsControlRenderHelper(){}, {render: function render(dataContext, container) {
                    return WinJS.UI.processAll(container).then(function bindingProcessAllAfterControlProcessAll() {
                            return WinJS.Binding.processAll(container, dataContext)
                        }).then(function returnContainer() {
                            return container
                        })
                }})
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ItemsControlWithViewModel: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ItemsControl", null, function itemsControlWithViewModel(element, options){}, {
            listViewModel: null, controlName: "ItemsControlWithViewModel", processItemData: function processItemData(itemData, index) {
                    return new MS.Entertainment.UI.Controls.ItemsControlViewModel(itemData, this.listViewModel, index)
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ItemsControlWithVariableSizeItems: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ItemsControl", null, function ItemsControlWithVariableSizeItems(element, options) {
            if (!this.getItemSize)
                throw new Error("getItemSize function is required when using variable sized items");
        }, {
            virtualize: true, additionalScrollContainerPadding: 0, additionalItemsToRealize: 0, highestIndexItemToRender: {get: function highestIndexItemToRender_get() {
                        if (this._highestIndexItemToRender === -1) {
                            var itemCount = 0;
                            var currentHighestViewportPosition = this.scrollPosition + this.scrollerSize - this.firstItemScrollOffset;
                            var summedSize = 0;
                            var workingLength = this._workingDataSource.length;
                            while (summedSize < currentHighestViewportPosition && itemCount < workingLength) {
                                summedSize += this.getItemSize(this._workingDataSource.item(itemCount));
                                itemCount++
                            }
                            if (this.additionalItemsToRealize) {
                                var adjustedItemIndex = Math.min(itemCount + this.additionalItemsToRealize, workingLength);
                                itemCount = adjustedItemIndex
                            }
                            this._highestIndexItemToRender = itemCount
                        }
                        return this._highestIndexItemToRender
                    }}, _setSizeForScrolling: function _setSizeForScrolling() {
                    if (!(this.useParentAsScrollContainer && this.virtualize))
                        return;
                    var size = String.empty;
                    if (this._workingDataSource && this._workingDataSource.length) {
                        var summedSize = 0;
                        this._workingDataSource.forEach(function sumItemSize(item) {
                            summedSize += this.getItemSize(item)
                        }.bind(this));
                        summedSize += this.additionalScrollContainerPadding;
                        size = summedSize + "px"
                    }
                    if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                        this.domElement.style.width = size;
                    else if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.vertical)
                        this.domElement.style.height = size
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ItemsControlViewModel: MS.Entertainment.UI.Framework.define(function itemsControlViewModel(data, listViewModel, index) {
            this.data = data;
            this.listViewModel = listViewModel;
            this.index = index
        }, {
            listViewModel: null, data: null, index: -1, instance: {get: function() {
                        return this
                    }}
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {CarouselItemsControl: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ItemsControl", null, function carouselItemsControl(element, options) {
            if (!this.itemSize)
                throw new Error("itemSize required when using a carousel");
            if (!this.virtualizationAxis)
                throw new Error("virtualizationOrientation required when using virtualization");
        }, {
            controlName: "CarouselItemsControl", leftOffset: 0, transitionDuration: 0, _defaultTimeoutMS: 500, _defaultTransitionDuration: 333, applyPanelTemplate: function applyPanelTemplate() {
                    if (this._workingDataSource) {
                        var marginLeft = WinJS.Utilities.convertToPixels(this.domElement, window.getComputedStyle(this.domElement, null)["margin-Left"]);
                        var marginRight = WinJS.Utilities.convertToPixels(this.domElement, window.getComputedStyle(this.domElement, null)["margin-Right"]);
                        var buffer = marginLeft + marginRight;
                        this.domElement.style.width = (this._workingDataSource.length * this.itemSize + buffer) + "px"
                    }
                }, applyItemTemplate: function applyItemTemplate(container, item, index) {
                    var offset = (this.itemSize * (this.leftOffset + index));
                    container.style.position = "absolute";
                    if (this.virtualizationAxis === MS.Entertainment.UI.Controls.ItemsControl.VirtualizationAxis.horizontal)
                        container.style.left = offset + "px";
                    else
                        container.style.top = offset + "px";
                    MS.Entertainment.UI.Framework.applyWithSelector(container, ".ent-delayInitialize, [data-win-control], .ent-control", function executeDelayInitialize(element) {
                        var currentControl = element.winControl;
                        if (currentControl && currentControl.enableDelayInitialization && currentControl.delayInitialize)
                            currentControl.delayInitialize()
                    });
                    return container
                }, scrollAnimated: function scrollAnimated(count, timeout) {
                    if (count === 0)
                        return WinJS.Promise.as();
                    if (!MS.Entertainment.UI.Framework.animationsEnabled)
                        return WinJS.Promise.as();
                    var translateDelta = -count * this.itemSize;
                    if (this.domElement.isAnimatingScroll)
                        return WinJS.Promise.as();
                    var updateItemPosition = function updateItemPosition() {
                            var removedItem = null;
                            var removedDataItem = null;
                            Array.prototype.forEach.call(this.domElement.children, function(item) {
                                WinJS.Utilities.removeClass(item, "scrollAnimation");
                                item.style.msTransform = "";
                                item.style.left = item.targetLeft + "px"
                            }.bind(this));
                            this.domElement.isAnimatingScroll = null
                        }.bind(this);
                    timeout = timeout || this._defaultTimeoutMS;
                    var timeoutPromise = WinJS.Promise.timeout(timeout).then(function resetAnimatingFlag() {
                            scrollComplete.cancel();
                            timeoutPromise = null
                        }.bind(this));
                    var scrollComplete = this.domElement.isAnimatingScroll;
                    if (!scrollComplete)
                        scrollComplete = MS.Entertainment.UI.Framework.waitForStartedTransitionsToComplete(this.domElement, true, "scrollAnimation").then(function() {
                            if (timeoutPromise) {
                                timeoutPromise.cancel();
                                timeoutPromise = null
                            }
                            updateItemPosition()
                        }.bind(this), function animationFailed() {
                            updateItemPosition()
                        }.bind(this));
                    else
                        MS.Entertainment.UI.Framework.resetStartedTransitionCount(this.domElement);
                    Array.prototype.forEach.call(this.domElement.children, function(item) {
                        WinJS.Utilities.addClass(item, "scrollAnimation");
                        var left = WinJS.Utilities.convertToPixels(item, window.getComputedStyle(item, null)["left"]);
                        item.targetLeft = Math.max(left + translateDelta, 0);
                        var transformStyle = "translateX(" + translateDelta + "px)";
                        var duration = this._defaultTransitionDuration;
                        if (this.transitionDuration > 0)
                            duration = this.transitionDuration;
                        item.style.transitionDuration = duration;
                        item.style.msTransform = transformStyle
                    }.bind(this));
                    this.domElement.isAnimatingScroll = scrollComplete;
                    return scrollComplete
                }
        })})
})()
