﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
WinJS.strictProcessing();
WinJS.Binding.optimizeBindingReferences = true;
scriptValidator();
MS.Entertainment.Utilities.updateHtmlDirectionAttribute();
MS.Entertainment.UI.Framework.unblockCriticalPreloading();
MS.Entertainment.UI.Framework.enableAutoControlCleanup();
MS.Entertainment.UI.Framework.enableSetImmediateBatching();
var individualizationWorker = null;
var appDisplayName = "";
(function() {
    if (window.usingNewMusicPage)
        return;
    var applicationLifetimeManager = null;
    var commonEventProvider = null;
    var tileManager = null;
    var initialized = false;
    var alreadyHandledLaunch = false;
    var startPlaybackOnLaunch = false;
    var stageTwoInitialised = false;
    var stageThreePromise = null;
    var stageFourPromise = null;
    var stageFourDelay = 5000;
    var shouldShowAppBar = false;
    var showAppBarDelay = 0;
    var wasRecentlyResumed = false;
    var isPrelaunched = false;
    if (window.clientInformation && window.clientInformation.cpuClass === "ARM")
        showAppBarDelay = 5000;
    WinJS.Application.onerror = MS.Entertainment.UI.Debug.unhandledPromiseErrorHandler;
    WinJS.Namespace.define("MS.Entertainment.UI.Application", {
        triggerSequences: [], Activation: MS.Entertainment.UI.Framework.define(null, null, {
                handlePrelaunch: function handlePrelaunch(args) {
                    isPrelaunched = true;
                    MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen();
                    MS.Entertainment.Utilities.loadHtmlPage("/delayedStageThreeStartup.html", "delayedStartupContainer");
                    var activationArgsClone = MS.Entertainment.Utilities.cloneActivationArguments(args);
                    var madeVisibleCount = 0;
                    var documentEvents = MS.Entertainment.UI.Framework.addEventHandlers(document, {visibilitychange: function() {
                                if (document.hidden)
                                    return;
                                isPrelaunched = false;
                                documentEvents.cancel();
                                MS.Entertainment.Utilities.resetPerfTrackStartTime();
                                MS.Entertainment.UI.Application.Activation.activated(activationArgsClone, false, true)
                            }})
                }, activated: function activated(activationArgs, isNonRootActivationHandler, preLaunched) {
                        if (window.sessionStorage["HardBlockEnabled"] === "true") {
                            WinJS.Promise.timeout().then(function _delay() {
                                window.location.href = "UpdateApp.html"
                            });
                            MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                            return
                        }
                        if (activationArgs.prelaunchActivated) {
                            MS.Entertainment.UI.Application.Activation.handlePrelaunch(activationArgs);
                            return
                        }
                        if (!isNonRootActivationHandler) {
                            if (activationArgs.arguments === MS.Entertainment.Utilities.retailExperienceArgument)
                                MS.Entertainment.Utilities.setRetailExperienceState(true);
                            WinJS.Application.start();
                            if (!commonEventProvider)
                                commonEventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Common;
                            commonEventProvider.traceProcessInitializeEventStart();
                            var startTime = new Date;
                            if (!applicationLifetimeManager)
                                applicationLifetimeManager = new Microsoft.Entertainment.ApplicationLifetimeManager;
                            if (!preLaunched)
                                applicationLifetimeManager.raiseActivated(activationArgs)
                        }
                        var isFirstRun = !initialized;
                        var isSupported = true;
                        if (!initialized) {
                            var className;
                            MS.Entertainment.UI.Application.Helpers.activationTelemetryData = [];
                            if (!isNonRootActivationHandler) {
                                var demoModeAppStateReset = MS.Entertainment.Utilities.resetAppStateForRetailExperienceIfNeeded();
                                MS.Entertainment.appMode = (new Microsoft.Entertainment.Application.Application).init();
                                if (demoModeAppStateReset)
                                    MS.Entertainment.Utilities.removeAllPlaylistsIfDemoMode()
                            }
                            var stateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                            var currentPackage = Windows.ApplicationModel.Package.current;
                            var currentVersion = currentPackage.id.version;
                            var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                            var minVersionSupported;
                            var minServiceVersionSupported;
                            if (MS.Entertainment.Utilities.valueFromPropertyPathFragments(Windows, ["ApplicationModel", "Search", "SearchPane", "hideThisApplication"]))
                                Windows.ApplicationModel.Search.SearchPane.hideThisApplication();
                            if (MS.Entertainment.Utilities.isMusicApp) {
                                appDisplayName = String.load(String.id.IDS_MANIFEST_MUSIC_APP_NAME);
                                if (MS.Entertainment.Utilities.isMusicApp1) {
                                    className = "music music1 app1";
                                    stateService.applicationTitle = String.load(String.id.IDS_XBOX_MUSIC_APP_TITLE)
                                }
                                else {
                                    className = "music music2 app2";
                                    stateService.applicationTitle = String.load(String.id.IDS_XBOX_MUSIC2_APP_TITLE)
                                }
                                minVersionSupported = MS.Entertainment.Utilities.parseVersionString(configurationManager.fue.minMusicAppSupportedVersion);
                                minServiceVersionSupported = MS.Entertainment.Utilities.parseVersionString(configurationManager.service.minMusicServiceSupportedVersion)
                            }
                            else if (MS.Entertainment.Utilities.isVideoApp) {
                                appDisplayName = String.load(String.id.IDS_MANIFEST_VIDEO_APP_NAME);
                                if (MS.Entertainment.Utilities.isVideoApp1) {
                                    className = "video video1 app1";
                                    stateService.applicationTitle = String.load(String.id.IDS_XBOX_VIDEO_APP_TITLE)
                                }
                                else {
                                    className = "video video2 app2";
                                    stateService.applicationTitle = String.load(String.id.IDS_XBOX_VIDEO2_APP_TITLE)
                                }
                                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                                if (!featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace) && !featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace))
                                    className += " noMarketplace";
                                minVersionSupported = MS.Entertainment.Utilities.parseVersionString(configurationManager.fue.minVideoAppSupportedVersion);
                                minServiceVersionSupported = MS.Entertainment.Utilities.parseVersionString(configurationManager.service.minVideoServiceSupportedVersion)
                            }
                            else if (MS.Entertainment.Utilities.isTestApp) {
                                appDisplayName = "test";
                                className = "test";
                                minVersionSupported = MS.Entertainment.Utilities.parseVersionString("1.0.0.0");
                                minServiceVersionSupported = MS.Entertainment.Utilities.parseVersionString("1.0.0.0")
                            }
                            else
                                className = String.empty;
                            if (configurationManager.shell.retailExperience)
                                className += " demo";
                            var versionSupported = (MS.Entertainment.Utilities.compareVersions(currentVersion, minVersionSupported) >= 0);
                            stateService.servicesEnabled = (MS.Entertainment.Utilities.compareVersions(currentVersion, minServiceVersionSupported) >= 0);
                            if (!versionSupported) {
                                WinJS.Promise.timeout().then(function _delay() {
                                    window.location.href = "UpdateApp.html"
                                });
                                MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                                return
                            }
                            WinJS.Utilities.addClass(document.documentElement, className);
                            MS.Entertainment.UI.Framework.flags.attachCookieToRemovedDomElements = configurationManager.shell.attachCookieToRemovedDomElements;
                            MS.Entertainment.UI.Framework.flags.attachLargeObjectToUnloadedControl = configurationManager.shell.attachLargeObjectToUnloadedControl;
                            if (MS.Entertainment.Utilities.isApp2) {
                                if (!MS.Entertainment.isAppModeOverride) {
                                    var previewConfigSeq = [WinJS.Utilities.Key.rtButton, WinJS.Utilities.Key.ltButton, WinJS.Utilities.Key.rGlobal, WinJS.Utilities.Key.lGlobal, WinJS.Utilities.Key.invokeButton];
                                    MS.Entertainment.UI.Application.triggerSequences.push(new MS.Entertainment.Utilities.TriggerSequence(previewConfigSeq, 500, function toggleFullRights() {
                                        var cm = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                        cm.playback.previewOnly = !cm.playback.previewOnly;
                                        var message = cm.playback.previewOnly ? "WARNING: PreviewOnly mode is now active." : "PreviewOnly mode is now OFF. \nMake sure your DRM is provisioned for SL2000.";
                                        MS.Entertainment.UI.Shell.showMessageBox("CONFIGURATION CHANGE", message)
                                    }))
                                }
                                document.body.addEventListener("keyup", function(e) {
                                    if (MS.Entertainment.UI.Application.triggerSequences)
                                        for (var i = 0; i < MS.Entertainment.UI.Application.triggerSequences.length; i++)
                                            if (MS.Entertainment.UI.Application.triggerSequences[i].keyIn(e.keyCode) && e.keyCode === WinJS.Utilities.Key.invokeButton)
                                                return;
                                    if (e.keyCode === WinJS.Utilities.Key.invokeButton || (!e.altKey && e.keyCode === WinJS.Utilities.Key.enter && !MS.Entertainment.Utilities.doesElementSupportKeyboardInput(e.target))) {
                                        if (document.activeElement && document.activeElement.click && e.target && e.target.tagName && e.target.tagName.toLowerCase() !== "button") {
                                            document.activeElement.click();
                                            e.stopPropagation();
                                            e.preventDefault()
                                        }
                                    }
                                    else if ((e.keyCode === WinJS.Utilities.Key.resetFocus) || (e.altKey && e.keyCode === WinJS.Utilities.Key.f))
                                        MS.Entertainment.UI.Framework.resetFocusToTopMostContent();
                                    else if (e.altKey && e.keyCode === WinJS.Utilities.Key.m);
                                }, false)
                            }
                            if ((MS.Entertainment.Utilities.isMusicApp1 && (configurationManager.music.radioStringLocales === "ALL" || configurationManager.music.radioStringLocales.match(new RegExp("(^|,)" + MS.Entertainment.Utilities.getResourceLanguage() + "(,|$)")))) || MS.Entertainment.Utilities.isMusicApp2)
                                MS.Entertainment.Utilities.useRadioStrings();
                            initialized = true
                        }
                        else
                            MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                        if (!isNonRootActivationHandler) {
                            var stopTime = new Date;
                            var duration = stopTime.valueOf() - startTime.valueOf();
                            commonEventProvider.traceProcessInitializeEventStop(duration)
                        }
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).appActivated();
                        var doActivate = function doActivate(evt) {
                                var navigationService;
                                var eventKind;
                                var deeplinkUri;
                                var launchArgs;
                                startPlaybackOnLaunch = MS.Entertainment.Utilities.isMusicApp2;
                                var PlatLog = Microsoft.Entertainment.Platform.Logging;
                                var dataPoint = new PlatLog.DataPoint(PlatLog.LoggingLevel.telemetry, PlatLog.TelemetryAuthMethod.unauthenticated);
                                dataPoint.appendEventName("X8Run");
                                dataPoint.appendParameter("ClientResolution", screen.width + "x" + screen.height);
                                try {
                                    eventKind = evt.kind
                                }
                                catch(e) {
                                    var error = e && e.detail && e.detail.error;
                                    var description = e && e.detail && e.detail.exception;
                                    MS.Entertainment.fail("Exception while trying to determine the activation kind. Error exception was:" + description + "." + "\n Error was:" + error);
                                    return
                                }
                                try {
                                    if (evt && evt.uri && evt.uri.rawUri)
                                        deeplinkUri = new Windows.Foundation.Uri(evt.uri.rawUri)
                                }
                                catch(e) {
                                    var error = e && e.detail && e.detail.error;
                                    var description = e && e.detail && e.detail.exception;
                                    MS.Entertainment.fail("Could not access activation event URI. Error exception was: " + description + "." + "\n Error was " + error)
                                }
                                try {
                                    if (evt && evt.arguments)
                                        launchArgs = evt.arguments
                                }
                                catch(e) {
                                    var error = e && e.detail && e.detail.error;
                                    var description = e && e.detail && e.detail.exception;
                                    MS.Entertainment.fail("Could not access activation event arguments. Error exception was: " + description + "." + "\n Error was " + error)
                                }
                                if (eventKind === Windows.ApplicationModel.Activation.ActivationKind.launch && !deeplinkUri && launchArgs)
                                    eventKind = Windows.ApplicationModel.Activation.ActivationKind.protocol;
                                else if (eventKind === Windows.ApplicationModel.Activation.ActivationKind.protocol && deeplinkUri && (!deeplinkUri.host || deeplinkUri.host === "default") && (!deeplinkUri.query || !alreadyHandledLaunch))
                                    eventKind = Windows.ApplicationModel.Activation.ActivationKind.launch;
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind = eventKind;
                                switch (eventKind) {
                                    case Windows.ApplicationModel.Activation.ActivationKind.protocol:
                                        var deepLinkProcessed = false;
                                        var preProcessPromise = WinJS.Promise.as();
                                        var finishInitializing = function finishInitializing(){};
                                        var processStageTwo = function processStageTwo() {
                                                MS.Entertainment.UI.Application.Activation.activateStageTwo();
                                                var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                                                if (uiStateService.isSnapped)
                                                    MS.Entertainment.UI.Components.Shell.getUnsnapAction().execute()
                                            };
                                        if (MS.Entertainment.Utilities.isApp1) {
                                            MS.Entertainment.UI.Application.Helpers.showExtendedSplashScreen(evt.splashScreen);
                                            processStageTwo();
                                            preProcessPromise = MS.Entertainment.UI.Application.Activation.activateStageThree()
                                        }
                                        else
                                            finishInitializing = function finishInitializing() {
                                                processStageTwo();
                                                MS.Entertainment.UI.Application.Activation.activateStageThree()
                                            };
                                        var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                        signIn.signInOnStart();
                                        if (!deeplinkUri && launchArgs)
                                            dataPoint.appendParameter("StartedFrom", "Deeplink");
                                        else
                                            dataPoint.appendParameter("StartedFrom", "Tile");
                                        preProcessPromise.done(function preProcessFinished() {
                                            if (MS.Entertainment.Utilities.isMusicApp1 && deeplinkUri && deeplinkUri.host && deeplinkUri.host === "play") {
                                                deepLinkProcessed = true;
                                                MS.Entertainment.UI.DeepLink.processProtocol((deeplinkUri && deeplinkUri.rawUri), dataPoint, launchArgs);
                                                MS.Entertainment.Instrumentation.PerfTrack.enableScenarioAppLaunchPlayProtectedContent();
                                                finishInitializing()
                                            }
                                            if (MS.Entertainment.Utilities.isApp2)
                                                MS.Entertainment.UI.Application.Helpers.showExtendedSplashScreen(evt.splashScreen);
                                            if (!deepLinkProcessed)
                                                WinJS.Promise.join({
                                                    validDeepLink: (!deeplinkUri || deeplinkUri.host !== "runTest"), showWelcomeDialog: MS.Entertainment.UI.Application.Helpers.shouldShowWelcomeDialog()
                                                }).then(function(result) {
                                                    showWelcomeDialog = result.validDeepLink && result.showWelcomeDialog;
                                                    if (showWelcomeDialog)
                                                        return MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen()
                                                }).done(function processDeeplink() {
                                                    if (!MS.Entertainment.UI.DeepLink.processProtocol((deeplinkUri && deeplinkUri.rawUri), dataPoint, launchArgs)) {
                                                        finishInitializing();
                                                        MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                                                        var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                                        navigationService.clearBackStackOnNextNavigate(false);
                                                        if (!navigationService.currentPage)
                                                            navigationService.init();
                                                        else
                                                            MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen()
                                                    }
                                                    else {
                                                        finishInitializing();
                                                        MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen();
                                                        if (isFirstRun)
                                                            if ((MS.Entertainment.Utilities.isVideoApp) || (MS.Entertainment.Utilities.isMusicApp))
                                                                if (deeplinkUri && deeplinkUri.host && deeplinkUri.host === "play")
                                                                    MS.Entertainment.Instrumentation.PerfTrack.enableScenarioAppLaunchPlayProtectedContent()
                                                    }
                                                })
                                        });
                                        break;
                                    case Windows.ApplicationModel.Activation.ActivationKind.file:
                                        MS.Entertainment.UI.Application.Helpers.waitForDatabaseUpdated();
                                        if (isFirstRun && !isNonRootActivationHandler)
                                            if ((MS.Entertainment.Utilities.isVideoApp) || (MS.Entertainment.Utilities.isMusicApp)) {
                                                MS.Entertainment.Instrumentation.PerfTrack.enableScenarioAppLaunchPlayNonProtectedContent();
                                                MS.Entertainment.Instrumentation.PerfTrack.enableScenarioAppLaunchPlayProtectedContent()
                                            }
                                        MS.Entertainment.UI.Application.Helpers.showExtendedSplashScreen(evt.splashScreen);
                                        var loadFileActivationHtmlPromise = null;
                                        if (MS.Entertainment.Utilities.isApp1)
                                            loadFileActivationHtmlPromise = MS.Entertainment.Utilities.loadHtmlPage("/fileActivationStartup.html", "delayedStartupContainer");
                                        else
                                            loadFileActivationHtmlPromise = WinJS.Promise.wrap();
                                        loadFileActivationHtmlPromise.done(function loadFileActivationFiles() {
                                            MS.Entertainment.UI.Framework.setImmediateMode = MS.Entertainment.UI.Framework.setImmediateModes.none;
                                            var suppressNavigateToImmersive = false;
                                            if (MS.Entertainment.Utilities.isMusicApp1) {
                                                var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                                                suppressNavigateToImmersive = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.fileLaunchToDashboard);
                                                shouldShowAppBar = suppressNavigateToImmersive
                                            }
                                            var beginPlaybackPromise = new WinJS.Promise.as;
                                            if (!isNonRootActivationHandler)
                                                beginPlaybackPromise = MS.Entertainment.Activation.fileActivationHandler(evt, !isFirstRun, suppressNavigateToImmersive);
                                            beginPlaybackPromise.then(function continueStageTwo() {
                                                if (!suppressNavigateToImmersive)
                                                    MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen();
                                                MS.Entertainment.UI.Framework.setImmediateMode = MS.Entertainment.UI.Framework.setImmediateModes.startup;
                                                MS.Entertainment.UI.Application.Activation.activateStageTwo();
                                                if (isFirstRun && suppressNavigateToImmersive) {
                                                    var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                                    if (!isNonRootActivationHandler && !preLaunched)
                                                        navigationService.skipEnterAnimationOnNextNavigation = true;
                                                    navigationService.init()
                                                }
                                                else
                                                    MS.Entertainment.UI.Application.Activation.activateStageThree()
                                            }, function onError() {
                                                MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                                                MS.Entertainment.UI.Application.Activation.activateStageTwo();
                                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).init()
                                            })
                                        });
                                        dataPoint.appendParameter("StartedFrom", "File");
                                        break;
                                    case Windows.ApplicationModel.Activation.ActivationKind.launch:
                                        if (alreadyHandledLaunch)
                                            return;
                                        alreadyHandledLaunch = true;
                                        MS.Entertainment.UI.Application.Helpers.showExtendedSplashScreen(evt.splashScreen);
                                        if (deeplinkUri && deeplinkUri.query && deeplinkUri.host === "default")
                                            try {
                                                var playState = deeplinkUri.queryParsed.getFirstValueByName("PlayState");
                                                startPlaybackOnLaunch = playState && playState.toLowerCase() === MS.Entertainment.UI.DeepLink.PlayStateType.play
                                            }
                                            catch(e) {
                                                startPlaybackOnLaunch = false
                                            }
                                        MS.Entertainment.UI.Application.Activation.activateStageTwo();
                                        if (MS.Entertainment.Utilities.isVideoApp) {
                                            var defaultLaunchSetting = String.Empty;
                                            var moniker = String.empty;
                                            if (MS.Entertainment.Utilities.isVideoApp1) {
                                                defaultLaunchSetting = Windows.Storage.ApplicationData.current.roamingSettings.values["launchLocation"];
                                                moniker = MS.Entertainment.UI.Monikers[defaultLaunchSetting]
                                            }
                                            if (!defaultLaunchSetting || !moniker)
                                                if (MS.Entertainment.Utilities.isVideoApp1)
                                                    MS.Entertainment.ViewModels.VideoSpotlight.startupVideoSpotlight = new MS.Entertainment.ViewModels.VideoSpotlight;
                                                else
                                                    MS.Entertainment.UI.Video.HomeDashboardViewModel.startupHomeDashboardViewModel = new MS.Entertainment.UI.Video.HomeDashboardViewModel
                                        }
                                        navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                        if (!isNonRootActivationHandler && !preLaunched)
                                            navigationService.skipEnterAnimationOnNextNavigation = true;
                                        navigationService.init();
                                        dataPoint.appendParameter("StartedFrom", "Tile");
                                        break;
                                    case Windows.ApplicationModel.Activation.ActivationKind.search:
                                        MS.Entertainment.UI.Application.Helpers.showExtendedSplashScreen(evt.splashScreen);
                                        MS.Entertainment.UI.Application.Activation.activateStageTwo();
                                        MS.Entertainment.UI.Application.Activation.activateStageThree().done(function stageThreeActivated() {
                                            var handled = false;
                                            if (evt && evt.queryText) {
                                                MS.Entertainment.ViewModels.SearchContractViewModel.init();
                                                if (MS.Entertainment.ViewModels.SearchContractViewModel.current)
                                                    handled = MS.Entertainment.ViewModels.SearchContractViewModel.current.searchKeywordSubmitted(evt)
                                            }
                                            if (!handled)
                                                if (!MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).currentPage)
                                                    MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).init();
                                            dataPoint.appendParameter("StartedFrom", "Deeplink");
                                            dataPoint.appendParameter("DeeplinkSource", "Search")
                                        });
                                        break
                                }
                                {};
                                if (!isNonRootActivationHandler)
                                    MS.Entertainment.Utilities.Telemetry.closeDataPoint(dataPoint)
                            };
                        doActivate(activationArgs)
                    }, resuming: function resuming(e) {
                        if (isPrelaunched)
                            return;
                        if (!commonEventProvider)
                            commonEventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Common;
                        commonEventProvider.traceProcessResumeEventStart();
                        var startTime = new Date;
                        if (!applicationLifetimeManager)
                            applicationLifetimeManager = new Microsoft.Entertainment.ApplicationLifetimeManager;
                        applicationLifetimeManager.raiseResuming();
                        if (tileManager && MS.Entertainment.Utilities.isApp1)
                            tileManager.updateTile();
                        commonEventProvider.traceProcessResumeTelemetryStart();
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).appResumed();
                        commonEventProvider.traceProcessResumeTelemetryStop();
                        MS.Entertainment.Instrumentation.PerfTrack.onResuming();
                        wasRecentlyResumed = true;
                        var stopTime = new Date;
                        var duration = stopTime.valueOf() - startTime.valueOf();
                        commonEventProvider.traceProcessResumeEventStop(duration);
                        if (MS.Entertainment.Utilities.isApp2 || Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToReceiver)
                            MS.Entertainment.Platform.PlayTo.initPlayToReceiver().done(function onInitPlayToReceiver(){}, function onInitPlayToReceiverError(){})
                    }, suspending: function suspending(e) {
                        if (isPrelaunched)
                            return;
                        if (!commonEventProvider)
                            commonEventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Common;
                        commonEventProvider.traceProcessSuspendEventStart();
                        var startTime = new Date;
                        if (!applicationLifetimeManager)
                            applicationLifetimeManager = new Microsoft.Entertainment.ApplicationLifetimeManager;
                        applicationLifetimeManager.raiseSuspending();
                        commonEventProvider.traceProcessSuspendTelemetryStart();
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).appSuspended();
                        commonEventProvider.traceProcessSuspendTelemetryStop();
                        MS.Entertainment.Instrumentation.PerfTrack.onSuspending();
                        var stopTime = new Date;
                        var duration = stopTime.valueOf() - startTime.valueOf();
                        commonEventProvider.traceProcessSuspendEventStop(duration);
                        if (MS.Entertainment.Utilities.isApp2 || Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToReceiver)
                            MS.Entertainment.Platform.PlayTo.stopPlayToReceiver(e.suspendingOperation.getDeferral()).done(function onStopPlayToReceiver(){}, function onStopPlayToReceiverError(){})
                    }, unload: function unload(e) {
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.sessionManager)) {
                            var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                            if (sessionMgr)
                                sessionMgr.displayRequestRelease()
                        }
                        var app = new Microsoft.Entertainment.Application.Application;
                        app.shutdownAsync();
                        window.removeEventListener("unload", MS.Entertainment.UI.Application.Activation.unload)
                    }, activateStageTwo: function activateStageTwo() {
                        if (stageTwoInitialised)
                            return;
                        stageTwoInitialised = true;
                        MS.Entertainment.UI.Components.Shell.initializeSnappedMode();
                        if (startPlaybackOnLaunch) {
                            var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                            signIn.signInOnStart();
                            signIn.bind("isSignedIn", function onSignInChange(isSignedIn) {
                                if (isSignedIn) {
                                    var playbackSession = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).primarySession;
                                    if (playbackSession) {
                                        playbackSession.playAt(0);
                                        playbackSession = null
                                    }
                                }
                            });
                            MS.Entertainment.Platform.PlaybackHelpers.reloadNowPlaying()
                        }
                        var handlers = MS.Entertainment.InformationArchitecture.getIAHandlersForAppId(MS.Entertainment.appMode);
                        var iaService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.informationArchitecture);
                        handlers(iaService);
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.networkStatus);
                        if (MS.Entertainment.FeatureEnablement)
                            MS.Entertainment.FeatureEnablement.initialize()
                    }, activateStageThree: function activateStageThree() {
                        var _delayTimerMS = 50;
                        if (shouldShowAppBar && !window.onNewMusicPage)
                            WinJS.Promise.timeout(showAppBarDelay).done(function() {
                                var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                                if (appBarControl)
                                    appBarControl.show(MS.Entertainment.UI.Controls.BottomAppBar.defaultHideTimeoutMS);
                                shouldShowAppBar = false;
                                showAppBarDelay = 0
                            });
                        if (stageThreePromise)
                            return stageThreePromise;
                        stageThreePromise = MS.Entertainment.Utilities.loadHtmlPage("/delayedStageThreeStartup.html", "delayedStartupContainer").then(function loadStageThreeFiles() {
                            if (MS.Entertainment.UI.Application.Helpers.activationTelemetryData && MS.Entertainment.UI.Application.Helpers.activationTelemetryData.length > 0) {
                                MS.Entertainment.UI.Application.Helpers.activationTelemetryData.forEach(function itemIterator(dataPoint) {
                                    dataPoint.write()
                                });
                                MS.Entertainment.UI.Application.Helpers.activationTelemetryData = null
                            }
                            if (MS.Entertainment.UI.FileTransferNotificationHandlers) {
                                MS.Entertainment.UI.fileTransferNotificationHandler = new MS.Entertainment.UI.FileTransferNotificationHandlers;
                                MS.Entertainment.UI.fileTransferNotificationHandler.startTransferListener()
                            }
                            if (MS.Entertainment.Utilities.isMusicApp1) {
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.collectionChangeNotifier);
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.adService);
                                MS.Entertainment.Platform.PlaybackHelpers.reloadNowPlaying()
                            }
                            if (MS.Entertainment.Utilities.isMusicApp)
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits).initialize();
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dashboardRefresher).initialize();
                            MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.backButton);
                            var pointerUpHandler = function mouseClickHandler(event) {
                                    if (event.button === 3) {
                                        var navigateBackAction = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.navigate);
                                        navigateBackAction.automationId = MS.Entertainment.UI.AutomationIds.mouseNavigateBack;
                                        navigateBackAction.parameter = MS.Entertainment.UI.Actions.navigate.NavigateLocation.back;
                                        navigateBackAction.execute()
                                    }
                                };
                            document.addEventListener("MSPointerUp", pointerUpHandler);
                            document.addEventListener("pointerup", pointerUpHandler);
                            MS.Entertainment.ViewModels.SearchContractViewModel.init();
                            if (MS.Entertainment.ViewModels.SearchContractViewModel.current)
                                MS.Entertainment.ViewModels.SearchContractViewModel.current.loadSearchObject();
                            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.typeToSearch))
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.typeToSearch).enableTypeToSearch();
                            if (MS.Entertainment.Utilities.isMusicApp || MS.Entertainment.Utilities.isVideoApp) {
                                var startDrmIndividualization = function startDrmIndividualization() {
                                        MS.Entertainment.Platform.Playback.drmIndividualizationPromise = new WinJS.Promise(function(c, e, p) {
                                            individualizationWorker = new Worker("/Components/Playback/IndivWorker.js");
                                            individualizationWorker.onmessage = function individualizationWorker_callback(event) {
                                                MS.Entertainment.Utilities.isDrmIndividualized = event.data;
                                                c(MS.Entertainment.Utilities.isDrmIndividualized)
                                            }
                                        })
                                    };
                                startDrmIndividualization()
                            }
                            MS.Entertainment.Framework.KeyboardInteractionListener.init();
                            MS.Entertainment.UI.Shell.createShellKeyboardShortcuts();
                            if (MS.Entertainment.UI.Shell.createShellVoiceShortcuts)
                                MS.Entertainment.UI.Shell.createShellVoiceShortcuts();
                            if (MS.Entertainment.UI.App2 && MS.Entertainment.UI.App2.registerForVoiceEvents)
                                MS.Entertainment.UI.App2.registerForVoiceEvents();
                            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.pinnedList))
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.pinnedList);
                            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.shareSender)) {
                                var sender = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.shareSender);
                                sender.setDefaultEmptyMessage()
                            }
                            MS.Entertainment.UI.PurchaseHistoryService.initialize();
                            if (MS.Entertainment.Utilities.isMusicApp) {
                                var cloudCollectionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.cloudCollection);
                                cloudCollectionService.startListening();
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).bind("isSignedIn", function onSignInChange(isSignedIn) {
                                    if (isSignedIn)
                                        if (MS.Entertainment.Utilities.isMusicApp1 && Microsoft.Entertainment.FileTransferManager)
                                            Microsoft.Entertainment.FileTransferManager.scheduleProgressCheck()
                                })
                            }
                            else if (MS.Entertainment.Utilities.isVideoApp)
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).bind("isSignedIn", function onSignInChange(isSignedIn) {
                                    if (isSignedIn) {
                                        var syncDelay = MS.Entertainment.Utilities.isVideoApp2 ? 5000 : 0;
                                        WinJS.Promise.timeout(syncDelay).done(function startSync() {
                                            var syncManager = new Microsoft.Entertainment.Sync.SyncManager;
                                            syncManager.requestSync()
                                        });
                                        if (Microsoft.Entertainment.FileTransferManager)
                                            Microsoft.Entertainment.FileTransferManager.scheduleProgressCheck()
                                    }
                                });
                            if (MS.Entertainment.Utilities.isApp2 || Microsoft.Entertainment.Configuration.ConfigurationManager().playback.enablePlayToReceiver)
                                MS.Entertainment.Platform.PlayTo.initPlayToReceiver().done(function onInitPlayToReceiver(){}, function onInitPlayToReceiverError(){});
                            var appNotificationInitPromise = WinJS.Promise.as();
                            if (!MS.Entertainment.Utilities.isApp2)
                                appNotificationInitPromise = WinJS.Promise.timeout(_delayTimerMS).then(function delay1() {
                                    return WinJS.UI.process(MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appInfoNotification))
                                }).then(function initializeControl(control) {
                                    if (control)
                                        control.delayedInitialize()
                                }).then(function loadCriticalNotification() {
                                    return WinJS.UI.process(MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appCriticalNotification)).then(function(control) {
                                            control.delayedInitialize()
                                        })
                                });
                            return appNotificationInitPromise.then(function delay() {
                                    if ((new Microsoft.Entertainment.Configuration.ConfigurationManager).shell.retailExperience)
                                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification).send(new MS.Entertainment.UI.Notification({
                                            notificationType: MS.Entertainment.UI.Notification.Type.Informational, title: String.load(String.id.IDS_DEMO_IN_DEMO_MODE), subTitle: "", moreDetails: "", action: null, secondaryActions: null, category: "demo", isPersistent: true
                                        }));
                                    if (MS.Entertainment.Utilities.isMusicApp1 && ((new Microsoft.Entertainment.Configuration.ConfigurationManager).service.useUserEngagementService))
                                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userEngagementService).initialize();
                                    if (MS.Entertainment.Utilities.isVideoApp2 && WinJS.Utilities.getMember("Microsoft.Entertainment.BackgroundTasks.EpgChannelUpdateTask"))
                                        WinJS.Promise.timeout(2000).then(function() {
                                            var epg = new Microsoft.Entertainment.BackgroundTasks.EpgChannelUpdateTask;
                                            epg.scheduleBackgroundTask();
                                            epg.updateChannelsNow()
                                        });
                                    return WinJS.Promise.timeout(_delayTimerMS).then(function processAppBar() {
                                            var bottomAppBar = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                                            var processAppBarPromise = WinJS.Promise.wrap();
                                            if (bottomAppBar && bottomAppBar.domElement === undefined)
                                                processAppBarPromise = WinJS.UI.processAll(bottomAppBar);
                                            processAppBarPromise.done(function loadAppBar() {
                                                if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.tileManager) && MS.Entertainment.Utilities.isApp1)
                                                    tileManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.tileManager);
                                                if (!MS.Entertainment.Utilities.isApp2)
                                                    MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar).deferredInit();
                                                else if (MS.Entertainment.isAppModeOverride)
                                                    MS.Entertainment.UI.Controls.CommandingPopOver.enableEdgeGlobalCommands();
                                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).stageThreeActivated = true
                                            }.bind(this))
                                        }).then(function delay3() {
                                            return WinJS.Promise.timeout(_delayTimerMS).then(function signIn() {
                                                    var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                                                    return signIn.signInOnStart()
                                                })
                                        }).then(function delay4() {
                                            return WinJS.Promise.timeout(_delayTimerMS).then(function initializePlaybackErrorDisplayService() {
                                                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.playbackErrorDisplayService))
                                                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.playbackErrorDisplayService).initialize()
                                                })
                                        }).then(function delay5() {
                                            var stageFourTimer = WinJS.Promise.timeout(stageFourDelay).then(MS.Entertainment.UI.Application.Activation.activateStageFour);
                                            return stageFourTimer
                                        })
                                })
                        });
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        if (MS.Entertainment.Utilities.isVideoApp2)
                            var isSnappedBinding = WinJS.Binding.bind(uiStateService, {isSnapped: function _isSnappedChanged(isSnapped) {
                                        if (isSnapped)
                                            return MS.Entertainment.Video.Video2WelcomeDialog.hide();
                                        else
                                            return MS.Entertainment.Video.Video2WelcomeDialog.show()
                                    }});
                        return stageThreePromise
                    }, activateStageFour: function activateStageFour() {
                        if (stageFourPromise)
                            return stageFourPromise;
                        stageFourPromise = MS.Entertainment.Utilities.loadHtmlPage("/delayedStageFourStartup.html", "delayedStartupContainer").then(function stageFourLoadFiles() {
                            if (!MS.Entertainment.Utilities.isMusicApp)
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.nowPlayingControlManager).preloadNowPlayingControls();
                            if (MS.Entertainment.UI.Actions.ImportPlaylists)
                                MS.Entertainment.UI.Actions.ImportPlaylists.resumeLastPlaylistImport();
                            if (MS.Entertainment.Utilities.isMusicApp2) {
                                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.idleApplicationService).initialize();
                                MS.Entertainment.UI.Application.Helpers.loadNavigateToNowPlayingOnIdleService()
                            }
                            if (MS.Entertainment.Utilities.isApp1 && MS.Entertainment.Framework.UpgradeToBlueNotification)
                                MS.Entertainment.Framework.UpgradeToBlueNotification.showNotification();
                            MS.Entertainment.UI.Framework.unblockPreloading()
                        });
                        return stageFourPromise
                    }
            })
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Application.Helpers", {
        splashScreenCleared: function splashScreenCleared() {
            (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceSplashScreen_Removed()
        }, activationTelemetryData: null, windowResizeSplashScreenHandler: null, showExtendedSplashScreen: function showExtendedSplashScreen(splashDetails) {
                var splashScreenImage = document.querySelector(".extendedSplashScreenImage");
                var splashScreenProgressContainer = document.querySelector(".extendedSplashScreenProgressContainer");
                if (!splashScreenImage)
                    return;
                if (!splashDetails) {
                    MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen();
                    return
                }
                MS.Entertainment.UI.Application.Helpers.windowResizeSplashScreenHandler = function() {
                    try {
                        if (MS.Entertainment.Utilities.isApp2) {
                            var imageLocation = splashDetails.imageLocation;
                            var splashWidth = 480;
                            var splashHeight = 300;
                            var splashDeltaX = (imageLocation.width - splashWidth) / 2;
                            var splashDeltaY = (imageLocation.height - splashHeight) / 2;
                            splashScreenImage.style.top = (imageLocation.y + splashDeltaY) + "px";
                            splashScreenImage.style.left = (imageLocation.x + splashDeltaX) + "px";
                            splashScreenImage.style.height = splashHeight + "px";
                            splashScreenImage.style.width = splashWidth + "px";
                            splashScreenProgressContainer.style.marginTop = imageLocation.y + splashDeltaY + splashHeight + 32 + "px"
                        }
                        else {
                            var imageLocation = splashDetails.imageLocation;
                            splashScreenImage.style.top = imageLocation.y + "px";
                            splashScreenImage.style.left = imageLocation.x + "px";
                            splashScreenImage.style.height = imageLocation.height + "px";
                            splashScreenImage.style.width = imageLocation.width + "px";
                            splashScreenProgressContainer.style.marginTop = imageLocation.y + imageLocation.height + 32 + "px"
                        }
                    }
                    catch(e) {
                        MS.Entertainment.fail("Exception trying to get splash screen information: " + e.toString())
                    }
                };
                MS.Entertainment.UI.Application.Helpers.windowResizeSplashScreenHandler();
                window.addEventListener("resize", MS.Entertainment.UI.Application.Helpers.windowResizeSplashScreenHandler)
            }, updateExtendedSplashScreenMessage: function updateExtendedSplashScreenMessage(title, message) {
                var splashScreenTitle = document.querySelector(".extendedSplashScreenTitle");
                var splashScreenMessage = document.querySelector(".extendedSplashScreenMessage");
                if (splashScreenTitle)
                    splashScreenTitle.innerText = title;
                if (splashScreenMessage)
                    splashScreenMessage.innerText = message
            }, waitForDatabaseUpdated: function waitForDatabaseUpdated() {
                var mediaStore;
                var promise;
                if (MS.Entertainment.Utilities.isMusicApp)
                    mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                if (mediaStore && mediaStore.databaseNeedsUpgrade) {
                    var query;
                    var waitTitle = String.load(String.id.IDS_APP_UPDATE_SPLASH_TITLE);
                    var waitMessage = String.load(String.id.IDS_APP_UPDATE_SPLASH_SUBTITLE);
                    MS.Entertainment.UI.Application.Helpers.updateExtendedSplashScreenMessage(waitTitle, waitMessage);
                    promise = mediaStore.ensureDatabaseOpenedAsync().then(null, function ignoreError(){})
                }
                return WinJS.Promise.as(promise)
            }, _inProgressRemoveExtendedSplashScreen: false, removeExtendedSplashScreenDOM: function removeExtendedSplashScreenDOM() {
                var extendedSplashScreen = document.querySelector(".extendedSplashScreen");
                if (!extendedSplashScreen)
                    return;
                window.removeEventListener("resize", MS.Entertainment.UI.Application.Helpers.windowResizeSplashScreenHandler);
                MS.Entertainment.UI.Application.Helpers.windowResizeSplashScreenHandler = null;
                MS.Entertainment.UI.Application.Helpers._inProgressRemoveExtendedSplashScreen = false;
                if (extendedSplashScreen.parentElement)
                    extendedSplashScreen.parentElement.removeChild(extendedSplashScreen);
                if (isPrelaunched) {
                    var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                    navigationService.skipEnterAnimationOnNextNavigation = false;
                    var unsnappedElement = document.getElementById("htmlUnsnapped");
                    if (unsnappedElement)
                        WinJS.Utilities.removeClass(unsnappedElement, "hideFromDisplay")
                }
            }, removeExtendedSplashScreen: function removeExtendedSplashScreen() {
                if (MS.Entertainment.UI.Application.Helpers._inProgressRemoveExtendedSplashScreen)
                    return WinJS.Promise.as();
                if (isPrelaunched) {
                    MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreenDOM();
                    return WinJS.Promise.as()
                }
                MS.Entertainment.UI.Application.Helpers._inProgressRemoveExtendedSplashScreen = true;
                return MS.Entertainment.UI.Application.Helpers.waitForDatabaseUpdated().then(function databaseUpdateFinishedOrNotNeeded() {
                        return MS.Entertainment.Utilities.loadDemoScripts()
                    }).then(function demoScriptsLoaded() {
                        var extendedSplashScreen = document.querySelector(".extendedSplashScreen");
                        var welcomeScreenDisplayed = WinJS.Promise.as();
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.welcomeDialogService))
                            welcomeScreenDisplayed = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.welcomeDialogService).initialize();
                        if (!extendedSplashScreen) {
                            MS.Entertainment.UI.Application.Helpers._inProgressRemoveExtendedSplashScreen = false;
                            return
                        }
                        welcomeScreenDisplayed.done(MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreenDOM, MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreenDOM);
                        var unsnappedElement = document.getElementById("htmlUnsnapped");
                        var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                        if (unsnappedElement && !uiStateService.isSnapped)
                            WinJS.Utilities.removeClass(unsnappedElement, "hideFromDisplay");
                        if (MS.Entertainment.Utilities.isApp2)
                            WinJS.Utilities.addClass(document.body, "showKeyboardFocus");
                        var currentPage = document.querySelector(".pageContainer.currentPage");
                        if (currentPage) {
                            MS.Entertainment.Utilities.enterElement(currentPage).done(function() {
                                MS.Entertainment.UI.Framework.setFocusRoot(currentPage)
                            });
                            if (MS.Entertainment.Utilities.isApp2)
                                WinJS.Utilities.addClass(document.activeElement, "acc-keyboardFocusTarget")
                        }
                        else {
                            var navigationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                            navigationService.skipEnterAnimationOnNextNavigation = false
                        }
                        return MS.Entertainment.UI.Application.Helpers.shouldShowWelcomeDialog().then(function(shouldShowWelcomeDialog) {
                                if (!shouldShowWelcomeDialog)
                                    return;
                                MS.Entertainment.assert(MS.Entertainment.Utilities.isApp2, "Only allowed in App2");
                                var showPromise = MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.welcomeDialogService) ? MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.welcomeDialogService).show() : MS.Entertainment.Video.Video2WelcomeDialog.show();
                                var onDialogDismissed = function onDialogDismissed() {
                                        if (!MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.welcomeDialogService))
                                            MS.Entertainment.UI.Application.Helpers.setShowWelcomeDialogState(false);
                                        if (unsnappedElement && !uiStateService.isSnapped) {
                                            var dashboardElement = document.querySelector(".currentPage .navigationHost.dashboardHost");
                                            if (dashboardElement && dashboardElement.winControl && dashboardElement.winControl.focusHome)
                                                dashboardElement.winControl.focusHome()
                                        }
                                    };
                                return showPromise.then(onDialogDismissed, onDialogDismissed)
                            })
                    })
            }, appConfig: {get: function get() {
                    var configManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    return MS.Entertainment.Utilities.isMusicApp ? configManager.music : configManager.video
                }}, shouldShowWelcomeDialog: function shouldShowWelcomeDialog() {
                if (!MS.Entertainment.Utilities.isApp2)
                    return WinJS.Promise.as(false);
                var showWelcomeDialog = MS.Entertainment.UI.Application.Helpers.appConfig.showWelcomeDialog;
                var welcomeDialogRequired;
                if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.welcomeDialogService))
                    welcomeDialogRequired = MS.Entertainment.UI.WelcomeDialogService.isWelcomeScreenRequired();
                else if (MS.Entertainment.Utilities.isVideoApp2) {
                    var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    var hasMarketplace = (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace) || featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace));
                    showWelcomeDialog = (!uiStateService.isSnapped && !hasMarketplace)
                }
                else if (!MS.Entertainment.isAppModeOverride && MS.Entertainment.Utilities.supportsProtectedContent)
                    showWelcomeDialog = false;
                return WinJS.Promise.join({
                        shouldShowWelcomeDialog: showWelcomeDialog, welcomeDialogRequired: welcomeDialogRequired || showWelcomeDialog
                    }).then(function(result) {
                        return result.shouldShowWelcomeDialog && result.welcomeDialogRequired
                    })
            }, setShowWelcomeDialogState: function setShowWelcomeDialogState(value) {
                if (!MS.Entertainment.Utilities.isApp2)
                    return;
                MS.Entertainment.UI.Application.Helpers.appConfig.showWelcomeDialog = value
            }, visibilityChanged: function visibilityChanged() {
                var isVisible = !document.hidden;
                if (!commonEventProvider)
                    commonEventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Common;
                commonEventProvider.traceAppVisibilityChanged(isVisible);
                var freezeThawTargets = [];
                var pageContainer;
                var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                uiStateService.isAppVisible = !document.hidden;
                var freezeThawPageContainer = function freezeThawPageContainer() {
                        pageContainer = document.getElementById("pageContainer");
                        if (pageContainer && pageContainer.childElementCount > 0)
                            (function() {
                                var target = document.querySelector("#pageContainer .currentPage");
                                MS.Entertainment.assert(target, "Didn't find the current page to thaw");
                                if (target)
                                    freezeThawTargets.push(target)
                            })();
                        var overlays = document.querySelectorAll(".overlayAnchor");
                        if (overlays)
                            Array.prototype.forEach.call(overlays, function(overlay) {
                                freezeThawTargets.push(overlay)
                            })
                    };
                if (!uiStateService.isSnapped)
                    freezeThawPageContainer();
                else
                    (function() {
                        var target = document.querySelector("#htmlSnapped");
                        if (WinJS.Utilities.hasClass(target, "hideFromDisplay"))
                            freezeThawPageContainer();
                        else {
                            MS.Entertainment.assert(target, "Didn't find the current page to thaw");
                            freezeThawTargets.push(target)
                        }
                    })();
                if (freezeThawTargets && freezeThawTargets.length)
                    if (document.hidden)
                        freezeThawTargets.forEach(function(freezeThawTarget) {
                            MS.Entertainment.Utilities.freezeControlsInSubtree(freezeThawTarget)
                        });
                    else {
                        freezeThawTargets.forEach(function(freezeThawTarget) {
                            MS.Entertainment.Utilities.thawControlsInSubtree(freezeThawTarget)
                        });
                        if (WinJS.Utilities.getMember("Microsoft.PerfTrack.PerfTrackTimePoint.responsive"))
                            if (wasRecentlyResumed)
                                MS.Entertainment.Instrumentation.PerfTrack.getLogger().writeResumeStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.responsive)
                    }
                wasRecentlyResumed = false;
                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userTimeTelemetryManager).appVisibilityChanged();
                try {
                    var mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                    mediaStore.prepareDatabaseForSuspend(!isVisible)
                }
                catch(e) {}
            }, handleDashboardVisible: function handleDashboardVisible() {
                if (!MS.Entertainment.Utilities.isApp2) {
                    var appBar = document.querySelector(".bottomAppBar");
                    WinJS.Utilities.removeClass(appBar, "removeFromDisplay")
                }
                document.removeEventListener("HubStripVisible", MS.Entertainment.UI.Application.Helpers.handleDashboardVisible);
                MS.Entertainment.UI.Application.Helpers.removeExtendedSplashScreen();
                WinJS.Promise.timeout(1).done(function() {
                    MS.Entertainment.Instrumentation.PerfTrack.triggerScenarioAppLaunch()
                })
            }, handleDashboardReady: function handleDashboardReady() {
                document.removeEventListener("HubStripReady", MS.Entertainment.UI.Application.Helpers.handleDashboardReady);
                MS.Entertainment.UI.Framework.setImmediateMode = MS.Entertainment.UI.Framework.setImmediateModes.normal;
                WinJS.Promise.timeout().then(function _delayHandleDashboardReady() {
                    MS.Entertainment.UI.Application.Activation.activateStageThree()
                })
            }, rejectImageDrags: function rejectImageDrags(event) {
                if (event.target.tagName === "IMG")
                    event.preventDefault()
            }, navigateBack: function navigateBack() {
                MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).navigateBack()
            }, loadNavigateToNowPlayingOnIdleService: function loadNavigateToNowPlayingOnIdleService() {
                var idleApplicationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.idleApplicationService);
                var playbackSession = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager).primarySession;
                var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                idleApplicationService.addEventListener(idleApplicationService.applicationIdleEvent, function navigateToNowPlaying() {
                    if (uiStateService && !uiStateService.isSnapped && !uiStateService.nowPlayingVisible && !uiStateService.isSearchPaneVisible && !uiStateService.overlayVisible && !uiStateService.activeListening && !uiStateService.nuiEngaged && playbackSession.currentTransportState === MS.Entertainment.Platform.Playback.TransportState.playing && playbackSession.playerState === MS.Entertainment.Platform.Playback.PlayerState.ready)
                        MS.Entertainment.Platform.PlaybackHelpers.showImmersive(null, {
                            sessionId: playbackSession.sessionId, startFullScreen: false
                        })
                })
            }
    });
    Object.defineProperty(window, "helpers", {get: function() {
            return MS.Entertainment.UI.Application.Helpers
        }});
    Object.defineProperty(window, "mnp", {get: function() {
            return MS.Entertainment.UI.Controls.MusicVisualization
        }});
    Object.defineProperty(window, "ccn", {get: function() {
            return MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.collectionChangeNotifier)
        }});
    if (!MS.Entertainment.Utilities.systemAppListenersAttached) {
        Windows.UI.WebUI.WebUIApplication.addEventListener("activated", MS.Entertainment.UI.Application.Activation.activated);
        Windows.UI.WebUI.WebUIApplication.addEventListener("resuming", MS.Entertainment.UI.Application.Activation.resuming);
        Windows.UI.WebUI.WebUIApplication.addEventListener("suspending", MS.Entertainment.UI.Application.Activation.suspending);
        window.addEventListener("unload", MS.Entertainment.UI.Application.Activation.unload, false);
        document.addEventListener("dragstart", MS.Entertainment.UI.Application.Helpers.rejectImageDrags, true);
        MS.Entertainment.Utilities.systemAppListenersAttached = true
    }
    document.addEventListener("visibilitychange", MS.Entertainment.UI.Application.Helpers.visibilityChanged, false);
    document.addEventListener("HubStripVisible", MS.Entertainment.UI.Application.Helpers.handleDashboardVisible);
    document.addEventListener("HubStripReady", MS.Entertainment.UI.Application.Helpers.handleDashboardReady);
    MS.Entertainment.Utilities.processAllOnDocumentLoaded().then(function mainLoaded() {
        (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceFinish_ProcessAll()
    })
})()
